/****************************************************************************** 
 * Licensed Materials - Property of IBM
 *  Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");

dojo.require("jazz.app.context");
(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var Constants  				= com.ibm.asq.common.web.client.internal.Constants;
var getCurrentPA            = jazz.app.context.get;
var EditorUtil				= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var CommonPreferenceClient 	= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient= {

	TER_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.ITestcaseExecutionRecordRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			if(appArgs.owner) {
				actualArgs.owner = appArgs.owner;
			}
			if(appArgs.newExecutionWorkItem){
				actualArgs.newExecutionWorkItem = appArgs.newExecutionWorkItem;
				if(appArgs.originator){
					actualArgs.originator = appArgs.originator;
				}
				if(appArgs.frequency){
					actualArgs.frequency = appArgs.frequency;
				}
				if(appArgs.testCase){
					actualArgs.testCase = appArgs.testCase;
				}
			}
			else{
				if(appArgs.owner){
					actualArgs.owner = appArgs.owner;
				}
				if(appArgs.defaultScript){
					actualArgs.defaultScript = appArgs.defaultScript;
				}
			}
			
			if(appArgs.ids)
			    actualArgs.ids = appArgs.ids;
			if(appArgs.id)
				actualArgs.id = appArgs.id;
			if(appArgs.ewiStateIds)
			    actualArgs.ewiStateIds = appArgs.ewiStateIds;		
			if(appArgs.defaultScript)
				actualArgs.defaultScript = appArgs.defaultScript;
			if(appArgs.itemId)
				actualArgs.itemId = appArgs.itemId;
            if(appArgs.itemIds)
                actualArgs.itemIds = appArgs.itemIds;
			if(appArgs.stateId)
				actualArgs.stateId = appArgs.stateId;
			if(appArgs.resultStateId)
				actualArgs.resultStateId = appArgs.resultStateId;
			if(appArgs.ewiItemId)
				actualArgs.ewiItemId = appArgs.ewiItemId;
			if(appArgs.ewiStateId)
				actualArgs.ewiStateId = appArgs.ewiStateId;
			if(appArgs.testScriptItemid)
				actualArgs.testScriptItemid = appArgs.testScriptItemid;
			if(appArgs.scriptItemid)
				actualArgs.scriptItemid = appArgs.scriptItemid;
			if(appArgs.scriptStateId)
				actualArgs.scriptStateId = appArgs.scriptStateId;
			if(appArgs.testCaseItemId)
				actualArgs.testCaseItemId = appArgs.testCaseItemId;
            if(appArgs.includeArchived)
                actualArgs.includeArchived = appArgs.includeArchived;
			if(appArgs.testConfig)
				actualArgs.testConfig = appArgs.testConfig;
			if(appArgs.resultItemId)
				actualArgs.resultItemId = appArgs.resultItemId;	
			if(appArgs.name)
				actualArgs.name = appArgs.name;	
			if(appArgs.testPlanItemId)
				actualArgs.testPlanItemId = appArgs.testPlanItemId;	
			if(appArgs.testPhase)
				actualArgs.testPhase = appArgs.testPhase;			
			if(appArgs.testCase)
				actualArgs.testCase = appArgs.testCase;
			if(appArgs.testcaseStateId)
				actualArgs.testcaseStateId = appArgs.testcaseStateId;
			if(appArgs.uuid_ewi)
				actualArgs.uuid_ewi = appArgs.uuid_ewi;
            if(appArgs.uuid_ewis)
                actualArgs.uuid_ewis = appArgs.uuid_ewis;
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;	
			if(appArgs.addDefectIds)
				actualArgs.addDefectIds = appArgs.addDefectIds;
			if(appArgs.removeDefectIds)
				actualArgs.removeDefectIds = appArgs.removeDefectIds;
            if(appArgs.weight)
                actualArgs.weight = appArgs.weight;
			if(appArgs.startTime)
				actualArgs.startTime = appArgs.startTime;
			if(appArgs.requestId)	
				actualArgs.requestId = appArgs.requestId;
			if(appArgs.resolveResults == true || appArgs.resolveResults == false)
				actualArgs.resolveResults = appArgs.resolveResults;
			if(appArgs.resolveWorkItems == true || appArgs.resolveWorkItems == false)
				actualArgs.resolveWorkItems = appArgs.resolveWorkItems;
			if(appArgs.resolveCurrentResult == true || appArgs.resolveCurrentResult == false)
				actualArgs.resolveCurrentResult = appArgs.resolveCurrentResult;
			if(appArgs.resolvePlan == true || appArgs.resolvePlan == false)
				actualArgs.resolvePlan = appArgs.resolvePlan;
			if(appArgs.resolveTestcase == true || appArgs.resolveTestcase == false)
				actualArgs.resolveTestcase = appArgs.resolveTestcase;
			if(appArgs.resolveFullTestcase == true || appArgs.resolveFullTestcase == false)
				actualArgs.resolveFullTestcase = appArgs.resolveFullTestcase;
			if(appArgs.resolveConfiguration == true || appArgs.resolveConfiguration == false)
				actualArgs.resolveConfiguration = appArgs.resolveConfiguration;
			if(appArgs.resolveEnv == true || appArgs.resolveEnv == false)
				actualArgs.resolveEnv = appArgs.resolveEnv;
			if(appArgs.resolveDefaultScript == true || appArgs.resolveDefaultScript == false)
				actualArgs.resolveDefaultScript = appArgs.resolveDefaultScript;
			if(appArgs.resolvePhase == true || appArgs.resolvePhase == false)
				actualArgs.resolvePhase = appArgs.resolvePhase;
			if(appArgs.resolveMinDefScript == true || appArgs.resolveMinDefScript == false)
				actualArgs.resolveMinDefScript = appArgs.resolveMinDefScript;
			if(appArgs.resolveMinCurResult == true || appArgs.resolveMinCurResult == false)
				actualArgs.resolveMinCurResult = appArgs.resolveMinCurResult;
			if(appArgs.testCaseRevision)
				actualArgs.testCaseRevision = appArgs.testCaseRevision;	
			if(appArgs.buildId)	
				actualArgs.buildId = appArgs.buildId;
			if(appArgs.buildRecordItemId)
				actualArgs.buildRecordItemId = appArgs.buildRecordItemId;	
			if(appArgs.resolveResult)	
				actualArgs.resolveResult = appArgs.resolveResult;
			if(appArgs.adapterItemId)	
				actualArgs.adapterItemId = appArgs.adapterItemId;
			if(appArgs.resWindowMin)
				actualArgs.resWindowMin = appArgs.resWindowMin;
			if(appArgs.state)
				actualArgs.state = appArgs.state;
			if(appArgs.scriptItemids)
				actualArgs.scriptItemids = appArgs.scriptItemids;
			if(appArgs.currentResult)
				actualArgs.currentResult = appArgs.currentResult;
			if(appArgs.ewiItemIds)
				actualArgs.ewiItemIds = appArgs.ewiItemIds;
			if(appArgs.variableJson)
				actualArgs.variableJson = appArgs.variableJson;
			if(appArgs.projectVariableJson)
				actualArgs.projectVariableJson = appArgs.projectVariableJson;
			if(appArgs.appendVariableMap)
				actualArgs.appendVariableMap = appArgs.appendVariableMap;	
            if(appArgs.categories != null)
                actualArgs.categories = appArgs.categories;   
            if(appArgs.categoryTypeIds)
                actualArgs.categoryTypeIds = appArgs.categoryTypeIds;   
            if(appArgs.sortableCategories)
                actualArgs.sortableCategories = appArgs.sortableCategories;
			if(appArgs.executionPriority)
				actualArgs.executionPriority = appArgs.executionPriority;  
			if(appArgs.estimate > Constants.INVALID_DURATION)
				actualArgs.estimate = appArgs.estimate;
			if(appArgs.timeSpent > Constants.INVALID_DURATION)
				actualArgs.timeSpent = appArgs.timeSpent;
            if(appArgs.category)
                actualArgs.category = appArgs.category;
			if(appArgs.requestItemIds)
				actualArgs.requestItemIds = appArgs.requestItemIds;
			if(appArgs.itemIds)
				actualArgs.itemIds = appArgs.itemIds;
			if(appArgs.resolveCustomAttributes  == true || appArgs.resolveCustomAttributes  == true){
				actualArgs.resolveCustomAttributes = appArgs.resolveCustomAttributes;
			}
			if(appArgs.customAttributesJson) {
	        	actualArgs.customAttributesJson = appArgs.customAttributesJson;                 
	        }
			if(appArgs.strCustomAttributes) {
	        	actualArgs.strCustomAttributes = appArgs.strCustomAttributes;                 
	        }
			if(appArgs.intCustomAttributes) {
	        	actualArgs.intCustomAttributes = appArgs.intCustomAttributes;                 
	        }
			if(appArgs.timeCustomAttributes) {
	        	actualArgs.timeCustomAttributes = appArgs.timeCustomAttributes;                 
	        }
			if(appArgs.execResultCustomAttributesJson)
				actualArgs.execResultCustomAttributesJson = appArgs.execResultCustomAttributesJson;
			if(appArgs.summary)
				actualArgs.summary = appArgs.summary;
			if(appArgs.resolveChangedTER)
				actualArgs.resolveChangedTER = appArgs.resolveChangedTER;
			if(appArgs.notes)
				actualArgs.notes = appArgs.notes;
			if(appArgs.pointsAttemptedPercent)
				actualArgs.pointsAttemptedPercent = appArgs.pointsAttemptedPercent; 
			if(appArgs.pointsBlockedPercent)
				actualArgs.pointsBlockedPercent = appArgs.pointsBlockedPercent ;
			if(appArgs.pointsFailedPercent)
				actualArgs.pointsFailedPercent = appArgs.pointsFailedPercent ;
			if(appArgs.pointsInconclusivePercent)
				actualArgs.pointsInconclusivePercent = appArgs.pointsInconclusivePercent;  
			if(appArgs.pointsPassedPercent)
				actualArgs.pointsPassedPercent = appArgs.pointsPassedPercent;	
			if(appArgs.queryFilterItemId)
				actualArgs.queryFilterItemId = appArgs.queryFilterItemId;
			if (appArgs.pointsDeferredPercent) {
	            actualArgs.pointsDeferredPercent = appArgs.pointsDeferredPercent;
			}
			if(appArgs.resolveMinResult){
				actualArgs.resolveMinResult = appArgs.resolveMinResult;
			}
			if(appArgs.projectAreaItemId)
				actualArgs.projectAreaItemId = appArgs.projectAreaItemId;
			if (appArgs.pointsPermFailedPercent) {
	            actualArgs.pointsPermFailedPercent = appArgs.pointsPermFailedPercent;
			}
			if (appArgs.scheduleOn) {
	            actualArgs.scheduleOn = appArgs.scheduleOn;
			}
			if(appArgs.datapoolRows){
				actualArgs.datapoolRows = appArgs.datapoolRows;
			}
			if(appArgs.isScriptLessExecution){
				actualArgs.isScriptLessExecution = appArgs.isScriptLessExecution;
			}
			if(appArgs.ewiId){
				actualArgs.ewiId = appArgs.ewiId;
			}
			if(appArgs.autoResultsJson) {
				actualArgs.autoResultsJson = encodeURI(dojo.toJson(appArgs.autoResultsJson));
			}
			if(appArgs.channelId){
				actualArgs.channelId = appArgs.channelId;
			}	
		}else{
			appArgs = {};
		}
		if(!appArgs.projectArea){
			actualArgs.projectArea = getCurrentPA().itemId;
		}else{
			actualArgs.projectArea = appArgs.projectArea;
		}
		
		if(appArgs.teamArea){
			actualArgs.teamArea = appArgs.teamArea;
		}
		if(appArgs.updateTeamArea == true || appArgs.updateTeamArea == false){
			actualArgs.updateTeamArea = appArgs.updateTeamArea;
		}
		if (appArgs.resolveStepRequirements){
			actualArgs.resolveStepRequirements = appArgs.resolveStepRequirements;
		}	
		if (appArgs.isArchived) {
			actualArgs.isArchived = appArgs.isArchived;
		}
		if (appArgs.isPurged) {
			actualArgs.isPurged = appArgs.isPurged;
		}
        actualArgs.isWebUI = true;
			
		var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getExecutionWorkItemDTOs: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getWorkItemDTOs", params);
	},

	getExecutionWorkItemMinimalDTOs: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getWorkItemMinimalDTOs", params);
	},
	
	getExecutionWorkItemSummaryDTOs: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getWorkItemSummaryDTOs", params);
	},
	
	getExecutionWorkItem: function(serviceResponseHandler, owner ){
		this._invokeService(serviceResponseHandler, "getWorkItem", {owner: owner });
	},
	
	postExecutionWorkItem: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postWorkItem", params);
	},
	
	postExecutionWorkItemDTO: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postWorkItemDTO", params);
	},
	
	postExecutionWorkItemMinimalSummaryDTO: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postWorkItemMinimalSummaryDTO", params);
	},
	
	_postExecuteDTO: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postExecuteDTO", params);
	},
	
	postExecuteDTO: function(serviceResponseHandler, params)
	{
		if(params.resolveStepRequirements == true || params.resolveStepRequirements == false){
			this._postExecuteDTO(serviceResponseHandler, params);
		}else{
			//Set resolveStepRequirements=true if test script preference is set to use validate requirement.
			//There are many UI widget using this method, to avoid make many changes on each widget, add this
			//interceptor here.
			EditorUtil.getUseValidateRequirementActivityOption(dojo.hitch(this, function(pref){
				params.resolveStepRequirements = pref;
				this._postExecuteDTO(serviceResponseHandler, params);
			}), dojo.hitch(this, function(e){
				this._postExecuteDTO(serviceResponseHandler, params);
			}));
		}
	
	},

	postCancelExecution: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postCancelExecution", params);
	},
	
	getAllTCToEWIMaps: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "getAllTCToEWIMaps", params);
	},
	
	getExecutionWorkItemByItemId: function(serviceResponseHandler, params)
	{
	this._invokeService(serviceResponseHandler, "getExecutionWorkItemByItemId", params);
	},
	
	postArchiveEWI: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postArchiveEWI", params);
	},
	postArchiveEWIsForTC: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postArchiveEWIsForTC", params);
	},
	postBulkChangeEWI: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postBulkChangeTER", params);
	},
    
    postManageBlockingDefects : function(serviceResponseHandler, params)
    {
        this._invokeService(serviceResponseHandler, "postManageBlockingDefects", params);
    },
    
    /*
     * This method is added to set the sortColumn currentResultScript instead of defaultScriptName if the execution preference is set
     * to use the last executed script as default in the TER list view. If this preference is set, the script shown in the TER list view is the 
     * last executed script.
     */
    searchExecutionWorkItemPrefCheck: function(serviceResponseHandler, params)
    {
    	if( CommonPreferenceClient.getExecutionPreference().showlastrunscript) {
    		if(params && params.sortColumns) {
    			var sortColumns = params.sortColumns;
    			var len = sortColumns.length;
    			for(var i=0; i< len; i++) {
    				if(sortColumns[i].indexOf("defaultScriptName") >= 0) {
    					sortColumns[i] = sortColumns[i].replace("defaultScriptName","currentResultScript");
    					break;
    				}
    			}
    			params.sortColumns = sortColumns;
    		}
    		
    	}
    	this.searchExecutionWorkItem(serviceResponseHandler, params);
    },

    searchExecutionWorkItem: function(serviceResponseHandler, params)
    {
        /*
            VALID PARAMETERS
            --------------------------------
            String processArea;         //itemId
            String name;                    
            String[] originatorUUIDs;   //itemId
            String[] ownerUUIDs;        //itemId
            String[] stateIds;          // eg. 'com.ibm.rqm.state.new'
            String weightComparator
            int weightValue
            boolean includeArchived = false;
            String policy;              //'enforce', 'truncate', 'ignore'  
            String queryToken;
            int page;
            int pageSize;
            String[] sortColumns;
            String textSearch;
            String defects;
            String virtualService;
        */         
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }   
        
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getPagedSearchResult", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
    },
    
	getExecutionStatusGroupByOwner: function(serviceResponseHandler, params)
	{
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }           
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getExecutionStatusGroupByOwner", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	
	getExecutionStatusGroupByPriority: function(serviceResponseHandler, params)
	{
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }           
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getExecutionStatusGroupByPriority", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	
	getExecutionStatusGroupByTestPlan: function(serviceResponseHandler, params)
	{
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }           
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getExecutionStatusGroupByTestPlan", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	
	getExecutionStatusGroupByTestPhase: function(serviceResponseHandler, params)
	{
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }           
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getExecutionStatusGroupByTestPhase", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	
	getExecutionStatusGroupByCategory: function(serviceResponseHandler, params){	
		params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }           
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getExecutionStatusGroupByCategory", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},

    getAllSearchResultItemIds: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------
                String queryToken;
                String idType;
         */         
        var typeMap = {
            'id': 'Id',
            'itemId': 'ItemHandle',
            'versionableItemId': 'VersionedItemHandle'
        };
        var type = args.kindOfHandles;
        args.kindOfHandles = typeMap[type];
        var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "getAllItemHandles", args);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
    },          
    
    getRelatedDefects: function(serviceResponseHandler, params)
    {
		/*
		 * params:
         *  String processArea;
         *  String uuid_ewi;
         *  String ewiStateId;
         */
        this._invokeService(serviceResponseHandler, "getReferencedDefects", params);
    },
	
	copyTERUnderSamePlan: function(serviceResponseHandler, params){
		params = params ? params : {};
		if (!params.projectArea) {
			params.projectArea = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "postCopyTERUnderSamePlan", params);
		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	
	copyTER: function(serviceResponseHandler, params){
		params = params ? params : {};
		if (!params.projectArea) {
			params.projectArea = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.TER_SERVICE_URI, "postCopyTER", params);
		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	
	getRelatedDefectsFromMultipleEWIs: function(serviceResponseHandler, params)
	{
        /*
         * params:
         *  String processArea;
         *  String uuid_ewis;
         *  String ewiStateIds;
         */
        this._invokeService(serviceResponseHandler, "getReferencedDefectsFromMultipleEWIs", params);
	},
	
	getTERCoverage: function(responseHandler, args) {
        var serviceRequest = new ServiceRequest(this.TER_SERVICE_URI, "postGetTERCoverage", args);
        TeamServerClient.invokeService(serviceRequest, responseHandler);		
	},
	
	getPagedSearchResultsByQueries: function(callbackObj, args) {
		this._invokeService(callbackObj, "getPagedSearchResultsByQueries", args);
	}

};

})();
