/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteExecutionRecordSummarySection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.extension.TestcaseExecutionRecordSummarySection");
dojo.require("dojo.parser");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");


(function() { // module container

var TestcaseExecutionRecordSummarySection 	= com.ibm.rqm.execution.web.ui.internal.view.extension.TestcaseExecutionRecordSummarySection;
var Constants 								= com.ibm.rqm.planning.web.client.internal.Constants;
var TestSuiteTableView 						= com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView;
var ExecutionUtility				    	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var CommonUtility                  			= com.ibm.asq.common.web.ui.internal.util.Utility;
var CommonConstants  						= com.ibm.asq.common.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteExecutionRecordSummarySection", [
                   dijit._Widget, dijit._Templated, TestcaseExecutionRecordSummarySection], {
	
	_updateTestCases: function(){
		if (this.ewi) {
			this._browseTP.set('disabled', true);
			this._clearTP.set('disabled', true);
			
			if(this.ewi.testSuite){
				var testSuite = this.ewi.testSuite;
                this._TC.innerHTML = CommonUtility.encodeHTMLTags(testSuite.name ? testSuite.name : "");
				this._setTSLink(testSuite);                    
			}
			this._browseTC.set('disabled', true);
			this._clearTC.set('disabled', true);
			return;
		}
		this._TC.innerHTML = Constants.getMessage("labelUnassigned");
		this._TCItemId = null;
	},
	
	_setTSLink: function(testSuite){
		if(testSuite.versionableItemId)
		{
			if (this._tcResLink) {
				this._tcResLink.destroyRecursive(true);
			}
			var testSuiteName = testSuite.name || "";
			testSuiteName = testSuiteName + (testSuite.snapshotInfo ? " (" + testSuite.snapshotInfo.name + ")" : "");

			// wrap the test case link with a rich hover resource
            this._tcResLink = new jazz.ui.ResourceLink({
                label: CommonUtility.encodeHTMLTags(testSuiteName),
				retainLinkText: true,
                uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_SUITE, testSuite.versionableItemId),
                presentationUri: testSuite.snapshotInfo ? ExecutionUtility.getTestSuiteURI(testSuite.versionableItemId, testSuite.snapshotInfo.revision) :
									ExecutionUtility.getTestSuiteURI(testSuite.id)
            }, this._TC);
			this.resourceLinks.push(this._tcResLink);
		}else{
			this._TC.href = ExecutionUtility.getTestSuiteURI(testSuite.id);
		}			
	},
	
	updateTitlesForEditor: function(){
		var colen = Constants.getMessage("labelColen");
		this._executeTCLabel.innerHTML = Constants.getMessage("labelTestSuite")+colen;
		this._estimateLabel.innerHTML = Constants.getMessage("labelEstimate")+ colen;
		this._timeSpentLabel.innerHTML = Constants.getMessage("labelTimeSpent")+ colen;
		this._defaultTSLabel.style.display = "none";
		this._TS.style.display = "none";
		//this.detailSection.setCSHelpId("rqm_ter_detail.html");
		this._browseTC_Title = Constants.getMessage("labelSelectTestSuite");
		if (dojo.isFunction(this._browseTC.set)) {
			this._browseTC.set('title', this._browseTC_Title);
		}
	},
	
	_browseClick:function(e){
		var planId = this._TPvalue;
		var tableArgs = {
			testCases: this.testCases,
            profile: Constants.TABLE_PROFILE_MINIMAL,
			isSingleSelect:true,
			contentIsVirtual: true,
            showQueryFilters: true,
            displayInPopup: true,
            isInPicker: true,
            enableRowEditable: false,
            minimalAction: true
		};
        // add the parent test plan constrain on the query.
		if (planId != "global") {
            tableArgs.parentItemIdArgName = "constrainParentVTestPlan";
            tableArgs.parentVersionItemId = this._getSelectedPlanItemId();
        }else{
            //Clear Filter args ourself as widget caches them
			tableArgs.initFilterArgs = {includeArchived: false};
        }
       
		tableArgs.showInitLoadProgress = true;
		this._list = new TestSuiteTableView(tableArgs);
        var dialogArgs = {
            primaryTitle: Constants.getMessage("labelSelectTestSuite"),
            okCallback: dojo.hitch(this, "_setTestSuite"),
			_truncate: function() {},  //disable the Dialog's '_truncate'
		    zIndex: 998,  // need to change the zIndex to allow the table's filters to popup.
            forceZIndex: true	
        };                
        var _dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
//        var cshelp = new CSHelp({contextID: "rqm_add_test_suites.html"});
//        cshelp.setButtonLabel(Constants.getMessage("labelAddExistingCSHelp"));
//        _dialog.setSecondaryTitleNode(cshelp.domNode);
        _dialog.contentContainer.appendChild(this._list.domNode);
		_dialog.open(false);
		_dialog.updatePosition();
		_dialog.getOkButton().disabled = false;
		this._dialog = _dialog;
		if(dojo.isIE) { //set focus to make JAWS announce the dialog (WI77646)
			this._dialog._headerText.focus();
		}
		dojo.stopEvent(e);
	},
	
	_setTestSuite:function(){
		var addedItems = this._list.getSelectedItems();
		if (addedItems && addedItems.length > 0) {
			this._TCId = addedItems[0].id;
			if(addedItems[0].versionableItemId)
				this._TCItemId = addedItems[0].versionableItemId;
			else
				this._TCItemId = this._getTestCaseVersionableItemId(addedItems[0].id);
			this._TC.innerHTML = CommonUtility.encodeHTMLTags(addedItems[0].name);
			this._setTSLink(addedItems[0]);	
			this.getParentEditor().selectedTestSuite = addedItems[0];
			if(!this.getParentEditor().isPriorityAssignedByUser()){
				this.getParentEditor().setPriority(addedItems[0].priority);
			}
			if(this.weightWidget){
				this.weightWidget.clearValue();	// clear text and validation warning icon
				this.weightWidget.setValue(addedItems[0].weight);
			}
			if(this.estimateWidget && addedItems[0].estimate >= 0){
				this.estimateWidget.setValue(addedItems[0].estimate);
			}
			this._onChange();
		}
	},
	
	//@Overriden from AbstractArtifactEditorSection
    getHelpContextID: function(){
        return "rqm_ter_detail.html";
    },
	
	 //@Overriden from AbstractArtifactEditorSection
    getAttributes: function(){
        var attributes = {};
        //weight
        if(this.weightWidget) {
            attributes.weight = this.weightWidget.getValue();
        }  
		
		if(this.estimateWidget){
			var estimate = this.estimateWidget.getValue();
			if(estimate > CommonConstants.INVALID_DURATION){
				attributes.estimate = estimate;
			}
		}
		
        if(this.timeSpentWidget){
			var timeSpent = this.timeSpentWidget.getValue();
			if(timeSpent > CommonConstants.INVALID_DURATION){
				attributes.timeSpent = timeSpent;
			}			
 		}
 
        if (this._categorySelect) {
            var categories = this._categorySelect.getSelectedItemIds();
            if (categories && categories.length) {
            	attributes.categories = categories.join();
            }else{
            	attributes.categories = "";
			}
            var sortableItems = this._categorySelect.getSortableItemIds();
            if(sortableItems.length > 0) {
            	attributes.sortableCategories = sortableItems.join();
            }
        }
		
		if(this.customAttrEditor){
			attributes.customAttributesJson =  dojo.toJson(this.customAttrEditor.getAttributes());
		}
		
		var testConfig = this._configurations1.value;
		attributes.suiteVersionableItemId = this._TCItemId;
		
		var testPlanItemId = this._getSelectedPlanItemId();
		var testPhase = this._Iteration.disabled ? null : (this._Iteration.value == this.unassigned ? this.unassigned : this._Iteration.value);
		
		if(testConfig && testConfig != "global")
			attributes.configurationItemId = testConfig;
		if(testPlanItemId != "global"){
			attributes.versionedTestPlanItemId = testPlanItemId;
		}
		
		if(testPhase != ""){
			attributes.testPhaseItemId = testPhase;
		}
		
        return attributes;
    }
    
	
});

})();
    
   