/**EWITV***************************************************************************** 
 * Licensed Materials - Property of IBM
 *  Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 * 
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView");
 
dojo.require("jazz.ui.Menu");
dojo.require("jazz.app.context");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.client.internal.CompositeWebClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormDurationField");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ExplorableTableFilterProvider");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ArtifactCellEditor");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Configuration");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.asq.common.web.client.internal.FiltersQueriesClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.PrintHelper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPlanPopup");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactContentProviderMixin");
dojo.require("com.ibm.rqm.planning.web.client.internal.CategoryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.categories.CategoryEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.CustomAttributesClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectPriorityPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectDurationPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTeamAreaPopup");
dojo.require("com.ibm.asq.common.web.ui.internal.util.DurationUtil");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionRecordTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactPriorities");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactActionProvider");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.RowChangeAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.EditableProperty");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.StateTransitionConstraintsUtil");

(function() {

var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     			= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        			= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      			= com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ExecutionWorkItemClient	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ConfirmationDialog      = com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var ViewHeaderLayout        = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var EWIMapper               = com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var TimeboxClient           = com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var CommonPreferenceClient 	= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
var LabelNone               = Constants.getMessage("labelNone");
var ProgressUtility         = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;
var RiskUtil				= com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
var CommonUtil              = com.ibm.asq.common.web.ui.internal.util.Utility;
var FiltersQueriesClient    = com.ibm.asq.common.web.client.internal.FiltersQueriesClient;
var PrintHelper 			= com.ibm.asq.common.web.ui.internal.util.PrintHelper;
var PlanningClient 			= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var CategoryClient          = com.ibm.rqm.planning.web.client.internal.CategoryClient;
var CategoryUtil            = com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil;
var AttributeClient 		= com.ibm.rqm.planning.web.client.internal.CustomAttributesClient;
var PrioritySelectionPopup  = com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectPriorityPopup;
var SelectDurationPopup		= com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectDurationPopup;
var DurationUtil			= com.ibm.asq.common.web.ui.internal.util.DurationUtil;
var NormalizeTimeStampString = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util.normalizeTimeStampString;
var ArtifactPriorities		= com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactPriorities;
var ExecutionResultStates 	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
var PlanningUtility			= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var LabelEWI				= Constants.getMessage("labelEWI");
var LabelUnassigned  		= Constants.getMessage("labelUnassigned");
var UnassignedTestPlanLabel = Constants.getMessage("labelUnassignedTestPlanFilter");
var SelectTeamAreaPopup     = com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTeamAreaPopup;
var EditableProperty        = com.ibm.rqm.planning.web.ui.internal.view.table.EditableProperty;
var ProgressDialog 			= com.ibm.asq.common.web.ui.internal.widgets.ProgressDialog;
var CompositeWebClient      = com.ibm.asq.common.web.client.internal.CompositeWebClient;
var ConstraintsUtil         = com.ibm.rqm.planning.web.ui.internal.util.StateTransitionConstraintsUtil;
var getCurrentProjectArea			= jazz.app.context.get;

dojo.declare("ExecutionWorkItemTableView.TableListener", 
             com.ibm.rqm.planning.web.ui.internal.view.table.AbstractExplorableTableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
        this._printsHistory = true;
    },
	
	setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
    rowCheckStateChanged: function(tableViewer, rowObject, state){
        var selection = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
		var p = this.parentView;
//		try{
//			tableViewer.actionProvider.getActions();//call to update the actions, needed for top row action menu
//			}catch(e){
//				console.debug("error while trying to update actions in rowcheckstatechanged");
//			}

		if (p.inEditMode)
			return;
		
		if (this.rowCheckListener && dojo.isFunction(this.rowCheckListener)) {
            var selectObj = rowObject;
            // virtual select all, just provide our current content.
            if(!realSelection) {
                selectObj = tableViewer.getContent();
            }
			this.rowCheckListener(selectObj, state);
		}

        PrintHelper.enableDisablePrintMenuItems(this.parentView);

    },
    
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
	
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /* optional */actionId){
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("ExecutionWorkItemTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    showTestCase: true,
    constructor: function(args) {
        dojo.mixin(this, args);
    },
    
	setChangeListener: function(listener){
		this.changeListener = listener;
	},
	
    _recordSelectedScriptName: function(rowData) {
        var tc = rowData.testCase;
        var tsItemId = rowData.selectedScriptId;
        
        if (tsItemId == '-1') {
            rowData.selectedScriptName = LabelNone;
			rowData.selectedScriptDatapoolItemId = "none";
			rowData.selectedScriptRecordSelection = "none";
        }
        else {
            var ts = tc ? tc.scripts : null;
            if (ts) {
                var len = ts.length;
                for (var i = 0; i < len; i++) {
                    if (ts[i].versionableItemId == tsItemId) {
                        rowData.selectedScriptName = ts[i].name;
						rowData.selectedScriptDatapoolItemId = ts[i].datapoolItemId;
						rowData.selectedScriptRecordSelection = ts[i].datapoolRecordSelection;
                        break;
                    }
                }
            }
        }       
    },
    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
        // store the new values in our internal data model
        columnIndex += (this.showTestCase || (columnIndex <= 4 ) ? 0 : 1);
		if(columnIndex == 12) {
            // update the current selected script on the row.
			rowObject.selectedScriptId = newValue;
            rowObject.testScriptValues.select = newValue;
            this._recordSelectedScriptName(rowObject);
            
			if (this.parent.inEditMode) {
				rowObject.isChanged = true;
				var listener = this.changeListener;
				if (rowObject.defaultScript) 
					rowObject.defaultScript.versionableItemId = newValue;
				else 
					rowObject.defaultScript = {
						versionableItemId: newValue
					};
				if (rowObject.defaultScript.versionableItemId == "-1") 
					rowObject.defaultScript.versionableItemId = null;
				if (listener && listener.method) 
					listener.method.apply(listener.context, [rowObject]);
			}else if (this.parent && this.parent.ewiList) {
				this.parent.ewiList.toggleRunActions(rowObject, this.viewer.rowCheckedHandler.getRowCheckState(rowObject));
				this.parent.storeChangedSelectedScriptIds(rowObject);
			}
        }else if(columnIndex == 2){// update name
			rowObject.name = newValue;
			if (this.parent.inEditMode) {
				var listener = this.changeListener;
				if (listener && listener.method) 
					listener.method.apply(listener.context, [rowObject]);
			}
		}
    },
    
    cellActionInvoked: function(rowObject, columnIndex){}
});

// Summary:
// Specific class to handle row change.
//
dojo.declare("ExecutionWorkItemTableView.RowChangeAction", 
 com.ibm.rqm.planning.web.ui.internal.model.action.RowChangeAction, 
{
    actionTitle : Constants.getMessage("labelChangeTestCaseExecutionRecordProperties"),
    
    postChangeRequest : function(responseHandler, params) {
        params.resolveFullTestcase = false;
        params.resolveTestcase = false;
        params.resolveMinCurResult = true;
        params.resolveMinDefScript = true;
        params.resolveMinResult = true;
        ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, params);
    }
});

dojo.declare("ExecutionWorkItemTableView.TableProvider", 
             [com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionRecordTableProvider,
			 com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactContentProviderMixin],
{
    showTestCase: true,
    customEditable: false,
    labelUnassigned: Constants.getMessage("labelUnassigned"),
    labelBlocking: Constants.getMessage("msgHasBlockingDefect"),
    labelNonBlocking: Constants.getMessage("msgNoBlockingDefect"),
    labelNoDefect: Constants.getMessage("msgNoDefect"),

    labelId: Constants.getMessage("labelId"),
    labelName: Constants.getMessage("labelName"),
    labelCommunityRiskHeader:  Constants.getMessage("labelCommunityRiskHeader"),
    labelRiskAssessment: Constants.getMessage("labelRiskAssessment"),
    labelTestCase: Constants.getMessage("labelTestCase"),
    labelConfig: Constants.getMessage("labelConfig"),
    labelTestPlan: Constants.getMessage("labelTestPlan"),
    labelIteration: Constants.getMessage("labelIteration"),
    labelOwner: Constants.getMessage("labelOwner"),
    labelCreatedBy: Constants.getMessage("labelCreatedBy"),
    labelScript: Constants.getMessage("labelScript"),
    labelDefaultScript: Constants.getMessage("labelDefaultTS"),
    labelBlockingStatus: Constants.getMessage("labelBlockingStatus"),
    labelLastResult:  Constants.getMessage("labelLastResult"),
    labelLastMod: Constants.getMessage("labelLastMod"),
    labelWeight: Constants.getMessage("labelWeight"),
    labelLastResultMod: Constants.getMessage("labelLastResultMod"),
	labelLastResultCompleted: Constants.getMessage("labelLastResultCompleted"),
	labelPriority: Constants.getMessage("labelPriority"),
	labelEstimate: Constants.getMessage("labelEstimate"),
	labelTimeSpent: Constants.getMessage("labelTimeSpent"),
    labelDefects : Constants.getMessage("labelDefects"),
    labelAttempts: Constants.getMessage("labelAttempts"),
	labelPoints: Constants.getMessage("labelPoints"),
	labelPassedPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelPassedPoints")),
	labelFailedPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelFailedPoints")),
	labelBlockedPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelBlocked")),
	labelInconclusivePoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelInconclusive")),
	labelDeferredPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labeldeferred")),
	labelPermFailedPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelpermFailed")),
	labelAttemptedPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelAttempted")),
	labelTotalPoints: Constants.getMessage("labelPointsValue", Constants.getMessage("labelTotal")),
	labelTeamArea:Constants.getMessage("labelTeamArea"), 
	labelVirtualService: Constants.getMessage("labelDeploymentItem"),
	labelChannel:Constants.getMessage("labelChannels"),
	
	constructor: function(args) {
        dojo.mixin(this, args);
		this.buildColumns();
	},
	
	buildColumns: function(){
        if (!this.categoryTypes || !dojo.isArray(this.categoryTypes)) {
            throw new Error("Parameter 'categoryTypes' is REQUIRED!");
        }
		this.customAttribsId = [];
        
        // initialize our category types (in ArtifactContentProviderMixin class)
        this.setCategoryTypes(this.categoryTypes);
        
        var isVirtual = this.isVirtual;
        var notSortable = isVirtual ? false : true;                        
        var columns = [];
        
        // any changes to the columns also need to be made in the server class
	    // TestCaseExecutionRecordCSVService getDefaultColumns()
		// when a new column is added update toggleTableHeaderName() function
        // with the correct index for scriptColumn
		columns.push(this.toColumn(this.labelId, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_RICH_HOVER, 'id', true));
		columns.push(this.toColumn(this.labelPriority, 6, true, true, TableConstants.ALIGN_CENTER, EditableProperty.PRIORITY, 'priority', true));
        columns.push(this.toColumn(this.labelName, 12, false, true, TableConstants.ALIGN_LEFT, EditableProperty.NAME, 'name', true));
        columns.push(this.toColumn(this.labelCommunityRiskHeader, 8, false, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_RICH_HOVER, 'communityRisk', false));
        columns.push(this.toColumn(this.labelRiskAssessment, 8, false, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_RICH_HOVER, 'calculatedRisk', false));

        if (this.showTestCase) {
            columns.push(this.toColumn(this.labelTestCase, 8, true, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'testCaseName', true));
        }
              
        columns.push(this.toColumn(this.labelConfig, 8, true, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'configuration', true));
        columns.push(this.toColumn(this.labelTestPlan, 8, true, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'testPlanName', false));
        columns.push(this.toColumn(this.labelIteration, 8, true, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'testPhases', true));
        columns.push(this.toColumn(this.labelOwner, 8, true, true, TableConstants.ALIGN_LEFT, EditableProperty.CONTRIBUTOR, 'ownerUUIDs', true));
        columns.push(this.toColumn(this.labelCreatedBy, 8, true, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'createdBy', true, "originator", true));
		columns.push(this.toColumn(this.labelEstimate, 6, false, true, TableConstants.ALIGN_CENTER, EditableProperty.DURATION, 'estimate', false));
		columns.push(this.toColumn(this.labelTimeSpent, 6, false, true, TableConstants.ALIGN_CENTER, EditableProperty.DURATION, 'timeSpent', false));
		columns.push(this.toColumn(this.labelScript, 10, false, true, TableConstants.ALIGN_LEFT, "RenderType.ScriptSelector", 'defaultScriptName', true));
        columns.push(this.toColumn(this.labelBlockingStatus, 6, notSortable, notSortable, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_RICH_HOVER, 'isBlocking', false));
        var lastResCol = this.toColumn(this.labelLastResult, 6, true, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_RICH_HOVER, 'stateIds', true);
        lastResCol.headerAlignment = TableConstants.ALIGN_LEFT;
        columns.push(lastResCol);
		columns.push(this.toColumn(this.labelPassedPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'passedPoints', false));
		columns.push(this.toColumn(this.labelFailedPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'failedPoints', false));
		columns.push(this.toColumn(this.labelBlockedPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'blockedPoints', false));
		columns.push(this.toColumn(this.labelInconclusivePoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'inconclusivePoints', false));
		columns.push(this.toColumn(this.labelDeferredPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'deferredPoints', false));
		columns.push(this.toColumn(this.labelPermFailedPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'permFailedPoints', false));
		columns.push(this.toColumn(this.labelAttemptedPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'attemptedPoints', false));
		columns.push(this.toColumn(this.labelTotalPoints, 5, false, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'totalPoints', false));
		if(CommonUtil.isTeamAreaEnabled()){
			columns.push(this.toColumn(this.labelTeamArea, 8, false, true, TableConstants.ALIGN_CENTER, EditableProperty.TEAMAREA, 'teamArea', true, 'teamArea'));
		}
		columns.push(this.toColumn(this.labelChannel, 8, false, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'channelIds', false));
		var length = dojo.isArray(this.customAttributes) ? this.customAttributes.length : 0;
		this.customAttributeCol = columns.length;	
    	for(var i =0; i< length; i++){
    		var currentAttribute = this.customAttributes[i];    		
    		var render =  null;
    		var size = 0;
    		var cType = currentAttribute.type; 
    		var cName  = currentAttribute.name;
            
            if(cType == "MEDIUM_STRING" || cType == "SMALL_STRING"){
                render = EditableProperty.ATTR_TEXT;
                size = 8;
            }
            else if(cType == "INTEGER"){
                render = EditableProperty.ATTR_INTEGER;
                size = 8;
            }
            else if(cType == "TIMESTAMP"){
                render = EditableProperty.ATTR_TIMESTAMP;
    			size = 20;
    		}        	
    		
    		var col = this.toColumn(cName, size, false, true, TableConstants.ALIGN_LEFT, render, cName, false, cName);
			col.isCustomAttribute = true;
			this.customAttribsId[currentAttribute.itemId] = col;
			columns.push(col);
    	}
        
        var categoryTypes = this.getOrderedCategoryTypes();      
        var numCategories = categoryTypes.length;
		this.categoryCol = columns.length;
		if (numCategories > 0) {			
			var width = Math.min(Math.floor(30 / numCategories), 8);
			for (var i = 0; i < numCategories; i++) {
				var t = categoryTypes[i];
				var name = Constants.getMessage(t.name); // out of the box category name has translated value.
				var col = this.toColumn(name, width, true, true, TableConstants.ALIGN_LEFT, EditableProperty.CATEGORY, null, false, t.name);
				col.typeItemId = t.itemId;
				col.isCategory = true;
				columns.push(col);
	            // record the category's column index. 
	            this.setCategoryColumnIndex(this.categoryCol+i, t.itemId);
			}
		}
		columns.push(this.toColumn(this.labelWeight, 5, true, true, TableConstants.ALIGN_LEFT, EditableProperty.WEIGHT, 'weight', false));
		columns.push(this.toColumn(this.labelLastMod, 5, false, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'modified', true));
        columns.push(this.toColumn(this.labelLastResultMod, 8, false, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'resultModified', false));
		columns.push(this.toColumn(this.labelLastResultCompleted, 8, false, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'resultCompleted', false));

        if (this.showTestCase) {
            columns.push(this.toColumn(this.labelDefects, 8, false, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER_LIST, 'defects', false));
			if(this.enableAutomationConsumer)
				columns.push(this.toColumn(this.labelVirtualService, 8, false, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'virtualService', false));
        }
        this.COLUMNS = columns;
        
        if (this.showTestCase) {
            this.generalProfile = this.buildGeneralProfile();
            this.traceProfile = [];
            this.traceProfile.push({
                'index': 2,
                'name': "name",
                'width': 20
            });
            this.traceProfile.push({
                'index': 5,
                'name': "testCaseName",
                'width': 20
            });
            this.traceProfile.push({
                'index': columns.length - 2,
                'name': "defects",
                'width': 30
            });
			this.traceProfile.push({
				'index': columns.length - 1,
                'name': "virtualService",
                'width': 30
			});
        }
    },
   
    toColumn: function(name, width, groupable, sortable, alignment, type, rowName, isVisible, dbName, key) {
        return {
            name: name,
            width: width,
            groupable: groupable,
            sortable: sortable,
            alignment: alignment,
            type: type,
            rowName: rowName,
            isVisible: isVisible,
            dbName: dbName || rowName,
			key: key
        };
    },

    buildGeneralProfile: function() {
        var profile = [];
        var cols = this.COLUMNS;
        var len = cols.length;
        
        for(var i = 0; i < len; i++) {
            var col = cols[i];
            var colKey = this.getColumnKeyword(i);
            var colName = this.getColumnIdName(i);
            if (col.isVisible) {
                profile.push({
                    'index': i,
                    'name': colKey + colName,
                    'width': col.width
                });
            }
        }
        return profile;
    },

    isShowingTraceColumns: function() {    	
        var cols = this.tableViewer.tableViewer.columnsProfile;
        var len = cols ? cols.length : 0;
        
        for(var i = 0; i < len; i++) {
            var colName = cols[i].name;
            if(colName == 'defects') {
                return true;
            }
			if(colName == 'virtualService'){
				return true;
			}
        }
        return false;        
    },  
	
	getGroupColumnExtraData: function(groupContent, atColumnIndex)
	{
		if((atColumnIndex == 9 || atColumnIndex == 1 || atColumnIndex == 7 || atColumnIndex == 8 ||
					this.COLUMNS[atColumnIndex].isCategory) && this.showTestCase){
			var execStatus = null;
			if(atColumnIndex == 9){
				execStatus = this.tableViewer._getRowDataExecStatusData(groupContent.ownerItemId);
			}else if(atColumnIndex == 1){
				execStatus = this.tableViewer._getRowDataExecStatusData(groupContent.executionPriority.id);
			}else if(atColumnIndex == 7){
				execStatus = this.tableViewer._getRowDataExecStatusData(groupContent.testPlan? groupContent.testPlan.versionableItemId : "Unassigned"); //$NON-NLS-1$
			}else if(atColumnIndex == 8){
				execStatus = this.tableViewer._getRowDataExecStatusData(groupContent.phase? groupContent.phase.iterationItemId : "Unassigned"); //$NON-NLS-1$
			}else if(this.COLUMNS[atColumnIndex].isCategory){
				var categories = groupContent.categories;
				if(!categories){
					execStatus = this.tableViewer._getRowDataExecStatusData("Unassigned"); //$NON-NLS-1$
				}else{
					var length = categories.length;
					var categoryType = this.COLUMNS[atColumnIndex].typeItemId;
					for(var i = 0; i < length; i++){
						if(categoryType == categories[i].categoryType.itemId){
							execStatus = this.tableViewer._getRowDataExecStatusData(categories[i].itemId);
						}
					}
				}
			}
			var inputProvider = dojo.hitch(this, '_updateProvider');
			return this._getExecutionStatusGroupByField(groupContent, execStatus,inputProvider, this.tableViewer.getCustomSettings(), atColumnIndex);
		}
		return null;
	},
    
    getViewColumnsProfile: function(viewModeId) {
        if(viewModeId == 'general') {
            return this.generalProfile;
        }
        if(viewModeId == "traceability") {
            return this.traceProfile;
        }
        return null;
    },
	
	_updateProvider: function(providerData) {
        var value = providerData.owner ? providerData.owner : providerData.priority;
		if(!value){
			value = providerData.testPlanVersionableItemId ? providerData.testPlanVersionableItemId : providerData.testPhaseItemId;
			if(!value){
				value = providerData.category ? providerData.category : Constants.getMessage("labelUnassigned");
			}
		}
		var type = providerData.type;
		var execStatus = this.tableViewer._getRowDataExecStatusData(value);
		
		if(execStatus != null){
			return this._getProviderData(type,execStatus);
		}
        return this.UnavailableData;
    },
	
	getItemIdOfCategoryColumn:function(atColumnIndex){
		var column = this.COLUMNS[atColumnIndex];
		if(column && column.isCategory){
			return column.typeItemId;
		}else{
			return null;
		}
	},
	
	isCategoryColumn:function(atColumnIndex){
		var column = this.COLUMNS[atColumnIndex];
		if(column && column.isCategory){
			return true;
		}else{
			return false;
		}
	},
	
	getCategoryValueAtColumnIndex:function(groupContent, atColumnIndex){
		var column = this.COLUMNS[atColumnIndex];
		if(!column.isCategory){
			return null;
		}
		var categories = groupContent.categories;
		var categoryItemId = this.LabelUnassigned;
		if(categories){
			var length = categories.length;
			var categoryType = this.COLUMNS[atColumnIndex].typeItemId;
			for(var i = 0; i < length; i++){
				if(categoryType == categories[i].categoryType.itemId){
					categoryItemId = categories[i].itemId;
					break;
				}
			}
		}
		return categoryItemId;
	},

    getColumnKeyword: function(columnIndex){
		var column = this.COLUMNS[columnIndex];
		 if(column.isCategory){
		 	return "isCategoryColumn";
		 }else if(column.isCustomAttribute){
		 	return "isCustomColumn";
		 }else{
		 	return "";
		 }
	},	

    // Summary:
    // This method is called whenever a new content is set to the table viewer. Rebuild
    // the test script's values for all of the TERs. We need to pre-build this information
    // to ensure sorting of the test script column would produce the correct results. The
    // sort would need to be on the current selected test script in each of the row.
    //
    contentChangedNotify: function(content) {
		var changedSelectedScriptIdsList = this.parent.maintainSelectedScriptIds;
		var changedSelectedScriptIdsList_len = changedSelectedScriptIdsList.length;
		var showlastrunscript = CommonPreferenceClient.getExecutionPreference().showlastrunscript;
		if (!content) {
            // content can be null when table viewer is reset
            content = [];
        }
        var content_len = content.length;
		if(changedSelectedScriptIdsList_len > 0) {
			for(var i=0; i<changedSelectedScriptIdsList_len; i++) {
				var changedSelectedScriptId = changedSelectedScriptIdsList[i];
				for (var n = 0; n < content_len; n++) {
            		var rowData = content[n];
					if(rowData.id == changedSelectedScriptId.id) {						
							content[n].selectedScriptId = changedSelectedScriptId.selectedScriptId;						
						
					}
				}
			}
		}        
        for (var n = 0; n < content_len; n++) {
            var rowData = content[n];
            var val = {};
            val.select = null;
            var defaultScriptId = null;
            if(rowData.selectedScriptId)
                val.select = rowData.selectedScriptId;
            else if(rowData.currentResult && showlastrunscript == true) {
                if(rowData.currentResult.scriptVersionableItemId){
                    val.select = rowData.currentResult.scriptVersionableItemId;
                }else{
                    val.select = "-1";
                }
            }else if(rowData.defaultScript && rowData.defaultScript.versionableItemId){
                val.select = rowData.defaultScript.versionableItemId;
                defaultScriptId = rowData.defaultScript.versionableItemId;
            }
            var choices = [];
            var tc = rowData.testCase;
            var testscripts = tc ? tc.scripts : null;
            var ts_len = testscripts ? testscripts.length : 0;
            var curSelectIndex = -1;
            if (ts_len > 0) {
                var found = false;
                var defaultScriptFound = false;
                for (var i = 0; i < ts_len; i++) {
                	var testscript=testscripts[i];
                	var versionableItemId=testscript.versionableItemId;
                    if(!testscript.archived){
                        choices.push({
							text: testscript.name,
							value: versionableItemId,
							datapool: testscript.datapoolItemId,
							datapoolRecordSelection: testscript.datapoolRecordSelection});
                        if(val.select == versionableItemId){
                            found = true;
                            curSelectIndex = i;
                        }
                        if(versionableItemId == defaultScriptId){
                            defaultScriptFound = true;
                        }
                    }else{
                        if(rowData.selectedScriptId == versionableItemId){
                            rowData.selectedScriptId = null;
                        }   
                        if(val.select == versionableItemId){
                            found = false;
                        }   
                    }
                }
                if(!found && val.select != "-1"){
                    val.select = defaultScriptFound ? rowData.defaultScript.versionableItemId : "-1";
                }
                choices.push({text: LabelNone, value: "-1", datapool: "none", datapoolRecordSelection: "none"});
                if (!rowData.selectedScriptId) {
                    rowData.selectedScriptId = val.select ? val.select : (val.choices.length > 1 ? val.choices[0].value : "-1");
                }
            }else{
                choices.push({text: LabelNone, value: "-1", datapool: "none", datapoolRecordSelection: "none"});
                val.select = "-1";
                rowData.selectedScriptId = "-1";
            }
            // store the testscript values in the row object.
            val.choices = choices;
            rowData.testScriptValues = val;
            
            // get and store the current selected item's name.
            if(curSelectIndex == -1) {
                var choices_len = choices.length;
                for(var i = 0; i < choices_len; i++) {
                    if(val.select == choices[i].value) {
                        curSelectIndex = i;
                        break;
                    }
                }
            }
            rowData.selectedScriptName = choices[curSelectIndex].text;
			rowData.selectedScriptDatapoolItemId = choices[curSelectIndex].datapool;
			rowData.selectedScriptRecordSelection = choices[curSelectIndex].datapoolRecordSelection;
        }
    },
     
	getIsCellEditable: function(rowData, atColumnIndex){
/*
        var dbName = this.COLUMNS[atColumnIndex].dbName;

		if (dbName == "defaultScriptName") {
			if (this.isCustomEditable()) {
				var editableRows = this.getEditableRows();
				if (editableRows) {
					var len = editableRows.length;
					for (var j = 0; j < len; j++) {
						if (editableRows[j].id == rowData.id) {
							return true;
						}
					}
				}
				return false;
			}else {
				return true;
			}
		}
*/
		return false;
	},
	    
    getNumColumns: function(content){
        return this.COLUMNS.length;
    },
    
    getColumnHeading: function(content, index){
        return this.COLUMNS[index].name;
    },
  
    getColumnIdName: function(index) {
        return this.COLUMNS[index].dbName;
    },
	getColumnIndex: function(name) {
        for (var i = 0; i < this.COLUMNS.length; i++) {
            if (this.COLUMNS[i].name == name) {
                return i;
            }
        }
        return -1;
    },	
    getIndexByColumnIdName: function(dbName) {
        var columns = this.COLUMNS;
        var len = columns.length;
        
        for(var i = 0; i < len; i++) {
            if(columns[i].dbName == dbName) {
                return i;
            }
        }
        return -1;
    },
    
    getColumnHeadingImage: function(content, atColumnIndex){       
		if (this.parent.editable) {
            var col = this.COLUMNS[atColumnIndex];
            var dbName = col.dbName;
            var actionId = null;
            
            switch (dbName) {
                case "weight":
                    actionId = Constants.getMessage("labelWeight");
                    break;
                case "ownerUUIDs":
                    actionId = Constants.getMessage("labelOwner");
                    break;
                case "testPhases":
                    actionId = Constants.getMessage("labelIteration");
                    break;
                case "testPlanName":
                    actionId = Constants.getMessage("labelTestPlan");
                    break;
                case "stateIds":
                    actionId = Constants.getMessage("labelLastResult");
                    break;
				case "priority":
                    actionId = Constants.getMessage("labelPriority");
                    break;
				case "estimate":
                    actionId = Constants.getMessage("labelEstimate");
                    break;
				case "timeSpent":
                    actionId = Constants.getMessage("labelTimeSpent");
                    break;
				case "teamArea":
				if(CommonUtil.isTeamAreaEnabled()){
                    actionId = Constants.getMessage("labelTeamArea");
				}
                    break;
            }
            if (col.isCategory) {
                actionId = col.name;
            }
            if (actionId) {
                var img = {
                    actionId: actionId,
                    src: ImageCache.BULK_CHANGE,
                    disabled: true
                };
                img.tooltip = Constants.getMessage("labelChangeProperties", actionId);
                return img;
            }
        }
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        var col = this.COLUMNS[atColumnIndex];
        return col.headerAlignment || col.alignment;
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
        return this.COLUMNS[atColumnIndex].groupable;
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return this.COLUMNS[atColumnIndex].sortable;
    },
	
	getIsColumnVisible: function(atColumnIndex)
    {
        return this.COLUMNS[atColumnIndex].isVisible;
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        return this.COLUMNS[atColumnIndex].width;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        return this.COLUMNS[atColumnIndex].type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return this.COLUMNS[atColumnIndex].alignment;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var column = this.COLUMNS[atColumnIndex];
        var dbName = column.dbName;
        var val = "";
		var currentResult = rowData.currentResult;
        
        switch(dbName) {
            case "id":
				val = !rowData.isNew ? rowData.id : "";
				break;
			case "name": 
                val = rowData.name || "";
                break;
			case "communityRisk": 
                val = this.getRiskLevel(rowData.risk, "communityRisk");
                break;
			case "calculatedRisk": 
                val = this.getRiskLevel(rowData.risk, "calculatedRisk");
                break;
			case "testCaseName": 
                val = (rowData.testCase && rowData.testCase.name)? rowData.testCase.name : this.labelUnassigned; // TestCase Name
                break;
            case "configuration": 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : this.labelUnassigned; // Configuration
				break;          
            case "testPlanName": 
				val = (rowData.testPlan && rowData.testPlan.name) ? rowData.testPlan.name : this.labelUnassigned; // Test Plan
				break;
			case "testPhases":
				val = (rowData.phase && rowData.phase.name) ? rowData.phase.name : this.labelUnassigned;// Iteration
                break;
			case "ownerUUIDs": 
                val = (rowData.owner && rowData.owner.name)? rowData.owner.name:"Unassigned";// Owner
                if (val == "Unassigned") {
                    val = this.labelUnassigned;
                }
                break; 
			 case "originator":
            	var createdBy = rowData.createdBy || { itemId: '', name: '' };
            	// Shouldn't be unassigned... but still
            	val = CommonUtil.isUnassignedUserId(createdBy.itemId) ? LabelUnassigned : createdBy.name;            	
                break; 
			case "defaultScriptName":
                val = rowData.selectedScriptName || LabelNone; // Script
                break;
			case "isBlocking": 
                val = ""; // Blocking
                break;	
			case "stateIds":
			    val = rowData.currentResult && rowData.currentResult.state ? rowData.currentResult.state.name : Constants.getMessage("labelNotRun");// Last Result
			    break;
			case "modified": 
                var date = new Date();
                date.setTime(rowData.modified);
                val = date; // Last Modified
                break;	
            case "weight":
            	if (rowData.weight) {
					val = rowData.weight;
				} else {
					val = "";
				}
            	break;
			case "resultModified": 
				if (currentResult) {
					var date = new Date();
					date.setTime(currentResult.modified);
					val = date; // Last Modified
				}else{
					val = "";
				}
                break;
			case "priority":
				val = rowData.executionPriority ? rowData.executionPriority.name : "";
				break;
			case "passedPoints":
				val = currentResult ? currentResult.pointsPassed : "0";
				break;
			case "failedPoints":
				val = currentResult ? currentResult.pointsFailed : "0";
				break;
			case "blockedPoints":
				val = currentResult ? currentResult.pointsBlocked : "0";
				break;
			case "inconclusivePoints":
				val = currentResult ? currentResult.pointsInconclusive : "0";
				break;
			case "deferredPoints":
				val = currentResult ? currentResult.pointsDeferred : "0";
				break;
			case "permFailedPoints":
				val = currentResult ? currentResult.pointsPermFailed : "0";
				break;
			case "attemptedPoints":
				val = currentResult ? currentResult.pointsAttempted : "0";
				break;
			case "totalPoints":
				val = currentResult ? currentResult.weight : "0";
				break;
			case "estimate":
				val = DurationUtil.getTwoPartsLabel(rowData.estimate, true);
				break;
			case "timeSpent":
				val = DurationUtil.getTwoPartsLabel(rowData.timeSpent, true);
				break;
			case "resultCompleted": 
				if (rowData.currentResultEndTime && rowData.currentResultEndTime != "0") {
					var date = new Date();
					date.setTime(rowData.currentResultEndTime);
					val = date;
				}else{
					val = "";
				}
                break;
            case "defects":
                var curResult = rowData.currentResult;
                if (curResult && curResult.defectCount > 0) {
                    val = curResult.defectCount + "";
                }
                else {
                	val = "--";
                } 	
                break;                  
            case "teamArea":            	
                val = rowData.teamAreaName?rowData.teamAreaName:LabelUnassigned;
                break; 
			case "virtualService":
				val = rowData.virtualService && rowData.virtualService.summary ? rowData.virtualService.summary: "";
				break;
			 case "channelIds":
				val = this.getChannelNames(rowData);
				break;
            default:
				var currentColumn = this.COLUMNS[atColumnIndex];
				if (currentColumn.isCustomAttribute) {
					
					// not the default columns, so we will do a search to look
                    // for custom Attributes, always
		            // show unassigned for empty custom attributes
		            val = LabelUnassigned;        	
					var customAttributes = rowData.customAttributes;
					var length = (customAttributes && customAttributes.length) ? customAttributes.length : 0;
					for (var i = 0; i < length; i++) {
						var currentAttribute = customAttributes[i];
						var currentAttribId = currentAttribute.itemId;
						if ((currentAttribute && currentAttribId) && currentColumn == this.customAttribsId[currentAttribId]) {
							val = currentAttribute.value;
							if (currentColumn.type == TableConstants.RENDER_TYPE_TIMESTAMP) {
								var tempVal = new Date();
								tempVal.setTime(val);
								// Timestamp renderer is giving a hard time
                                // because it requires a very specific
                                // formatting, so for this case the best choice
                                // would be to parse the date manually
								val = NormalizeTimeStampString("" + tempVal);
							}
							break;
						}
					}
				}else{
					val = this.getCategoryByType(rowData, column.typeItemId) || "";
				}
		             
				break;
		}
        return val;
    },	
    
	getChannelNames: function(rowData)
    {
    	var channel = rowData.channels; 
    	
    	var channelNames = [];   	
    	channelNames.push(Constants.UNASSIGNED_CHANNEL_NAME);
    	if(channel != null){
    		var channelLen = channel.length;
	    	for(var j=0; j<channelLen; j++)
			{
	    		channelNames.push(channel[j].name);	    		
			}
    	}
		return channelNames.join(", ");
    },
    
    getCellRawData: function(rowData, atColumnIndex)
    {
        var column = this.COLUMNS[atColumnIndex];
        var dbName = column.dbName;
        var val = "";
		var currentResult = rowData.currentResult;
		if (column.isCustomAttribute) {
            //not the default columns, so we will do a search to look for custom Attributes             
            var customAttributes = rowData.customAttributes;
            var length = (customAttributes && customAttributes.length) ? customAttributes.length : 0;
            for (var i = 0; i < length; i++) {
                var currentAttribute = customAttributes[i];
                var currentAttribId = currentAttribute.itemId;
                if ((currentAttribute && currentAttribId) && column == this.customAttribsId[currentAttribId]) {
                    return currentAttribute.value;
                }
            }
            return val;
        }
		if(column.isCategory) {
		    return this.getCategoryByType(rowData, column.typeItemId) || "";
		}
		switch(dbName) {
			case "id":
				val = rowData.id;
				break;
            case "name": 
                val = (rowData.name || "");
                break;
            case "communityRisk": 
                val = this.getRiskLevel(rowData.risk, "communityRisk");
                break;
            case "calculatedRisk": 
                val = this.getRiskLevel(rowData.risk, "calculatedRisk");
                break;
            case "testCaseName": 
                val = (rowData.testCase?(rowData.testCase.id? rowData.testCase.id + ":":"") +   // id:name to  properly identify groups in the group collator
                		(rowData.testCase.name ? rowData.testCase.name:""): this.labelUnassigned); //TestCase Name                	
                break;
            case "configuration": 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : this.labelUnassigned; //Configuration
                break;          
            case "testPlanName": 
                val =(rowData.testPlan?(rowData.testPlan.id? rowData.testPlan.id + ":":"") + 
                		(rowData.testPlan.name ? rowData.testPlan.name:""): this.labelUnassigned); //Test Plan
                break;
            case "testPhases":
                val = (rowData.phase && rowData.phase.name) ? rowData.phase.name : this.labelUnassigned;// Iteration
                break;
            case "ownerUUIDs": 
                val = (rowData.owner && rowData.owner.name) ? rowData.owner.name : this.labelUnassigned;// Owner
                break; 
            case "defaultScriptName": 
                val = rowData.selectedScriptId != "-1" ? rowData.selectedScriptId : ""; // Script
                break;
            case "weight": 
                val = rowData.weight;
                break;  
			case "passedPoints":
				val = currentResult ? currentResult.pointsPassed : "";
				break;
			case "failedPoints":
				val = currentResult ? currentResult.pointsFailed : "";
				break;
			case "blockedPoints":
				val = currentResult ? currentResult.pointsBlocked : "";
				break;
			case "inconclusivePoints":
				val = currentResult ? currentResult.pointsInconclusive : "";
				break;
			case "deferredPoints":
				val = currentResult ? currentResult.pointsDeferred : "";
				break;
			case "permFailedPoints":
				val = currentResult ? currentResult.pointsPermFailed : "";
				break;
			case "attemptedPoints":
				val = currentResult ? currentResult.pointsAttempted : "";
				break;
			case "totalPoints":
				val = currentResult ? currentResult.weight : "";
				break;
            case "isBlocking": 
                if(rowData.defects && rowData.defects.length > 0){
                    val =  this.labelNonBlocking;
					var len = rowData.defects.length;
                    for(var i=0;i<len;i++){
                        if(rowData.defects[i].isBlocking){
                            val = this.labelBlocking;
							break;
                        }
                    }
                }else {
                    val = this.labelNoDefect;
                }
                break;  
            case "stateIds":
                val = rowData.currentResult ? rowData.currentResult.state.id : "none";
                break;
            case "modified": 
                val = rowData.modified;
                break;  
            case "resultModified": 
                val = rowData.currentResult ? rowData.currentResult.modified : "";
                break;
			case "priority":
				val = rowData.executionPriority ? rowData.executionPriority.id : "";
				break;
			case "estimate":
				val = rowData.estimate;
				break;
			case "timeSpent":
				val = rowData.timeSpent;
				break;
			 case "resultCompleted": 
                val = rowData.currentResultEndTime ? rowData.currentResultEndTime : "";
                break;
			 case "teamArea":
			     val = rowData.teamArea;
			     break;
			 case "channelIds":
				val = this.getChannelNames(rowData);
				break;
       }
        return val;
    },  
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var column = this.COLUMNS[atColumnIndex];
        var dbName = column.dbName;
        var val = null;
		if(dbName == "id" || dbName == "name") {
			val = this.getNameColExtendedData(rowData, (dbName == "name"));			
        }
		else if(dbName == "isBlocking") {
		    val = {};
			if(rowData.defects && rowData.defects.length > 0){
				val.image = ImageCache.NOIMAGE;
				val.tooltip = this.labelNonBlocking;
				val.alt = this.labelNonBlocking;;
				for(var i=0;i<rowData.defects.length;i++){
					if(rowData.defects[i].isBlocking){
						val.image = ImageCache.BLOCKING_DEFECT;
						val.tooltip = this.labelBlocking;
						val.alt = this.labelNonBlocking;
						return val;
					}
				}
			}else{
				val.image = ImageCache.NOIMAGE;
				val.tooltip = this.labelNoDefect;
				val.alt = this.labelNoDefect;
			}
        }
		else if(dbName == "communityRisk") {
            val = {};
			var level = this.getRiskLevel(rowData.risk, "communityRisk");
			var image = ImageCache.RISK_LEVELS[level];
            if (image) {
                val.image = image;
                var tooltip = RiskUtil.getRiskLabel(level);
                val.tooltip = tooltip;
				val.alt = tooltip;
            }
        }
		else if(dbName == "calculatedRisk") {
            val = {};
			var level = this.getRiskLevel(rowData.risk, "calculatedRisk");
			var image = ImageCache.RISK_LEVELS[level];
  			if (image) {
                val.image = image;
                var tooltip = RiskUtil.getRiskLabel(level);
                val.tooltip = tooltip;
				val.alt = tooltip;
			}
        }
		else if(dbName == "testCaseName") {
            val = {};
            if (rowData.testCase && rowData.testCase.name) {
                val = {
                    decorateImage: ImageCache.TEST_CASE,
                    label: rowData.testCase.name,
                    noUpdateLabel: true,
                    uri: CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_CASE, rowData.testCase.versionableItemId),
                    openInTab: true,
                    presentationUri: Utility.getTestCaseURI(rowData.testCase.id)
                };
            }
        }
		else if(dbName == "configuration"){
			val = {};
			if(rowData.config && rowData.config.id)
				val['href'] = ConfigurationUriUtil.getEditConfigurationURI(rowData.config.id);
		}
        else if(dbName == "testPlanName") {
            val = {};
            if (rowData.testPlan && rowData.testPlan.name) {
                val = {
                    label: rowData.testPlan.name,
                    noUpdateLabel: true,
                    decorateImage: ImageCache.TEST_PLAN,
                    uri: CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_PLAN, rowData.testPlan.versionableItemId),
                    openInTab: true,
                    presentationUri: rowData.testPlanSnapshotRevision ? PlanningUtility.getTestPlanURI({uid : rowData.testPlan.itemId, revision : rowData.testPlanSnapshotRevision}) :
										 PlanningUtility.getTestPlanURI({id: rowData.testPlan.id})
                };
            }
        }
		else if(dbName == "defaultScriptName") {
            val = {};
            if (rowData.selectedScriptId != "-1") {
                // no hover for no script
                val = {
                    decorateImage: ImageCache.TEST_SCRIPT,
                    label: rowData.selectedScriptName,
                    noUpdateLabel: true,
                    uri: CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_SCRIPT, rowData.selectedScriptId),
                    openInTab: true,
                    presentationUri: PlanningUtility.getTestScriptURI(/* id */null, /* perspective */null, /* revision */null, /* snapshotName */null, /* versionableItemId */rowData.selectedScriptId)
                    };
            }
            if (rowData.testCase && rowData.testCase.scripts){
                val.getOptions = dojo.hitch(rowData, function (rowData) {
                    var choices = [];
                    var tc = this.testCase;
                    var testscripts = tc ? tc.scripts : null;
                    var ts_len = testscripts ? testscripts.length : 0;
                    if (ts_len > 0) {
                        for (var i = 0; i < ts_len; i++) {
                            var testscript=testscripts[i];
                            var versionableItemId=testscript.versionableItemId;
                            if(!testscript.archived){
                                choices.push({
                                    name: testscript.name,
                                    value: versionableItemId
                                    });
                                }
                            }
                        }
                        choices.push({name: LabelNone, value: ""});
                        return choices;
                    });
            }

        }
        else if(dbName == "stateIds") {
            val = {};
            var currentResult = rowData.currentResult;
			var resultState = currentResult ? currentResult.state.id : null;
			var vScriptId = rowData.currentResultScritpId ? rowData.currentResultScritpId :
								(currentResult ? currentResult.scriptVersionableItemId : null);
            val.openInTab = true;
            val.noUpdateLabel = true;
			val.image = Utility.getImageForState(resultState);
            val.uri = currentResult ? CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_EXECUTION_RESULT, currentResult.itemId) : null;
			if((vScriptId != null) && (currentResult && !currentResult.archived) &&
					(resultState === ExecutionResultStates.IN_PROGRESS || resultState === ExecutionResultStates.PAUSED)){
				val.presentationUri = Utility.startExecution(rowData.itemId, currentResult.scriptVersionableItemId, currentResult.itemId, currentResult.requestId);
			}else{
				val.presentationUri = resultState ? Utility.getResultURI({resultItemId: currentResult.itemId}) : "javascript:{}";
			}
			val.tooltip = currentResult ? Utility.getResultsTooltip({result: currentResult, ewiItemId:rowData.itemId}) : Utility.getResultsTooltip();
			val.alt = val.tooltip;
        }
		else if(dbName == "priority"){
			val = rowData.executionPriority;
		}
		else if(dbName == "ownerUUIDs"){
            val = {name:rowData.ownerName, itemId:rowData.ownerItemId, userId:rowData.ownerUserId};
		}
        else if(dbName == "defects") {
            val = {};
            var curResult = rowData.currentResult;
            if(curResult && curResult.defects) {
                var defects = curResult.defects;
                var len = defects.length;
                var links = [];
                for (var i = 0; i < len; i++) {
                    var defect = defects[i].workItem;
                    var url = defect.itemId;
                    links.push({
                        label: defect.summary,
                        uri:url,
                        presentationUri: url
                    });
                }
                val.useNumericLabel = true;
                val.items = links;
            }
        }
		else if(dbName == "virtualService")
		{
			val = {};
			if(rowData.virtualService)
			{
				val = {
                    label: rowData.virtualService.summary,
                    uri: rowData.virtualService.uri,
                    presentationUri: rowData.virtualService.uri
                };
			}
			
		}     
		else if(dbName == "channelIds")
        {       
			val = this.getChannelNames(rowData);			
        }
        return val;
    },
	
	getNameColExtendedData: function(rowData, isName){
        var val = {};
        var isRemote = this.tableViewer.isRemote;
        var rootUrl = this.tableViewer.rootUrl;
        var projectAreaItemId = this.tableViewer.projectAreaItemId;
        if (!rowData.isNew) {
            val.label = isName ? rowData.name : rowData.id;
            val.noImage = !isName;
            val.noUpdateLabel = true;
            val.uri = CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_EWI, rowData.itemId, rootUrl, projectAreaItemId);
        }
		if (!isRemote) {
            val.openInTab = true;
            val.presentationUri = Utility.getEwiURI(rowData.id, null, null);
        }
        else {
            val.target = TableConstants.TARGET_RQM_FOR_REMOTE;
        }
        if (isName) {
            val.decorateImage = ImageCache.EWI;
            val.alt = LabelEWI;
        }
        return val;
    },
	
	setCustomEditable: function(flag,editableRows){
		this.customEditable = flag;
		if(flag && editableRows)
			this.editableRows = editableRows;
	},
    getEditableRows:function(){
		return this.editableRows;
	},
	isCustomEditable: function(){
		return this.customEditable;
	},	
	
    doRowUpdate: function(rowObject, newData, tableRefreshCallback){
        var callbackArgs = {
                provider: this,
                rowObject: rowObject,
                tableRefreshCallback: tableRefreshCallback
        };
        // there are now dependencis on existing column names so we cannot change then to be "correct"
        // lets do some translation here
        if (newData.priority) newData.executionPriority = newData.priority;
        if (newData.ownerUUIDs) newData.owner = newData.ownerUUIDs.userId;
        if (newData.defaultScriptName) {
            newData.defaultScript = newData.defaultScriptName.value;
            newData.defaultScriptName = "";
        } else {
            // must send default script or its deleted
            newData.defaultScript = rowObject.selectedScriptId;
        }
        if (!newData.teamArea && rowObject.teamArea) {
        	newData.teamArea = rowObject.teamArea;// we must pass along team area or it will be cleared
        } else if (newData.teamArea) {
        	newData.updateTeamArea = true;
        	if (newData.teamArea == Constants.UNASSIGNED_TEAMAREA_CONSTANT_VALUE) {
            	newData.teamArea = ""; // this will clear team area
            }
        }
       
        // special handling for custom attribute
        var customAttributesJson = this._buildCustomAttributesJsonForUpdate(rowObject, this.customAttributes, newData);
        if (customAttributesJson) {
            newData.customAttributesJson = customAttributesJson;
        }
        // process the category values
        this.processCategoryCellEdits(rowObject, newData);
        if(newData.categories != undefined) {
            callbackArgs.updateCategories = true;
        }
        
        var action = new ExecutionWorkItemTableView.RowChangeAction({
            completeCallback: dojo.hitch(callbackArgs, function(updatedArtifact){
                var callbackArgs = this;
                for (var i = 0; i < callbackArgs.provider.COLUMNS.length; i++) {
                    var colInfo = callbackArgs.provider.COLUMNS[i];
                    if (colInfo.isCustomAttribute){
                        // we'll grab all custom attrs later
                        continue;
                    }
                    var name = colInfo.dbName; 
                    if (name == "ownerUUIDs"){
                        callbackArgs.rowObject.owner = updatedArtifact["owner"];
                        if (callbackArgs.rowObject.owner){
                            callbackArgs.rowObject["ownerItemId"] = callbackArgs.rowObject.owner.itemId;
                            callbackArgs.rowObject["ownerName"] = callbackArgs.rowObject.owner.name;
                            callbackArgs.rowObject["ownerUserId"] = callbackArgs.rowObject.owner.userId;
                        }
                    } else if (name == "priority"){
                        callbackArgs.rowObject["executionPriority"] = updatedArtifact["executionPriority"];
                    } else if (name == "defaultScriptName"){
                        if (updatedArtifact.defaultScript){
                            callbackArgs.rowObject.selectedScriptName = 
                                callbackArgs.rowObject.defaultScriptName = updatedArtifact.defaultScript.name;
                            callbackArgs.rowObject.selectedScriptId = 
                                callbackArgs.rowObject.defaultScriptId = updatedArtifact.defaultScript.versionableItemId;
                            callbackArgs.rowObject.defaultScriptType = updatedArtifact.defaultScript.scriptType.id;
                        } else {
                            callbackArgs.rowObject.selectedScriptName = null;
                            callbackArgs.rowObject.selectedScriptId = "-1";
                        }
                    } else if (name == "teamArea"){
                        callbackArgs.rowObject[name] = updatedArtifact[name];
                        callbackArgs.rowObject["teamAreaName"] = updatedArtifact["teamAreaName"];
                    } else {
                        callbackArgs.rowObject[name] = updatedArtifact[name];
                    }
                }
                callbackArgs.rowObject["customAttributes"] = updatedArtifact["customAttributes"];
                if(callbackArgs.updateCategories) {
                    callbackArgs.rowObject["categories"] = updatedArtifact["categories"];
                }
                callbackArgs.tableRefreshCallback();
            }),
            errorCallback: dojo.hitch(callbackArgs, function(error){
                callbackArgs.tableRefreshCallback();
            })
        });
        action.execute(rowObject["itemId"], newData);
    }

});


dojo.declare("DashboardExecutionWorkItemTableView.TableProvider",[ExecutionWorkItemTableView.TableProvider],
{
	profile: null,
	
	buildColumns: function(){
		this.COLUMNS_ALL = {
			NAME: this.toColumn(Constants.getMessage("labelName"), 20, true, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'name', true),
            TCER_ESTIMATES: this.toColumn(this.labelEstimate, 25, false, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_PROGRESS_BAR, 'estimate', true, null, 'exec'),
            TCER_ATTEMPTS: this.toColumn(this.labelAttempts, 25, false, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_PROGRESS_BAR, 'count', true, null, 'exec'),
            TCER_POINTS: this.toColumn(this.labelPoints, 25, false, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_PROGRESS_BAR, 'point', true, null, 'exec')
        };      

		this.COLUMNS = [this.COLUMNS_ALL.NAME, this.COLUMNS_ALL.TCER_ESTIMATES, this.COLUMNS_ALL.TCER_ATTEMPTS, this.COLUMNS_ALL.TCER_POINTS];
	},
	getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    
    getIsSettingChangeableForColumn: function(atColumnIndex) {
        return atColumnIndex > 0;
    },

    getCellDisplayData: function(rowData, atColumnIndex, nChildRow){
        var val = "";
        var column = this.COLUMNS[atColumnIndex];
        
        if (column.name == this.COLUMNS_ALL.NAME.name) {
            val = rowData.owner ? rowData.owner.name : rowData.ownerUUID;
        }
        return val;
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex, nChildRow)
    {
        var val = {};
        var column = this.COLUMNS[atColumnIndex];

        if(column.key == 'exec') {
            return this.getExecCellDisplayExtendedInfo(atColumnIndex, rowData, nChildRow);
        }
        return val;
    },

    isExpandableRow: function() 
    {
        return false;
    },
	
	getExecCellDisplayExtendedInfo: function(atColumnIndex, rowData, nChildRow)
    {
        var val = {};
        var column = this.COLUMNS[atColumnIndex];
        var colName = column.name;
        var table = this.tableViewer.tableViewer;
        
        // the test suite is a pending item, don't show any
        // execution data.
        if (table.isItemInPendingState(rowData)) {
            return val;
        }
        
        
        switch (colName) {
            case this.COLUMNS_ALL.TCER_ESTIMATES.name:
            case this.COLUMNS_ALL.TCER_ATTEMPTS.name:
            case this.COLUMNS_ALL.TCER_POINTS.name:
				val = this._getProviderData(column.rowName,rowData);
                
        }
        return val;
    }

});


dojo.declare("ExecutionWorkItemTableView.TableFilterProvider", 
    com.ibm.rqm.planning.web.ui.internal.view.table.ExplorableTableFilterProvider,
{
    artifactTypeQueryKey: FiltersQueriesClient.TER_QUERY_KEY,

    constructor: function(args) {
        dojo.mixin(this, args);

        // define the static filters
        this.filters = [
          {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
				type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescription", Constants.getMessage("labelEWIs"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
	
   filterRunActionInvoked: function(actionName, filters){
        var args = {};
        var allCategories = [];
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                if (nameKey == "weight") {
                    args['weightComparator'] = filters[nameKey].operator;
 					args['weightValue'] = filters[nameKey].value;
                }else if (nameKey == "passedPoints") {
                    args['passedPointComparator'] = filters[nameKey].operator;
 					args['passedPointValue'] = filters[nameKey].value;
                }else if (nameKey == "failedPoints") {
                    args['failedPointComparator'] = filters[nameKey].operator;
 					args['failedPointValue'] = filters[nameKey].value;
                }else if (nameKey == "blockedPoints") {
                    args['blockedPointComparator'] = filters[nameKey].operator;
 					args['blockedPointValue'] = filters[nameKey].value;
                }else if (nameKey == "inconclusivePoints") {
                    args['inconclusivePointComparator'] = filters[nameKey].operator;
 					args['inconclusivePointValue'] = filters[nameKey].value;
                }else if (nameKey == "deferredPoints") {
                    args['deferredPointComparator'] = filters[nameKey].operator;
 					args['deferredPointValue'] = filters[nameKey].value;
                }else if (nameKey == "permFailedPoints") {
                    args['permFailedPointComparator'] = filters[nameKey].operator;
 					args['permFailedPointValue'] = filters[nameKey].value;
                }else if (nameKey == "attemptedPoints") {
                    args['attemptedPointComparator'] = filters[nameKey].operator;
 					args['attemptedPointValue'] = filters[nameKey].value;
                }else if (nameKey == "totalPoints") {
                    args['totalPointComparator'] = filters[nameKey].operator;
 					args['totalPointValue'] = filters[nameKey].value;
                }else if (nameKey == "estimate") {
                    args['estimateComparator'] = filters[nameKey].operator;
                    args['estimateValue'] = filters[nameKey].value;
                }else if (nameKey == "timeSpent") {
                    args['timeSpentComparator'] = filters[nameKey].operator;
                    args['timeSpentValue'] = filters[nameKey].value;
                }else  if(nameKey == "isBlocking"){   //avoid sending a "" value for isBlocking when "Any" is selected
                	if(filters["isBlocking"]!="Any@@"){
                		args["isBlocking"] = filters[nameKey];
                	}
                } else if (nameKey.indexOf("categories") == 0) {
                    // filter name has "categories" prefix, flatten all selected categories 
                    // into an array of comma separated strings. The list of selected categories
                    // need to be preceeded by its type's id. Locate the filter record and get
                    // the type id.
                    var values = filters[nameKey];
                    if (values && values.length > 0) {
                        var category = this.getFilterByName(this.filters, nameKey);
                        var catFilter = category.uniqueId + ":" + values.join(",");
                        allCategories.push(catFilter);
                    }
                } else {
                    args[nameKey] = filters[nameKey] || "";
                    if (args[nameKey] == 'Any@@') 
                        args[nameKey] = '';
                }
            }
        }
        // add the flattened categories array to the args if there is any defined
        if (allCategories.length > 0) {
            args["categories"] = allCategories;
        }
		// reset the paging for new query
        this.tableView.queryToken = null;
        this.tableView.runQuery(args);
    }
});

/*
dojo.declare("ExecutionWorkItemTableView.ArtifactActionProvider", 
		com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactActionProvider,
	{

    getActions: function(actionCtrl){
    	
    	var virtualTotal = this.contentProvider.vcGetContentItemCount ? this.contentProvider.vcGetContentItemCount(): 0;
    	var selection = this.tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
        var selectionCount;
        if(selection == TableConstants.VIRTUAL_CONTENT_SELECT_ALL) {
            selectionCount = virtualTotal - this.tableViewer.rowCheckedHandler.virtualContentGetDeselectedRows().length;
        }
        else {
            selectionCount = selection.length;
        }
        

    	var actions = this.actionList;//Modify the actions list to show channel based information
    	//Find the execute-icon-image -> execute - subactions->actions
    	var actionsLen = actions.length;
    	var executeAction = null
    	for(var i=0;i<actionsLen;i++){
    		if(actions[i].actionId == "execute-icon-image"){
    			executeAction = actions[i];
    			break;
    		}
    	}
    	
    	var executeSubActions = executeAction.subActions.actions;
    	var executeSubActionsLen = executeSubActions.length;
    	var runAction = null;
    	for(var i=0;i<executeSubActionsLen;i++){
    		if(executeSubActions[i].actionId == "execute"){
    			runAction = executeSubActions[i];
    			break;
    		}
    	}
    	if(selectionCount == 1 && realSelection){        	
    		runAction.disabled = false;
    		runAction.isSubMenu = true;
    		runAction.subActions.actions = this.parentView.getMenuOptionsForChannels(selection[0].channels);
        }else{
//        	runAction.subActions = null;
        	runAction.disabled = true;
        	runAction.isSubMenu = false;
        	//remove all actions for channels and return the list.
        }
    	
    	return this.inherited("getActions", arguments);
    },

	
	});
*/

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView", 
    com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionRecordTableView,
{    
    editable: true,
    printable: false,
    pdfPrintType: "executionworkitem",  // define the pdf print type. Our super class will handle it.
    exploreSavedQueries: true,
    exploreCategory: true,
    explorableArtifactType: Constants.MODEL_TYPE_TESTCASE_EXECUTION_RECORD,
    enableExternalFilters: true,
	includeCustomAttributes: true,
	rowsSelectable: null,
    viewProfile: null,

    explorableBaseArtifactType: Constants.MODEL_TYPE_CASE,
	explorableBaseArtifactKey: 'TC-CATEGORIES',
    explorableBaseArtifactLabel: Constants.getMessage("labelFilterByTCCategories"),
    
    // by default enable test plan filter.
    testplanFilterName: "testPlanName",
    useTestPlanFilter: true,
    
	// For TCER list, after refreshing, should update related info widget
	refreshCallback: null,
	
    constructor: function() {
        this.actions = [];
        this._actionButtons = [];
	 	this.executionWorkItems = [];
		this.queryName = null;
		this.executable = false;
        this.showTestCase = true;
		this._itemsToTrack = {};
		this.contentAfterEdit = [];
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
        this.filterArgs = null;
		this.customAttributes = [];
		this.maintainSelectedScriptIds = [];
		this.refreshCallback = null;
		this.initExecutionPreference();
	 },
	 
	 initExecutionPreference: function(){
			var self = this;
			var callback = {
				success: function(executionPref){
					var preferences = executionPref && executionPref.value ? dojo.fromJson(executionPref.value) : {};
					self.setCreateTCERsWithTSERPreference(preferences.createTCERsWithTSER);				
				},
				failure: function(){
					console.error("Unable to load execution pref");
				}
			}
			var option = new com.ibm.asq.common.web.client.internal.option();
			var handler = new ServiceResponseHandler(callback, "success", "failure");
			option.getProjectPreferences(handler, getCurrentProjectArea().itemId, Constants.EXECUTION_SYSTEM_CONSTRAINTS);
		},
		
		setCreateTCERsWithTSERPreference: function(preference)
		{
			this.isCreateTCERsWithTSEREnabled = preference;
		},

    postCreate: function() {
        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
        this.skipUpdateOnQuerySelectionChanged = !this.queryName;

        this.inherited("postCreate", arguments);

    	this._supportsArtifactSummary= true;
    	this._supportsComprehensive = true;
    	this._supportsHistory = true; 
    	this._supportsTableSummary =  true;

		this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		
        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(ExecutionWorkItemClient, "getAllSearchResultItemIds");

		// set options for search filters
        this.setSearchFunction(this.getTableSearchFunction());
		this.setSearchCallback(dojo.hitch(this, "show"));
        this.setResponseHandlerType(this.getResponseHandlerClass());
        // apply the user preference whether to initially open the filter area
        if (this.isInPicker || this.showQueryFilters) {
	        this.setTypeLabel(Constants.getMessage("labelEWIs"));					
        }
        
        if (!this.projectAreaItemId) {
        	this.projectAreaItemId = jazz.app.context.get().itemId;
        }
        
		ArtifactPriorities.initializePriorities(dojo.hitch(this, "callCompositeWeb"), this.projectAreaItemId);

    },
    callCompositeWeb: function() {
		var responseHandler = new ServiceResponseHandler(this, "afterCompositeWeb", "_error"); 

        CompositeWebClient.getBrowseInitInfo(responseHandler,this.projectAreaItemId,CompositeWebClient.TYPE_TCER);
    },
    
    afterCompositeWeb: function(data) {
    	ConstraintsUtil.setConstraints(this.projectAreaItemId, data.advisorsEnabledForSave, Constants.MODEL_TYPE_CASE);
    	this._setCustomAttributes(data.customAttributes);
    	this._initialize(data);
    },
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    },  

	getTableSearchFunction: function(){
		return dojo.hitch(ExecutionWorkItemClient, "searchExecutionWorkItemPrefCheck");
	},
	
	getResponseHandlerClass: function(){
		return EWIMapper;
	},
	
    _setCustomAttributes: function(items){
		var self = this;
		dojo.forEach(items, function(item){
			self.customAttributes.push(item);
		});
		
    },
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function(data){
    	var categoryTypes = data.categoryTypes;
        this.categoryTypes = categoryTypes || [];

        // create the filter provider for the table
        this.filterProvider = new ExecutionWorkItemTableView.TableFilterProvider({
            tableView: this,
			projectAreaItemId: this.projectAreaItemId,
            initOpenFilter: this.isInitiallyOpen(),            
            saveQueriesSupport: this.exploreSavedQueries,
            onSavedQuerySaved: dojo.hitch(this, "onSavedQuerySaved"),
            queryFilters: data.queryFilters || []
        });
        
        var filters = this.filterProvider.filters;
		
		// initlize the priority filter
        var priorityFilter = {
            // filterName, filterLabel, filterPrompt, filterType, callback
            name: "priority",
            label: Constants.getMessage("labelPriorityLabel"),
            prompt: Constants.getMessage("labelPriority"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST
        };
        // need to wait until the filter's values comes back before finalizing the initialization
        this.addArtifactPriorityFilter(priorityFilter, filters, ArtifactPriorities.Priorities);
		
		this.addTimelineIterationFilter(filters, "testPhases");
        filters.push({
            name: "id", // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });
        filters.push({
            name: "configuration", // must match key in the arg list of the API
            title: Constants.getMessage("labelConfig") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelConfig"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null,
            params: null
        });
        filters.push({
            name: "isBlocking", // must match key in the arg list of the API
            title: Constants.getMessage("labelBlockingStatus") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelBlockingStatus"),
            type: TableContentFilterProvider.FIELD_ENUM,
            defaultValue: 'Any@@',
            params: [{
                name: Constants.getMessage("labelAnyCap"),
                value: 'Any@@'
            }, {
                name: Constants.getMessage("labelBlocking"),
                value: 'true'
            }, {
                name: Constants.getMessage("labelNonBlocking"),
                value: 'false'
            }]
        });
        filters.push({
			name: "defects",
			title: Constants.getMessage("labelDefectsWithColon"),
			promptTitle: Constants.getMessage("labelDefectsWithColon"),
			type: TableContentFilterProvider.FIELD_ENUM,
			defaultValue: "",
            showInSelectorTrim: false,
			params: [{
				name:  Constants.getMessage("labelAnyCap"),
				value: ""
			}, {
				name:  Constants.getMessage("labelHasDefect"),
				value: Constants.HAS_LINK
			}, {
				name:  Constants.getMessage("labelDoesNotHaveDefect"),
				value: Constants.HAS_NO_LINK
			}]
        });
        filters.push({
			name: "virtualService",
			title: Constants.getMessage("labelDeploymentPlanWithColon"),
			promptTitle: Constants.getMessage("labelDeploymentPlanWithColon"),
			type: TableContentFilterProvider.FIELD_ENUM,
			defaultValue: "",
            showInSelectorTrim: false,
			params: [{
				name:  Constants.getMessage("labelAnyCap"),
				value: ""
			}, {
				name:  Constants.getMessage("labelHasDeploymentPlan"),
				value: Constants.HAS_LINK
			}, {
				name:  Constants.getMessage("labelDoesNotHaveDeploymentPlan"),
				value: Constants.HAS_NO_LINK
			}]
        });
        // add the risk filters
        var calculatedRiskFilter = {
            name: "calculatedRisk", // must match key in the arg list of the API
            label: Constants.getMessage("labelRiskAssessment") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelRiskAssessment")
        };
        this.addRiskFilter(calculatedRiskFilter, filters);
        
        var communityRiskFilter = {
            name: "communityRisk", // must match key in the arg list of the API
            label: Constants.getMessage("labelCommunityRiskHeader") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelCommunityRiskHeader")
        };
        this.addRiskFilter(communityRiskFilter, filters);
        
        // add the test script filter
        var testScriptFilter = {
            name: "defaultScriptName", // must match what the filter provider looks for
            label: Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelTestScript"),
            artifactType: Constants.MODEL_TYPE_SCRIPT,
            useUnassigned: false,
            legacyKey: "vScriptUUIDs"
        };
        this.addAdvancedArtifactFilter(testScriptFilter, filters);
        
        // add the test case filter
        var testCaseFilter = {
            name: "testCaseName", // must match what the filter provider looks for
            label: Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelTestCase"),
            artifactType: Constants.MODEL_TYPE_CASE,
            useUnassigned: false,
            useItemId: true,
            legacyKey: "vTestCaseUUIDs"
        };
        this.addAdvancedArtifactFilter(testCaseFilter, filters);
        
        // add the test plan filter
        if (this.useTestPlanFilter) {
            var testPlanFilter = {
                name: this.testplanFilterName, // must match what the filter provider looks for
                label: Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen"),
                prompt: Constants.getMessage("labelTestPlan"),
                artifactType: Constants.MODEL_TYPE_PLAN,
                useUnassigned: true,
                unassignedLabel: UnassignedTestPlanLabel,
                legacyKey: "vTestPlanItemIds"
            };
            var advancedParams = {
                showChildPlans: false
            };
            this.addAdvancedArtifactFilter(testPlanFilter, filters, advancedParams);
        }
        
        var labelCreatedBy = Constants.getMessage("labelCreatedBy");
        // get the list of contributors for originator and owner filters
        filters.push({
            name: "originatorUUIDs",
            dbName: "originator",
            title: labelCreatedBy,
            promptTitle: labelCreatedBy,
            params : {
                projectAreaItemId: this.projectAreaItemId
            },
            type: TableContentFilterProvider.FIELD_CONTRIBUTOR_TOGGLELIST,
            defaultValue: []
        });
        
        if (this.viewProfile != 'dashboard-exec') {
	        filters.push({
	            name: "ownerUUIDs", // must match key in the arg list of the API
	            title: Constants.getMessage("labelowner"),
	            promptTitle: Constants.getMessage("labelOwner"),
				params : {
                	projectAreaItemId: this.projectAreaItemId
            	},
	            type: TableContentFilterProvider.FIELD_CONTRIBUTOR_TOGGLELIST,
	            defaultValue: []
	        });
		}
        
        this.weightFilter = {
            name: "weight",
            title: Constants.getMessage("labelWeight") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelWeight"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.weightFilter);
		 
		 this.passedPointFilter = {
            name: "passedPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelPassedPoints")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelPassedPoints")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.passedPointFilter);
		 
		 this.failedPointFilter = {
            name: "failedPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelFailedPoints")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelFailedPoints")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.failedPointFilter);
		 
		 this.blockedPointFilter = {
            name: "blockedPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelBlocked")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelBlocked")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.blockedPointFilter);
		 
		 this.inconclusivePointFilter = {
            name: "inconclusivePoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelInconclusive")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelInconclusive")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.inconclusivePointFilter);
		 
		 this.deferredPointFilter = {
            name: "deferredPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labeldeferred")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labeldeferred")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.deferredPointFilter);
		 
		 this.permFailedPointFilter = {
            name: "permFailedPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelpermFailed")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelpermFailed")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.permFailedPointFilter);
		 
		 this.attemptedPointFilter = {
            name: "attemptedPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelAttempted")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelAttempted")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.attemptedPointFilter);
		 
		 this.totalPointFilter = {
            name: "totalPoints",
            title: Constants.getMessage("labelPointsValue", Constants.getMessage("labelTotal")) + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelPointsValue", Constants.getMessage("labelTotal")),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {
                    'showNumericOperators': true
                }
            }
        };
         filters.push(this.totalPointFilter);
		 
		 this.estimateFilter = {
            name: "estimate",
            title: Constants.getMessage("labelEstimate:"),
            promptTitle: Constants.getMessage("labelEstimate"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormDurationField",
                fieldArgs: {
                    'showNumericOperators': true,
					'useShortForm': true,
					'isReadOnly': false
                }
            }
        };
        filters.push(this.estimateFilter);
		 
		this.timeSpentFilter = {
            name: "timeSpent",
            title: Constants.getMessage("labelTimeSpent") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelTimeSpent"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormDurationField",
                fieldArgs: {
                    'showNumericOperators': true,
					'useShortForm': true,
					'isReadOnly': false
                }
            }
        };
        filters.push(this.timeSpentFilter);
		
		// add the modified time filter
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modified", // must match what the filter provider looks for
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: Constants.getMessage("labelLastMod") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelLastMod")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, filters);
        // add the last result modified time filter
		var datetimeRangeFilter = {
            name: "resultModified",
            title: Constants.getMessage("labelLastResultMod") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelLastResultMod"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 350,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateTimeRangeField"
            }
        };
        filters.push(datetimeRangeFilter);
		
		// add the last result completed time filter
		var datetimeRangeFilterOnLastResultCompleted = {
            name: "resultCompleted",
            title: Constants.getMessage("labelLastResultCompleted") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelLastResultCompleted"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 350,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateTimeRangeField"
            }
        };
        filters.push(datetimeRangeFilterOnLastResultCompleted);
		
		// initlize the execution state filter
        var statesFilter = {
            // filterName, filterLabel, filterPrompt, filterType, callback
            name: "stateIds",
            label: Constants.getMessage("labelLastResult") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelLastResult"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST
        };
		// need to wait until the filter's values comes back before finalizing the initialization
        this.setExecutionStateFilter(statesFilter, this.filterProvider.filters, data.executionResultStates);    
		    
        //add Channel filters
        this.addChannelFilter(filters, "channelIds");

      // add Team Area filters
        if(CommonUtil.isTeamAreaEnabled()){
        	this.addTeamAreaFilter(filters, "teamArea");
        }
        // Initialize filters for Categories
        this.currentCategoryFilters = CategoryUtil.getCategoryTypesFilters(this._getCategoryValuesLoader(), 'loadCategoryValues', categoryTypes);
        for (var j = 0; j < this.currentCategoryFilters.length; j++) {
            filters.push(this.currentCategoryFilters[j]);
		}
		filters = this._addCustomAttributesFilterSupport(filters);
    },	
	
    _remapQueryArgs: function(cachedFilterArgs) {
        var filterArgs = this.inherited("_remapQueryArgs", arguments);
        var filterArgsCloned = false;
        
		if (filterArgs["passedPoints"]) {
			var value = Number(filterArgs["passedPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["passedPoints"].value != "") {
	            filterArgs["passedPointComparator"] = filterArgs["passedPoints"].operator;
				filterArgs["passedPointValue"] = filterArgs["passedPoints"].value;
			}
			delete filterArgs["passedPoints"];
        }
		if (filterArgs["failedPoints"] != null) {
			var value = Number(filterArgs["failedPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["failedPoints"].value != "") {
            	filterArgs["failedPointComparator"] = filterArgs["failedPoints"].operator;
				filterArgs["failedPointValue"] = filterArgs["failedPoints"].value;
			}
			delete filterArgs["failedPoints"];
        }
		if (filterArgs["blockedPoints"] != null) {
			var value = Number(filterArgs["blockedPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["blockedPoints"].value != "") {
            	filterArgs["blockedPointComparator"] = filterArgs["blockedPoints"].operator;
				filterArgs["blockedPointValue"] = filterArgs["blockedPoints"].value;
			}
			delete filterArgs["blockedPoints"];
        }
		if (filterArgs["inconclusivePoints"] != null) {
			var value = Number(filterArgs["inconclusivePoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["inconclusivePoints"].value != "") {
            	filterArgs["inconclusivePointComparator"] = filterArgs["inconclusivePoints"].operator;
				filterArgs["inconclusivePointValue"] = filterArgs["inconclusivePoints"].value;
			}
			delete filterArgs["inconclusivePoints"];
        }
		if (filterArgs["deferredPoints"] != null) {
			var value = Number(filterArgs["deferredPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["deferredPoints"].value != "") {
            	filterArgs["deferredPointComparator"] = filterArgs["deferredPoints"].operator;
				filterArgs["deferredPointValue"] = filterArgs["deferredPoints"].value;
			}
			delete filterArgs["deferredPoints"];
        }
		if (filterArgs["permFailedPoints"] != null) {
			var value = Number(filterArgs["permFailedPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["permFailedPoints"].value != "") {
            	filterArgs["permFailedPointComparator"] = filterArgs["permFailedPoints"].operator;
				filterArgs["permFailedPointValue"] = filterArgs["permFailedPoints"].value;
			}
			delete filterArgs["permFailedPoints"];
        }
		if (filterArgs["attemptedPoints"] != null) {
			var value = Number(filterArgs["attemptedPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["attemptedPoints"].value != "") {
            	filterArgs["attemptedPointComparator"] = filterArgs["attemptedPoints"].operator;
				filterArgs["attemptedPointValue"] = filterArgs["attemptedPoints"].value;
			}
			delete filterArgs["attemptedPoints"];
        }
		if (filterArgs["totalPoints"] != null) {
			var value = Number(filterArgs["totalPoints"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["totalPoints"].value != "") {
            	filterArgs["totalPointComparator"] = filterArgs["totalPoints"].operator;
				filterArgs["totalPointValue"] = filterArgs["totalPoints"].value;
			}
			delete filterArgs["totalPoints"];
        }
		if (filterArgs["estimate"] != null) {
			var value = Number(filterArgs["estimate"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["estimate"].value != "") {
	            filterArgs["estimateComparator"] = filterArgs["estimate"].operator;
	            filterArgs["estimateValue"] = filterArgs["estimate"].value;
			}
			delete filterArgs["estimate"];
        }
		if (filterArgs["timeSpent"] != null) {
			var value = Number(filterArgs["timeSpent"].value);
            if (!isNaN(value) && value >= 0 && filterArgs["timeSpent"].value != "") {
	            filterArgs["timeSpentComparator"] = filterArgs["timeSpent"].operator;
	            filterArgs["timeSpentValue"] = filterArgs["timeSpent"].value;
			}
			delete filterArgs["timeSpent"];
        }
        if(filterArgs["isBlocking"] && filterArgs["isBlocking"] == "Any@@"){
			delete filterArgs["isBlocking"];
		}
		if (filterArgs["defaultScriptName"] != null) {
            var scriptFilter = filterArgs["defaultScriptName"];
            if (scriptFilter["defaultScriptName"]) {
                // simple name filter
                filterArgs["defaultScriptName"] = scriptFilter["defaultScriptName"];
            } else if (scriptFilter["vScriptUUIDs"]) {
                // advanced ids filter
                filterArgs = dojo.clone(filterArgs);
                filterArgsCloned = true;
                filterArgs["vScriptUUIDs"] = scriptFilter["vScriptUUIDs"];
                delete filterArgs["defaultScriptName"];
            } else if (!dojo.isString(scriptFilter)) {
                // invalid filter, should not get here but just in case
                delete filterArgs["defaultScriptName"];
            }
        }
        // test case filter can be simple by name or advanced by array of id
        if (filterArgs["testCaseName"] != null) {
            var caseFilter = filterArgs["testCaseName"];
            if (caseFilter["testCaseName"]) {
                // simple name filter
                filterArgs["testCaseName"] = caseFilter["testCaseName"];
            } else if (caseFilter["vTestCaseUUIDs"]) {
                // advanced ids filter
                if (!filterArgsCloned) {
                    filterArgs = dojo.clone(filterArgs);
                    filterArgsCloned = true;
                }
                filterArgs["vTestCaseUUIDs"] = caseFilter["vTestCaseUUIDs"];
                delete filterArgs["testCaseName"];
            } else if (!dojo.isString(caseFilter)) {
                // invalid filter, should not get here but just in case
                delete filterArgs["testCaseName"];
            }
        }
        // test plan filter can be simple by name or advanced by array of id
        if (filterArgs["testPlanName"] != null) {
            var planFilter = filterArgs["testPlanName"];
            if (planFilter["vTestPlanItemIds"]) {
                // advanced ids filter
                if (!filterArgsCloned) {
                    filterArgs = dojo.clone(filterArgs);
                    filterArgsCloned = true;
                }
                filterArgs["vTestPlanItemIds"] = planFilter["vTestPlanItemIds"];
                delete filterArgs["testPlanName"];
            } else if (planFilter["testPlanName"]) {
                // simple name filter
                filterArgs["testPlanName"] = planFilter["testPlanName"];
            } else if (!dojo.isString(planFilter)) {
                // invalid filter, should not get here but just in case
                delete filterArgs["testPlanName"];
            }
        }
        if (filterArgs["resultModified"] != null) {
            var dateTimeFilter = filterArgs["resultModified"];
            var from = dateTimeFilter.fromDateTime;
            var to = dateTimeFilter.toDateTime;
            var relativeUnit = dateTimeFilter.relative;
            
            if (relativeUnit) {
                // For relative date time, the from value is the number of the time unit.
                // The method getRelativeDateTime returns the "from" date time relative to now.
                from = com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateField.getRelativeDateTime(dateTimeFilter);
            }
            if (from) {
                filterArgs["resultModifiedFrom"] = from;
            }
            if (to) {
                filterArgs["resultModifiedTo"] = to;
            }
            delete filterArgs["resultModified"];
        }
		
		if (filterArgs["resultCompleted"] != null) {
            var dateTimeFilter = filterArgs["resultCompleted"];
            var from = dateTimeFilter.fromDateTime;
            var to = dateTimeFilter.toDateTime;
            var relativeUnit = dateTimeFilter.relative;
            
            if (relativeUnit) {
                // For relative date time, the from value is the number of the time unit.
                // The method getRelativeDateTime returns the "from" date time relative to now.
                from = com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateField.getRelativeDateTime(dateTimeFilter);
            }
            if (from) {
                filterArgs["resultCompletedFrom"] = from;
            }
            if (to) {
                filterArgs["resultCompletedTo"] = to;
            }
            delete filterArgs["resultCompleted"];
        }
        if(filterArgs["configuration"] == "") {
            delete filterArgs["configuration"];
        }
		if(this.includeArchived){
			filterArgs.includeArchived = this.includeArchived;
		}
        return filterArgs;
    },

    _initialize: function(data)  {
    	var categoryTypes = data.categoryTypes;
        this.categoryTypes = categoryTypes || [];
        
        this.printable = this.parentSection ? this.parentSection.isPrintView() : false;
        var allowsAspectView = (this.isQueryPage || this.showAspectView) && this.showTestCase;
        var provider = this._constructTableContentProvider();
        // create the table viewer
        
		var tableId = this.tableId ? this.tableId : ((this.isQueryPage) ? "RQM-TER-QUERY-TABLEVIWER" : "RQM-TER-TABLEVIWER");
		
		
		var tableArgs = {
            // turn off all controls if in print mode
            isCompactMode: !this.printable,
            showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
            showViewModeControl: allowsAspectView,
			sortDir: TableConstants.SORT_DIR_DESCEND,
            allowMultiSort: true,
            sortByColumn: provider.getIndexByColumnIdName("modified"),
            allowAdjustSettings: !this.printable,
            autoSaveSettings: true,
            handleVirtualSelectAll: this.showQueryFilters, 
            isInPicker: this.isInPicker,
            showFloatingStatusBar: this.showFloatingStatusBar,
            // allow the user to save the table settings as project wide default if the user is an admin.
            showSaveAsProjectSettingsOption: allowsAspectView && this.userIsProjectAdmin,
			tableSettingsChanged: this.showTestCase ? dojo.hitch(this, '_handleTableSettingsChanged') : null,
            tableId: tableId,
            cellRendererMap: EditableProperty.CELL_RENDERER_MAP
        };
		
		if (this.viewProfile != 'dashboard-exec') {
			tableArgs.customSettingsUIProvider = this.showTestCase ? dojo.hitch(this, 'customSettingUIProvider') : null;
 			tableArgs.customSettingsValuesProvider = this.showTestCase ? dojo.hitch(this, 'customSettingValuesProvider'): null;
		}
		if(this.tableArgs) {
            dojo.mixin(tableArgs, this.tableArgs);
        } 
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(tableArgs);	        
        // initFilterProvider uses the table's id to index
        // into the per-session saved filters. Need to setup
        // this attribute to properly obtain the saved filters.
        this.tableViewer = tableViewer;       
        this._tableViewerNode.appendChild(tableViewer.domNode);
        if(this.showQueryFilters) {
            this._initializeFilters(data);
        }
        tableViewer.showLoadingProgress();
		if(this.showQueryFilters)
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        var content = this.executionWorkItems ? this.executionWorkItems : [];
		this.maintainSelectedScriptIds= [];
        if (this.viewHeaderNode) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this.viewHeaderNode.setCSHelpId("rqm_view_ters.html");
			this.viewHeaderNode.setCSHelpButtonLabel(this.queryName+" "+Constants.getMessage("labelHelp"));        
        }
        this._tableViewerNode.appendChild(tableViewer.domNode);
        tableViewer.setContentProvider(provider);
        tableViewer.setContent(dojo.clone(content));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ? this.queryName: Constants.getMessage("labelEWIs")));
		tableViewer.getContentProvider().setCustomEditable(false);  
		var tableListener = new ExecutionWorkItemTableView.TableListener(this);
		if (this.executable && this.rowCheckListener)
           tableListener.setRowCheckListener(this.rowCheckListener);
		tableViewer.setTableListener(tableListener);
        		
        var shouldWrap = CommonPreferenceClient.getIsWordWrapEnabled();
        var showArgs = {
            categoryTypes: this.categoryTypes,
            showTestCase: this.showTestCase,
            parent: this,
            shouldWrap: shouldWrap,
			viewer: tableViewer
        };
		var cellModifier = new ExecutionWorkItemTableView.CellModifier(showArgs);
		var listener = {
			context: this,
			method:dojo.hitch(this, function(rowObject, state) {
                    this.storeChangedEWIs(rowObject);
                })
		};
		cellModifier.setChangeListener(listener);
		tableViewer.setCellModifier(cellModifier);
		this.inEditMode = false;
		var checkable = this.rowsSelectable != null ? this.rowsSelectable : (this.isInPicker || (this.executable && !this.printable));
		tableViewer.setTableRowsCheckable(checkable, false);
        tableViewer.registerCellRenderer("RenderType.TextCombo", 
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer());
				
		tableViewer.registerCellRenderer("RenderType.ScriptSelector",
			new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ArtifactCellEditor({
				scriptSelectorConstraint : true
			}));
		tableViewer.customEditable = false;
		
        var actionProvider = this.actionProvider = 
            new com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactActionProvider({
            parentView: this,
            tableViewer: tableViewer,
            contentProvider: provider,
            artifactName: Constants.getMessagePart("labelExecutionRecord"),
            artifactNamePlural: Constants.getMessagePart("labelExecutionRecords")
        });
        tableViewer.setActionProvider(actionProvider);

		
		// add refresh action via 'refreshQuery' api if showing filters
		if (this.showQueryFilters) {
        	var actionButton = tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, "refreshQuery"));
			this._actionButtons.push(actionButton);    
        }
		this._itemsToTrack.menus = [];
		if (this.viewProfile != 'dashboard-exec' && !this.isInPicker) {
			this._addExecuteActions(actionProvider);
		}
        // add any actions provided by the consumer
        actionProvider.addTableActions(this.actions, this.editable);    
        
        // add row edit 
        if (this.editable){
            actionProvider.addRowEditAction(tableViewer, dojo.hitch(this, function() {
                    // is selected row editable?
                    return true;
                }
            ));
        }


        this.tc_exe_perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE_EXE);
        var ewi_perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);

        if (!ewi_perm || ewi_perm.archive) {
            actionProvider.addDeleteAction(
                    dojo.hitch(this, "invokeAction", "itemId", this, "_onDeleteActionClick"), // callback
                    dojo.hitch(this, function(selectionCount, archiveCount, snapshotCount){
                            if (this.inEditMode) return false;
                            var isTestCaseSaveable = true;
                            var p = this.ewiList || this.parentView;
                            var tableViewer = this.tableViewer;
                            if(p.parentSection && dojo.isFunction(p.parentSection.isParentEditorSaveable))
                                isTestCaseSaveable = p.parentSection.isParentEditorSaveable();
                            return tableViewer.isEditable() && isTestCaseSaveable;
                        })); 
        }
        if(this.isQueryPage) {
            var cat_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_CATEGORY);
            if (!cat_permission || cat_permission[PermissionsClient.ACTION_EDIT]) {
                // add action for managing categories
                this.configureActionNode = tableViewer.addAction("configure", // action id
                    Constants.getArtifactTypeMessage("labelManageCategories", Constants.TYPE_EWI), // label
                    null, // callback data
                    "categories-icon-image", // icon class
                    dojo.hitch(this, "_handleCategoriesClick") // callback
                );
            }
        }       
            
		if (this.printable) {
			tableViewer.setContentPageSize(-1);
		}
		
		if (!ewi_perm || ewi_perm[PermissionsClient.ACTION_CREATE]) {

			//show this option in a Test Plan artifact
			if(this.parentSection && this.parentSection.getArtifactType() == Constants.TYPE_PLAN) {
				//copy to the same test plan, choseTestPlan = true
				actionProvider.addCopyERtoThisTP(
						dojo.hitch(this, "_onCopyToThisTPActionClick"), // callback
						dojo.hitch(this, "_onDuplicateEnableCheck"));
				
				//copy to the same test plan, choseTestPlan = false
				actionProvider.addCopyERtoDifferentTP(
						dojo.hitch(this, "_onCopyToDifferentTPActionClick"), // callback
						dojo.hitch(this, "_onDuplicateEnableCheck"));
				
			}else {
				// for browse view
				actionProvider.addCopyExecutionRecordAction(
					dojo.hitch(this, "_onDuplicateActionClick"), // callback
					dojo.hitch(this, "_onDuplicateEnableCheck")
				);
			}
		}
		// whenever our table is updated with new data, if we are
        // in execution view mode, fetch the status for the result
        // set
		if (this.isQueryPage || this.showExecStatus) {
            this.connect(this, 'refresh', '_fetchExecutionStatuses');
        }
        if(allowsAspectView) {
            var viewModes = [];
            viewModes.push({
                id: 'general',
                label: Constants.getMessage("labelViewGeneral"),
                columnsProfile: true
            });
            tableViewer.tableViewModeId = "general";
            viewModes.push({
                id: "traceability",
                label: Constants.getMessage("labelViewTraceability"),
                columnsProfile: true
            });
            this._configureViewModes(viewModes, tableViewer);            
        }
        tableViewer.show();
		tableViewer.setEditable(this.editable);		
        tableViewer.executable = this.executable;
        if (!this.parentSection) {
        	actionProvider.addPrintArtifactAction(this.buildPrintArtifactActionMenu(), dojo.hitch(this, function(){return !this.inEditMode;}));
        	this.printSummaryActionNode = this.buildPrintTableMenu();
	        PrintHelper.enableDisablePrintMenuItems(this);  // initial selection
        }            
        this.addCSVExportAction();
		if(!this.showQueryFilters){
        	this.showInitLoadProgress = false;
			tableViewer.endLoadingProgress();
		}
        this._initialize2();
    },
	
    
    // Summary:
    // Post query call to fetch the page's execution status data. If the page's data
    // has been fetched, this method returns immediately.
    //
    _fetchExecutionStatuses: function() {
		if(this.tableViewer.groupByColumn == 9 || this.tableViewer.groupByColumn == 1 ||
			this.tableViewer.groupByColumn == 7 ||  this.tableViewer.groupByColumn == 8 ||
			this.provider.isCategoryColumn(this.tableViewer.groupByColumn)){
				
			this.inherited(arguments);
		}
	},

    hasTraceabilityColumns: function() {
        return this.provider.isShowingTraceColumns(); 
    },

    _handleTableSettingsChanged: function() {
        // the table's columns have changed, make sure that we have the data.
        // If there're traceability columns, just re-run the query.
        // 
        if (this.hasTraceabilityColumns()) {
            this.ignoreStaleQuery = true;
            
            // after the runQuery, fetchExectionStatuses will be invoked
            // don't have to call that separately.
            setTimeout(dojo.hitch(this, 'runQuery', null, true));
        }
        else {
            this._fetchExecutionStatuses();
        }
    },
    
// runQuery: function(){
// this.inherited("runQuery", arguments);
// if(dojo.isFunction(this.refreshCallback)){
// this.refreshCallback();
// }
// },
	
	getExecutionStatusGroupByOwner: function(responseHandler, filterArgs){	
		ExecutionWorkItemClient.getExecutionStatusGroupByOwner(responseHandler, filterArgs);
	},
	
	getExecutionStatusGroupByPriority: function(responseHandler, filterArgs){	
		ExecutionWorkItemClient.getExecutionStatusGroupByPriority(responseHandler, filterArgs);
	},
	
	getExecutionStatusGroupByTestPlan: function(responseHandler, filterArgs){	
		ExecutionWorkItemClient.getExecutionStatusGroupByTestPlan(responseHandler, filterArgs);
	},
	
	getExecutionStatusGroupByTestPhase: function(responseHandler, filterArgs){	
		ExecutionWorkItemClient.getExecutionStatusGroupByTestPhase(responseHandler, filterArgs);
	},
	
	getExecutionStatusGroupByCategory: function(responseHandler, filterArgs, categoryTypeItemId){	
		ExecutionWorkItemClient.getExecutionStatusGroupByCategory(responseHandler, filterArgs, categoryTypeItemId);
	},
	
	copyERS: function() {
		this._copyERS(true);
	},
	
	_handleBulkERCreation:function(iterationItemId, testPlan, testCase) {
		var self = this;
		var handler = {
			success: function(createdCount){
				if(createdCount < self.ersToCopy.length )
				self._displayAlertDialog(Constants.getMessage("msgLesserTCERCopied",	
										self.ersToCopy.length,	
										createdCount,
										self.ersToCopy.length - createdCount), Constants.getMessage("labelAlert")
									);
				self.ersToCopy = [];
				ProgressUtility.endTaskMonitor(self.monitorId);
				var refresh = self.tableViewer.getActionButton('refresh');
				if(refresh && refresh.callback){
					refresh.callback();
				}
			},
			error: function(e){
				self.ersToCopy = [];
				ProgressUtility.endTaskMonitor(self.monitorId, e.message);
				console.error(e);
			}
		};
		this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("labelGenEWIs"), 0, null);
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");
		ExecutionWorkItemClient.copyTER(responseHandler, {
			ewiItemIds: this.ersToCopy,
			testPhase: iterationItemId,
			vTestPlan: testPlan ? testPlan.versionableItemId : "",
			vTestCase: testCase ? testCase.versionableItemId : ""
		});
	},
	
	createResultWithoutExecution: function(selectedItems){
		var selectedEWIs = selectedItems;
		this.bulkChangeSelectedItems = selectedItems;
		var pageSize = this.pageSize || TableConstants.MIN_PAGE_SIZE;
        var selectedItemsLength = selectedItems.length;
		if (selectedEWIs == null) {
			selectedEWIs = this.getSelectedEWIs();
		}
	  	if (selectedEWIs != null) {
	  		if (selectedEWIs.length == 1) {
	   			this.ewiList.onCreateResult();
	   		} else {
				// Multiple select case
								
				// Validate State before generating result
				var unApprovedTestCase = [];
				var validateFail =false;
				for(var i = 0; i < selectedEWIs.length; i++)
				{
					if(!(this.validateStateForExecution(selectedEWIs[i].testCase))){
						validateFail = true;	
						if(unApprovedTestCase.length == 0){
							unApprovedTestCase.push(selectedEWIs[i].testCase.name);		
						}else{					
							if(dojo.indexOf(unApprovedTestCase,selectedEWIs[i].testCase.name) == -1 )
							unApprovedTestCase.push(selectedEWIs[i].testCase.name);				
						}							
					}
				}
				if(validateFail && unApprovedTestCase.length >0){
					var errorStr = Constants.getMessage("msgCannotExecuteTestCaseNotApproved", unApprovedTestCase.join(", "));
					if(this.parentSection){
						this.parentSection.getParentEditor().setHeaderStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, errorStr);
					}else{
						this._displayAlertDialog(errorStr);
					}
					return;	
				}
				this.dia = null;
				this.dia = 
				new com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog
				({
					parentEditor: this,
					okCallback: dojo.hitch(this, this._handleTERBulkChanged, {
						actionId: Constants.getMessage("labelLastResult")
					}),
					verdictTypes: this.ewiList.verdicts,
					dialogTitle: Constants.getMessage("labelCreateResult"),
					labelTopMessage: Constants.getMessage("labelSelectVerdict"),
					bulkUpdateForTERs: true,
					pageSize: pageSize,
					selectedItems: selectedItemsLength
				});
				this.dia.initialize();
			}
		}
	},
	
	_addExecuteActions: function(actionProvider){
		var ewi_type = PermissionsClient.OP_TEST_CASE_EXE;
            var tc_exe_perm = PermissionsClient.getStoredPermission(ewi_type);
            
        if (!tc_exe_perm || tc_exe_perm.execute) {
			
            var executeMenuEntries = [];
            executeMenuEntries.push({
                actionId: "execute",
	        	label: Constants.getMessage("labelExecute"),
//	        	callback: dojo.hitch(this.ewiList, "onExecute"),
	        	callback: dojo.hitch(this, "_runWithChannel"),
				iconClass: "execute-icon-image"
//				isSubMenu: true,
//				subActions: {actions:this.getMenuOptionsForChannels()}
	        });
            executeMenuEntries.push({
                actionId: "resume",
                label: Constants.getMessage("labelResumeExe"),
                callback: dojo.hitch(this.ewiList, "onResume"),
                iconClass: "resume-icon-image"
            });            
           executeMenuEntries.push({
                actionId: "runWithOptions",
                label: Constants.getMessage("labelRunWithOptions"),
                callback: dojo.hitch(this.ewiList, "onRunWithOptions"),
                iconClass: "execute-icon-image"
            });
            executeMenuEntries.push({
                actionId: "offlineExecute",
                label: Constants.getMessage("labelExecuteOffline"),
                callback: dojo.hitch(this.ewiList, "onOfflineExecute"),
                iconClass: "execute-offline-icon-image"
            });
			// TODO: Request icon for executiuon without execution
            executeMenuEntries.push({
                actionId: "createResult",
	        	label: Constants.getMessage("labelCreateResult"),
	        	callback: dojo.hitch(this,"_runWithoutExecutionOption"),
				iconClass: "create-result-icon-image"
	        });
            this.executeActionMenu = actionProvider.addActionMenu(
                    Constants.getMessage("menuExecute"),     
                    Constants.getMessage("menuExecuteMultiple"),
                    "execute-icon-image",                       // icon class
                    dojo.hitch(this, "_enableRunActions"),      // visible only on "normal" artifacts
                    null,                                       // enabled only on "normal" artifacts
                    executeMenuEntries,                         // sub menu
                    true                                        // add to table header toolbar
                    );                       
        }
	},
/*	
	getMenuOptionsForChannels: function(channels){
		var channels = dojo.isArray(channels) ? channels : [];
		var channelsLen = channels.length;
		var channelMenu = [];
		channelMenu.push({
            label: Constants.getMessage("labelUnassigned"),
            callback: dojo.hitch(this, "_runWithChannel", "-1")
        });
		for (var i=0;i<channelsLen;i++){
			channelMenu.push({
                label: channels[i].name,
                callback: dojo.hitch(this, "_runWithChannel", channels[i].id)
            });
		}
		return channelMenu;
	},
*/		
//	_runWithChannel: function(channelId){
	_runWithChannel: function(){
		var selectedEWIs = this.getSelectedEWIs();
        var ewi = selectedEWIs[0];
        var channels = ewi.channels;
        var channelId = "-1";
        if(channels && channels.length > 0){
        	channelId = channels[0].id;
        }
		if(channelId != "-1")
			this.ewiList.onExecute(null, channelId);
		else{
			this.ewiList.onExecute();//skip channel information for Unassigned.
		}
	},

    _enableRunOption: function(id, enabled){
        var actionList = this.executeActionMenu.subActions.actions;
        for (var i = 0; i < actionList.length; ++i){
            var action = actionList[i];
            if (action.actionId == id){
                action.disabled = !enabled;
                return;
            }
        }
    },
    
    _enableRunActions: function(selectedCount, archivedCount, snapshotCount) {
        if (this.inEditMode) return false;
        // ewi, state
        if ((selectedCount - archivedCount - snapshotCount) < 1){
            return false;// if we are in the table toolbar
        } else if (selectedCount > 1){
            this._enableRunOption("offlineExecute", true);
            this._enableRunOption("createResult", true);
            this._enableRunOption("execute", false);
            this._enableRunOption("resume", false);
            this._enableRunOption("runWithOptions", false);
            return true;
        }
        
        var selectedEWIs = this.getSelectedEWIs();
        var ewi = selectedEWIs[0];
        this._enableRunOption("execute", true);
        this._enableRunOption("createResult", true);
        this._enableRunOption("resume", Utility.isPaused(ewi.currentResult));

        // check for available test scripts for the TER
        if (ewi.testScriptValues.choices.length == 1 && ewi.testScriptValues.select == "-1") {
            // one choice of none when there is no test script associated, therefore no option
            // besides default run of script-less
            this._enableRunOption("runWithOptions", false);
        } else {
            // test script selection is part of the options
            this._enableRunOption("runWithOptions", true);
        }

        if (ewi.selectedScriptId != "-1") {
            var scripts = ewi.testCase.scripts;
            var len = scripts ? scripts.length : 0;
            for (var i = 0; i < len; i++) {
                if(scripts[i].versionableItemId == ewi.selectedScriptId){
                    if(scripts[i].scriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual"){
                        this._enableRunOption("offlineExecute", true);
                    }else{
                        this._enableRunOption("offlineExecute", false);
                    }
                }
            }
        }else{
            this._enableRunOption("offlineExecute", false);
        }
        return true;
    },


	
	_runWithoutExecutionOption: function(){
			var self= this;
			this.getVirtualSelectedRows('id', dojo.hitch(this, function(selectedItems){
				self.createResultWithoutExecution(selectedItems);
		}));
	},	
	
	_initialize2:function(){
		// if preference specifies, run the query
		if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
			this.initRunQuery();
		} 
    },

		
	validateStateForExecution: function(testcase){
		return true;
	},
	        
    _constructTableContentProvider: function() {
        var shouldWrap = CommonPreferenceClient.getIsWordWrapEnabled();
        var args = {
            categoryTypes: this.categoryTypes,
            showTestCase: this.showTestCase,
            parent: this,
            shouldWrap: shouldWrap,
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
			customAttributes: this.customAttributes,
			enableAutomationConsumer: this.enableAutomationConsumer,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /* updatePageOnly */ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /* updatePageOnly */ true);
            })
        };
        // create the table provider
        if (this.viewProfile == 'dashboard-exec') {
 			this.provider = new DashboardExecutionWorkItemTableView.TableProvider(args);
        }else{
			this.provider = new ExecutionWorkItemTableView.TableProvider(args);
		}    
        return this.provider; 
    },
    
    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },
    
    clearSelectedItems: function() {
    	this.tableViewer.clearSelection(true/*notify*/, true/*refreshDisplay*/);
    },
    
	 // API
    getSelectedEWIs: function() {
        var rows = this.tableViewer.getCheckedRows();
        // we can only give a page of data
        if(!dojo.isArray(rows)) {
            rows = this.tableViewer.getContent();
        }
        return rows;
    },

    getAction: function(actionId) {
		var len = this.actions?this.actions.length:0;
        for (var i = 0; i < len; i++) {
            if (this.actions[i].actionId == actionId) {
                return this.actions[i];
            }
        }        
    },
    
    getActionButton: function(actionId) {
		return this.tableViewer.getActionButton(actionId);
    },
    
    hideAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
			dojo.addClass(button.domNode,"dijitDisplayNone");
        }
    },
    
    showAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
			dojo.removeClass(button.domNode,"dijitDisplayNone");
        } 
    },    

	disableAction: function(actionId) {
        var button = this.getActionButton(actionId);
         if (button ) {
            button.set('disabled',true);
        } 
    },
	
	enableAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button ) {
            button.set('disabled',false);
        } 
    }, 
        
    appendEWI: function(ewi) {
    	var content = this.tableViewer.getContent();
        content.push(ewi);
        this.tableViewer.setContent(content);
        this.tableViewer.show();
    },
	
    addConfigurationInfo: function(ewiId, config) {
        var content = this.tableViewer.getContent();
		var len = content.length;
        for (var i = 0; i < len; i++) {
        	if (content[i].id == ewiId) {
        		content[i].config = config;
				break;
        	}
        }
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },
	
	updateEWI: function(ewi,refresh) {
        var content = this.tableViewer.getContent();
		var len = content.length;
        for (var i = 0; i < len; i++) {
        	if (content[i].id == ewi.id) {
        		content[i].phase = ewi.phase;
				content[i].owner = ewi.owner;
				content[i].modified = ewi.modified;
				content[i].stateId = ewi.stateId;
				content[i].defaultScript = ewi.defaultScript;
				if(!ewi.defaultScript || !ewi.defaultScript.versionableItemId)
					content[i].selectedScriptId = null;
				content[i].defects = ewi.defects;
				break;
        	}
        }
        // found the item to change. Update the display.
        if (i < len) {
            this.tableViewer.setContent(content);
            if (refresh) 
                this.tableViewer.refresh();
        }
    },
	
    refresh: function(content, resetProgress, updatePageOnly) {
        if (!this.tableViewer) {
            // _initialize() is run in setTimeout to improve performance.  Make sure it is completed
            // before using the table.
            setTimeout(dojo.hitch(this, function(content, iterations, contributors, resetProgress){
                this._refresh(content, iterations, contributors, resetProgress);
            }), 0);
        } else {
            this._refresh(content, resetProgress, updatePageOnly);
        }
    },
        
	_refresh: function(content, resetProgress, updatePageOnly) {
		var tableContentProvider = this.provider;
		// need this for WI 4015
		var oldContent = this.tableViewer.getContent();
		if(oldContent && content){
			var len = oldContent.length;
			var len2 = content.length;
			for(var i=0;i<len;i++){
				for(var j=0;j<len2;j++){
					if(content[j].itemId == oldContent[i].itemId){
						if(oldContent[i].selectedScriptId){
							content[j].selectedScriptId = oldContent[i].selectedScriptId;
							break;
						}
					}
				}
			}
		}
        if(this.showInitLoadProgress && resetProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		this.executionWorkItems = content ? content:[];
		if(this.printSummaryActionNode){
			if(!content || !content.length){
				this.printSummaryActionNode.set('disabled',true);
				dojo.addClass(this.printSummaryActionNode.domNode,"dijitButtonDisabled");
			}else{
				this.printSummaryActionNode.set('disabled',false);
				dojo.removeClass(this.printSummaryActionNode.domNode,"dijitButtonDisabled");
			}
		}
        // we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        var tableContent = dojo.clone(this.executionWorkItems);
        if (this.updatePageOnly || updatePageOnly) {
            this.provider.loadPageContent(tableContent);
        }
        else {
            this.tableViewer.setContent(tableContent);
            this.tableViewer.refresh();
        }
		this.enableEditableActions(this.inEditMode);
        if (this.viewHeaderNode) {
            this.viewHeaderNode.clearStatus();
        }
        PrintHelper.enableDisablePrintMenuItems(this); // initial selection
        
        if(dojo.isFunction(this.refreshCallback)){
        	this.refreshCallback();
        }
        
	 },
	 
	 show: function(ters) {
        if (this.ewiList) {
            this.ewiList._setEWITableContent(ters || []);
        } else {
            this.refresh(ters || []);
            this.stopInProgress();
        }	         	
	 },
	
	isCustomEditable: function()
	{
		return this.tableViewer.getContentProvider().isCustomEditable();;
	},
	
	toggleTableStateForEditing: function(discard)
	{
		if(this.inEditMode && discard)
			this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
		this.inEditMode = !this.inEditMode;
		var selectedEWIs = null;
		if(this.inEditMode){
			selectedEWIs = this.tableViewer.getCheckedRows();
			this.contentAfterEdit = selectedEWIs;
		}
		
		this.tableViewer.getContentProvider().setCustomEditable(this.inEditMode,selectedEWIs);
		this.tableViewer.setTableRowsCheckable(this.executable, false);
		this.enableEditableActions(this.inEditMode);
		this.changedEWIList = []; // initial definition
		this.tableViewer.refresh();
		this.toggleTableHeaderName(this.inEditMode);
	},
	
	toggleTableHeaderName: function(inEditMode) {
		//change Test Script column header. If in edit mode, the column header is "Default Test Script".
		// Otherwise, it is "Test Script"
		var columnIndex = this.showTestCase ? 12 : 11;		
		var header = this.tableViewer.headerRenderer.getColumnHeaderAt(columnIndex);
		if(header) {
			var text = inEditMode ? Constants.getMessage("labelDefaultTS") : Constants.getMessage("labelScript");
			var children = header.getElementsByTagName("A");
			if(children && children.length == 1)
				children[0].innerHTML = text;
		}
	},
	
	getContentAfterEdit: function(){
		return this.contentAfterEdit;   //Store the checked row's state when click the "Edit" button.
	},
	
	storeChangedSelectedScriptIds: function(rowData)
    {
		var newItem = true;
		var maintainSelectedScriptIds = this.maintainSelectedScriptIds;
        if (maintainSelectedScriptIds) {
			var len = maintainSelectedScriptIds.length;
            for (var i = 0; i < len; i++) {
                if (maintainSelectedScriptIds[i].id == rowData.id) {
					newItem = false;
                    maintainSelectedScriptIds[i].selectedScriptId = rowData.selectedScriptId;					
                }
            }
            if (newItem) {
                var args = {
                    id: rowData.id,
                   	selectedScriptId:rowData.selectedScriptId,
					selectedScriptName:rowData.selectedScriptName
                };
                maintainSelectedScriptIds.push(args);
            }
        }
    },	
	
    storeChangedEWIs: function(rowData)
    {
        var found = false;
        if (this.changedEWIList) {
			var len = this.changedEWIList.length;
            for (var i = 0; i < len; i++) {
                if (this.changedEWIList[i].id == rowData.id) {
                    found = true;
                    this.changedEWIList[i].defaultScript = rowData.defaultScript ? rowData.defaultScript.versionableItemId : null;
					this.changedEWIList[i].name = rowData.name;
                }
            }
            if (!found) {
                var args = {
                    id: rowData.id,
                    owner: rowData.owner ? rowData.owner.userId : null,
                    testPhase: rowData.phase ? rowData.phase.itemId : null,
                    defaultScript: rowData.defaultScript ? rowData.defaultScript.versionableItemId : null,
                    newExecutionWorkItem: false,
                    ewiStateId: rowData.stateId,
                    weight: rowData.weight,
					name:rowData.name
                };
                this.changedEWIList.push(args);
            }
        }
    },
	
	getChangedEWIs: function()
	{
		
		var included = this.getContentAfterEdit();
		var len = included.length;
		for( var m = 0; m < len; m ++){
			included[m].needToPost = false;  
			if( included[m].isChanged){
				included[m].needToPost = true;
			}
		}

		if(included.length == this.changedEWIList.length){
			return this.changedEWIList;
		}
		var missed = [];
		for(var i = 0; i < len; i ++){
			var found = false;
			for(var j = 0; j < this.changedEWIList.length; j ++){
				if(included[i].id == this.changedEWIList[j].id){
					found = true;
					break;
				}
			}
			if((!found) && included[i].needToPost){
				missed.push(i);
			}
		}
		var len2 = missed.length;
		for( var k = 0; k < len2; k ++){
			var ewi = included[missed[k]];
			var args = {
					id: ewi.id,
					defaultScript: ewi.defaultScript ? ewi.defaultScript.versionableItemId : null,
					ewiStateId: ewi.stateId,
					name:ewi.name
				};
				this.changedEWIList.push(args);
		}		
		return this.changedEWIList;
	},
	
	enableEditableActions: function(editable)
	{
		if (editable) {
			this.hideAction("refresh");
			this.hideAction("generate");
		} else {
			this.showAction("refresh");
			this.showAction("generate");
						
			// generate/execute actions for snapshot view
			var section = this.parentSection;
			if (this.editable && section && section.isParentEditorSaveable && section.isParentEditorSaveable()) {
				this.enableAction("generate");
			} else {
				this.disableAction("generate");
			}
			this.enableAction("refresh");			
		}
	},    

    _onDeleteActionClick: function(itemIds) {
		var len = itemIds.length;
        if(len < 1) return;

        var promptMsg = len > 1 ? "msgDelEWIConfirm" : "msgDelOneEWIConfirm";
        var args = {
            'primaryTitle': Constants.getMessage("labelConfirmation"),
            'message': this.isCreateTCERsWithTSEREnabled ? Constants.getMessage("msgTCEROutOfSynchWarning_delete") : Constants.getMessage(promptMsg,len),
            'okCallback': dojo.hitch(this, "_deleteAction"),
            'okCallbackData': itemIds,
            'okLabel': Constants.getMessage('labelDelete'),
            'cancelCallback': null,
            'cancelCallbackData': null
        };
        var confirmDialog = new ConfirmationDialog(args);
        confirmDialog.open();
    },

    _deleteAction: function(itemIds) {
		var selectedEWIs = this.tableViewer.getCheckedRows();
        
        if (!this.contentIsVirtual && dojo.isArray(selectedEWIs)) {
            var ewiList = this.ewiList;
            if (ewiList) {
                var ewiSaveContextGroup = ewiList.ewiSaveContextGroup;
                if (ewiSaveContextGroup && ewiSaveContextGroup.length) {
                    var length = ewiSaveContextGroup.length;
                    for (var j = 0; j < length; j++) {
                        ewiSaveContextGroup[j].removeEwis(selectedEWIs);
                    }
                }
            }
            var nEwi = selectedEWIs.length;
            itemIds = [];
            for (var i = 0; i < nEwi; i++) {
                var selectedEWI = selectedEWIs[i];
                if (!selectedEWI.isNew) {
                    itemIds.push(selectedEWI.itemId);
                }
            }
        }
        this.selectedEWICount = itemIds.length;
        this.errorEWICount = 0;
        this.deletedEWICount = 0;
        
        nEwi = itemIds.length;
        if (nEwi > 0){
            var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
            var args = {
                        uuid_ewis: itemIds,
                        archive: true
	                    };
			ExecutionWorkItemClient.postArchiveEWI(responseHandler, args);
           this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingEWI"), 0, null); 
        }else{
			this._deleteSuccess();
		}
    },
	
    _deleteSuccess: function(response) {
        if (response) {
        	this.deletedEWICount= +response;
        }else{
        	this.deletedEWICount = 0;
        }
        this._setDeleteStatus();

    },
    
    _deleteFailure: function(err) {
        this.errorEWICount = this.selectedEWICount;
        if (this.viewHeaderNode)
            this.viewHeaderNode.setProgressEnd();
        this._setDeleteStatus(err);
    },
    
    _setDeleteStatus: function(err) {
        if ((this.deletedEWICount + this.errorEWICount) == this.selectedEWICount) {
            var error = (err && err.message)?err.message:null;
        	ProgressUtility.endTaskMonitor(this.monitorId,error);
            if (this.viewHeaderNode) {
                var promptMsg = this.deletedEWICount > 1 ? "msgDeletedEWI" : "msgDeletedOneEWI";
                this.viewHeaderNode.setStatus(Constants.getMessage(promptMsg, this.deletedEWICount, this.selectedEWICount), this.errorEWICount == 0 ? ViewHeaderLayout.SUCCESS : ViewHeaderLayout.ERROR, null, err);
            }
            if (this.deletedEWICount > 0) {
            	var deletedEWIs = this.tableViewer.getCheckedRows();
				if(!this.isQueryPage){// Inside editor Update myself
					this.onArtifactChanged(GlobalEvents.ArtifactsDeleted, Constants.TYPE_EWI, deletedEWIs);
				}
                else {
                    this._deleteBySelf = true;
                }
                // notify all pages (including itself) execution workitem are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_EWI, deletedEWIs]);
                this.tableViewer.clearSelection(true, false);
            }
        }
    },

    _handleCategoriesClick: function() {
        // refresh tableview by public event
        this._categoriesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.categories.CategoryEditor({
            artifactType: this.explorableArtifactType,
            typeName: Constants.TYPE_EWI,
            isDialog: true
        });
    },

    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about EWI
		var len = artifactArray.length;
        if (artifactType == Constants.TYPE_EWI) {
            if(this._deleteBySelf && changeType == GlobalEvents.ArtifactsDeleted) {
                this._invalidateQuery();
                delete this._deleteBySelf;
                return;
            }
            if (this.viewHeaderNode) {
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_EWI, changeType);
                return;
            }
            
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add EWI to the table
                if (!this.executionWorkItems)
                    this.executionWorkItems = artifactArray;
                else
                    this.executionWorkItems = this.executionWorkItems.concat(artifactArray);
            } else {
				var executionWorkItems = this.executionWorkItems;
                // iterate through the array of artifacts
                for (var i = 0; i < len; i++) {
					var len2 = executionWorkItems.length;
                    // iterate through the array of EWI's in the table
                    var artifact = artifactArray[i];
                    for (var j = 0; j < len2; j++) {
                        // handle the matching EWI
                        if (artifact.id == executionWorkItems[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap EWI on update
								if(!artifact.config)
									artifact.config = executionWorkItems[j].config;
								artifact.selectedScriptId = executionWorkItems[j].selectedScriptId;
								artifact.selectedScriptName = executionWorkItems[j].selectedScriptName;
                                executionWorkItems.splice(j, 1, artifact);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove EWI from table on delete
                                executionWorkItems.splice(j, 1);
                            }
                            break;
                        }
                    }
                }
            }
            this.tableViewer.setContent(this.executionWorkItems);
            this.tableViewer.refresh();
			this.disableAction("execute");
			this.disableAction("resume");			
			this.disableAction("unblock");
        }else if ((artifactType == Constants.TYPE_CASE) && ((changeType == GlobalEvents.ArtifactsUpdated))){
            if (this.viewHeaderNode) {
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_CASE, changeType);
                return;
            }
			var executionWorkItems = this.executionWorkItems;
			var len2 = executionWorkItems.length;
			for (var i = 0; i < len; i++) {
				var artifact = artifactArray[i];
                // iterate through the array of EWI's in the table
                for (var j = 0; j <len2; j++) {//Should traverse all EWIs to update test case
                    // handle the matching EWI
                    if (artifact.id == executionWorkItems[j].testCase.id) {
							executionWorkItems[j].testCase =artifact; 
                    }
                }
            }
			this.tableViewer.setContent(this.executionWorkItems);
            this.tableViewer.refresh();
		}
        else if(artifactType == Constants.TYPE_TER_CATEGORY) {
            // call base class AbstractFilteredTableView's handler
            // to refresh categories.
            this._handleCategoriesChanged();
        }
    },
	
	tableHeaderColumnActionInvoked: function(columnIndex, actionId){
		if(this._progressDialog){
			delete this._progressDialog;
			this._progressDialog = null;
		}
		this._progressDialog = new ProgressDialog();	
		this._progressDialog.setMessage(Constants.getMessage("labelLoading"));
		this._progressDialog.show();
        // we might not have all data. Get virtual selected rows will determine
        // whether this is a select all and, if so, it will fetch all data for this action.
        // if there are deselected items from a select all, filter them by the item's id
        this.getVirtualSelectedRows('id', dojo.hitch(this, function(selectedItems){
        	if(actionId == Constants.getMessage("labelIteration") && this.isCreateTCERsWithTSEREnabled)
    		{
        		var selectedEWIs = selectedItems;
				var samePlan = true;
				var planItemId = selectedEWIs && selectedEWIs[0].testPlan ? selectedEWIs[0].testPlan.versionableItemId : "";
				var len = selectedEWIs ? selectedEWIs.length : 0;
				for (var i = 0; i < len; i++) {
					if (!selectedEWIs[i].testPlan || selectedEWIs[i].testPlan.versionableItemId != planItemId) {
						samePlan = false;
						break;
					}
				}
				if (samePlan && planItemId) {
					this.showConfirmationDialog(selectedItems, columnIndex, actionId);
				}
				else {
					if(this._progressDialog){
						this._progressDialog.hide();
					}
					var msg = Constants.getMessage("msgNotInSamePlan");
					if (!planItemId) 
						msg = Constants.getMessage("msgNotInPlan");
					this._displayAlertDialog(msg);
				}
    		}
        	else
        		this._doHeaderColumnActionInvoked(selectedItems, columnIndex, actionId);
        }));
    },
    
    _doHeaderColumnActionInvoked: function(selectedItems, columnIndex, actionId) {
		if(this._progressDialog){
			this._progressDialog.hide();
		}
		var self = this;
		// yield the bulk change dialog to avoid lose the focus.
		setTimeout(dojo.hitch(this, function(){
	        this.bulkChangeSelectedItems = selectedItems;
	        var selectedItemsLength = selectedItems.length;
	        var pageSize = this.pageSize || TableConstants.MIN_PAGE_SIZE;
	        var categoryType = this.provider.getCategoryTypeAtColumn(columnIndex);
	        if (categoryType) {
	        	var args = {
                    fullCategorySupport: true,
                    artifactType: this.explorableArtifactType,
                    categoryTypes: this.categoryTypes,
                    categoryType: categoryType,
                    actionId: actionId,
                    okCallback: dojo.hitch(this, function(args) {
                        this._handleTERBulkChanged(args, null, true);
                    })
                };
                this._categorySelect = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup(args);
	        }
	        else if (actionId == Constants.getMessage("labelWeight")) {
				var args = {
					actionId: actionId,
					okCallback: dojo.hitch(this, "_handleTERBulkChanged"),
					pageSize: pageSize,
					selectedItems: selectedItemsLength
				};
				var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup();
				dlg.initialize(args);
			}
			else if (actionId == Constants.getMessage("labelOwner")) {
				var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup();
				dlg.initialize({
	                actionId: actionId,
	                okCallback: dojo.hitch(this, "_handleTERBulkChanged"),
	                pageSize: pageSize,
					selectedItems: selectedItemsLength
	            });
	        }
			else if (actionId == Constants.getMessage("labelIteration")) {
				var selectedEWIs = selectedItems;				
				var planItemId = selectedEWIs && selectedEWIs[0].testPlan ? selectedEWIs[0].testPlan.versionableItemId : "";
				var planTeamAreaItemId = selectedEWIs && selectedEWIs[0].testPlan ? selectedEWIs[0].testPlan.teamAreaItemId : "";
								
				var handler = {
					success: function(phases){
						var args = {
							phases: phases,
							actionId: actionId,
							planTeamAreaItemId: planTeamAreaItemId,
							okCallback: dojo.hitch(self, "_handleTERBulkChanged"),
							pageSize: pageSize,
							selectedItems: selectedItemsLength
						};
						
						var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPhasePopup();
						dlg.initialize(args);
					},
					error: function(e){
						console.error(e);
					}
				};
				var responseHandler = new ServiceResponseHandler(handler, "success", "error");
				TimeboxClient.getTestPhasesSummaryDTO(responseHandler, {
					testPlanId: planItemId
				});
				
				
			} else if (actionId == Constants.getMessage("labelLastResult")) {
				this.createResultWithoutExecution(selectedItems);
			}else if (actionId == Constants.getMessage("labelPriority")) {
				var args = {
	                actionId: actionId,
	                okCallback: dojo.hitch(this, "_handleTERBulkChanged"),
	                pageSize: pageSize,
					selectedItems: selectedItemsLength
	            };
	            dlg = new PrioritySelectionPopup();
	            dlg.initialize(args);
			}else if(actionId == Constants.getMessage("labelEstimate")){			
				var args = {
					actionId: actionId,
	                okCallback: dojo.hitch(this, "_handleTERBulkChanged"),
					label: Constants.getMessage("labelEstimate:"),
					labelChange: Constants.getMessage("labelChangeEstimateTitle"),
					pageSize: pageSize,
					selectedItems: selectedItemsLength
				};
				var selectedEWIs = selectedItems;
				var len = selectedEWIs ? selectedEWIs.length : 0;
				if(len == 1){
					args.value = selectedEWIs[0].estimate;
				}
				dlg = new SelectDurationPopup();
				dlg.initialize(args);
			}else if(actionId == Constants.getMessage("labelTimeSpent")){
				var args = {
					actionId: actionId,
	                okCallback: dojo.hitch(this, "_handleTERBulkChanged"),
					label: Constants.getMessage("labelTimeSpent") + Constants.getMessage("labelColen"),
					labelChange: Constants.getMessage("labelChangeTimeSpentTitle"),
					pageSize: pageSize,
					selectedItems: selectedItemsLength
				};
				var selectedEWIs = selectedItems;
				var len = selectedEWIs ? selectedEWIs.length : 0;
				if(len == 1){
					args.value = selectedEWIs[0].timeSpent;
				}
				dlg = new SelectDurationPopup();
				dlg.initialize(args);
			} else if (actionId == Constants.getMessage("labelTestPlan")) {
				var selectedEWIs = selectedItems;
				var hasResult = false;
				var caseItemIds = new Array();
				var i;
				var len = selectedEWIs ? selectedEWIs.length : 0;
				for (i = 0; i < len; i++) {					
					if(selectedEWIs[i].currentResult){
						hasResult = true;
						break;
					}				
					if(caseItemIds.length == 0){
						caseItemIds.push(selectedEWIs[i].testCase.versionableItemId);					
					}else{					
						if(dojo.indexOf(caseItemIds,selectedEWIs[i].testCase.versionableItemId) == -1 ){
							caseItemIds.push(selectedEWIs[i].testCase.versionableItemId);							
						}
					}
				}			
				if(!hasResult) {
					var handler = {
						success: function(plans){
							if (plans && plans.length > 0) {
								var args = {
									plans: plans,
									actionId: actionId,
									okCallback: dojo.hitch(self, "_handleTERBulkChanged"),
									pageSize: pageSize,
									selectedItems: selectedItemsLength
								};
								
								var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPlanPopup();
								dlg.initialize(args);
							}else {
								if(caseItemIds.length!=1)
									self._displayAlertDialog(Constants.getMessage("msgTestCasesWithNoCommonPlan"));
								else
									self._displayAlertDialog(Constants.getMessage("msgTestCaseNotinPlan"));
							}
						},
						error: function(e){
							console.error(e);
						}
					};
					var args = {
						uuidList: caseItemIds, 
						includeRetiredPlan: true,
						includeSnapshots: false
					};
					var responseHandler = new ServiceResponseHandler(handler, "success", "error");
					PlanningClient.getCommonTestPlansByCaseMinimalSummary(responseHandler, args);
				}else{
					msg = Constants.getMessage("msgTERHasResult");
					this._displayAlertDialog(msg);
				}
			
			} else if (actionId == Constants.getMessage("labelTeamArea")) {
				var args = {
					actionId: actionId,
					okCallback: dojo.hitch(this, "_handleTERBulkChanged"),
					pageSize: pageSize,
					selectedItems: selectedItemsLength
				};
				var dlg = new SelectTeamAreaPopup();
				dlg.initialize(args);
			}
		}), 0);
	},
	
	showConfirmationDialog: function(selectedItems, columnIndex, actionId){		
		var args = {
	            'primaryTitle': Constants.getMessage("labelConfirmation"),
	            'message': Constants.getMessage("msgOutOfSynchWarning_TC_Iteration"),
	            'okCallback': dojo.hitch(this, "_doHeaderColumnActionInvoked", selectedItems, columnIndex, actionId),
	            'okCallbackData': null,
	            'okLabel': Constants.getMessage('labelOk'),
	            'cancelCallback': dojo.hitch(this, "_cancelCallBack"),
	            'cancelCallbackData': null
	        };
	    var confirmDialog = new ConfirmationDialog(args);
	    confirmDialog.open();				
	},
	
	_cancelCallBack: function(){		
		if(this._progressDialog){
			this._progressDialog.hide();
		}
	},
	
	_getSelectedScriptId: function(selectedEWI){
		var showlastrunscript = CommonPreferenceClient.getExecutionPreference().showlastrunscript;
		var currentlyVisibleSelectedEWIs = this.getSelectedEWIs();;
		var value = "-1";
		var found = false;
		var currentlyVisibleSelectedEWIsLength = dojo.isArray(currentlyVisibleSelectedEWIs) ? currentlyVisibleSelectedEWIs.length :0;
		for (var n = 0; n < currentlyVisibleSelectedEWIsLength; n++) {
			if(selectedEWI.itemId == currentlyVisibleSelectedEWIs[n].itemId ){
				found = true;
				if(currentlyVisibleSelectedEWIs[n].selectedScriptId){
					value = currentlyVisibleSelectedEWIs[n].selectedScriptId;
					break;				
				}
				else if(currentlyVisibleSelectedEWIs[n].currentResult && showlastrunscript == true) {
	            	if(currentlyVisibleSelectedEWIs[n].currentResult.scriptVersionableItemId){
	               	 	value = currentlyVisibleSelectedEWIs[n].currentResult.scriptVersionableItemId;
	            	}else{
	               		value = "-1";
	            	}
					break;
	        	}else if(currentlyVisibleSelectedEWIs[n].defaultScript && currentlyVisibleSelectedEWIs[n].defaultScript.versionableItemId){
	            	value = currentlyVisibleSelectedEWIs[n].defaultScript.versionableItemId;   
					break;             	
	        	}else{
					value = "-1";
				}
			}
			
		}
		if(!found){
			if(this.maintainSelectedScriptIds.length > 0)
			{
					value  = this.getLastChangedSelectedScript(selectedEWI);
					if(value !="")
						return value.id;				
			}
			if(selectedEWI.currentResult && showlastrunscript == true){				
				if(selectedEWI.currentResult.scriptVersionableItemId){
	            	value = selectedEWI.currentResult.scriptVersionableItemId;
	            }else{
	                value = "-1";
	            }
			}else if(!found && selectedEWI.defaultScript){
				if(selectedEWI.defaultScript.versionableItemId){
					value = selectedEWI.defaultScript.versionableItemId; 
				}else{
					value = "-1";
				}  
			}else{
				value = "-1";
			}
		}
		
		return value;
	},
	
    getLastChangedSelectedScript: function(selectedEWI){
		var selectedScript = "";
		var changedselectedScriptList = this.maintainSelectedScriptIds;
		var changedselectedScriptListLength =  changedselectedScriptList.length;
		for (var i = 0; i< changedselectedScriptListLength; i++ ){
			if(selectedEWI.id == changedselectedScriptList[i].id){
				selectedScript = {id:changedselectedScriptList[i].selectedScriptId, name:changedselectedScriptList[i].selectedScriptName};
				break;
			}
		}
		return selectedScript;
	},
	_handleTERBulkChanged: function(args, args2, isCategory){
		var self = this;
		var selectedEWIs = this.bulkChangeSelectedItems;
		if (selectedEWIs == null) {
			selectedEWIs = this.getSelectedEWIs();
		}
		var ewiList = this.ewiList;
		var weightChange = (args.actionId == Constants.getMessage("labelWeight"));
		var ownerChange = (args.actionId == Constants.getMessage("labelOwner"));
		var iterationChange = (args.actionId == Constants.getMessage("labelIteration"));
		var lastResultChange = (args.actionId == Constants.getMessage("labelLastResult"));
		var planChange = (args.actionId == Constants.getMessage("labelTestPlan"));
		var priorityChange = (args.actionId == Constants.getMessage("labelPriority"));
		var estimateChange = (args.actionId == Constants.getMessage("labelEstimate"));
		var timeSpentChange = (args.actionId == Constants.getMessage("labelTimeSpent"));
		var teamAreaChange = (args.actionId == Constants.getMessage("labelTeamArea")); 
        var categoryChange = isCategory;
        
		if(ewiList){
			var ewiSaveContextGroup = ewiList.ewiSaveContextGroup;
			if(ewiSaveContextGroup && ewiSaveContextGroup.length) {
				var updatedEwis = [];
				var selectedEWIsLength = selectedEWIs.length;
				for(var i = 0; i < selectedEWIsLength; i++){
					var ewi = selectedEWIs[i];
					if(ewi.isNew) {
						if (weightChange) {
							ewi.weight = args.weight;
						}	
						if (ownerChange) {
							ewi.owner = args.owner;
							ewi.ownerName = args.owner.name;
							ewi.ownerUserId = args.owner.userId;
						}	
						if (iterationChange) {
							ewi.phase = args.phase;
						}
						if(priorityChange){
							ewi.executionPriority = args.priority;
						}
						if(estimateChange){
							ewi.estimate = args.duration;
						}
						if(timeSpentChange){
							ewi.timeSpent = args.duration;
						}
						
						if(planChange){
							if (args.testPlanName) {
								ewi.testPlan = {
									name: args.testPlanName,
									id: args.testPlanId,
									versionableItemId: args.testPlanVersionableItemId
								};
							}else{
								ewi.testPlan = null;
								ewi.phase = null;
							}
						}
                        if(categoryChange) {
                            var categories = this._categorySelect.getSelectedCategory();
                            CategoryUtil.updateItemCategories(ewi, categories);
                        }
						updatedEwis.push(ewi);
					}
				}
				var length = ewiSaveContextGroup.length;
				for(var j = 0; j < length; j++){
					ewiSaveContextGroup[j].updateEwis(updatedEwis);
				}
				dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, updatedEwis]);
				this.tableViewer.refresh();
			}
		}
		
		var getCurrentResultAndAssociateDefect = function(ters){
			if (self.ewiList && args2 && args2.workItems && args2.workItems.length > 0) {
				var getTERHandler = {
                    success: function(ters){
						var resultSummaryDTOs = [];
						dojo.forEach(ters, function(r){
							// For bulk defect assignment let's include the ewi data inside resultSummaryDTOs
							var resultItemId = r.currentResultItemId ? r.currentResultItemId : (r.currentResult ? r.currentResult.itemId : null);
							if(!resultItemId){
								console.error("Cannot associate the defect with execution result. " +
										"The required attribute 'currentResultItemId' is null for TCER : " + r.name);
								return;
							}
							var resultName = (r.currentResult && r.currentResult.name) ? r.currentResult.name : r.name;
							var caseVItemId = r.testCaseVersionableItemId ? r.testCaseVersionableItemId : (r.testCase ? r.testCase.versionableItemId : null);
							var caseName = r.testCaseName ? r.testCaseName : (r.testCase ? r.testCase.name : null);
							var planVItemId = r.testPlanVersionableItemId ? r.testPlanVersionableItemId : (r.testPlan ? r.testPlan.versionableItemId : null);
							var planName = r.testPlanName ? r.testPlanName : (r.testPlan ? r.testPlan.name : null);
							
							resultSummaryDTOs.push({
								itemId: resultItemId,
								name: resultName,
								ewi: {
									testCase: {versionableItemId: caseVItemId, name: caseName},
									testPlan: {versionableItemId: planVItemId, name: planName}
								}
							});
						});
						
						Utility.linkDefectsToExecutionResults(
								resultSummaryDTOs,
								null,
								args2.workItems,
								function() {
									self.updateTable(ters);
								}
							);
					},
            	
	            	 error: function(err){
	                 	var error = (err && err.message)?err.message:null;	                    
	     				self._displayAlertDialog(error);
	                 }
	            };
				var params = {};
				params.itemIds = [];
				for (var i in selectedEWIs) {
                	var ter = selectedEWIs[i];
                	params.itemIds.push(ter.itemId);
				}
				var responseHandler =  this.contentIsVirtual ? new ServiceResponseHandler(getTERHandler, "success", "error") : new EWIMapper(getTERHandler, "success", "error");
	            ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, params);	            
			}
	            
		};
		
        var handler = {
            success: function(){
                ProgressUtility.endTaskMonitor(self.bulkChangeMonId);
                dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, selectedEWIs]);
                if (self.ewiList && args2 && args2.workItems && args2.workItems.length > 0) {
                	getCurrentResultAndAssociateDefect(selectedEWIs);
                }else{                
					self.updateTable(selectedEWIs);
                }
            },
            error: function(err){
            	var error = (err && err.message)?err.message:null;
                ProgressUtility.endTaskMonitor(self.bulkChangeMonId,error);
				if(err.errorClass == "com.ibm.rqm.execution.common.TestcaseExecutionRecordAlreadyExistException"){
					self._displayAlertDialog(err.message);
				}else
                self._error(err);
            }
        };
        var postArgs = {};
		postArgs.ewiStateIds = [];
		postArgs.ewiItemIds = [];		
		if (lastResultChange) {
			postArgs.scriptItemids = [];						
		}
		var length=(selectedEWIs ? selectedEWIs.length : 0);
        for (var i = 0; i < length; i++) {
        	var selectedEWI=selectedEWIs[i];
        	if(!selectedEWI.isNew){
	            postArgs.ewiItemIds.push(selectedEWI.itemId);
				postArgs.ewiStateIds.push(selectedEWI.stateId);
				if (lastResultChange) {
					var scriptId = this._getSelectedScriptId(selectedEWI);
					postArgs.scriptItemids.push(scriptId);
				}
	        }
        }
		if (weightChange) {
			postArgs.weight = args.weight;
		}	
		if (ownerChange) {
			postArgs.owner = args.OwnerUserId;
		}	
		if (iterationChange) {
			postArgs.testPhase = args.testPhaseItemId;
		}
		if(teamAreaChange){
			postArgs.teamArea = args.teamArea;
		}
		if (lastResultChange) {
			postArgs.currentResult = args2.verdict;
			if(args2.customAttributesJson)// Its possible this is not present
				postArgs.execResultCustomAttributesJson = args2.customAttributesJson;
			postArgs.notes = args2.notes;
			postArgs.execResultCustomAttributesJson = args2.execResultCustomAttributesJson; 
			postArgs.sortableCategories = args2.sortableCategories ;
			postArgs.categories = args2.categories ;
			postArgs.pointsAttemptedPercent = args2.pointsAttemptedPercent; 
			postArgs.pointsBlockedPercent = args2.pointsBlockedPercent ;
			postArgs.pointsFailedPercent = args2.pointsFailedPercent ;
			postArgs.pointsInconclusivePercent = args2.pointsInconclusivePercent;  
			postArgs.pointsPassedPercent = args2.pointsPassedPercent	;
			postArgs.pointsPermFailedPercent =args2.pointsPermFailedPercent	; 
			postArgs.pointsDeferredPercent = args2.pointsDeferredPercent;
			postArgs.buildRecordItemId = args2.buildUUID;
			postArgs.channelId = args2.channelId;
		}	
		if(planChange){
			postArgs.testPlanItemId = args.testPlanVersionableItemId?args.testPlanVersionableItemId:"Unassigned";
		}
		if(priorityChange){
			postArgs.executionPriority = args.priority;
		}
		if(estimateChange){
			postArgs.estimate = args.duration;
		}
		if(timeSpentChange){
			postArgs.timeSpent = args.duration;
		}
        if(categoryChange){
            postArgs.categories = args.categories;
            postArgs.categoryTypeIds = args.categoryTypeIds;
            if(args.sortableCategories) {
                postArgs.sortableCategories = args.sortableCategories;
            }
        }
		postArgs.resolveChangedTER = true;//this.contentIsVirtual ? false : true;

		if(postArgs.ewiItemIds.length){
		  	var responseHandler =  this.contentIsVirtual ? new ServiceResponseHandler(handler, "success", "error") : new EWIMapper(handler, "success", "error");
            ExecutionWorkItemClient.postBulkChangeEWI(responseHandler, postArgs); 
            this.bulkChangeMonId = ProgressUtility.beginTaskMonitor(Constants.getMessage("labelChangeProperties", args.actionId), 0, null);
		}
	},
	
	updateTable : function(newContent){
		if(this.contentIsVirtual) {
            this.refreshQuery();
            return;
        }
    
        var content = this.tableViewer.getContent();
        for (var i in newContent) {
        	var ter=newContent[i];
        	var terId=ter.id;
            for (var j in content) {
            	var theContent=content[j];
                if (theContent.id == terId) {
					theContent.stateId = ter.stateId;
                    theContent.modified = ter.modified;
                    theContent.weight = ter.weight;
					theContent.owner = {
						name: ter.owner ? ter.owner.name : Constants.getMessage("labelUnassigned"),
						userId: ter.owner ? ter.owner.userId : null
					};
					theContent.phase = {
						itemId: ter.phase ? ter.phase.itemId : null,
						name: ter.phase ? ter.phase.name : Constants.getMessage("labelUnassigned")
					};
					theContent.testPlan = ter.testPlan;
					theContent.currentResult = ter.currentResult;
					theContent.executionPriority = ter.executionPriority;
					theContent.estimate = ter.estimate;
					theContent.timeSpent = ter.timeSpent;
                }
            }
        }
		this.executionWorkItems = this.tableViewer.getContent();
        this.tableViewer.refresh();
	},

	getCurrentEditableRows: function(){
		return this.tableViewer.getContentProvider().getEditableRows();
	},

	getIsInEditMode:function(){
		return this.inEditMode;
	},

	uninitialize: function(){
		// Remove menu items
		if(this._itemsToTrack && this._itemsToTrack.menus){
			var menus = this._itemsToTrack.menus;
			var menuLength = menus.length;
			if(menus && menuLength>0){
				for(var i=0;i<menuLength;i++){
					menus[i].destroyRecursive();
				}
			}
		}
	}
	
});
})();
