/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.shared.ui.internal.columns.PlanColumnProvider");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.apt.api.client.IPlanElement");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.ui.structure.IGroupElement");
dojo.require("com.ibm.team.apt.shared.ui.internal.columns.PlanColumns");
dojo.require("com.ibm.team.apt.shared.ui.internal.gantt.GanttLinkProvider");
dojo.require("com.ibm.team.apt.shared.ui.structure.ScheduleGroupElement");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IColumn");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel");

(function() {
var jdojo2= com.ibm.jdojo;
var jdojo= jdojo2.lang.Runtime;
var Assert= jdojo2.util.Assert;
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var client= api.client;
var IPlanElement= client.IPlanElement;
var IPlanItem= client.IPlanItem;
var IGroupElement= api.ui.structure.IGroupElement;
var ui= apt.shared.ui;
var internal= ui.internal;
var PlanColumns= internal.columns.PlanColumns;
var GanttLinkProvider= internal.gantt.GanttLinkProvider;
var ScheduleGroupElement= ui.structure.ScheduleGroupElement;
var model2= team.rtc.foundation.api.ui.model;
var ColumnTag= model2.ColumnTag;
var Unit= model2.IColumn.Unit;
var Domain= model2.IViewModel.Domain;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.apt.shared.ui.internal.columns.PlanColumnProvider", null, {
	"-chains-": { constructor: "manual" },

	//fColumnSize: null,

	//fHiddenColumns: null,

	//fShowWorkItemHeadersInRoot: null,

	//fRootHeaders: null,

	//fPlanElementColumns: null,

	//fGroupElementColumns: null,

	//fScheduleGroupElementColumns: null,

	//fEntryColumnsHeaders: null,

	//fColumnPropertyDescriptors: null,

	//fPlanColumnPropertyDescriptors: null,

	//fMissingColumns: null,

	//fLinkProviders: null,

	//fInput: null,

	constructor: function(columns, columnContext) {
		this.fColumnSize= {};
		this.fHiddenColumns= {};
		this.fMissingColumns= [];
		this.fLinkProviders= [];
		var descriptor;
		this.fColumnPropertyDescriptors= [];
		for (var i= 0; i < columns.length; i++){
			var column= columns[i];
			descriptor= columnContext.createColumnDescriptor(column);
			if (descriptor != null) {
				this.fColumnPropertyDescriptors.push(descriptor);
				if (jdojo.implementsInterface(descriptor, "com.ibm.team.apt.api.ui.essentials.IGanttColumnPropertyDescriptor")) {
					this.fLinkProviders.push(new GanttLinkProvider(descriptor));
				}
			} else {
				this.fMissingColumns.push(column.getAttribute().getHandleValue());
			}
		}
		this.fPlanColumnPropertyDescriptors= {};
		this.fPlanColumnPropertyDescriptors[PlanColumns.ACTION.getIdentifier()]= columnContext.createPlanColumnDescriptor(PlanColumns.ACTION);
		this.fPlanColumnPropertyDescriptors[PlanColumns.MARKER.getIdentifier()]= columnContext.createPlanColumnDescriptor(PlanColumns.MARKER);
		this.fPlanColumnPropertyDescriptors[PlanColumns.GROUP_INFO.getIdentifier()]= columnContext.createPlanColumnDescriptor(PlanColumns.GROUP_INFO);
		this.fPlanColumnPropertyDescriptors[PlanColumns.GROUP_PROGRESS.getIdentifier()]= columnContext.createPlanColumnDescriptor(PlanColumns.GROUP_PROGRESS);
	},

	setColumnSize: function(identifier, data) {
		this.fColumnSize[identifier.getId()]= data;
	},

	setColumnVisibility: function(columnIdentifier, visible) {
		if (visible) {
			delete this.fHiddenColumns[columnIdentifier];
		} else {
			this.fHiddenColumns[columnIdentifier]= true;
		}
	},

	getMissingColumns: function() {
		return this.fMissingColumns;
	},

	provideColumnInfo: function(viewEntry, readAccessor) {
		var element= viewEntry.getElement();
		if (jdojo.implementsInterface(element, "com.ibm.team.apt.api.client.IPlanElement")) 
			return this.fPlanElementColumns[this.getEntryColumn(viewEntry, readAccessor).getIdentifier()];
		if (element instanceof ScheduleGroupElement) 
			return this.fScheduleGroupElementColumns[this.getEntryColumn(viewEntry, readAccessor).getIdentifier()];
		if (jdojo.implementsInterface(element, "com.ibm.team.apt.api.ui.structure.IGroupElement")) 
			return this.fGroupElementColumns[this.getEntryColumn(viewEntry, readAccessor).getIdentifier()];
		if (jdojo.implementsInterface(element, "com.ibm.team.rtc.foundation.api.ui.model.IEntryColumn")) 
			return this.fEntryColumnsHeaders[element.getIdentifier()];
		return null;
	},

	getEntryColumn: function(viewEntry, readAccessor) {
		return readAccessor.getRootColumn();
	},

	inputChanged: function(model, newInput) {
		if (!(newInput == null || jdojo.implementsInterface(newInput, "com.ibm.team.apt.api.client.IPlanModel"))) Assert.fail("newInput == null || jdojo.implementsInterface(newInput, \"com.ibm.team.apt.api.client.IPlanModel\")", "PlanColumnProvider:143");
		this.fInput= newInput;
	},

	showHeadersInRoot: function(showHeadersInRoot) {
		this.fShowWorkItemHeadersInRoot= showHeadersInRoot;
	},

	getLinkProviders: function() {
		return this.fLinkProviders;
	},

	refreshHeader: function(updateAccessor) {
		this.fGroupElementColumns= {};
		this.fScheduleGroupElementColumns= {};
		this.fPlanElementColumns= {};
		this.fEntryColumnsHeaders= {};
		this.fRootHeaders= [];
		var rootColumn= updateAccessor.getRootColumn();
		this.addColumnsToEntryColumn(rootColumn, updateAccessor);
		if (this.fShowWorkItemHeadersInRoot) {
			this.fRootHeaders.push(this.fPlanElementColumns[rootColumn.getIdentifier()].getPropertyColumns());
		}
		if (this.fRootHeaders.length > 0) {
			updateAccessor.setTag(updateAccessor.getRootEntry(Domain.Content), new ColumnTag(null, this.fRootHeaders));
		}
	},

	addColumnsToEntryColumn: function(rootColumn, updateAccessor) {
		var desc;
		var column;
		var planElementColumns= rootColumn.addPropertyColumnList(IPlanElement.prototype.declaredClass, updateAccessor);
		desc= this.fPlanColumnPropertyDescriptors[PlanColumns.ACTION.getIdentifier()];
		if (this.isColumnVisible(desc.getId())) {
			column= planElementColumns.addColumn(desc.getId(), desc.getName(), null, desc, updateAccessor);
			column.setSize({size: 72, unit: Unit.px}, null, 0, updateAccessor);
		}
		desc= this.fPlanColumnPropertyDescriptors[PlanColumns.MARKER.getIdentifier()];
		if (this.isColumnVisible(desc.getId())) {
			column= planElementColumns.addColumn(desc.getId(), desc.getName(), null, desc, updateAccessor);
			column.setSize({size: 12, unit: Unit.px}, null, 0, updateAccessor);
		}
		var $subject= this.fColumnPropertyDescriptors;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var descriptor= $subject[$count];
			if (this.isColumnVisible(descriptor.getId())) {
				column= planElementColumns.addColumn(descriptor.getId(), descriptor.getName(), null, descriptor, updateAccessor);
				var sizeData= this.fColumnSize[descriptor.getId()];
				if (sizeData != null) {
					column.setSize(sizeData.min, sizeData.max, sizeData.weight, updateAccessor);
				} else {
					column.setSize(null, null, 10, updateAccessor);
				}
				if (jdojo.implementsInterface(descriptor, "com.ibm.team.apt.api.ui.essentials.IGanttColumnPropertyDescriptor")) {
					this.fRootHeaders.push(new GanttHeaderColumnList(column));
					var $subject2= this.fLinkProviders;
					var $length2= $subject2.length;
					for (var $count2= 0; $count2 < $length2; $count2++){
						var planningLinkProvider= $subject2[$count2];
						if (planningLinkProvider instanceof GanttLinkProvider) {
							if (planningLinkProvider.getDescriptor() === descriptor) {
								planningLinkProvider.setGanttColumn(column);
							}
						}
					}
				}
			}
		}
		var groupElementColumns= rootColumn.addPropertyColumnList(IGroupElement.prototype.declaredClass, updateAccessor);
		desc= this.fPlanColumnPropertyDescriptors[PlanColumns.ACTION.getIdentifier()];
		if (this.isColumnVisible(desc.getId())) {
			column= groupElementColumns.addColumn(desc.getId(), desc.getName(), null, desc, updateAccessor);
			column.setSize({size: 72, unit: Unit.px}, null, 0, updateAccessor);
		}
		desc= this.fPlanColumnPropertyDescriptors[PlanColumns.GROUP_INFO.getIdentifier()];
		if (this.isColumnVisible(desc.getId())) {
			column= groupElementColumns.addColumn(desc.getId(), desc.getName(), null, desc, updateAccessor);
			column.setSize(null, null, 10, updateAccessor);
		}
		desc= this.fPlanColumnPropertyDescriptors[PlanColumns.GROUP_PROGRESS.getIdentifier()];
		if (this.isColumnVisible(desc.getId())) {
			column= groupElementColumns.addColumn(desc.getId(), desc.getName(), null, desc, updateAccessor);
			column.setSize({size: 400, unit: Unit.px}, null, 0, updateAccessor);
		}
		var scheduleGroupElementColumns= rootColumn.addPropertyColumnList(ScheduleGroupElement.prototype.declaredClass, updateAccessor);
		desc= this.fPlanColumnPropertyDescriptors[PlanColumns.GROUP_INFO.getIdentifier()];
		if (this.isColumnVisible(desc.getId())) {
			column= scheduleGroupElementColumns.addColumn(desc.getId(), desc.getName(), null, desc, updateAccessor);
			column.setSize(null, null, 10, updateAccessor);
		}
		this.fPlanElementColumns[rootColumn.getIdentifier()]= new ColumnTag(planElementColumns, null);
		this.fGroupElementColumns[rootColumn.getIdentifier()]= new ColumnTag(groupElementColumns, [planElementColumns]);
		this.fScheduleGroupElementColumns[rootColumn.getIdentifier()]= new ColumnTag(scheduleGroupElementColumns, null);
		this.fEntryColumnsHeaders[rootColumn.getIdentifier()]= new ColumnTag(null, null);
	},

	isColumnVisible: function(columnIdentifier) {
		return !(columnIdentifier in this.fHiddenColumns);
	},

	getDependentAttributes: function() {
		var result= [IPlanItem.RESOLVED];
		var $subject3= this.fColumnPropertyDescriptors;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var descriptor= $subject3[$count3];
			if (jdojo.implementsInterface(descriptor, "com.ibm.team.apt.api.client.IPlanningAttributeDependent")) {
				Array.prototype.push.apply(result, descriptor.getDependentAttributes());
			}
		}
		var $subject4= jdojo.getProperties(this.fPlanColumnPropertyDescriptors);
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var key= $subject4[$count4];
			var descriptor= this.fPlanColumnPropertyDescriptors[key];
			if (jdojo.implementsInterface(descriptor, "com.ibm.team.apt.api.client.IPlanningAttributeDependent")) {
				Array.prototype.push.apply(result, descriptor.getDependentAttributes());
			}
		}
		for (var i= 0; i < this.fLinkProviders.length; i++){
			var referenceAttribute= this.fLinkProviders[i].getReferenceAttribute();
			if (referenceAttribute != null) 
				result.push(referenceAttribute);
		}
		return result;
	},

	$interfaces: {
		'com.ibm.team.apt.api.client.IPlanningAttributeDependent': true
	}
});
var GanttHeaderColumnList= dojo.declare("com.ibm.team.apt.shared.ui.internal.columns.PlanColumnProvider.GanttHeaderColumnList", null, {
	"-chains-": { constructor: "manual" },

	//fColumns: null,

	constructor: function(ganttColumn) {
		this.fColumns= [new GanttControlColumn(ganttColumn, this)];
	},

	getIdentifier: function() {
		return GanttHeaderColumnList.ID;
	},

	getId: function() {
		return GanttHeaderColumnList.ID;
	},

	getColumns: function(readAccessor) {
		return this.fColumns;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true,
		'com.ibm.team.rtc.foundation.api.ui.model.IColumnList': true
	}
});
var GanttControlColumn= dojo.declare("com.ibm.team.apt.shared.ui.internal.columns.PlanColumnProvider.GanttControlColumn", null, {
	"-chains-": { constructor: "manual" },

	//fColumn: null,

	//fGanttHeaderColumnList: null,

	constructor: function(column, ganttHeaderColumnList) {
		this.fColumn= column;
		this.fGanttHeaderColumnList= ganttHeaderColumnList;
	},

	getIdentifier: function() {
		return this.fColumn.getIdentifier();
	},

	getMinimalSize: function() {
		return this.fColumn.getMinimalSize();
	},

	getMaximalSize: function() {
		return this.fColumn.getMaximalSize();
	},

	getWeight: function() {
		return this.fColumn.getWeight();
	},

	getId: function() {
		return this.fColumn.getId();
	},

	getLabel: function() {
		return this.fColumn.getLabel();
	},

	getIconUri: function() {
		return this.fColumn.getIconUri();
	},

	setSize: function(minSize, maxSize, weight, updateAccessor) {
		this.fColumn.setSize(minSize, maxSize, weight, updateAccessor);
	},

	getColumnList: function() {
		return this.fGanttHeaderColumnList;
	},

	getPropertyDescriptor: function() {
		return this.fColumn.getPropertyDescriptor();
	},

	getColumn: function() {
		return this.fColumn;
	},

	isCollapsible: function() {
		return false;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true,
		'com.ibm.team.rtc.foundation.api.ui.model.IColumn': true,
		'com.ibm.team.rtc.foundation.api.ui.model.IPropertyColumn': true
	}
});

GanttHeaderColumnList.ID= "com.ibm.team.apt.gantt";

})();
