/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.client.internal.model.attributes.SnapshotWorkItemScheduleAttribute");

dojo.require("com.ibm.team.apt.api.client.ICmChangeRequest");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.common.ItemType");
dojo.require("com.ibm.team.apt.api.common.UIItemHandle");
dojo.require("com.ibm.team.apt.api.common.planning.ISnapshotTypes");
dojo.require("com.ibm.team.apt.shared.client.internal.duration.Timespan");
dojo.require("com.ibm.team.apt.shared.client.internal.util.CountingFuture");
dojo.require("com.ibm.team.apt.shared.client.internal.util.Future");
dojo.require("com.ibm.team.apt.web.client.internal.items.compability.ChangeRequest");
dojo.require("com.ibm.team.apt.web.client.internal.items.compability.PlannedFor");
dojo.require("com.ibm.team.apt.web.client.internal.items.compability.Schedule");
dojo.require("com.ibm.team.apt.web.client.internal.items.process.Iteration");
dojo.require("com.ibm.team.apt.web.client.internal.items.snapshots.SnapshotWorkItemScheduleList");
dojo.require("com.ibm.team.apt.web.client.internal.model.attributes.AbstractWebClientAttribute");
dojo.require("com.ibm.team.apt.web.client.util");
dojo.require("com.ibm.team.rtc.foundation.web.ui.items.model.CountDownFutureBuilder");
dojo.require("dojo.date.stamp");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.apt.web.client.internal.model.attributes", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.client.internal.model.attributes", "Messages");

var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var client= api.client;
var ICmChangeRequest= client.ICmChangeRequest;
var IPlanItem= client.IPlanItem;
var common= api.common;
var ItemType= common.ItemType;
var UIItemHandle= common.UIItemHandle;
var ISnapshotTypes= common.planning.ISnapshotTypes;
var internal= apt.shared.client.internal;
var Timespan= internal.duration.Timespan;
var util2= internal.util;
var CountingFuture= util2.CountingFuture;
var Future= util2.Future;
var client2= apt.web.client;
var internal2= client2.internal;
var items3= internal2.items;
var compability= items3.compability;
var ChangeRequest= compability.ChangeRequest;
var ChangeRequestProfile= ChangeRequest.ChangeRequestProfile;
var PlannedForProfile= compability.PlannedFor.PlannedForProfile;
var ScheduleProfile= compability.Schedule.ScheduleProfile;
var Iteration= items3.process.Iteration;
var SnapshotWorkItemScheduleList= items3.snapshots.SnapshotWorkItemScheduleList;
var AbstractWebClientAttribute= internal2.model.attributes.AbstractWebClientAttribute;
var util= client2.util;
var CountDownFutureBuilder= team.rtc.foundation.web.ui.items.model.CountDownFutureBuilder;
var string= dojo.string;

dojo.declare("com.ibm.team.apt.web.client.internal.model.attributes.SnapshotWorkItemScheduleAttribute", AbstractWebClientAttribute, {

	//fPlanningClient: null,

	constructor: function(description, planningClient, context) {
		this.inherited(arguments, [description, planningClient, context]);
		this.fPlanningClient= this.getPlanningClient();
	},

	initialize: function(planModel, planElements, future /*, flags... */ ) {
		var handles= [];
		var items= [];
		var $subject= planElements;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var planElement= $subject[$count];
			var planItem= planElement.getAdapter(IPlanItem);
			if (planItem != null && !planItem.getWorkItem().isNew()) {
				var workItem= planItem.getWorkItem();
				var workItemUIItem= UIItemHandle.itemHandleFor(workItem);
				handles.push(workItemUIItem);
				continue;
			}
			var changeRequest= planElement.getAdapter(ICmChangeRequest);
			if (changeRequest != null) {
				items.push(changeRequest.getItem());
				continue;
			}
			planElement.define(this, null);
		}
		var count= Math.min(1, handles.length) + Math.min(1, items.length);
		if (count === 0) {
			future.callback(null);
			return ;
		}
		var countingFuture= new CountingFuture(count, future);
		if (handles.length !== 0) {
			this.getWorkItemsInSnapshotOfType(planModel, handles, countingFuture);
		}
		if (items.length !== 0) {
			this.getScheduleFromCmChangeRequests(planModel, items, countingFuture);
		}
	},

	getWorkItemsInSnapshotOfType: function(planModel, handles, future) {
		var $this= this;
		var errHandler= function(object) {
			future.errback(object);
		};
		var handleFuture= new Future();
		handleFuture.setErrCallback(errHandler);
		handleFuture.setCallback(function(workItemScheduleListDTO) {
			var workItemScheduleList= new SnapshotWorkItemScheduleList(workItemScheduleListDTO);
			var workItemScheduleMap= workItemScheduleList.getSnapshotWorkItemsMap();
			for (var i= 0; i < handles.length; i++){
				var itemId= handles[i].getItemId();
				var planElement= planModel.getPlanElement(itemId);
				var scheduleInfo= null;
				var schedule= workItemScheduleMap[itemId];
				if (schedule != null && schedule.getStartDate() != null && schedule.getEndDate() != null) {
					scheduleInfo= {};
					scheduleInfo.value= new Timespan(schedule.getStartDate(), schedule.getEndDate());
					var planName= schedule.getPlanName();
					if (planName != null) {
						scheduleInfo.explanation= string.substitute(Messages.SnapshotWorkItemScheduleAttribute_EXPLAIN_DATES_FROM_SNAPSHOT, [planName ]);
					}
					if (schedule.getPlanHandle() != null) {
						scheduleInfo.scheduleUri= util.getPlanViewURI(schedule.getPlanHandle().getItemId(), null);
					}
				}
				planElement.define($this, scheduleInfo);
			}
			future.callback(null);
		});
		this.fPlanningClient.postWorkItemsInSnapshotOfType(handles, handleFuture, ISnapshotTypes.TYPE_PLANNED);
	},

	getScheduleFromCmChangeRequests: function(planModel, items, countingFuture) {
		var $this= this;
		var builder= new CountDownFutureBuilder();
		dojo.forEach(items, function(item, index, array) {
			var profile= new ChangeRequestProfile().schedule(new ScheduleProfile().plannedEndDate().plannedStartDate().scheduleUri().schedulingReasons()).plannedFor(new PlannedForProfile().startDate().endDate().title()).dueDate();
			builder.add(ChangeRequest.load(item, profile, true).onSuccess(function(changeRequest) {
				var scheduleItem= changeRequest.getSchedule();
				if (scheduleItem != null) {
					var start= scheduleItem.getPlannedStartDate();
					var end= scheduleItem.getPlannedEndDate();
					var scheduleInfo= null;
					if (start != null && end != null) {
						scheduleInfo= {};
						scheduleInfo.value= new Timespan(start, end);
						scheduleInfo.explanation= scheduleItem.getSchedulingReasons();
						scheduleInfo.scheduleUri= scheduleItem.getScheduleUri();
					}
					planModel.getPlanElement(item.fHandle.fItemId).define($this, scheduleInfo);
				}
				var plannedForItem= changeRequest.getPlannedFor();
				if (plannedForItem != null && plannedForItem.getStartDate() != null && plannedForItem.getEndDate() != null) {
					var iterationItemDTO= {};
					iterationItemDTO.itemType= ItemType.Iteration.getQualifiedName();
					var startDate= new Date(plannedForItem.getStartDate().getTime());
					iterationItemDTO.startDate= dojo.date.stamp.toISOString(startDate);
					var endDate= new Date(plannedForItem.getEndDate().getTime());
					iterationItemDTO.endDate= dojo.date.stamp.toISOString(endDate);
					iterationItemDTO.label= plannedForItem.getLabel();
					var iteration= new Iteration(iterationItemDTO);
					planModel.getPlanElement(item.fHandle.fItemId).define(IPlanItem.TARGET, iteration);
				}
				var dueDate= changeRequest.getDueDate();
				planModel.getPlanElement(item.fHandle.fItemId).define(IPlanItem.DUE_DATE, dueDate);
			}));
		});
		var future= builder.buildNamed("<init> SnashotWorkItemSchedulerAttribute");
		future.onError(function(error) {
			countingFuture.errback(error);
		});
		future.onSuccess(function(_void) {
			countingFuture.callback(null);
		});
	}
});

})();
