/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2009, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.calm.PlanPickerContent");

dojo.require("com.ibm.team.apt.api.common.UIItemHandle");
dojo.require("com.ibm.team.apt.api.common.query.PredefinedQueries");
dojo.require("com.ibm.team.apt.shared.client.internal.util.Future");
dojo.require("com.ibm.team.apt.web.client.CALMDialogPlanningClient");
dojo.require("com.ibm.team.apt.web.client.internal.query.QueryDescriptor");
dojo.require("com.ibm.team.apt.web.ui.internal.calm.PlanPickerListBox");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages");

(function() {
var IterationPlanMessages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages");

var apt= com.ibm.team.apt;
var common= apt.api.common;
var UIItemHandle= common.UIItemHandle;
var PredefinedQueries= common.query.PredefinedQueries;
var Future= apt.shared.client.internal.util.Future;
var web= apt.web;
var client= web.client;
var CALMDialogPlanningClient= client.CALMDialogPlanningClient;
var QueryDescriptor= client.internal.query.QueryDescriptor;
var PlanPickerListBox= web.ui.internal.calm.PlanPickerListBox;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;

dojo.declare("com.ibm.team.apt.web.ui.internal.calm.PlanPickerContent", [ _Widget, _Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web.ui", "internal/calm/templates/PlanPickerContent.html"),

	//results: null,

	//queryInput: null,

	//projectAreaValue: null,

	//okCmd: null,

	//cancelCmd: null,

	//status: null,

	//checkboxShowCurrent: null,

	//list: null,

	//_projectAreaId: null,

	//_projectAreaName: null,

	//_onCloseCallback: null,

	//_allowMultipleSelection: null,

	//_applicationURL: null,

	//DELAY: null,

	intervalID: 0,

	//ProjectArea: null,

	//EnterSearchString: null,

	//MatchingPlans: null,

	//OkButton: null,

	//CancelButton: null,

	//OnlyCurrentPlans: null,

	//Disabled: null,

	//EMPTY_STRING: null,

	constructor: function(params) {
		this.DELAY= 750;
		this.Disabled= "Disabled";
		this.EMPTY_STRING= "";
		this._projectAreaId= params.projectAreaId;
		this._projectAreaName= params.projectAreaName;
		this._onCloseCallback= params.onCloseCallback;
		this._allowMultipleSelection= params.allowMultipleSelection;
		this._applicationURL= params.applicationURL;
		this.ProjectArea= IterationPlanMessages.PLAN_PICKER_PROJECTAREA;
		this.EnterSearchString= IterationPlanMessages.PLAN_PICKER_ENTERSEARCHSTRING;
		this.MatchingPlans= IterationPlanMessages.PLAN_PICKER_MATCHING_PLANS_LABEL;
		this.OkButton= IterationPlanMessages.PLAN_PICKER_OKBUTTON;
		this.CancelButton= IterationPlanMessages.PLAN_PICKER_CANCELBUTTON;
		this.OnlyCurrentPlans= IterationPlanMessages.PLAN_PICKER_ONLY_CURRENT_PLANS;
	},

	postCreate: function() {
		this._initalize();
		this._connectEvents();
		this.subscribeEvents();
		this._doSearch();
		this.inherited("postCreate", arguments, []);
	},

	/**
	 * Initialize the List Box 
	 * Add the onDoubleClick and onClick 
	 */
	_initalize: function() {
		this.projectAreaValue.appendChild(window.document.createTextNode(this._projectAreaName));
		if (this.list == null) {
			var params= {};
			params.ondblClick= dojo.hitch(this, function(entry) {
				this._onOkButton([entry.value]);
			});
			params.allowMultipleSelections= this._allowMultipleSelection;
			this.list= new PlanPickerListBox(params);
		}
		this.results.appendChild(this.list.domNode);
	},

	subscribeEvents: function() {
		dojo.subscribe("PUBLISH_ON_SELECT", this, "_enable");
		dojo.subscribe("PUBLISH_ON_ESCAPE", this, "_onCancel");
		dojo.subscribe("PUBLISH_ON_ENTER", this, "_onClickOk");
		dojo.subscribe("PUBLISH_ON_CHANGE_FOCUS", this, "_setFocus");
	},

	_setFocus: function() {
		this.queryInput.focus();
	},

	/**
	 * Connect the Required Events 
	 */
	_connectEvents: function() {
		this.connect(this.queryInput, 'keyup', dojo.hitch(this, function(e) {
			this._search(e);
		}));
		this.connect(this.okCmd, 'click', dojo.hitch(this, function(e) {
			this._onClickOk();
		}));
		this.connect(this.cancelCmd, 'click', dojo.hitch(this, function(e) {
			this._onCancel();
		}));
		this.connect(this.checkboxShowCurrent, 'click', dojo.hitch(this, function(e) {
			this._onShowCurrentFilterChanged();
		}));
	},

	/**
	 * Call the Search method and add the Message
	 */
	_doSearch: function() {
		var queryString= this.queryInput.value;
		this.status.innerHTML= IterationPlanMessages.PLAN_PICKER_SEARCHING;
		var onSuccess= dojo.hitch(this, "_onSearchPerformed");
		var onFailure= dojo.hitch(this, "_searchProblem");
		var searchCompleted= new Future();
		searchCompleted.setCallback(onSuccess);
		searchCompleted.setErrCallback(onFailure);
		var showCurrent= this.checkboxShowCurrent.checked;
		var query= showCurrent ? PredefinedQueries.CURRENTPLANS : PredefinedQueries.ALLPLANS;
		var queryDescriptor= QueryDescriptor.newPredefinedQuery(query, queryString, String(new Date().getMilliseconds()));
		var planningClient= CALMDialogPlanningClient.getInstance();
		planningClient.searchPlans(this._projectAreaId, queryDescriptor, 0, 100, null, searchCompleted);
	},

	/**
	 * Reset and search 
	 */
	_search: function(kEvent) {
		this._reset();
		if (kEvent != null) {
			if (kEvent.keyCode === 38) {
				return ;
			}
			if (kEvent.keyCode === 40) {
				var args= [this];
				dojo.publish("PUBLISH_ON_CHANGE_DOWN", args);
				return ;
			}
		}
		if (this.intervalID > 0) {
			window.clearTimeout(this.intervalID);
		}
		this.intervalID= window.setTimeout(dojo.hitch(this, function() {
			this._doSearch();
		}), this.DELAY);
	},

	/**
	 * On selection , enable the Ok Button
	 * @param label
	 * @param id
	 */
	_onOk: function(label, id) {
		this.okCmd.disabled= this.EMPTY_STRING;
	},

	_enable: function() {
		this.okCmd.disabled= this.EMPTY_STRING;
	},

	/**
	 * Populate the list box with Results and handle accordingly
	 * @param result
	 */
	_onSearchPerformed: function(searchResult) {
		var numberOfMatches= 0;
		var planHandles= [];
		if (searchResult.items != null) {
			numberOfMatches= searchResult.items.length;
			var $subject= searchResult.items;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var item= $subject[$count];
				planHandles.push(UIItemHandle.fromHandle(item));
			}
		}
		var message;
		var hidden= searchResult.totalPlans - planHandles.length;
		if (hidden <= 0) {
			message= dojo.string.substitute(IterationPlanMessages.PLAN_PICKER_RESULTS, [numberOfMatches]);
		} else {
			message= dojo.string.substitute(IterationPlanMessages.PLAN_PICKER_RESULTS_HIDDEN, [numberOfMatches, searchResult.totalPlans]);
		}
		this.status.innerHTML= message;
		var plansLoadedCallback= dojo.hitch(this, "_onSearchResultsEvaluated");
		var errorCallback= dojo.hitch(this, "_searchProblem");
		var plansLoaded= new Future();
		plansLoaded.setCallback(plansLoadedCallback);
		plansLoaded.setErrCallback(errorCallback);
		var planningClient= CALMDialogPlanningClient.getInstance();
		planningClient.getItemStore().withItems(planHandles, plansLoaded);
	},

	_searchProblem: function(error) {
		this._handleError(String(error));
		this.status.innerHTML= IterationPlanMessages.PLAN_PICKER_NORESULTS;
	},

	/**
	 * Populate the list box with Results and handle accordingly
	 * @param result
	 */
	_onSearchResultsEvaluated: function(matchedPlans) {
		this.list.removeAllEntries();
		this.list.showLoading(true);
		var iterationHandles= [];
		for (var i= 0; i < matchedPlans.length; i++){
			var matchedPlan= matchedPlans[i];
			var entry= {};
			entry.label= matchedPlan.getLabel();
			entry.id= matchedPlan.getItemId();
			entry.value= matchedPlan;
			entry.type= matchedPlan.getItemType().name;
			this.list.addEntry(entry);
			var iterationHandle= matchedPlan.getIteration();
			if (iterationHandle != null) {
				iterationHandles.push(iterationHandle);
			}
		}
		this.list.selectFirst();
		this.results.replaceChild(this.list.domNode, this.list.domNode);
		this.results.setAttribute("tabIndex", "0");
		this.list.showLoading(false);
		var iterationsLoadedCallback= dojo.hitch(this, "_onIterationsEvaluated");
		var iterationsLoaded= new Future();
		iterationsLoaded.setCallback(iterationsLoadedCallback);
		var planningClient= CALMDialogPlanningClient.getInstance();
		planningClient.getItemStore().withItems(iterationHandles, iterationsLoaded);
	},

	_onIterationsEvaluated: function(iterations) {
		var allEntries= this.list.getAllEntries();
		for (var i= 0; i < allEntries.length; i++){
			var entry= allEntries[i];
			var record= entry.value;
			var iteration= this._findIteration(iterations, record.getIteration());
			if (iteration != null) {
				entry.subLabel= iteration.getLabel();
				this.list.update(entry);
			}
		}
	},

	_findIteration: function(iterations, handle) {
		for (var i= 0; i < iterations.length; i++){
			if (iterations[i].getItemId() === handle.getItemId()) {
				return iterations[i];
			}
		}
		return null;
	},

	/**
	 * On click of Ok get the selected item and Handle accordingly
	 */
	_onClickOk: function() {
		if (this.list != null) {
			var entries= this.list.getSelection();
			if (entries != null && entries.length > 0) {
				var records= [];
				for (var i= 0; i < entries.length; i++){
					var entry= entries[i];
					if (entry != null) {
						records.push(entry.value);
					}
				}
				this._onOkButton(records);
			}
		}
	},

	/**
	 * Handle the error Message
	 * @param errorMsg
	 */
	_handleError: function(error) {
		console.log(error);
	},

	/**
	 * Reset the ok button to disabled 
	 */
	_reset: function() {
		this.okCmd.disabled= this.Disabled;
		this.results.setAttribute("tabIndex", "1");
	},

	/**
	 * Call back and close
	 * @param label
	 * @param id
	 */
	_onOkButton: function(plans) {
		var results= [];
		for (var i= 0; i < plans.length; i++){
			var plan= plans[i];
			if (plan != null) {
				var result= {};
				result.summary= plan.getLabel();
				result.url= this._applicationURL + "resource/itemOid/com.ibm.team.apt.IterationPlanRecord/" + plan.getItemId();
				result.handleValue= UIItemHandle.itemHandleFor(plan).getHandleValue();
				results.push(result);
			}
		}
		this._close(results, "oslc_cm.select");
	},

	_close: function(resultArray, returnMessage) {
		if (this._onCloseCallback != null) {
			this._onCloseCallback(resultArray, returnMessage);
		}
	},

	_onCancel: function() {
		this._close(null, null);
	},

	_onShowCurrentFilterChanged: function() {
		this._search(null);
	}
});

})();
