/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule
 Contract with IBM Corp.
 ******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.tpt.web.ui.timesheet.internal.TimeSheetEntryPartWeb");

dojo.require("com.ibm.jdojo.lang.JavaScriptException");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.rtc.foundation.api.common.Severity");
dojo.require("com.ibm.team.rtc.foundation.api.common.Status");
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.Sprites");
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.StatusIndicator");
dojo.require("com.ibm.team.tpt.web.client.internal.TptClient");
dojo.require("com.ibm.team.tpt.web.ui.internal.TPTImagePool");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.dto.TimeSheetEntries");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.editor.WeekTextBox");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimeSheetColumnProvider");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimeSheetLabelProvider");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimesheetConstants");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimesheetTableViewer");
dojo.require("com.ibm.team.workitem.api.common.WorkItemCollections");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.date");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.tpt.web.ui.timesheet.internal.messages", "TimesheetMessages");

(function() {
var TimesheetMessages= dojo.i18n.getLocalization("com.ibm.team.tpt.web.ui.timesheet.internal.messages", "TimesheetMessages");

var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var team= com.ibm.team;
var ServiceResponseHandler= team.repository.web.transport.ServiceResponseHandler;
var foundation= team.rtc.foundation;
var common= foundation.api.common;
var Severity= common.Severity;
var Status= common.Status;
var ui= foundation.web.ui;
var Sprites= ui.util.Sprites;
var StatusIndicator= ui.widgets.StatusIndicator;
var web= team.tpt.web;
var TptClient= web.client.internal.TptClient;
var ui2= web.ui;
var TPTImagePool= ui2.internal.TPTImagePool;
var internal= ui2.timesheet.internal;
var TimeSheetEntries= internal.dto.TimeSheetEntries;
var WeekTextBox= internal.editor.WeekTextBox;
var viewers= internal.viewers;
var TimeSheetColumnProvider= viewers.TimeSheetColumnProvider;
var TimeSheetLabelProvider= viewers.TimeSheetLabelProvider;
var TimesheetConstants= viewers.TimesheetConstants;
var TimesheetTableViewer= viewers.TimesheetTableViewer;
var WorkItemCollections= team.workitem.api.common.WorkItemCollections;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;

dojo.declare("com.ibm.team.tpt.web.ui.timesheet.internal.TimeSheetEntryPartWeb", [ _Widget, _Templated], {

	//fTimecodeList: null,

	//isOperationComplete: null,

	//_startDateId: null,

	//_left_Seperator: null,

	//_right_Seperator: null,

	//_timesheet: null,

	//_previous: null,

	//_next: null,

	//_addButton: null,

	//_setStartDate: null,

	//_status: null,

	templatePath: dojo.moduleUrl("com.ibm.team.tpt.web.ui", "timesheet/internal/templates/TimeSheetEditorPage.html"),

	//fWorkitemCopy: null,

	//fTimesheetEntries: null,

	//ftWeekTextBox: null,

	//fWeekSelected: null,

	//ftTimeSheetViewer: null,

	//fProjectAreaId: null,

	//fTimeCodesArray: null,

	//fWorkItemType: null,

	//fHeader: null,

	//_statusIndicator: null,

	//eventHandlers: null,

	//subscribeHandle: null,

	//fTimeTrackingSyncEnabled: null,

	constructor: function(parameters) {
		this.isOperationComplete= false;
		this.eventHandlers= [];
		this.fTimeTrackingSyncEnabled= "false";
		if (parameters == null || parameters.workingCopy == null) {
			throw new JavaScriptException("TimeSheetEntryPartWeb: Invalid parameters");
		}
		this.fWorkitemCopy= parameters.workingCopy;
		this.fTimesheetEntries= new TimeSheetEntries(this.fWorkitemCopy);
		this.fHeader= parameters.parentController._editorParts;
		this.fProjectAreaId= this.fWorkitemCopy.getProjectAreaItemId();
		this.getTimeCodes();
		this.getWorkItemType();
		this.fetchTimetrackingInfo(this.fProjectAreaId);
	},

	getWorkItemType: function() {
		var args= {};
		args.path= [TimesheetConstants.WORKITEM_ATTRIBUTES, TimesheetConstants.WORKITEM_TYPE];
		var literal= this.fWorkitemCopy.getValue(args);
		if (literal != null) {
			this.fWorkItemType= literal.label;
		}
	},

	destroy: function(param) {
		if (this.ftTimeSheetViewer != null) {
			this.ftTimeSheetViewer.destroy(param);
		}
		var length= this.eventHandlers.length;
		for (var i= 0; i < length; i++){
			dojo.disconnect(this.eventHandlers.pop());
		}
		if (this.subscribeHandle != null) {
			dojo.unsubscribe(this.subscribeHandle);
			this.subscribeHandle= null;
		}
		this.inherited("destroy", arguments, [param]);
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []);
		this.createWeekPicker();
		var tptTimesheetTable= ["tptTSTable"];
		this.ftTimeSheetViewer= new TimesheetTableViewer();
		this.ftTimeSheetViewer.initializeTimesheetTableViewer(tptTimesheetTable, new TimeSheetLabelProvider(), new TimeSheetColumnProvider(), this.fWeekSelected, this);
		this.fCurrentUserId= com.ibm.team.repository.web.client.session.getAuthenticatedContributor().userId;
		this.fCurrentUserName= com.ibm.team.repository.web.client.session.getAuthenticatedContributor().name;
		this._timesheet.appendChild(this.ftTimeSheetViewer.domNode);
		this.createAddButton();
		var MaxDate= this.getMaxDate();
		if (MaxDate == null) {
			this.ftWeekTextBox.setValue(new Date());
			this.fWeekSelected= this.ftWeekTextBox.getValue();
			MaxDate= this.fWeekSelected;
		}
		this.ftWeekTextBox.setValue(MaxDate);
		this.fWeekSelected= this.ftWeekTextBox.getValue();
		this.ftTimeSheetViewer.setInput(this.fTimesheetEntries);
		this.ftTimeSheetViewer.setWorkItemType(this.fWorkItemType);
		this._statusIndicator= new StatusIndicator();
		dojo.place(this._statusIndicator.domNode, this._status);
		this.subscribeHandle= dojo.subscribe(TimesheetConstants.TIMESHEET_ENTRY_CLICKED, this, "handleTimesheetEntryClick");
	},

	handleTimesheetEntryClick: function(weekDate) {
		var newDate= new Date(weekDate);
		this.ftWeekTextBox.setValue(newDate);
		this.fWeekSelected= this.ftWeekTextBox.getValue();
	},

	/**
	 * Creates an add button for adding a new row to the time sheet table for entering a new time code
	 */
	createAddButton: function() {
		var textDivElement= window.document.createElement("span");
		textDivElement.appendChild(window.document.createTextNode(TimesheetMessages.ADD_TIMECODE_LABEL));
		var anchorDivElement= window.document.createElement("span");
		var ftAddButton= window.document.createElement("a");
		ftAddButton.href= "#";
		ftAddButton.setAttribute("title", TimesheetMessages.ADD_TIMECODE);
		var eventHandle= dojo.connect(ftAddButton, 'click', dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			this.addNewTimeSheetRow();
		}));
		dojo.addClass(ftAddButton, "anchorHover");
		this.eventHandlers.push(eventHandle);
		var imgDivElement= window.document.createElement("span");
		var img= Sprites.create(TPTImagePool.TIME_CODE);
		img.style.verticalAlign= "bottom";
		imgDivElement.appendChild(img);
		var textTimeCodeDivElement= window.document.createElement("span");
		textTimeCodeDivElement.appendChild(window.document.createTextNode(TimesheetMessages.TIME_ENTRY));
		ftAddButton.appendChild(imgDivElement);
		ftAddButton.appendChild(textTimeCodeDivElement);
		anchorDivElement.appendChild(ftAddButton);
		this._addButton.appendChild(textDivElement);
		this._addButton.appendChild(anchorDivElement);
	},

	/**
	 * 1. Get the list of time code if this is the first time and the time code array has not been initialized
	 * 2. Add a new row in the time sheet table
	 */
	addNewTimeSheetRow: function() {
		this.checkOwnerValidation();
		if (this.fTimeCodesArray == null) {
			this.readTimeCodes();
			if (this.fTimeCodesArray == null) {
				this.handleError(TimesheetMessages.NO_TIMECODE_PRESENT, Severity.INFO);
				return ;
			}
			this.ftTimeSheetViewer.setTimeCodes(this.fTimeCodesArray);
		}
		this.ftTimeSheetViewer.addTimesheetRow();
	},

	getTimeCodes: function() {
		this.fetchLiteralValue(this.fProjectAreaId, TimesheetConstants.TIMECODES_ID);
	},

	fetchLiteralValue: function(projectAreaId, literalId) {
		this.isOperationComplete= false;
		var onSuccess= dojo.hitch(this, function(result) {
			this.fTimecodeList= [];
			if (result != null && result.length > 0) {
				for (var x= 0; x < result.length; x++){
					this.fTimecodeList.push(result[x]);
				}
			}
			this.isOperationComplete= true;
		});
		var onFailure= dojo.hitch(this, function(result) {
			this.fTimecodeList= null;
			this.isOperationComplete= true;
			this.handleError(result.message, Severity.ERROR);
		});
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure');
		TptClient.getTimecodeForProjectArea(handler, projectAreaId);
	},

	fetchTimetrackingInfo: function(projectAreaId) {
		var onSuccess= dojo.hitch(this, function(result) {
			if (result != null) {
				this.fTimeTrackingSyncEnabled= result;
				this.setTimetrackingSyncInfo();
			}
		});
		var onFailure= dojo.hitch(this, function(result) {
			this.handleError(result.message, Severity.ERROR);
		});
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure');
		TptClient.getTimetrackingInfo(handler, projectAreaId);
	},

	setTimetrackingSyncInfo: function() {
		this.fTimesheetEntries.setTimetrackingSyncInfo(this.fTimeTrackingSyncEnabled);
	},

	handleError: function(message, severity) {
		this._statusIndicator.setStatus(new Status(severity, message));
	},

	readTimeCodes: function() {
		if (this.isOperationComplete) {
			if (this.fTimecodeList != null && this.fTimecodeList.length > 0) {
				this.fTimeCodesArray= new Array(this.fTimecodeList.length);
				for (var i= 0; i < this.fTimecodeList.length; i++){
					this.fTimeCodesArray[i]= this.fTimecodeList[i].label;
				}
			}
		}
	},

	createWeekPicker: function() {
		this.ftWeekTextBox= new WeekTextBox();
		var eventHandle= dojo.connect(this.ftWeekTextBox.weekPicker, "onChange", dojo.hitch(this, function(event) {
			this.fWeekSelected= this.ftWeekTextBox.getValue();
			this.resetWeekAndTimeSheetData();
		}));
		this.eventHandlers.push(eventHandle);
		this.ftWeekTextBox.buildView();
		this._startDateId.appendChild(this.ftWeekTextBox.domNode);
		this.fWeekSelected= this.ftWeekTextBox.getValue();
		var ftImg= window.document.createElement("img");
		ftImg.src= TPTImagePool.OUT_OF_OFFICE.toUri();
		this._setStartDate.appendChild(ftImg);
		eventHandle= dojo.connect(ftImg, 'click', dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			this.ftWeekTextBox.weekPicker.focus();
		}));
		this.eventHandlers.push(eventHandle);
		this._left_Seperator.appendChild(Sprites.create(TPTImagePool.SEPARATOR));
		this._right_Seperator.appendChild(Sprites.create(TPTImagePool.SEPARATOR));
		var ftPrevious= dojo.create("a", {href: "#", innerHTML: TimesheetMessages.PREVIOUS});
		this._previous.appendChild(ftPrevious);
		eventHandle= dojo.connect(ftPrevious, 'click', dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			this.fWeekSelected= this.ftWeekTextBox.getValue();
			this.fWeekSelected= new Date(this.fWeekSelected.getFullYear(), this.fWeekSelected.getMonth(), this.fWeekSelected.getDate() - 7, 12);
			this.ftWeekTextBox.setValue(this.fWeekSelected);
		}));
		this.eventHandlers.push(eventHandle);
		var ftNext= dojo.create("a", {href: "#", innerHTML: TimesheetMessages.NEXT});
		this._next.appendChild(ftNext);
		eventHandle= dojo.connect(ftNext, 'click', dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			this.fWeekSelected= this.ftWeekTextBox.getValue();
			this.fWeekSelected= new Date(this.fWeekSelected.getFullYear(), this.fWeekSelected.getMonth(), this.fWeekSelected.getDate() + 7, 12);
			this.ftWeekTextBox.setValue(this.fWeekSelected);
		}));
		this.eventHandlers.push(eventHandle);
	},

	resetWeekAndTimeSheetData: function() {
		this.ftTimeSheetViewer.setWeekDate(this.fWeekSelected);
	},

	_handleSave: function() {
		this.fTimesheetEntries.saveChanges();
	},

	getMaxDate: function() {
		var timesheetDTO= this.fTimesheetEntries.getTimeSheetEntries();
		var maxDate= new Date(0);
		for (var i= 0; i < timesheetDTO.length; i++){
			if (timesheetDTO[i] == null || timesheetDTO[i].startDate == null) 
				continue;
			var startDate= TimesheetTableViewer.getDTOStartDate(timesheetDTO[i]);
			if (dojo.date.compare(startDate, maxDate, "date") >= 0) {
				maxDate= startDate;
			}
		}
		if (dojo.date.compare(new Date(0), maxDate, "date") === 0) {
			return null;
		}
		return maxDate;
	},

	//fCurrentUserId: null,

	//fCurrentUserName: null,

	//fCurrentWIOwnerId: null,

	getCurrentWIOwner: function() {
		if (null == this.fCurrentWIOwnerId) {
			var args= {};
			args.path= [WorkItemCollections.ATTRIBUTES, "owner"];
			var argValue= this.fWorkitemCopy.getValue(args);
			this.fCurrentWIOwnerId= argValue.userId;
		}
		return this.fCurrentWIOwnerId;
	},

	checkOwnerValidation: function() {
		var wiOwner= this.getCurrentWIOwner();
		var currUser= com.ibm.team.repository.web.client.session.getAuthenticatedContributor().userId;
		if (currUser.localeCompare(wiOwner) !== 0) {
			this.handleError(TimesheetMessages.ONLY_WI_OWNER, Severity.WARNING);
		}
	}
});

})();
