/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.tpt.web.ui.timesheet.internal.dto.TimeSheetEntries");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.util.DateUtil");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimesheetConstants");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes");
dojo.require("dojo.date");
dojo.require("dojo.number");

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var internal= team.tpt.web.ui.timesheet.internal;
var DateUtil= internal.util.DateUtil;
var TimesheetConstants= internal.viewers.TimesheetConstants;
var WorkItemAttributes= team.workitem.web.client.internal.WorkItemAttributes;
var number= dojo.number;

dojo.declare("com.ibm.team.tpt.web.ui.timesheet.internal.dto.TimeSheetEntries", null, {
	"-chains-": { constructor: "manual" },

	//fTimeSheetEntries: null,

	//fOriginalItems: null,

	//fWorkitemCopy: null,

	//fTimeTrackingSyncEnabled: null,

	constructor: function(workitemCopy) {
		this.fTimeTrackingSyncEnabled= "false";
		this.fWorkitemCopy= workitemCopy;
		this.fTimeSheetEntries= [];
		this.fOriginalItems= {};
		var parms= {path: [TimesheetConstants.LINK_TYPES]};
		var linkTypeDTOs= workitemCopy.getValue(parms);
		var $subject= linkTypeDTOs;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var linkTypeDTO= $subject[$count];
			if ((TimesheetConstants.TIMESHEET_LINK_ID === linkTypeDTO.id)) {
				var linkDTOs= linkTypeDTO.linkDTOs;
				if (linkDTOs != null) {
					var $subject2= linkDTOs;
					var $length2= $subject2.length;
					for (var $count2= 0; $count2 < $length2; $count2++){
						var linkDTO= $subject2[$count2];
						var timeSheetEntry= linkDTO.target;
						if (timeSheetEntry != null) {
							var cloneDTO= dojo.clone(timeSheetEntry);
							this.fTimeSheetEntries.push(cloneDTO);
							this.fOriginalItems[linkDTO.itemId]= linkDTO;
						}
					}
				}
			}
		}
	},

	setTimetrackingSyncInfo: function(syncEnabled) {
		this.fTimeTrackingSyncEnabled= syncEnabled;
	},

	getTimeSheetEntries: function() {
		return this.fTimeSheetEntries;
	},

	addTimeSheetEntry: function(startDate, hoursSpent, workType, timeCode, userId) {
		var dto= {};
		dto.startDate= startDate;
		dto.timeSpent= Math.round(hoursSpent*1000*60*60);
		dto.workType= workType;
		dto.timeCode= timeCode;
		dto.creator= {};
		dto.creator.userId= userId;
		this.fTimeSheetEntries.push(dto);
		this.updateWorkItemTimeSpent();
		return dto;
	},

	removeTimeSheetEntry: function(dto) {
		var index= dojo.indexOf(this.fTimeSheetEntries, dto);
		if (index >= 0) {
			this.fTimeSheetEntries.splice(index, 1);
			this.updateWorkItemTimeSpent();
			return true;
		}
		return false;
	},

	updateWorkItemTimeSpent: function() {
		if (this.fTimeSheetEntries != null && this.fTimeTrackingSyncEnabled.localeCompare("true") === 0) {
			var timeSpent= 0;
			for (var i= 0; i < this.fTimeSheetEntries.length; i++){
				timeSpent+= this.fTimeSheetEntries[i].timeSpent;
			}
			var dto;
			if (timeSpent > 0) {
				var options= {};
				options.pattern= "#.##";
				dto= {id: (timeSpent).toString(), label: number.format(timeSpent / (1000 * 60 * 60), options)};
			} else {
				var unassigned= (-1).toString();
				dto= {id: unassigned, label: unassigned};
			}
			var args= {};
			args.path= ["attributes", WorkItemAttributes.TIME_SPENT];
			args.attributeId= WorkItemAttributes.TIME_SPENT;
			args.value= dto;
			args.caller= this;
			this.fWorkitemCopy.setValue(args);
		}
	},

	getLinksToSave: function() {
		var links= [];
		var seen= {};
		var $subject3= this.fTimeSheetEntries;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var timeSheetEntry= $subject3[$count3];
			var linkDTO= null;
			if (timeSheetEntry.itemId != null && timeSheetEntry.itemId.length > 0) {
				seen[timeSheetEntry.itemId]= true;
				var original= this.fOriginalItems[timeSheetEntry.itemId];
				if (this.hasChanged(timeSheetEntry, original.target)) {
					linkDTO= {};
					linkDTO._isUpdated= true;
					linkDTO._updateTarget= true;
					linkDTO.target= timeSheetEntry;
				} else {
					linkDTO= original;
				}
			} else {
				linkDTO= {};
				linkDTO._isNew= true;
				linkDTO._updateTarget= true;
				linkDTO.target= timeSheetEntry;
			}
			links.push(linkDTO);
		}
		var $subject4= jdojo.getProperties(this.fOriginalItems);
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var itemId= $subject4[$count4];
			if (!(itemId in seen)) {
				var linkDTO= {};
				linkDTO._isDeleted= true;
				linkDTO.itemId= itemId;
				links.push(linkDTO);
			}
		}
		return links;
	},

	saveChanges: function() {
		var links= this.getLinksToSave();
		var setValArgs= {};
		setValArgs.path= [TimesheetConstants.LINK_TYPES, TimesheetConstants.TIMESHEET_LINK_ID];
		setValArgs.value= links;
		this.fWorkitemCopy.setValue(setValArgs);
	},

	hasChanged: function(t1, t2) {
		if (t1 == null || t2 == null) 
			return false;
		return !((t1.startDate === t2.startDate) && t1.timeSpent === t2.timeSpent && (t1.workType === t2.workType) && (t1.timeCode === t2.timeCode));
	},

	getTimesheetEntryWithStartDateAndTimecode: function(startDate, timeCode, userId) {
		var timesheet= null;
		if (this.fTimeSheetEntries != null && this.fTimeSheetEntries.length > 0) {
			var inputDate= DateUtil.createNormalizedDate(startDate);
			for (var i= 0; i < this.fTimeSheetEntries.length; i++){
				timesheet= this.fTimeSheetEntries[i];
				if (timesheet.timeCode === timeCode && (timesheet.creator != null && timesheet.creator.userId.localeCompare(userId) === 0)) {
					var timesheetDate= DateUtil.createNormalizedDate(timesheet.startDate);
					if (dojo.date.compare(timesheetDate, inputDate, "date") === 0) {
						return timesheet;
					}
				}
				timesheet= null;
			}
		}
		return timesheet;
	},

	getWorkItemTotalForTimeCodeAndUser: function(timeCode, userId) {
		var timesheet= null;
		var retVal= 0;
		if (this.fTimeSheetEntries != null && this.fTimeSheetEntries.length > 0) {
			for (var i= 0; i < this.fTimeSheetEntries.length; i++){
				timesheet= this.fTimeSheetEntries[i];
				if (timesheet.timeCode === timeCode && (timesheet.creator != null && timesheet.creator.userId.localeCompare(userId) === 0)) {
					retVal+= timesheet.timeSpent/(1000*60*60);
				}
			}
		}
		return retVal;
	},

	getAllTimesheetWithTimeCodes: function(timeCode, userId) {
		var timesheetArray= [];
		if (this.fTimeSheetEntries != null && this.fTimeSheetEntries.length > 0) {
			var timesheet= null;
			for (var i= 0; i < this.fTimeSheetEntries.length; i++){
				timesheet= this.fTimeSheetEntries[i];
				if (timesheet != null && timesheet.timeCode === timeCode && (timesheet.creator != null && timesheet.creator.userId.localeCompare(userId) === 0)) {
					timesheetArray.push(timesheet);
				}
			}
		}
		return timesheetArray;
	}
});

})();
