/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2010. All Rights Reserved.
 
 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule
 Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.team.tpt.web.ui.timesheet.internal.editor.WeekTextBox");

dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1
dojo.require("dojo.parser");
dojo.require("dojo.date");
dojo.require("dojo.date.locale");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.DateTextBox");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.editor.WeekDateTextBox");
	
(function() {
	
	var WeekDateTextBox = com.ibm.team.tpt.web.ui.timesheet.internal.editor.WeekDateTextBox;
	
 	dojo.declare("com.ibm.team.tpt.web.ui.timesheet.internal.editor.WeekTextBox", [dijit._Widget, dijit._Templated], {

    	templateString: '<div class="com-ibm-team-tpt-web-ui-internal-editor-WeekTextBox"><div dojoAttachPoint="weekTextBoxAttPt"></div></div>',
    	 
    	weekPicker: null,

    	constructor: function() {

        	this.weekPicker = new WeekDateTextBox({
        		isDate: true,
        		containerToggle: "fade",
				onKeyPress: dojo.hitch(this, this._keyPressed),
        		onChange: dojo.hitch(this, this.onChange1)
      		});
    	},
		
		/**
		 * 
		 * @param {Object} event
		 * If enter key is pressed, call the onChange event explicitly
		 * 
		 */
		_keyPressed: function(event){
			
			var keys = dojo.keys;
			
			if(event.keyCode === keys.ENTER){
				
				var value = this.getValue();
				this.onChange1(value);
			}
			
		},
    
    	onChange1: function(value) {
    	
    		// directly calling onChange is not working when the event has to be caught from BasicTimesheetViewlet, so indirection
			this.weekPicker.focusNode.blur();
    		this.onChange(value);
    	},

    	onChange: function(value) {
    	    	
    	},

    	buildView: function() {

      		this.weekTextBoxAttPt.appendChild(this.weekPicker.domNode);
    	},

    	getValue: function() {
    	
			return this.weekPicker.value;
    	},
		
		setValue:function(val){
			this.weekPicker.setNewWeekDate(val);
		}
    
	});

  	
})();


