/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.tpt.web.ui.timesheet.internal.util.DateUtil");

dojo.require("com.ibm.jdojo.lang.Exception");
dojo.require("com.ibm.jdojo.lang.JavaScriptException");
dojo.require("dojo.date");
dojo.require("dojo.date.locale");
dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.require("jazz.util.calendar");

dojo.requireLocalization("com.ibm.team.tpt.web.ui.timesheet.internal.messages", "TimesheetMessages");

(function() {
var TimesheetMessages= dojo.i18n.getLocalization("com.ibm.team.tpt.web.ui.timesheet.internal.messages", "TimesheetMessages");

var lang= com.ibm.jdojo.lang;
var Exception= lang.Exception;
var JavaScriptException= lang.JavaScriptException;
var string= dojo.string;
var calendar= jazz.util.calendar;

var DateUtil= dojo.declare("com.ibm.team.tpt.web.ui.timesheet.internal.util.DateUtil", null, {
	"-chains-": { constructor: "manual" }
});

DateUtil.fStartDayOfWeek= 0;
DateUtil.weekBegin= "weekBegin";
DateUtil.weekEnd= "weekEnd";
DateUtil.millisesondsDay= 24 * 60 * 60 * 1000;
DateUtil.blankWeekFormat= " - ";
DateUtil.defaultDateFormat= "yyyy-MM-dd";
DateUtil.defaultTimeFormat= "hh:mm:ss";
DateUtil.normalizedDateTimeFormatWrite= "yyyy-MM-dd'T'12:00:00.000'Z'";
DateUtil.normalizedDateTimeFormatRead= "yyyy-MM-dd'T'HH:00:00.000'Z'";
DateUtil.formatToWeekValue= function(value, constraintsWeekDate1, constraintsWeekDate2) {
	var formattedVal= "";
	if (value != null) {
		var weekDetails= DateUtil.getWeekOf(value, DateUtil.fStartDayOfWeek);
		formattedVal= string.substitute(TimesheetMessages.DATE_FROM_TO, [DateUtil.formatDate(weekDetails[DateUtil.weekBegin], constraintsWeekDate1) , DateUtil.formatDate(weekDetails[DateUtil.weekEnd], constraintsWeekDate2)]);
	}
	return formattedVal;
};
DateUtil.formatDate= function(inDatum, constraints) {
	if (inDatum != null) {
		try {
			if (constraints == null) {
				constraints= {};
				constraints.selector= "date";
				constraints.formatLength= "medium";
			}
			var leastDate= DateUtil.parseDate("1980-12-31", constraints);
			if (dojo.date.compare(leastDate, inDatum, "date") === 1) {
				return "";
			}
			var dateString= calendar.date.locale.format(inDatum, constraints);
			return dateString;
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				return DateUtil.blankWeekFormat;
			} else {
				throw e;
			}
		}
	} else {
		return DateUtil.blankWeekFormat;
	}
};
DateUtil.formatDateToTimestamp= function(inDatum, constraints) {
	if (inDatum != null) {
		try {
			if (constraints == null) {
				constraints= {};
				constraints.selector= "date and time";
				constraints.formatLength= "medium";
				constraints.timePattern= DateUtil.defaultTimeFormat;
				constraints.datePattern= DateUtil.defaultDateFormat;
			}
			var leastDate= DateUtil.parseDate("1980-12-31", constraints);
			if (dojo.date.compare(leastDate, inDatum, "date") === 1) {
				return "";
			}
			var dateString= calendar.date.locale.format(inDatum, constraints);
			return dateString;
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				return DateUtil.blankWeekFormat;
			} else {
				throw e;
			}
		}
	} else {
		return DateUtil.blankWeekFormat;
	}
};
DateUtil.parseDate= function(dateString, constraints) {
	if (dateString != null && dateString !== "" && dateString !== "null") {
		try {
			if (constraints == null) {
				constraints= {};
				constraints.selector= "date";
				constraints.datePattern= DateUtil.defaultDateFormat;
				constraints.formatLength= "medium";
			}
			var date= dojo.date.locale.parse(dateString, constraints);
			return date;
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				return null;
			} else {
				throw e;
			}
		}
	}
	return null;
};
DateUtil.getWeekOf= function(d, startDayOfWeek) {
	var beginOffset= 0;
	var endOffset= 0;
	var t= startDayOfWeek - d.getDay();
	if (d.getDay() < startDayOfWeek) {
		beginOffset= t - 7;
		endOffset= t - 1;
	} else {
		beginOffset= t;
		endOffset= 6 + t;
	}
	beginOffset= beginOffset * DateUtil.millisesondsDay;
	endOffset= endOffset * DateUtil.millisesondsDay;
	var beginOfWeek= new Date(d.getTime() + beginOffset);
	var endOfWeek= new Date(d.getTime() + endOffset);
	var returnVal= {};
	returnVal[DateUtil.weekBegin]= beginOfWeek;
	returnVal[DateUtil.weekEnd]= endOfWeek;
	return returnVal;
};
DateUtil.createNormalizedDate= function(normalizedDateString) {
	var constraints= {};
	constraints.selector= "date";
	constraints.formatLength= "short";
	constraints.datePattern= DateUtil.normalizedDateTimeFormatRead;
	var parsedDate= DateUtil.parseDate(normalizedDateString, constraints);
	return parsedDate;
};
DateUtil.normalizedFormatDate= function(date) {
	var constraints= {};
	constraints.selector= "date";
	constraints.formatLength= "short";
	constraints.datePattern= DateUtil.normalizedDateTimeFormatWrite;
	var formattedStr= DateUtil.formatDate(date, constraints);
	return formattedStr;
};

})();
