 /*   AENDERUNGEN:                                                   */
 /*   IDENTIFIK. DATUM    DURCH   BEMERKUNG                          */
 /*   ---------- -------- ------- -----------------------------------*/
 /*   AEND0001   09.08.00 Wagner  Druck-Sortierung erweitern         */
 /*                               innerhalb der AG nach VP sortieren.*/
 /*                               F-Tarife einfuegen.                */
 /*                                                                  */
 /*   AEND0002   26.06.01 Wagner  return (0), wenn O.K.              */
 /*                                                                  */
 /*   AEND0003   06.08.03 Wagner  F54/F55, G-Tarife.                 */
 /*                                                                  */
 /*   AEND0004   28.02.05 Stelzi  H-Renten-Erweiterung               */
 /*                                                                  */
 /********************************************************************\
  *       allgemeine C - includes                                    *
 \********************************************************************/

 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
 #include "XKL1996.H"
 #include "sqlproto.h"

 /*********************************************************************\
  *       projekt/programmspezifische includes                        *
 \*********************************************************************/

 /*********************************************************************\
  *       globale Variablen                                           *
 \*********************************************************************/

 /* -- #define D1E  "D1E "  -- AEND0001 -- */
 /* -- #define D1   "D1  "  -- AEND0001 -- */
 /* -- #define D11E "D11E"  -- AEND0001 -- */
 /* -- #define E1   "E1  "  -- AEND0001 -- */
 /* -- #define E33  "E33 "  -- AEND0001 -- */
 #define NULL16 "0000000000000000"

 EXEC SQL INCLUDE SQLCA;

 #ifndef SQLCODE
 #define SQLCODE sqlca.sqlcode
 #endif

 #include "decimal.h"
 /********************************************************************/
 /*   Prototypen der internen Funktionen                             */
 /********************************************************************/
   void VpDaten(void);

   char        namevp[21];         /* Hilfsfeld fuer Druckausgabe */
   char        vnamevp[21];        /* Hilfsfeld fuer Druckausgabe */
   char        strassevp[21];      /* Hilfsfeld fuer Druckausgabe */
   char        ortvp[16];          /* Hilfsfeld fuer Druckausgabe */
   char        plzvp[6];           /* Hilfsfeld fuer Druckausgabe */
   char        nameag[31];         /* Hilfsfeld fuer Druckausgabe */
   char        strasseag[21];      /* Hilfsfeld fuer Druckausgabe */
   char        ortag[16];          /* Hilfsfeld fuer Druckausgabe */
   char        plzag[6];           /* Hilfsfeld fuer Druckausgabe */
   char        qkdnr[16];          /* Hilfsfeld fuer Druckausgabe */
   char        tarif[5];           /* Hilfsfeld fuer Druckausgabe */
   char        abljj[5];
   int         iabljj;
   int         igebjj;
   char        ablmm[2];
   int         iablmm;
   int         igebmm;
   int         alter;
   int         anzahl;
 /********************************************************************/
 /*   Host-Variablen definieren  (beginnen alle mit 'h')             */
 /********************************************************************/
 EXEC SQL BEGIN DECLARE SECTION;
   decimal (5,0)   hHistnr;
   decimal (15,0)  hVtrnr;
   char            hVsnr[11];
   decimal (5,0)   hVartkz;
   char            hVtgbegdt[11];
   char            hVtgabl[11];
   char            hZahlw[3];
   decimal (15,2)  hVtrinkbtg;
   decimal (15,2)  hVtrbtg;
   decimal (15,2)  hVersumme;
   char            hGeschart_Kz[6];
   char            hNameAG[36];
   char            hNameTP[35];      /* AEND0001 */
   char            hNameVP[36];
   char            hVnameVP[31];
   char            hGebjj[5];
   char            hGebmm[3];
   char            hGebtt[3];
   char            hPlzVP[7];
   char            hOrtVP[31];
   char            hStrasseVP[36];
   char            hPlzAG[7];
   char            hOrtAG[31];
   char            hStrasseAG[36];
   char            hVnr[16];
   char            hVbezakz[5];
   char            hPartnr[17];
   char            hErmvnr[16];     /* erm. VNR fr KAVIS-Aufruf */
   decimal (15,0)  hErmvtrnr;
 EXEC SQL END DECLARE SECTION;
 /********************************************************************/
 /*   Cursor definieren                                              */
 /****i***************************************************************/

 EXEC SQL DECLARE CursAG CURSOR FOR
  SELECT A.VTRNR
       , C.NAME
       , D.PLZ
       , D.ORT
       , D.STRASSE_POSTFACH
       , B.VNR
       , B.VBEZAKZ
       , E.VTGBEGDT
       , E.VTGABL
       , E.ZAHLW
       , E.VARTKZ
       , G.NAME                   /* AEND0001 */
   FROM TBKL_VTRKOLL A
       ,TBKI_VERTRAGSBEZ B
       ,TBKI_KUNDE C
       ,TBKI_KUNDEADR D
       ,TBKO_VERTRAG E
       ,TBKI_VERTRAG F
       ,TBKI_KUNDE G                 /* AEND0001 */
       ,TBKI_VERTRAGSBEZ K           /* AEND0001 */
  WHERE A.VTRNR = E.VTRNR
    AND A.HISTNR = 1
    AND A.HISTNR = E.HISTNR
    AND F.VSNR = E.VSNR
    AND B.VNR = F.VNR
    AND K.VNR = F.VNR                /* AEND0001 */
    AND B.BESTAKZ = F.BESTAKZ
    AND K.BESTAKZ = F.BESTAKZ        /* AEND0001 */
    AND B.KDNR = C.KDNR
    AND K.KDNR = G.KDNR              /* AEND0001 */
    AND B.KDNR = D.KDNR
    AND B.ADRNR = D.ADRNR
    AND A.VTRNR BETWEEN 400000000000000 AND 499999999999999
    AND B.VBEZAKZ LIKE 'N%'
    AND K.VBEZAKZ LIKE 'V%'          /* AEND0001 */
    AND A.GESCHART_KZ LIKE 'DV%'
    ORDER BY C.NAME, G.NAME;         /* AEND0001 */

 EXEC SQL DECLARE CursVP CURSOR FOR
     SELECT
        C.NAME
      , C.VNAME
      , C.GEBJJ
      , C.GEBMM
      , C.GEBTT
      , D.PLZ
      , D.ORT
      , D.STRASSE_POSTFACH
      , B.VNR
      , B.VBEZAKZ
      , E.VTRBTG
      , E.VTRINKBTG
      , A.VERSUMME
        FROM
             TBKO_LVB A
           , TBKI_VERTRAGSBEZ B
           , TBKI_KUNDE C
           , TBKI_KUNDEADR D
           , TBKL_VERTRAG E
           , TBKO_VERTRAG F
           , TBKI_VERTRAG G
       WHERE A.VTRNR = E.VTRNR
         AND A.HISTNR = E.HISTNR
         AND E.VTRNR = F.VTRNR
         AND E.HISTNR = F.HISTNR
         AND F.VSNR = G.VSNR
         AND B.VNR = G.VNR
         AND B.BESTAKZ = G.BESTAKZ
         AND B.KDNR = C.KDNR
         AND B.KDNR = D.KDNR
         AND B.ADRNR = D.ADRNR
         AND A.VTRNR = :hErmvtrnr
         AND A.LVNR = 1
         AND B.VBEZAKZ LIKE 'V%'
         AND A.HISTNR = (SELECT MAX(HISTNR)
                           FROM TBKO_LVB A2
                          WHERE A.VTRNR = A2.VTRNR);



 /********************************************************************/
 /*   main-funktion                                                  */
 /*                                                                  */
 /*   in der Funktion 'main' wird                                    */
 /*                                                                  */
 /*   - der Cursor zur Ermittlung der relevanten                     */
 /*     KOMPASS-Daten aufgerufen                                     */
 /*                                                                  */
 /*   - anhand der ermittelten VTRNR wird in die                     */
 /*     die Funktion 'VpDaten' verzweigt                             */
 /*                                                                  */
 /*                                                                  */
 /*                                                                  */
 /*                                                                  */
 /*                                                                  */
 /********************************************************************/
 int main()
 {


    EXEC SQL OPEN CursAG;

    if (SQLCODE != 0)
       printf("Open CursAG-Fehler: %ld !\n",
              SQLCODE);

    EXEC SQL FETCH CursAG
        INTO
            :hVtrnr,
            :hNameAG,
            :hPlzAG,
            :hOrtAG,
            :hStrasseAG,
            :hVsnr,
            :hVbezakz,
            :hVtgbegdt,
            :hVtgabl,
            :hZahlw,
            :hVartkz,
            :hNameTP;              /* AEND0001 */

 /*------------------------------------------------------------------*/

    /* Ueberschrift erste Zeile */
    printf("QKDNR            VSNR       Vers.-Person(VT)            ");
    printf("              Gebdat (VT)   Vers-Summe Inkasso");
    printf("   Vtr-Beginn  Zahlw\n");

    /* Ueberschrift zweite Zeile */
    printf("                            Vers_Nehmer(VN)             ");
    printf("                            Tarif       Brutto");
    printf("   Vtr.-Ende  Endalter\n");

    /* Ueberschrift dritte Zeile */
    printf("                            VN Adresse \n");

    anzahl = 0;

    while (SQLCODE == 0) {

    printf(" \n");


 /* Funktion zur Ermittlung der KAVIS-Daten aufrufen  */

       hErmvtrnr = hVtrnr;

       strcpy(hErmvnr,hVsnr); /* Umstellung der 11-stelligen*/
                              /* VNR auf 15-stellige VNR)   */
       strcat(hErmvnr,"     ");

       VpDaten();

 /*------------------------------------------------------------------*/
 /*  Grundstrukturen einstellen                                      */
 /*------------------------------------------ raus am 26.06.2001 -----
    memset (hVsnr,'0',sizeof(hVsnr));
    hHistnr = 0;
    hVtrnr = 0;
    hVartkz = 0;
    hVtrinkbtg = 0;
    hVtrbtg = 0;
    hVersumme = 0;
    hErmvtrnr = 0;
    memset (hVtgbegdt,0,sizeof(hVtgbegdt));
    memset (hVtgabl,0,sizeof(hVtgabl));
    memset (hZahlw,0,sizeof(hZahlw));
    memset (hGeschart_Kz,0,sizeof(hGeschart_Kz));
    memset (hNameAG,0,sizeof(hNameAG));
    memset (hNameTP,0,sizeof(hNameTP));     * AEND0001 *
    memset (hNameVP,0,sizeof(hNameVP));
    memset (hVnameVP,0,sizeof(hVnameVP));
    memset (hGebjj,0,sizeof(hGebjj));
    memset (hGebmm,0,sizeof(hGebmm));
    memset (hGebtt,0,sizeof(hGebtt));
    memset (hPlzAG,0,sizeof(hPlzAG));
    memset (hOrtAG,0,sizeof(hOrtAG));
    memset (hStrasseAG,0,sizeof(hStrasseAG));
    memset (hPlzVP,0,sizeof(hPlzVP));
    memset (hOrtVP,0,sizeof(hOrtVP));
    memset (hStrasseVP,0,sizeof(hStrasseVP));
    memset (hVnr,0,sizeof(hVnr));
    memset (hVbezakz,0,sizeof(hVbezakz));
    memset (hPartnr,0,sizeof(hPartnr));      * AEND0001 *
    memset (hErmvnr,0,sizeof(hErmvnr));
    memset (namevp,0,sizeof(namevp));
    memset (vnamevp,0,sizeof(vnamevp));
    memset (strassevp,0,sizeof(strassevp));
    memset (ortvp,0,sizeof(ortvp));
    memset (plzvp,0,sizeof(plzvp));
    memset (nameag,0,sizeof(nameag));
    memset (strasseag,0,sizeof(strasseag));
    memset (ortag,0,sizeof(ortag));
    memset (plzag,0,sizeof(plzag));
    memset (qkdnr,0,sizeof(qkdnr));
    memset (tarif,0,sizeof(tarif));
  ----------------------------------------*/
    EXEC SQL FETCH CursAG
        INTO
            :hVtrnr,
            :hNameAG,
            :hPlzAG,
            :hOrtAG,
            :hStrasseAG,
            :hVsnr,
            :hVbezakz,
            :hVtgbegdt,
            :hVtgabl,
            :hZahlw,
            :hVartkz,
            :hNameTP;              /* AEND0001 */

    }
    if (SQLCODE != 100) {
       printf("Fetch-Cursor-Fehler: %ld !\n",
              SQLCODE);
 /* PGM-Abbruch ??? */
    }
    EXEC SQL CLOSE CursAG;

    if (SQLCODE != 0)
       printf("Close CursAG-Fehler: %ld !\n",
              SQLCODE);

  printf("Anzahl Vertraege: %d\n",anzahl);

  return(0);             /* -- AEND0002 -- */

  }
 /********************************************************************/
 /*   Funktion zur Ermittlung der VP-Daten                           */
 /*       Variablen Aufruf:                                          */
 /*                 Rueckgabe:                                       */
 /********************************************************************/
 void VpDaten (void)
 {

    EXEC SQL OPEN CursVP;

    if (SQLCODE != 0)
       printf("Open CursVP-Fehler: %ld !\n",
              SQLCODE);

  while (SQLCODE == 0) {

    EXEC SQL FETCH CursVP
        INTO
          :hNameVP
         ,:hVnameVP
         ,:hGebjj
         ,:hGebmm
         ,:hGebtt
         ,:hPlzVP
         ,:hOrtVP
         ,:hStrasseVP
         ,:hVnr
         ,:hVbezakz
         ,:hVtrbtg
         ,:hVtrinkbtg
         ,:hVersumme;

    if (SQLCODE == 0) {

    EXEC SQL
    SELECT A.PARTNR
          INTO :hPartnr
     FROM TBKI_KUNDEZGRP A
         ,TBKI_VERTRAGSBEZ B
     WHERE B.BESTAKZ = '04'
       AND B.VBEZGRP LIKE 'N%'
       AND A.KDNR = B.KDNR
       AND A.KUZGRKZ = 'QKDNR'
       AND B.VNR = :hErmvnr;


     if (SQLCODE == 0) {
  /*-  strncpy(qkdnr,hPartnr,16);    AEND0001 - */
       strcpy(qkdnr,hPartnr);
     } else {
       strcpy(qkdnr,NULL16);
     }


  /* if (strncmp(hVbezakz,"V1",2) == 0) { */
     /*  printf("Daten der Versicherten Person:\n"); */
   /********************************/
   /* Zeile 1 aufbereiten          */
   /********************************/

   anzahl = anzahl + 1;

       if (hVartkz == 40001) {
          strncpy(tarif,"D1E ",4);
       } else {
         if (hVartkz == 40002) {
            strncpy(tarif,"D1  ",4);
        } else {
          if (hVartkz == 40003) {
             strncpy(tarif,"D11E",4);
         } else {
           if (hVartkz == 40020) {
              strncpy(tarif,"E1  ",4);
          } else {
            if (hVartkz == 40022) {
               strncpy(tarif,"E33 ",4);
           } else {
             if (hVartkz == 40101) {
                strncpy(tarif,"F1  ",4);
            } else {
              if (hVartkz == 40111) {
                 strncpy(tarif,"F11 ",4);
             } else {
               if (hVartkz == 40151) {
                  strncpy(tarif,"F51 ",4);
              } else {                        /* AEND0003 */
                if (hVartkz == 40154) {
                   strncpy(tarif,"F54 ",4);
               } else {
                 if (hVartkz == 40155) {
                    strncpy(tarif,"F55 ",4);
                } else {
                  if (hVartkz == 40201) {
                     strncpy(tarif,"G1  ",4);
                 } else {
                   if (hVartkz == 40211) {
                      strncpy(tarif,"G11 ",4);
                  } else {
                    if (hVartkz == 40251) {
                       strncpy(tarif,"G51 ",4);
                   } else {
                     if (hVartkz == 40254) {
                        strncpy(tarif,"G54 ",4);
                    } else {
                      if (hVartkz == 40255) {
                         strncpy(tarif,"G55 ",4);
                             /* ---------- AEND0004 BEGINN --------- */
                     } else {
                       if (hVartkz == 40351) {
                          strncpy(tarif,"H51 ",4);
                      } else {
                        if (hVartkz == 40354) {
                           strncpy(tarif,"H54 ",4);
                       } else {
                         if (hVartkz == 40355) {
                            strncpy(tarif,"H55 ",4);
                             /* ---------- AEND0004 ENDE   --------- */
                        } else {
                           printf("keine Daten vorhanden\n");
                        }
                             /* ---------- AEND0004 BEGINN --------- */
                       }
                      }
                     }
                             /* ---------- AEND0004 ENDE   --------- */
                    }
                   }
                  }
                 }
                }
               }
              }
             }
            }
           }
          }
         }
        }
       }

    /* Endalter berechnen */
      strncpy(ablmm,hVtgabl+3,2);
      iablmm =atoi(ablmm);
      igebmm =atoi(hGebmm);

      strncpy(abljj,hVtgabl+6,5);
      iabljj =atoi(abljj);
      igebjj =atoi(hGebjj);


      alter = iabljj - igebjj;


      if (igebmm > iablmm) {
        alter = alter - 1;
      }



       strncpy(namevp,hNameVP,20);
       strncpy(vnamevp,hVnameVP,20);

       printf("%s %s %s %s %s.%s.%s %12.2D(15,2)",
       qkdnr, hVsnr, namevp, vnamevp, hGebtt,hGebmm, hGebjj, hVersumme);

       printf(" %8.2D(15,2)   %s   %s\n",
                    hVtrinkbtg,  hVtgbegdt, hZahlw);


   /********************************/
   /* Zeile 2 aufbereiten          */
   /********************************/

       strncpy(strassevp,hStrasseVP,20);
       strncpy(plzvp,hPlzVP,5);
       strncpy(ortvp,hOrtVP,15);

       printf("                            %s %s %s ",
            strassevp, plzvp, ortvp);

       printf("              %s     %8.2D(15,2)   %s   %d     \n",
              tarif,hVtrbtg,    hVtgabl,alter);

   /********************************/
   /* Zeile 3 aufbereiten          */
   /********************************/

       strncpy(nameag,hNameAG,30);

       printf("                            %s\n",nameag);


   /********************************/
   /* Zeile 4 aufbereiten          */
   /********************************/

       strncpy(strasseag,hStrasseAG,20);
       strncpy(plzag,hPlzAG,5);
       strncpy(ortag,hOrtAG,15);

       printf("                            %s %s %s\n",
            strasseag, plzag, ortag);



       }
 /* }
    else if (SQLCODE == 100) {
       printf("kein weiterer KAVIS-Satz gefunden\n");*/
 /* }
         else if (SQLCODE != 0) {
         printf("Fehler bei der Ermittlung der VpDaten\n");
         printf("Fehlercode: %ld !\n", SQLCODE);
    } */
    }
    EXEC SQL CLOSE CursVP;

    }
