/********************************************************************/
/*                                                                  */
/* Name         : PYDBC22                                           */
/*                                                                  */
/* Beschreibung : Copystrecke f|r die Plausibilisierung der ZfA     */
/*                Struktur                                          */
/*                                                                  */
/* Stand        : 24.04.2002                                        */
/*                                                                  */
/* Autor        : Yuehong Song                                      */
/*                                                                  */
/* $Header:: /PRofiL/PUDBM20/PYDBC22.H 12    29.11.02 17:35 Hausma $*/
/*                                                                  */
/*                                                                  */
/*==================================================================*/
/*------------------------------------------------------------------*/
/* $Log:: /PRofiL/PUDBM20/PYDBC22.H                                $
 *
 * 12    29.11.02 17:35 Hausmann
 * Code von YS entfernt
 *
 * 11    30.10.02 15:50 Hausmann
 * Kommentierte Bereiche geloescht
 *
 * 10    17.09.02 17:37 Duebbelde
 * BITLST20
 *
 * 9     22.08.02 8:21 Rueckertn
 * Zu langes Zeichenkette entfernt
 *
 * 8     24.07.02 12:42 Kophala
 * - Anpassungen nach Aenderung der datenstrukturen gem ZfA
 * - Fehlerbehebung
 *
 * 7     18.07.02 18:20 Kophala
 * A1020 Strukturaenderung, Anpassung gem. Schnittstellenhandbuch
 *
 * 6     1.07.02 18:31 Rueckertn
 * Neue Aktivierung
 *
 * 5     20.06.02 16:10 Duebbelde
 * Auslagerung von Strukturen in PYDBC03.h
 *
 * 4     5.06.02 11:59 Songy
 *
 * 3     30.05.02 17:37 Songy
 *
 * 1     28.05.02 15:49 Songy
 *
 * 11    22.05.02 17:57 Songy
 *
 * 10    21.05.02 17:40 Songy
 *
 * 9     17.05.02 16:00 Songy
 *
 * 8     16.05.02 17:26 Songy
 *
 * 7     8.05.02 9:59 Songy
 * Aktueller Tagesstand
 *
 * 4     29.04.02 10:51 Songy
 * Tagesstand von Frau Song
 *
 * 2     25.04.02 10:18 Rueckertn
 * Erster Einbeu der Struktur                                       */
/*                                                                  */
/*------------------------------------------------------------------*/
/*                                                                  */
/*                                                                  */
/*==================================================================*/
/*                                                                  */
/********************************************************************/
/*345678901234567890123456789012345678901234567890123456789012345678*/
/*      1         2         3         4         5         6         */

#ifndef _PYDBC22_H
#define _PYDBC22_H


/* Steuer- und Fehlerbereich */
#include "PYDBC00.h"
#include "PYDBC03.h"
#include "PUDBA02.h"

#define OK             -1   /* Geprueften Daten richtig ist */
#define STAATSAN       "DE, US" /* Staatsangehvrigkeit */


#define L_MEGD         5
#define L_ANBIETERNR  11
#define L_KENZEICHEN   2   /* Kennzeichen                 */
#define AZ_FE          3   /* Fehleranzahl                */
#define L_JAHR         5   /* JHJJ                        */
#define L_JHJJMM       7   /* JHJJMM                      */
#define L_JHJJMMTT     9   /* JHJJMMTT                    */
#define L_DATUMZEIT   21   /* JHJJMMTThhmmssMsmsms        */
#define L_STNR        13   /* Steuernummer                */
#define L_VSZUNR      13   /* Versicherung und Zulagenr.  */

#define L_NANE        36
#define L_STR         36   /* Strasse                     */
#define L_HAUSNR      10   /* Hausnummer                  */
#define L_PLZ          6   /* Postleitzahl                */
#define L_ORT         36   /* Wohnorts                    */

#define L_STANG        3   /* Staatsangehvrigkeit         */
#define L_VWORT       21   /* Vorsatzwort                 */
#define L_NAMZUS      21   /* Namenszusatz                */
#define L_TITEL       21   /* Titel                       */

#define L_VTNR        21   /* Vertragsnr. des Anbieters   */
#define L_ZERTIFINR   21   /* Zertifizierungsnummer       */
#define L_BETRAG       9   /* Betrage in EURO             */

#define ART_WAE        4   /* Wdhrungskeinnzeichen        */


#define L_ZAHKST      31   /* Arbeitsamt/Zahlstelle       */
#define L_AKTEN       21   /* Aktenzeichen                */


#endif
