 /*********************************************************************/
 /*  MKQ0417  Modulkurzbezeichnung                                    */
 /*                                                                   */
 /*   PROJEKT:               KOMPASS-KFZ                              */
 /*                                                                   */
 /*   UNTERPROJEKT:          ZUGRIFF AUF GRUNDLAGENTABELLEN           */
 /*                                                                   */
 /*   PROGRAMMIERER:         R. Hingkeldey                            */
 /*                                                                   */
 /*   ERSTELLUNGSDATUM:      21.03.1996                               */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /*   PGM-FUNKTION:                                                   */
 /*                                                                   */
 /*   Das Modul MKQ0417 dient zum Lesen des Faktors fuer die Typklas- */
 /*   sen zur neuen Tarifierung aus der Tabelle TBKF_TYPKLG_FAKT      */
 /*   sowie der Typklassengruppe.                                     */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /*   18.11.1996   Tuning des SQL-Zugriffs mit Hilfe der Decimal-Da-  */
 /*   HINGKELDEY   tentypen von DB2.                                  */
 /*                                                                   */
 /*   AENDERUNGEN: ST.BRANDT                                          */
 /*   11.04.1996   Einfügen von STRUKTUR_NAME_0417, VERSION_0417,     */
 /*                SQL geandert                                       */
 /*********************************************************************/
 /*********************************************************************/
 /*                S Y S T E M I N C L U D E S                        */
 /*********************************************************************/
 ??=include <stdio.h>                   /* Ein-/ Ausgabe              */
 ??=include <string.h>                  /* String-Funktionen          */
 ??=include <stdlib.h>                  /* Stdlib-Funktionen          */
 ??=include <decimal.h>                 /* Decimal-Datentypen         */
 /*********************************************************************/
 /*                S Q L  -  C O N T R O L   A R E A                  */
 /*********************************************************************/
 EXEC SQL INCLUDE SQLCA;
 /*********************************************************************/
 /*             S Y S T E M  -  D E F I N I T I O N                   */
 /*********************************************************************/
 ??=include "XKQ0000C.h"
 ??=include "CICSBATC"
 /*********************************************************************/
 /*                     D E F A U L T S                               */
 /*********************************************************************/
 /*********************************************************************/
 /*                U E B E R G A B E - B E R E I C H                  */
 /*********************************************************************/
 ??=include "XKQ0417C.h"
 /*********************************************************************/
 /*                T A B E L L E N  -  D E F I N I T I O N            */
 /*********************************************************************/
 /*********************************************************************/
 /*                   L O K A L E     D A T E N                       */
 /*********************************************************************/
 /*-------------------------------------------------------------------*/
 /* KONSTANTEN                                                        */
 /*-------------------------------------------------------------------*/

 /*********************************************************************/
 /*                      D B 2   -   H O S T V A R I A B L E N        */
 /*********************************************************************/
 EXEC SQL BEGIN DECLARE SECTION;
   char     staffelnr_tmp[3];
   char     typkl_von_tmp[3];
   char     typkl_bis_tmp[3];
   char     tarif_tmp[7];
   char     mandant_tmp[2];
   decimal(5,3)  faktor_tmp;
 EXEC SQL END DECLARE SECTION;
 /*********************************************************************/
 /*                      D B 2   -   C U R S O R                      */
 /*********************************************************************/
 /*********************************************************************/
 /*   VORWäRTSDEKLARATION DER FUNKTIONEN                              */
 /*********************************************************************/
  void  abbruch_mkq0417(), db2_mkq0417(), grundwerte_mkq0417(),
        plausi_parm_mkq0417(),verarbeitung_mkq0417();
 /*********************************************************************/
 /*   GLOBALE VARIABLE                                                */
 /*********************************************************************/
  P_XKQ0417 pxkq0417;
  char      retcode[5];
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
  #ifdef __QV_CICS__
  void main (pxkq0417)
  {
  /********************************************************************/
  /* Laden Commarea                                                   */
  /********************************************************************/
      EXEC CICS ADDRESS COMMAREA (pxkq0417);
  /********************************************************************/
  /* Aufruf MKQ0417                                                   */
  /********************************************************************/
      aufruf_0417(&pxkq0417);

      EXEC CICS RETURN ;
  }
  #else
  void MKQ0417 (pxkq0417 )
  {
      aufruf_0417(&pxkq0417);
      return;
  }
  #endif
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
 int  aufruf_0417(P_XKQ0417 *pxkq0417tmp)
 {
  pxkq0417 = *pxkq0417tmp;
                                            /*------------------------*/
                                            /* VOREINSTELLUNGEN       */
                                            /*------------------------*/
  grundwerte_mkq0417();
                                            /*------------------------*/
                                            /* PR!FEN EINGABEDATEN    */
                                            /*------------------------*/
  plausi_parm_mkq0417();

  if (strncmp(retcode, "    ",sizeof(retcode)-1))
    abbruch_mkq0417();
                                            /*------------------------*/
                                            /* STEUERUNG IO-ZUGRIFF   */
                                            /*------------------------*/
  else
    verarbeitung_mkq0417();

  return (RC_OK);
 }

  /********************************************************************/
  /*                I N T E R N E    P R O Z E D U R E N              */
  /********************************************************************/
  /********************************************************************/
  /* ABBRUCH_MKQ0417        : ABBRUCH DES PROGRAMMS                   */
  /* DB2_MKQ0417            : SAMMLUNG DER DB2-SQL DATENBANKZUGRIFFE  */
  /* GRUNDWERTE_MKQ0417     : INITIALISIERUNGEN                       */
  /* PLAUSI_PARM_MKQ0417    : PRUEFEN DER EINGABEDATEN                */
  /* VERARBEITUNG_MKQ0417   : ANWENDUNGSSPEZIFISCHE VERARBEITUNG      */
  /********************************************************************/

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: A B B R U C H                                  */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - BEHANDLUNG VON UNERWARTETEN FEHLERN                            */
  /********************************************************************/
 void abbruch_mkq0417 () {
   psqlca kfsqlca = pxkq0417->P_SQLCA;
                                            /*------------------------*/
                                            /* SETZEN STEUERBEREICH   */
                                            /*------------------------*/
   memcpy(pxkq0417->STEUER.fmodul,"MKQ0417 ",
          sizeof(pxkq0417->STEUER.fmodul)-1);
   memcpy(pxkq0417->STEUER.fmodul_retcode,
          pxkq0417->STEUER.retcode,
          sizeof(pxkq0417->STEUER.fmodul_retcode)-1);
                                            /*------------------------*/
                                            /* UEBERTRAGEN SPA        */
                                            /*------------------------*/
   if (atoi(retcode) == 200)
     kfsqlca = &sqlca;

   memcpy(pxkq0417->STEUER.retcode,retcode,                              0000111
          sizeof(pxkq0417->STEUER.retcode)-1);                           0000111
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: D B 2                                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - SAMMLUNG DER INTERNEN DB2-SQL DATENBANKZUGRIFFE:               */
  /*   01 : TBKF_TYPKLG_FAKT   LESEN Faktor fuer Typklassengruppe so- */
  /*        wie Typklassengruppe ermitteln                            */
  /********************************************************************/
 void db2_mkq0417 (int nr)
 {
   if ( nr == 1 )
   {
   /*******************************************************************/
   /*  01 : TBKF_TYPKLG_FAKT   LESEN TBKF_TYPKLG_FAKT                 */
   /*******************************************************************/
     EXEC SQL
       SELECT
              TYPKL_VON, TYPKL_BIS, STAFFELNR, FAKTOR
       INTO
              :typkl_von_tmp,:typkl_bis_tmp,:staffelnr_tmp,:faktor_tmp
       FROM
              TBKF_TYPKLG_FAKT
       WHERE
              TARIF       =    :tarif_tmp
       AND
              TYPKL_VON   <=   :typkl_von_tmp
       AND
              TYPKL_BIS   >=   :typkl_von_tmp
       AND
              MANDANT     =    :mandant_tmp
     ;

     if (SQLCODE == SQL_OK)
       strcpy(retcode,"0000");
     else
     {
       if (SQLCODE == SQL_NICHT_GEFUNDEN)
       {
         strcpy(retcode,"0100");                                            0000
         pxkq0417->STEUER.fmodul_sqlcallnr =  nr;                           0000
         memcpy(pxkq0417->STEUER.fmodul_retcode,
                retcode,
                sizeof(pxkq0417->STEUER.fmodul_retcode)-1);
         memcpy(pxkq0417->STEUER.fmodul,
                "MKQ0417 ",
                sizeof(pxkq0417->STEUER.fmodul)-1);
       }
       else
       {
         strcpy(retcode,"0200");
         pxkq0417->STEUER.fmodul_sqlcallnr = nr;
         abbruch_mkq0417();
       }
     }
   }
                                            /*------------------------*/
                                            /* UNGUELTIGER AUFRUF DB2 */
                                            /*------------------------*/
   else
   {
     strcpy(retcode,"0199");
     abbruch_mkq0417();
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: G R U N D W E R T E                            */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - INITIALISIEREN VON FELDERN                                     */
  /********************************************************************/
 void grundwerte_mkq0417() {
                                            /*------------------------*/
                                            /* LOESCHEN STEUERBEREICH */
                                            /*------------------------*/
    memcpy(retcode,"    ",                                              00001110
           sizeof(pxkq0417->STEUER.retcode)-1);                         00001110
    memset(pxkq0417->STEUER.hinweis,0,                                  00001110
           sizeof(pxkq0417->STEUER.hinweis)-1);                         00001110
    memset(pxkq0417->STEUER.fmodul,0,                                   00001110
           sizeof(pxkq0417->STEUER.fmodul)-1);                          00001110
    memset(pxkq0417->STEUER.fmodul_retcode,0,                           00001110
           sizeof(pxkq0417->STEUER.fmodul_retcode)-1);                  00001110
    pxkq0417->STEUER.fmodul_sqlcallnr = 0;                              00001150
                                            /*------------------------*/00001150
                                            /* LOESCHEN AUSGABE       */
                                            /*------------------------*/
    pxkq0417->AUSGABE.faktor = 0;                                       00001110
    memset(pxkq0417->AUSGABE.typkl_von,0,                               00001110
           sizeof(pxkq0417->AUSGABE.typkl_von)-1);                      00001110
    memset(pxkq0417->AUSGABE.typkl_bis,0,                               00001110
           sizeof(pxkq0417->AUSGABE.typkl_bis)-1);                      00001110
    memset(pxkq0417->AUSGABE.staffelnr,0,                               00001110
           sizeof(pxkq0417->AUSGABE.staffelnr)-1);                      00001110

 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: P L A U S I _ P A R M                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - PRUEFUNGEN DER EINGABEDATEN                                    */
  /********************************************************************/
 void plausi_parm_mkq0417 () {
   char struk_name_tmp[9];
   char version_tmp[5];
   char ende_tmp[5];

   memset(struk_name_tmp,0,sizeof(struk_name_tmp));                      0000111
   memset(version_tmp,0,sizeof(version_tmp));                            0000111
   memset(ende_tmp,0,sizeof(ende_tmp));                                  0000111
                                            /*------------------------*/
                                            /* PRUEFEN VERSION        */
                                            /*------------------------*/
   memcpy(pxkq0417->IDENT.struktur_name,__STRUKTUR_NAME_0417,            0000111
          sizeof(pxkq0417->IDENT.struktur_name)-1);                      0000111
   memcpy(pxkq0417->IDENT.version,__VERSION_0417,
          sizeof(pxkq0417->IDENT.version)-1);
   memcpy(pxkq0417->ende,__ENDE,
          sizeof(pxkq0417->ende)-1);

   memcpy(struk_name_tmp,pxkq0417->IDENT.struktur_name,
          sizeof(pxkq0417->IDENT.struktur_name)-1);
   memcpy(version_tmp,pxkq0417->IDENT.version,
          sizeof(pxkq0417->IDENT.version)-1);
   memcpy(ende_tmp,pxkq0417->ende,
          sizeof(pxkq0417->ende)-1);
   if (       strcmp(struk_name_tmp,"XKQ0417 ")
       ??!??! strcmp(version_tmp,"0001")
       ??!??! strcmp(ende_tmp,"ENDE"))
   {
     strcpy(pxkq0417->STEUER.retcode,"1");
     return;
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: V E R A R B E I T U N G                        */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /*  - ANWENDUNGSSPEZIFISCHE VERARBEITUNG                            */
  /********************************************************************/
 void verarbeitung_mkq0417 () {
                                            /*------------------------*/
                                            /*LESEN TBKF_TYPKLG_FAKT  */
                                            /*------------------------*/
   memcpy(typkl_von_tmp,pxkq0417->EINGABE.typkl_von,
          sizeof(pxkq0417->EINGABE.typkl_von)-1);
   memcpy(tarif_tmp,pxkq0417->EINGABE.tarif,
          sizeof(pxkq0417->EINGABE.tarif)-1);
   memcpy(mandant_tmp,pxkq0417->EINGABE.mandant,
          sizeof(pxkq0417->EINGABE.mandant)-1);
   db2_mkq0417(1);
   if (SQLCODE == SQL_NICHT_GEFUNDEN)
     memcpy(pxkq0417->STEUER.retcode,
            retcode,
            sizeof(pxkq0417->STEUER.retcode)-1);                           00001
   if (SQLCODE == SQL_OK)
   {
     memcpy(pxkq0417->STEUER.retcode,
            retcode,
            sizeof(pxkq0417->STEUER.retcode)-1);                           00001
     pxkq0417->AUSGABE.faktor       =  faktor_tmp;
     memcpy(pxkq0417->AUSGABE.typkl_von,                                 0000111
            typkl_von_tmp,                                               0000111
            sizeof(pxkq0417->AUSGABE.typkl_von)-1);                      0000111
     memcpy(pxkq0417->AUSGABE.typkl_bis,                                 0000111
            typkl_bis_tmp,                                               0000111
            sizeof(pxkq0417->AUSGABE.typkl_bis)-1);                      0000111
     memcpy(pxkq0417->AUSGABE.staffelnr,                                 0000111
            staffelnr_tmp,                                               0000111
            sizeof(pxkq0417->AUSGABE.staffelnr)-1);                      0000111
   }
 }

  /********************************************************************/
  /* ENDE MKQ0417                                                     */
  /********************************************************************/
