 /*********************************************************************/
 /*                                                                   */
 /*                                                                   */
 /*      PROJEKT:        ABGLEICHFUNKTION                             */
 /*      UNTERPROJEKT:   M  K  O  1  6  7  9                          */
 /*      PROGRAMMIERER:  TH.RAFFEL                                    */
 /*      VERSION:        001  (NEUENTWIKLUNG)                         */
 /*      ERSTELLT:       18. OKTOBER 1999                             */
 /*      AUTOR:          TH.RAFFEL                                    */
 /*                                                                   */
 /*                                                                   */
 /*-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-*/
 /*                                                                   */
 /*                                                                   */
 /*      GEAENDERT AM:   18. OKTOBER 1999                             */
 /*      AUTOR:          THOMAS RAFFEL                                */
 /*      VERSION:        001                                          */
 /*      GRUND:          NEUENTWICKLUNG                               */
 /*                                                                   */
 /*                                                                   */
 /*********************************************************************/


 /*********************************************************************/
 /*                                                                   */
 /*      S  Y  S  T  E  M  I  N  C  L  U  D  E  S                     */
 /*                                                                   */
 /*********************************************************************/


 #include <stdio.h>                           /* Ein-/ Ausgabe        */
 #include <stdlib.h>                          /* Allgemeine Lib       */
 #include <string.h>                          /* STRING-Funktionen    */
 #include "XAG00QV"                           /* MAG - Routinen       */


 /*********************************************************************/
 /*                                                                   */
 /*      S  Q  L  -  V  A  R  I  A  B  L  E  N                        */
 /*                                                                   */
 /*********************************************************************/


 EXEC SQL INCLUDE SQLCA;
 #include "XAG0SQL"                           /* SQL-Routinen(MAG0002)*/
 EXEC SQL BEGIN DECLARE SECTION;

 struct otag_abst_summe
  { char              ZWEIG[5];
    char              ARKZ[3];
    char              ZIEL_KZ[7];
    char              VERURSACHER[9];
    char              ABST_DATUM[11];
    char              EINST_DATUM[11];
    char              STATUS[2];
    long              WHGNR;
    char              MANDANT;
    char              SPRACHCODE;
    long              ANZAHL;
    decimal(15,2)     SUMME;
  } OTAG_ABST_SUMME;

 struct stag_abst_verurs
  { long              BEZIEH_NR;
    char              VERURSACHER[9];
    char              EIN_ABH[1];
    char              ARKZ[3];
    char              ZIEL_KZ[7];
    char              MANDANT;
    char              SPRACHCODE;
  } STAG_ABST_VERURS;

 static  char  Hzweig[5];
 static  char  Harkz[3];
 static  char  Hziel_kz[7];
 static  char  Hverursacher[9];
 static  char  Hmandant;
 static  char  Hsprachcode;

 static  long          Workanzahl = 0;
 static  decimal(15,2) Worksumme  = 0;

 EXEC SQL END DECLARE SECTION;


 /*********************************************************************/
 /*                                                                   */
 /*      D  E  F  I  N  I  T  I  O  N  E  N                           */
 /*                                                                   */
 /*********************************************************************/


 #define  IST_ON      1                       /* BEDINGUNG ERFüLLT    */
 #define  NICHT_ON    0                       /* BEDINGUNG ERFüLLT    */


 /*********************************************************************/
 /*                                                                   */
 /*      E  X  T  E  R  N  E     P  R  O  G  R  A  M  M  E            */
 /*                                                                   */
 /*********************************************************************/


 static  char Mandant = '1';
 static  char Sprachcode = 'D';

 #include "XKO1674"

 static void connect(void)
 {

    EXEC SQL BEGIN DECLARE SECTION;
         char   H_Loc[17];
    EXEC SQL END   DECLARE SECTION;

    strcpy(H_Loc,"     ");

    EXEC SQL SET :H_Loc = CURRENT SERVER;

    if (SQLCODE != 0 ||
        *H_Loc  == 0 || *H_Loc == ' ' )
    {
        printf("Kein DB2-Connect!");
        exit (16);
    }

 }


 /*********************************************************************/
 /*                                                                   */
 /*      S  C  H  A  L  T  E  R                                       */
 /*                                                                   */
 /*********************************************************************/


 static  const  char *Modul = "PKO1679";      /* Programmname         */
 static  const  char *Routine = "Verarbeitung";
 static  int    Rc = 0;                       /* Returncode           */


 /*********************************************************************/
 /*                                                                   */
 /*      U  N  T  E  R  P  R  O  G  R  A  M  M  E                     */
 /*                                                                   */
 /*********************************************************************/


 void  openEinsteller        ( void );
 int   fetchEinsteller       ( void );
 void  closeEinsteller       ( void );
 void  openSummen            ( void );
 int   fetchSummen           ( void );
 void  closeSummen           ( void );
 void  SummeAnzahl           ( void );
 void  updateAbholer         ( void );


 /*********************************************************************/
 /*                                                                   */
 /*      P  R  O  G  R  A  M  M  A  N  F  A  N  G                     */
 /*                                                                   */
 /*********************************************************************/


 main()
 {

 static  ENV Env;

        connect();                            /* Verbindung zum DB2   */
        memset(Hzweig      ,'\0',sizeof(Hzweig      ));
        memset(Harkz       ,'\0',sizeof(Harkz       ));
        memset(Hziel_kz    ,'\0',sizeof(Hziel_kz    ));
        memset(Hverursacher,'\0',sizeof(Hverursacher));


 /*********************************************************************/
 /*                                                                   */
 /*      C  U  R  S  O  R                                             */
 /*                                                                   */
 /*********************************************************************/


         EXEC SQL
         DECLARE  C1 CURSOR FOR
         SELECT   BEZIEH_NR
                 ,VERURSACHER
                 ,EIN_ABH
                 ,ARKZ
                 ,ZIEL_KZ
                 ,MANDANT
                 ,SPRACHCODE
         FROM     STAG_ABST_VERURS
         WHERE    EIN_ABH = 'A';



         EXEC SQL
         DECLARE  C2 CURSOR FOR
         SELECT   ZWEIG
                 ,ARKZ
                 ,ZIEL_KZ
                 ,VERURSACHER
                 ,WHGNR
                 ,MANDANT
                 ,SPRACHCODE
         FROM     OTAG_ABST_SUMME
         WHERE    STATUS = 'W'
           AND    VERURSACHER = :STAG_ABST_VERURS.VERURSACHER
           AND    MANDANT     = :STAG_ABST_VERURS.MANDANT
           AND    SPRACHCODE  = :STAG_ABST_VERURS.SPRACHCODE
         GROUP BY ZWEIG
                 ,ARKZ
                 ,ZIEL_KZ
                 ,VERURSACHER
                 ,WHGNR
                 ,MANDANT
                 ,SPRACHCODE
                 ;


 /*********************************************************************/
 /*                                                                   */
 /*      V  E  R  A  R  B  E  I  T  U  N  G                           */
 /*                                                                   */
 /*********************************************************************/


        Env = initAG0002(Env);
        initKO1674(Env);

        TRY

          openEinsteller();
          while ( fetchEinsteller() == 0 )
          {

             openSummen();
             while ( fetchSummen() == 0 )
             {

              if ( Hzweig[0] == '\0' )
              {
                     strcpy(Hzweig,OTAG_ABST_SUMME.ZWEIG);
                     strcpy(Harkz,OTAG_ABST_SUMME.ARKZ);
                     strcpy(Hziel_kz,OTAG_ABST_SUMME.ZIEL_KZ);
                     strcpy(Hverursacher,OTAG_ABST_SUMME.VERURSACHER);
                     Hmandant = OTAG_ABST_SUMME.MANDANT;
                     Hsprachcode = OTAG_ABST_SUMME.SPRACHCODE;
              }

              SummeAnzahl();

              if (( memcmp(Hverursacher,OTAG_ABST_SUMME.VERURSACHER,8)
                 == 0 )
              &&  ( Hsprachcode == OTAG_ABST_SUMME.SPRACHCODE )
              &&  ( memcmp(Harkz,OTAG_ABST_SUMME.ARKZ,2) == 0 )
              &&  ( memcmp(Hziel_kz,OTAG_ABST_SUMME.ZIEL_KZ,6) == 0 )
              &&  ( memcmp(Hzweig,OTAG_ABST_SUMME.ZWEIG,4) == 0 )
              &&  ( Hmandant == OTAG_ABST_SUMME.MANDANT ) )
                 {
                     Workanzahl = Workanzahl + OTAG_ABST_SUMME.ANZAHL;
                     Worksumme  = Worksumme  + OTAG_ABST_SUMME.SUMME;
                 }
              else
                 {

                     if ( Workanzahl > 0
                       || Worksumme  > 0 )
                      {
                          Rc = abgleich( Hzweig
                                       , Harkz
                                       , Hziel_kz
                                       , Hverursacher
                                       , Hmandant
                                       , Hsprachcode
                                       , ""
                                       , Workanzahl
                                       , Worksumme
                                       );
                          if ( Rc == 1 )
                               updateAbholer();

                      }

                      Workanzahl = 0;
                      Worksumme  = 0;
                      Workanzahl = Workanzahl + OTAG_ABST_SUMME.ANZAHL;
                      Worksumme  = Worksumme  + OTAG_ABST_SUMME.SUMME;
                      strcpy(Hzweig,OTAG_ABST_SUMME.ZWEIG);
                      strcpy(Harkz,OTAG_ABST_SUMME.ARKZ);
                      strcpy(Hziel_kz,OTAG_ABST_SUMME.ZIEL_KZ);
                      strcpy(Hverursacher,OTAG_ABST_SUMME.VERURSACHER);
                      Hmandant = OTAG_ABST_SUMME.MANDANT;
                      Hsprachcode = OTAG_ABST_SUMME.SPRACHCODE;

                 }

             }

             if ( Workanzahl != 0
               || Worksumme  != 0 )
             {
                  Rc = abgleich( Hzweig
                               , Harkz
                               , Hziel_kz
                               , Hverursacher
                               , Hmandant
                               , Hsprachcode
                               , ""
                               , Workanzahl
                               , Worksumme
                               );

                  if ( Rc == 1 )
                       updateAbholer();

             }

             Workanzahl = 0;
             Worksumme  = 0;

             closeSummen();

          }
          closeEinsteller();




 /*********************************************************************/
 /*                                                                   */
 /*     E  P  I  L  O  G                                              */
 /*                                                                   */
 /*********************************************************************/


          EXEC SQL
          DELETE
          FROM     OTAG_ABST_SUMME
          WHERE    STATUS = 'W'
            AND    ANZAHL     <= 0
            AND    SUMME      <= 0
            ;

          QV_CHECK(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));


        RECOVER
          printf(".%s. %s. %s. %s. %s \n",Modul,Routine,datim_today(0)
                                         ,datim_now(0)
                                         ,err_msg() );
        END

 }


 /*********************************************************************/
 /*                                                                   */
 /*      o  p  e  n  E  i  n  s  t  e  l  l  e  r                     */
 /*                                                                   */
 /*********************************************************************/


 static void openEinsteller( void )
 {

 static  const  char *Routine = "openEinsteller";


               EXEC SQL
                    OPEN  C1;

               QV_CHECK0(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

 }                                            /* openEinsteller       */


 /*********************************************************************/
 /*                                                                   */
 /*      c  l  o  s  e  E  i  n  s  t  e  l  l  e  r                  */
 /*                                                                   */
 /*********************************************************************/


 static void closeEinsteller( void )
 {

 static  const  char *Routine = "closeEinsteller";


               EXEC SQL
                    CLOSE C1;

               QV_CHECK0(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

 }                                            /* closeEinsteller      */


 /*********************************************************************/
 /*                                                                   */
 /*      f  e  t  c  h  E  i  n  s  t  e  l  l  e  r                  */
 /*                                                                   */
 /*********************************************************************/


 static int  fetchEinsteller( void )
 {

 static  const  char *Routine = "fetchEinsteller";


               EXEC SQL
                 FETCH C1
                 INTO :STAG_ABST_VERURS.BEZIEH_NR
                     ,:STAG_ABST_VERURS.VERURSACHER
                     ,:STAG_ABST_VERURS.EIN_ABH
                     ,:STAG_ABST_VERURS.ARKZ
                     ,:STAG_ABST_VERURS.ZIEL_KZ
                     ,:STAG_ABST_VERURS.MANDANT
                     ,:STAG_ABST_VERURS.SPRACHCODE
                     ;

               QV_CHECK(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

               return(sqlca.sqlcode);

 }                                            /* fetchEinsteller      */


 /*********************************************************************/
 /*                                                                   */
 /*      o  p  e  n  S  u  m  m  e  n                                 */
 /*                                                                   */
 /*********************************************************************/


 static void openSummen( void )
 {

 static  const  char *Routine = "openSummen";


               EXEC SQL
                    OPEN  C2;

               QV_CHECK0(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

 }                                            /* openSummen           */


 /*********************************************************************/
 /*                                                                   */
 /*      c  l  o  s  e  S  u  m  m  e  n                              */
 /*                                                                   */
 /*********************************************************************/


 static void closeSummen( void )
 {

 static  const  char *Routine = "closeSummen";


               EXEC SQL
                    CLOSE C2;

               QV_CHECK0(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

 }                                            /* closeSummen          */


 /*********************************************************************/
 /*                                                                   */
 /*      f  e  t  c  h  S  u  m  m  e  n                              */
 /*                                                                   */
 /*********************************************************************/


 static int  fetchSummen( void )
 {

 static  const  char *Routine = "fetchSummen";


               EXEC SQL
                 FETCH C2
                 INTO :OTAG_ABST_SUMME.ZWEIG
                     ,:OTAG_ABST_SUMME.ARKZ
                     ,:OTAG_ABST_SUMME.ZIEL_KZ
                     ,:OTAG_ABST_SUMME.VERURSACHER
                     ,:OTAG_ABST_SUMME.WHGNR
                     ,:OTAG_ABST_SUMME.MANDANT
                     ,:OTAG_ABST_SUMME.SPRACHCODE
                     ;

               QV_CHECK(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

               return(sqlca.sqlcode);

 }                                            /* fetchEinsteller      */


 /*********************************************************************/
 /*                                                                   */
 /*      S  u  m  m  e  A  n  z  a  h  l                              */
 /*                                                                   */
 /*********************************************************************/


 static void SummeAnzahl( void )
 {

 static  const  char *Routine = "SummeAnzahl";

               EXEC SQL
               SELECT   SUM(ANZAHL)
                       ,SUM(SUMME)
               INTO     :OTAG_ABST_SUMME.ANZAHL
                       ,:OTAG_ABST_SUMME.SUMME
               FROM     OTAG_ABST_SUMME
               WHERE    STATUS = 'W'
                 AND    ZWEIG       = :OTAG_ABST_SUMME.ZWEIG
                 AND    ARKZ        = :OTAG_ABST_SUMME.ARKZ
                 AND    ZIEL_KZ     = :OTAG_ABST_SUMME.ZIEL_KZ
                 AND    VERURSACHER = :OTAG_ABST_SUMME.VERURSACHER
                 AND    WHGNR       = :OTAG_ABST_SUMME.WHGNR
                 AND    MANDANT     = :OTAG_ABST_SUMME.MANDANT
                 AND    SPRACHCODE  = :OTAG_ABST_SUMME.SPRACHCODE
                 ;


               QV_CHECK(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

 }                                            /* SummeAnzahl          */


 /*********************************************************************/
 /*                                                                   */
 /*      u  p  d  a  t  e  A  b  h  o  l  e  r                        */
 /*                                                                   */
 /*********************************************************************/


 static void updateAbholer( void )
 {

 static  const  char *Routine = "updateAbholer";


               EXEC SQL
               UPDATE   OTAG_ABST_SUMME
               SET      STATUS = 'F'
               WHERE    STATUS = 'W'
                 AND    ZWEIG       = :Hzweig
                 AND    ARKZ        = :Harkz
                 AND    ZIEL_KZ     = :Hziel_kz
                 AND    VERURSACHER = :Hverursacher
                 AND    MANDANT     = :Hmandant
                 AND    SPRACHCODE  = :Hsprachcode
                 AND    ANZAHL      = :Workanzahl
                 AND    SUMME       = :Worksumme
                 ;

               QV_CHECK(ABBRUCH,qv_msg("%s - %s ",Modul,Routine));

 }                                            /* SummeAnzahl          */
