 @process override mparm('DSPRVURV')
          TITLE('DSPRVURV - Recovery System DBRC Recovery Exit')
          format;
 @process override env(z/OS) machine(zSeries) optimize(ADV,64)
                  storemotion inline(MAX) assert(blockreorder);
 /********************************************************************/
 /*                                                                  */
 /* MODULE NAME: DSPRVURV                                            */
 /*                                                                  */
 /* DESCRIPTIVE NAME:  DBRC Recovery System Recovery Exit            */
 /*                                                                  */
 /*                                                                  */
 /************************************************************@SCPYRT*/
 /*                                                                  */
 /*    IBM Confidential                                              */
 /*                                                                  */
 /*    OCO Source Materials                                          */
 /*                                                                  */
 /*    5635-A04                                                      */
 /*                                                                  */
 /*        Copyright IBM Corp. 1996,2007                             */
 /*                                                                  */
 /*    The source code for this program is not published or other-   */
 /*    wise divested of its trade secrets, irrespective of what has  */
 /*    been deposited with the U.S. Copyright Office.                */
 /*                                                                  */
 /************************************************************@ECPYRT*/
 /*                                                                  */
 /*                                                                  */
 /* STATUS: IMS/ESA VERSION 6 RELEASE 1                              */
 /*                                                                  */
 /* FUNCTION:                                                        */
 /*        This routine determines all the inputs needed for the     */
 /*        recovery system to perform db recovery.                   */
 /*                                                                  */
 /* NOTES:                                                           */
 /*  DEPENDENCIES: None.                                             */
 /*                                                                  */
 /*  RESTRICTIONS: None.                                             */
 /*                                                                  */
 /*  REGISTER CONVENTIONS:                                           */
 /*    Standard PL/X-370                                             */
 /*                                                                  */
 /*  PATCH LABEL: Compiler generated.                                */
 /*                                                                  */
 /* MODULE TYPE: System.                                             */
 /*                                                                  */
 /*  PROCESSOR: PL/X-370                                             */
 /*                                                                  */
 /*  MODULE SIZE: See assembler listing.                             */
 /*                                                                  */
 /*  ATTRIBUTES: Reentrant                                           */
 /*                                                                  */
 /* ENTRY POINT: DSPRVURV                                            */
 /*                                                                  */
 /*  PURPOSE: See function.                                          */
 /*                                                                  */
 /*  LINKAGE: call dsprvurv(dfsbrlsb)                                */
 /*                                                                  */
 /* INPUT:                                                           */
 /*   dfsbrlsb - DBRC parameter block                                */
 /*                                                                  */
 /* OUTPUT: tbd                                                      */
 /*                                                                  */
 /* NORMAL EXIT:                                                     */
 /*  R15   R0          Description                                   */
 /*   0    -        Successful completion.                           */
 /*   4    -        One or more data bases could not be recovered    */
 /*   12   -        Severe error encountered,                        */
 /*   44   -        DBRC encountered a severe error                  */
 /*                                                                  */
 /*   The following reason codes are returned in the parameter area: */
 /*                                                                  */
 /*   Reason Code   Description                                      */
 /*    0            Successful recovery generation                   */
 /*    4            No useable image copy found                      */
 /*    8            The data base is in use                          */
 /*    12           Duplicate entry                                  */
 /*                                                                  */
 /* ERROR EXIT:                                                      */
 /*  R15   R0          Description                                   */
 /*                                                                  */
 /* EXTERNAL REFERENCES:                                             */
 /*                                                                  */
 /*  ROUTINES:                                                       */
 /*                                                                  */
 /*  DATA AREAS:                                                     */
 /*                                                                  */
 /*  CONTROL BLOCKS:                                                 */
 /*      see %includes                                               */
 /*                                                                  */
 /* TABLES: None                                                     */
 /*                                                                  */
 /* MACROS: BPESTART                                                 */
 /*                                                                  */
 /* MESSAGES: None                                                   */
 /*                                                                  */
 /* ABENDS: None                                                     */
 /*                                                                  */
 /* CHANGE ACTIVITY:                                                 */
 /*  Date    Coder  PTM#     Rel    Reason                           */
 /* -------  -----  -------  ----  ----------------------------------*/
 /* 11/10/95  LES            V6R1  Created Module                    */
 /********************************************************************/
 @eject;
 ?DSPRVURV: dspstart
                     options(codenum(2))
                     fixes(
                          );
 /***************************************************************/
 /*  Control blocks, register declares, etc.                    */
 /***************************************************************/
 %dcl incls char ext;
 %incls = 'NO';
 %include syslib(dspgdb);
 gen code ( COPY BPE64NOP ) optacross;
 ?dspdreg;
   return code(0);

 ?epilog;
 End DSPRVURV;