 /*********************************************************************/
 /*  MKQ0451  Modulkurzbezeichnung                                    */
 /*                                                                   */
 /*   PROJEKT:               KOMPASS-KFZ                              */
 /*                                                                   */
 /*   UNTERPROJEKT:          ZUGRIFF AUF GRUNDLAGENTABELLEN           */
 /*                                                                   */
 /*   PROGRAMMIERER:         R. Hingkeldey                            */
 /*                                                                   */
 /*   ERSTELLUNGSDATUM:      25.03.1996                               */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /*   PGM-FUNKTION:                                                   */
 /*                                                                   */
 /*   Das Modul MKQ0451 dient zum Lesen des Faktors fuer den Gesamt-  */
 /*   gewinn sowie des Operators und des Wertes zur neuen Tarifierung.*/
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /*   18.11.1996   Tuning des SQL-Zugriffs mit Hilfe der Decimal-Da-  */
 /*   HINGKELDEY   tentypen von DB2.                                  */
 /*                                                                   */
 /*********************************************************************/
 /*********************************************************************/
 /*                S Y S T E M I N C L U D E S                        */
 /*********************************************************************/
 ??=include <stdio.h>                   /* Ein-/ Ausgabe              */
 ??=include <string.h>                  /* String-Funktionen          */
 ??=include <stdlib.h>                  /* Stdlib-Funktionen          */
 ??=include <decimal.h>                 /* Decimal-Datentypen         */
 /*********************************************************************/
 /*                S Q L  -  C O N T R O L   A R E A                  */
 /*********************************************************************/
 EXEC SQL INCLUDE SQLCA;
 /*********************************************************************/
 /*             S Y S T E M  -  D E F I N I T I O N                   */
 /*********************************************************************/
 ??=include "XKQ0000C.h"
 ??=include "CICSBATC"
 /*********************************************************************/
 /*                     D E F A U L T S                               */
 /*********************************************************************/
 /*********************************************************************/
 /*                U E B E R G A B E - B E R E I C H                  */
 /*********************************************************************/
 ??=include "XKQ0451C.h"
 /*********************************************************************/
 /*                T A B E L L E N  -  D E F I N I T I O N            */
 /*********************************************************************/
 /*********************************************************************/
 /*                   L O K A L E     D A T E N                       */
 /*********************************************************************/
 /*-------------------------------------------------------------------*/
 /* KONSTANTEN                                                        */
 /*-------------------------------------------------------------------*/

 /*********************************************************************/
 /*                      D B 2   -   H O S T V A R I A B L E N        */
 /*********************************************************************/
 EXEC SQL BEGIN DECLARE SECTION;
   char     wkz_tmp[4];
   char     typkl_grp_tmp[3];
   decimal(15,0) leist_schl_tmp;
   char     tarif_tmp[7];
   char     tarifgr_tmp[3];
   char     deckungs_sl_tmp[5];
   char     mandant_tmp[2];
   char     operand_tmp[2];
   decimal(5,3)  faktor_tmp;
   decimal(8,5)  ber_wert_tmp;
 EXEC SQL END DECLARE SECTION;
 /*********************************************************************/
 /*                      D B 2   -   C U R S O R                      */
 /*********************************************************************/
 /*********************************************************************/
 /*   VORWäRTSDEKLARATION DER FUNKTIONEN                              */
 /*********************************************************************/
  void  abbruch_mkq0451(), db2_mkq0451(), grundwerte_mkq0451(),
        plausi_parm_mkq0451(),verarbeitung_mkq0451();
 /*********************************************************************/
 /*   GLOBALE VARIABLE                                                */
 /*********************************************************************/
  P_XKQ0451 pxkq0451;
  char      retcode[5];
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
  #ifdef __QV_CICS__
  void main (pxkq0451)
  {
  /********************************************************************/
  /* Laden Commarea                                                   */
  /********************************************************************/
      EXEC CICS ADDRESS COMMAREA (pxkq0451);
  /********************************************************************/
  /* Aufruf MKQ0451                                                   */
  /********************************************************************/
      aufruf_0451(&pxkq0451);

      EXEC CICS RETURN ;
  }
  #else
  void MKQ0451 (pxkq0451)
  {
      aufruf_0451(&pxkq0451);
      return;
  }
  #endif
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
 int  aufruf_0451(P_XKQ0451 *pxkq0451tmp)
 {
  pxkq0451 = *pxkq0451tmp;
                                            /*------------------------*/
                                            /* VOREINSTELLUNGEN       */
                                            /*------------------------*/
  grundwerte_mkq0451();
                                            /*------------------------*/
                                            /* PR!FEN EINGABEDATEN    */
                                            /*------------------------*/
  plausi_parm_mkq0451();

  if (strncmp(retcode, "    ",sizeof(retcode)-1))
    abbruch_mkq0451();
                                            /*------------------------*/
                                            /* STEUERUNG IO-ZUGRIFF   */
                                            /*------------------------*/
  else
    verarbeitung_mkq0451();

    return (RC_OK);
 }

  /********************************************************************/
  /*                I N T E R N E    P R O Z E D U R E N              */
  /********************************************************************/
  /********************************************************************/
  /* ABBRUCH_MKQ0451        : ABBRUCH DES PROGRAMMS                   */
  /* DB2_MKQ0451            : SAMMLUNG DER DB2-SQL DATENBANKZUGRIFFE  */
  /* GRUNDWERTE_MKQ0451     : INITIALISIERUNGEN                       */
  /* PLAUSI_PARM_MKQ0451    : PRUEFEN DER EINGABEDATEN                */
  /* VERARBEITUNG_MKQ0451   : ANWENDUNGSSPEZIFISCHE VERARBEITUNG      */
  /********************************************************************/

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: A B B R U C H                                  */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - BEHANDLUNG VON UNERWARTETEN FEHLERN                            */
  /********************************************************************/
 void abbruch_mkq0451 () {
   psqlca kfsqlca = pxkq0451->P_SQLCA;
                                            /*------------------------*/
                                            /* SETZEN STEUERBEREICH   */
                                            /*------------------------*/
   memcpy(pxkq0451->STEUER.fmodul,"MKQ0451 ",
          sizeof(pxkq0451->STEUER.fmodul)-1);
   memcpy(pxkq0451->STEUER.fmodul_retcode,
          pxkq0451->STEUER.retcode,
          sizeof(pxkq0451->STEUER.fmodul_retcode)-1);
                                            /*------------------------*/
                                            /* UEBERTRAGEN SPA        */
                                            /*------------------------*/
   if (atoi(retcode) == 200)
     kfsqlca = &sqlca;

   memcpy(pxkq0451->STEUER.retcode,retcode,                              0000111
          sizeof(pxkq0451->STEUER.retcode)-1);                           0000111
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: D B 2                                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - SAMMLUNG DER INTERNEN DB2-SQL DATENBANKZUGRIFFE:               */
  /*   01 : TBKF_GEWINN_FAKT    LESEN Faktor fuer Regionalklasse      */
  /********************************************************************/
 void db2_mkq0451 (int nr)
 {
   if ( nr == 1 )
   {
   /*******************************************************************/
   /*  01 : TBKF_GEWINN_FAKT  LESEN TBKF_GEWINN_FAKT                  */
   /*******************************************************************/
     EXEC SQL
       SELECT
              FAKTOR, OPERAND, BER_WERT
       INTO
              :faktor_tmp, :operand_tmp, :ber_wert_tmp
       FROM
              TBKF_GEWINN_FAKT
       WHERE
              WKZ         =     :wkz_tmp
       AND
              TYPKL_GRP   =     :typkl_grp_tmp
       AND
              LEIST_SCHL  =     :leist_schl_tmp
       AND
              TARIF       =     :tarif_tmp
       AND
              DECKUNGS_SL =     :deckungs_sl_tmp
       AND
              TARIFGR     =     :tarifgr_tmp
       AND
              MANDANT     =     :mandant_tmp
     ;

     if (SQLCODE == SQL_OK)
       strcpy(retcode,"0000");
     else
     {
       if (SQLCODE == SQL_NICHT_GEFUNDEN)
       {
         strcpy(retcode,"0100");                                            0000
         pxkq0451->STEUER.fmodul_sqlcallnr =  nr;                           0000
         memcpy(pxkq0451->STEUER.fmodul_retcode,
                retcode,
                sizeof(pxkq0451->STEUER.fmodul_retcode)-1);
         memcpy(pxkq0451->STEUER.fmodul,
                "MKQ0451 ",
                sizeof(pxkq0451->STEUER.fmodul)-1);
       }
       else
       {
         strcpy(retcode,"0200");
         pxkq0451->STEUER.fmodul_sqlcallnr = nr;
         abbruch_mkq0451();
       }
     }
   }
                                            /*------------------------*/
                                            /* UNGUELTIGER AUFRUF DB2 */
                                            /*------------------------*/
   else
   {
     strcpy(retcode,"0199");
     abbruch_mkq0451();
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: G R U N D W E R T E                            */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - INITIALISIEREN VON FELDERN                                     */
  /********************************************************************/
 void grundwerte_mkq0451() {
                                            /*------------------------*/
                                            /* LOESCHEN STEUERBEREICH */
                                            /*------------------------*/
    memcpy(retcode,"    ",                                              00001110
           sizeof(pxkq0451->STEUER.retcode)-1);                         00001110
    memset(pxkq0451->STEUER.hinweis,0,                                  00001110
           sizeof(pxkq0451->STEUER.hinweis)-1);                         00001110
    memset(pxkq0451->STEUER.fmodul,0,                                   00001110
           sizeof(pxkq0451->STEUER.fmodul)-1);                          00001110
    memset(pxkq0451->STEUER.fmodul_retcode,0,                           00001110
           sizeof(pxkq0451->STEUER.fmodul_retcode)-1);                  00001110
    pxkq0451->STEUER.fmodul_sqlcallnr = 0;                              00001150
                                            /*------------------------*/00001150
                                            /* LOESCHEN AUSGABE       */
                                            /*------------------------*/
    pxkq0451->AUSGABE.ber_wert = 0;                                     00001110
    pxkq0451->AUSGABE.faktor   = 0;                                     00001110
    memset(pxkq0451->AUSGABE.operand,0,                                 00001110
           sizeof(pxkq0451->AUSGABE.operand)-1);                        00001110

 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: P L A U S I _ P A R M                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - PRUEFUNGEN DER EINGABEDATEN                                    */
  /********************************************************************/
 void plausi_parm_mkq0451 () {
   char struk_name_tmp[9];
   char version_tmp[5];
   char ende_tmp[5];

   memset(struk_name_tmp,0,sizeof(struk_name_tmp));                      0000111
   memset(version_tmp,0,sizeof(version_tmp));                            0000111
   memset(ende_tmp,0,sizeof(ende_tmp));                                  0000111
                                            /*------------------------*/
                                            /* PRUEFEN VERSION        */
                                            /*------------------------*/
   memcpy(pxkq0451->IDENT.struktur_name,__STRUKTUR_NAME_0451,            0000111
          sizeof(pxkq0451->IDENT.struktur_name));                        0000111
   memcpy(pxkq0451->IDENT.version,__VERSION_0451,
          sizeof(pxkq0451->IDENT.version));
   memcpy(pxkq0451->ende,__ENDE,
          sizeof(pxkq0451->ende));

   memcpy(struk_name_tmp,pxkq0451->IDENT.struktur_name,                  0000111
          sizeof(pxkq0451->IDENT.struktur_name));                        0000111
   memcpy(version_tmp,pxkq0451->IDENT.version,
          sizeof(pxkq0451->IDENT.version));
   memcpy(ende_tmp,pxkq0451->ende,
          sizeof(pxkq0451->ende));
   if (       strcmp(struk_name_tmp,"XKQ0451 ")
       ??!??! strcmp(version_tmp,"0001")
       ??!??! strcmp(ende_tmp,"ENDE"))
   {
     strcpy(pxkq0451->STEUER.retcode,"1");
     return;
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: V E R A R B E I T U N G                        */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /*  - ANWENDUNGSSPEZIFISCHE VERARBEITUNG                            */
  /********************************************************************/
 void verarbeitung_mkq0451 () {
                                            /*------------------------*/
                                            /* LESEN TBKF_NETTO_SCHAD */
                                            /*------------------------*/
   memcpy(wkz_tmp,pxkq0451->EINGABE.wkz,
          sizeof(pxkq0451->EINGABE.wkz)-1);
   memcpy(typkl_grp_tmp,pxkq0451->EINGABE.typkl_grp,
          sizeof(pxkq0451->EINGABE.typkl_grp)-1);
   leist_schl_tmp = pxkq0451->EINGABE.leist_schl;
   memcpy(deckungs_sl_tmp,pxkq0451->EINGABE.deckungs_sl,
          sizeof(pxkq0451->EINGABE.deckungs_sl)-1);
   memcpy(tarif_tmp,pxkq0451->EINGABE.tarif,
          sizeof(pxkq0451->EINGABE.tarif)-1);
   memcpy(tarifgr_tmp,pxkq0451->EINGABE.tarifgr,
          sizeof(pxkq0451->EINGABE.tarifgr)-1);
   memcpy(mandant_tmp,pxkq0451->EINGABE.mandant,
          sizeof(pxkq0451->EINGABE.mandant)-1);
   db2_mkq0451(1);
   if (SQLCODE == SQL_NICHT_GEFUNDEN)
     memcpy(pxkq0451->STEUER.retcode,
            retcode,
            sizeof(pxkq0451->STEUER.retcode)-1);                           00001
   if (SQLCODE == SQL_OK)
   {
     memcpy(pxkq0451->STEUER.retcode,
            retcode,
            sizeof(pxkq0451->STEUER.retcode)-1);                           00001
     pxkq0451->AUSGABE.faktor       =  faktor_tmp;
     pxkq0451->AUSGABE.ber_wert     =  ber_wert_tmp;
     memcpy(pxkq0451->AUSGABE.operand,
            operand_tmp,
            sizeof(pxkq0451->AUSGABE.operand)-1);                          00001
   }
 }

  /********************************************************************/
  /* ENDE MKQ0451                                                     */
  /********************************************************************/
