 /*********************************************************************/
 /*  MKQ0455  Modulkurzbezeichnung                                    */
 /*                                                                   */
 /*   PROJEKT:               KOMPASS-KFZ                              */
 /*                                                                   */
 /*   UNTERPROJEKT:          ZUGRIFF AUF GRUNDLAGENTABELLEN           */
 /*                                                                   */
 /*   PROGRAMMIERER:         R. Hingkeldey                            */
 /*                                                                   */
 /*   ERSTELLUNGSDATUM:      01.01.1994                               */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /*   PGM-FUNKTION:                                                   */
 /*                                                                   */
 /*   DAS MODUL MKQ0455 DIENT ZUM LESEN DES MINIMALEN BZW. MAXIMALEN  */
 /*   FAKTORWERTES FUER DIE TARIFIERUNG.                              */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /*   18.11.1996   Tuning des SQL-Zugriffs mit Hilfe der Decimal-Da-  */
 /*   HINGKELDEY   tentypen von DB2.                                  */
 /*                                                                   */
 /*********************************************************************/
 /*********************************************************************/
 /*                S Y S T E M I N C L U D E S                        */
 /*********************************************************************/
 ??=pragma linkage (mkq0455, PLI)
 ??=include <stdio.h>                   /* Ein-/ Ausgabe              */
 ??=include <string.h>                  /* String-Funktionen          */
 ??=include <stdlib.h>                  /* Stdlib-Funktionen          */
 ??=include <decimal.h>                 /* Decimal-Datentypen         */
 /*********************************************************************/
 /*                S Q L  -  C O N T R O L   A R E A                  */
 /*********************************************************************/
 EXEC SQL INCLUDE SQLCA;
 /*********************************************************************/
 /*             S Y S T E M  -  D E F I N I T I O N                   */
 /*********************************************************************/
 ??=include "XKQ0000C.h"
 ??=include "CICSBATC"
 /*********************************************************************/
 /*                     D E F A U L T S                               */
 /*********************************************************************/
 /*********************************************************************/
 /*                U E B E R G A B E - B E R E I C H                  */
 /*********************************************************************/
 ??=include "XKQ0455C.h"
 /*********************************************************************/
 /*                T A B E L L E N  -  D E F I N I T I O N            */
 /*********************************************************************/
 /*********************************************************************/
 /*                   L O K A L E     D A T E N                       */
 /*********************************************************************/
 /*-------------------------------------------------------------------*/
 /* KONSTANTEN                                                        */
 /*-------------------------------------------------------------------*/

 /*********************************************************************/
 /*                      D B 2   -   H O S T V A R I A B L E N        */
 /*********************************************************************/
 EXEC SQL BEGIN DECLARE SECTION;
   char     tarif_tmp??(7??);
   char     mandant_tmp??(2??);
   decimal(4,3)  min_wert_tmp;
   decimal(4,3)  max_wert_tmp;
 EXEC SQL END DECLARE SECTION;
 /*********************************************************************/
 /*                      D B 2   -   C U R S O R                      */
 /*********************************************************************/
 /*********************************************************************/
 /*   VORWäRTSDEKLARATION DER FUNKTIONEN                              */
 /*********************************************************************/
  void  abbruch_mkq0455(), db2_mkq0455(), grundwerte_mkq0455(),
        plausi_parm_mkq0455(),verarbeitung_mkq0455();
 /*********************************************************************/
 /*   GLOBALE VARIABLE                                                */
 /*********************************************************************/
  P_XKQ0455 pxkq0455;
  char      retcode??(5??);
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
  #ifdef __QV_CICS__
  void main (pxkq0455)
  {
  /********************************************************************/
  /* Laden Commarea                                                   */
  /********************************************************************/
      EXEC CICS ADDRESS COMMAREA (pxkq0455);
  /********************************************************************/
  /* Aufruf MKQ0455                                                   */
  /********************************************************************/
      aufruf_0455(&pxkq0455);

      EXEC CICS RETURN ;
  }
  #else
  void MKQ0455 (pxkq0455)
  {
      aufruf_0455(&pxkq0455);
      return;
  }
  #endif
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
 int  aufruf_0455(P_XKQ0455 *pxkq0455tmp)
 {
  pxkq0455 = *pxkq0455tmp;
                                            /*------------------------*/
                                            /* VOREINSTELLUNGEN       */
                                            /*------------------------*/
  grundwerte_mkq0455();
                                            /*------------------------*/
                                            /* PR!FEN EINGABEDATEN    */
                                            /*------------------------*/
  plausi_parm_mkq0455();

  if (strncmp(retcode, "    ",sizeof(retcode)-1))
    abbruch_mkq0455();
                                            /*------------------------*/
                                            /* STEUERUNG IO-ZUGRIFF   */
                                            /*------------------------*/
  else
    verarbeitung_mkq0455();

    return (RC_OK);
 }

  /********************************************************************/
  /*                I N T E R N E    P R O Z E D U R E N              */
  /********************************************************************/
  /********************************************************************/
  /* ABBRUCH_MKQ0455        : ABBRUCH DES PROGRAMMS                   */
  /* DB2_MKQ0455            : SAMMLUNG DER DB2-SQL DATENBANKZUGRIFFE  */
  /* GRUNDWERTE_MKQ0455     : INITIALISIERUNGEN                       */
  /* PLAUSI_PARM_MKQ0455    : PRUEFEN DER EINGABEDATEN                */
  /* VERARBEITUNG_MKQ0455   : ANWENDUNGSSPEZIFISCHE VERARBEITUNG      */
  /********************************************************************/

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: A B B R U C H                                  */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - BEHANDLUNG VON UNERWARTETEN FEHLERN                            */
  /********************************************************************/
 void abbruch_mkq0455 () {
   psqlca kfsqlca = pxkq0455->P_SQLCA;
                                            /*------------------------*/
                                            /* SETZEN STEUERBEREICH   */
                                            /*------------------------*/
   memcpy(pxkq0455->STEUER.fmodul,"MKQ0455 ",
          sizeof(pxkq0455->STEUER.fmodul)-1);
   memcpy(pxkq0455->STEUER.fmodul_retcode,
          pxkq0455->STEUER.retcode,
          sizeof(pxkq0455->STEUER.fmodul_retcode)-1);
                                            /*------------------------*/
                                            /* UEBERTRAGEN SPA        */
                                            /*------------------------*/
   if (atoi(retcode) == 200)
     kfsqlca = &sqlca;

   memcpy(pxkq0455->STEUER.retcode,retcode,                              0000111
          sizeof(pxkq0455->STEUER.retcode)-1);                           0000111
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: D B 2                                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - SAMMLUNG DER INTERNEN DB2-SQL DATENBANKZUGRIFFE:               */
  /*   01 : TBKF_NETTO_SCHAD  LESEN GRUND_BETR                        */
  /********************************************************************/
 void db2_mkq0455 (int nr)
 {
   if ( nr == 1 )
   {
   /*******************************************************************/
   /*  01 : TBKF_NETTO_SCHAD  LESEN TBKF_NETTO_SCHAD                  */
   /*******************************************************************/
     EXEC SQL
       SELECT
              MIN_WERT, MAX_WERT
       INTO
              :min_wert_tmp,:max_wert_tmp
       FROM
              TBKF_MINMAX_WERT
       WHERE
              TARIF       =    :tarif_tmp
       AND
              MANDANT     =    :mandant_tmp
     ;

     if (SQLCODE == SQL_OK)
       strcpy(retcode,"0000");
     else
     {
       if (SQLCODE == SQL_NICHT_GEFUNDEN)
       {
         strcpy(retcode,"0100");                                            0000
         pxkq0455->STEUER.fmodul_sqlcallnr =  nr;                           0000
         memcpy(pxkq0455->STEUER.fmodul_retcode,
                retcode,
                sizeof(pxkq0455->STEUER.fmodul_retcode)-1);
         memcpy(pxkq0455->STEUER.fmodul,
                "MKQ0455 ",
                sizeof(pxkq0455->STEUER.fmodul)-1);
       }
       else
       {
         strcpy(retcode,"0200");
         pxkq0455->STEUER.fmodul_sqlcallnr = nr;
         abbruch_mkq0455();
       }
     }
   }
                                            /*------------------------*/
                                            /* UNGUELTIGER AUFRUF DB2 */
                                            /*------------------------*/
   else
   {
     strcpy(retcode,"0199");
     abbruch_mkq0455();
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: G R U N D W E R T E                            */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - INITIALISIEREN VON FELDERN                                     */
  /********************************************************************/
 void grundwerte_mkq0455() {
                                            /*------------------------*/
                                            /* LOESCHEN STEUERBEREICH */
                                            /*------------------------*/
    memcpy(retcode,"    ",                                              00001110
           sizeof(pxkq0455->STEUER.retcode)-1);                         00001110
    memset(pxkq0455->STEUER.hinweis,0,                                  00001110
           sizeof(pxkq0455->STEUER.hinweis));                           00001110
    memset(pxkq0455->STEUER.fmodul,0,                                   00001110
           sizeof(pxkq0455->STEUER.fmodul));                            00001110
    memset(pxkq0455->STEUER.fmodul_retcode,0,                           00001110
           sizeof(pxkq0455->STEUER.fmodul_retcode));                    00001110
    pxkq0455->STEUER.fmodul_sqlcallnr = 0;                              00001150
                                            /*------------------------*/00001150
                                            /* LOESCHEN AUSGABE       */
                                            /*------------------------*/
    pxkq0455->AUSGABE.min_wert = 0;                                     00001110
    pxkq0455->AUSGABE.max_wert = 0;                                     00001110

 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: P L A U S I _ P A R M                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - PRUEFUNGEN DER EINGABEDATEN                                    */
  /********************************************************************/
 void plausi_parm_mkq0455 () {
   char struk_name_tmp??(9??);
   char version_tmp??(5??);
   char ende_tmp??(5??);

   memset(struk_name_tmp,0,sizeof(struk_name_tmp));                      0000111
   memset(version_tmp,0,sizeof(version_tmp));                            0000111
   memset(ende_tmp,0,sizeof(ende_tmp));                                  0000111
                                            /*------------------------*/
                                            /* PRUEFEN VERSION        */
                                            /*------------------------*/
   memcpy(pxkq0455->IDENT.struktur_name,__STRUKTUR_NAME_0455,            0000111
          sizeof(pxkq0455->IDENT.struktur_name));                        0000111
   memcpy(pxkq0455->IDENT.version,__VERSION_0455,
          sizeof(pxkq0455->IDENT.version));
   memcpy(pxkq0455->ende,__ENDE,
          sizeof(pxkq0455->ende));

   memcpy(struk_name_tmp,pxkq0455->IDENT.struktur_name,                  0000111
          sizeof(pxkq0455->IDENT.struktur_name));                        0000111
   memcpy(version_tmp,pxkq0455->IDENT.version,
          sizeof(pxkq0455->IDENT.version));
   memcpy(ende_tmp,pxkq0455->ende,
          sizeof(pxkq0455->ende));
   if (       strcmp(struk_name_tmp,"XKQ0455 ")
       ??!??! strcmp(version_tmp,"0001")
       ??!??! strcmp(ende_tmp,"ENDE"))
   {
     strcpy(pxkq0455->STEUER.retcode,"1");
     return;
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: V E R A R B E I T U N G                        */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /*  - ANWENDUNGSSPEZIFISCHE VERARBEITUNG                            */
  /********************************************************************/
 void verarbeitung_mkq0455 () {
                                            /*------------------------*/
                                            /* LESEN TBKF_NETTO_SCHAD */
                                            /*------------------------*/
   memcpy(tarif_tmp,pxkq0455->EINGABE.tarif,
          sizeof(pxkq0455->EINGABE.tarif)-1);
   memcpy(mandant_tmp,pxkq0455->EINGABE.mandant,
          sizeof(pxkq0455->EINGABE.mandant)-1);
   db2_mkq0455(1);
   if (SQLCODE == SQL_NICHT_GEFUNDEN)
     memcpy(pxkq0455->STEUER.retcode,
            retcode,
            sizeof(pxkq0455->STEUER.retcode)-1);                           00001
   if (SQLCODE == SQL_OK)
   {
     memcpy(pxkq0455->STEUER.retcode,
            retcode,
            sizeof(pxkq0455->STEUER.retcode)-1);                           00001
     pxkq0455->AUSGABE.min_wert =  min_wert_tmp;
     pxkq0455->AUSGABE.max_wert =  max_wert_tmp;
   }
 }

  /********************************************************************/
  /* ENDE MKQ0455                                                     */
  /********************************************************************/
