/*===$MAG1054===========================================================

PARSERSGENERATOR
================

EINGABE: BNF-Programm; (optionell) SETUP-File.
AUSGABE: Benutzersparser (C-Modul, fetchbar); Headerfile.

========================================================================

THIS VERSION (2004.05):


TO BE DONE (TBD):
=================
 1.1 Regard excessively long function headers. putl.inst.fprint-Done
 1.2 Unmatching types Type

 2.1 Argument control (can lead to compilation errors)
           (TBD: built-in function result(StepNr)
                  where StepNr is counted only within subsequence)
    Addition of arguments into generated functions
 2.2 PUBLIC/PROTECTED/PRIVATE [CALL|TYPE] attributes
 2.3 Specify user libraries (include_c?). Generate include & init
 2.4 date, time, datetime, common numbers (0|H;(U|I|F|E ))
  (also in MAG1052 and MAG1050)

 3.1(?) Direct output:   blin direct (also reserve as kw)
 3.2(?) Preprocessor: %if,%else,%elif,%endif,%include,%define
 3.3(?)
    parse_templ(tp_lexs **Tks,bool Oblig,char **Text,
                char *TpsAllowed,int Lenmin,int Lenmax,
                parse_sepreq SepReq)
    (Tps in CHUIFENULTSK, U-uppercase name,L-lowercase,T-capitalized)
    and/or
    parse_rex(tp_lexs **Tks,bool Oblig,char **Text,
              char *REx,int Lenmin,int Lenmax,parse_sepreq SepReq)
 3.4(?) NOT-prefix or predicate
 3.5(?) LLk-conversion
------------------------------------------------------------------------

MODE-PARAMETER
==============
ACTION=<char>      - Anfangssymbol der Aktions (AS).
                     Falls leer, wird ein Name als AS erwartet.
                     <char> definiert auch AS-Ende, wobei ([{< mit
                     jeweils )]}> ersetzt werden.
                     Default: '"'.
ALT=<token>        - Zeichenfolge zur Trennung der Alternativen einer
                     Regel. Zulaessig ist auch "\n".
                     Leere Zeichenfolge oder 0 bedeutet Trennung durch
                     wiederholte Definition einer NT.
                     Default: "|".
ARGS=Y|N|O         - Parameter sind erforderlich | verboten | optionell.
                     Betrifft nur Terminaele, nicht-Terminaele und
                     eingebaute Funktionen, die leere Parameterliste
                     zulassen. Default: N.
BLIN={[+|=]name1,name2...}
                   - Vordefinierte (eingebaute) Benutzers-AS.
                       +       - hinzufuegen
                       =       - setzen (Default)
                     Beeinflusst nur syntaktische Darstellung der
                     Benutzersfunktionen. Wenn so definiert, mu
                     (obwohl darf) der Name nicht in <ACTION>-Symbole
                     eingeklammert werden.
                     ALLE NAMEN WERDEN ZUM KLEINTEXT KONVERTIERT!
BNF=<file>         - Eingabefile. Fuer MVS ohne 'DD:'-Praefix.
                     ERFORDERLICH!
CLAUSES=<string>   - Zeichenfolge zur Trennung des zu definierenden
                     non-Terminals von der rechten Seite der Regel.
                     <string> aus Leerzeichen ist nicht erlaubt.
                     Default: "=".
CONT=<token>       - wenn RULE_END '\n' enthaellt, dient CONT zur
                     Bezeichnung der Regelfortsetzung auf der naechsten
                     Zeile. 0 setzt CONT zu NULL; Default: NULL.
CUT=<char>         - Bezeichnung fuer Cut-Kommando aus Prolog oder 0
                    (kein Cut erlaubt). Default: 0.
DEF2               - erlaubt mehrfache Definitionen.
NODEF2             - verbietet mehrfache Definitionen (default)
DIRHEAD            - Verzeichnis, in welchem Headerfile generiert wird
DIRMOD             - Verzeichnis, in welchem Programmfile generiert wird
EMPTY=<token>      - Bezeichnung des leeren Elements. Default: E.
EXTERN=<names>     - Definiert externe NTs. Entsprechendes INCLUDE-File
                     mu mit INCLUDE-Option eingeschlossen werden.
                     <names> ist entweder Einzelname oder Namensliste
                     in Hochkommas (Trenner=Comma).
GEN*               - zu generierende Programme
GEN_PARSE          - Parser
GEN_READ           - Lesemodul
GEN_WRITE          - Schreibmodul (bin-Format)
GEN_PRINT          - Schreibmodul (Textformat)
GEN_CLEAR          - Speicherfreigabemodul
GEN_IMPL           - Implementierungsmodul (wird nur skizziert)
GEN_ALL            - Alle
GEN_NO             - Keines

MOD_* = <Name>     - Modulnamen von C-Datei, C-Kopfdatei und C-Kopfdatei
                     f. Initialisierungsmodul. Der letzte Name soll
                     auch bei der Generation eines unfetchbaren
                     Unterprogramms angegeben werden, darf aber kein
                     Name von ins Programm angeschlossenen Modul sein.
                     Fuer jedes Objekt angegebene Namen muessen entweder
		     distinkt, oder identisch den Namen eines anderen
                     Objektes.
MOD_PARSE_C, MOD_PARSE_H1, MOD_PARSE_H2 - Parser.
 Default=bnf-Dateiname
MOD_WRITE_C, MOD_WRITE_H1, MOD_WRITE_H2 - Schreibmodul (bin).
 Default=MOD_PARSE_*
MOD_PRINT_C, MOD_PRINT_H1, MOD_PRINT_H2 - Schreibmodul (Text).
 Default=MOD_PARSE_*
MOD_CLEAR_C, MOD_CLEAR_H1, MOD_CLEAR_H2 - Speicherfreigabemodul
 Default=MOD_PRINT_*
MOD_READ_C, MOD_READ_H1, MOD_READ_H2    - Lesemodul.
 Default=MOD_CLEAR_*
MOD_IMPL_C, MOD_IMPL_H1, MOD_IMPL_H2    - Implementierungsmodul
 Default=MOD_READ_*

NOGENER(NOGEN)     - Benutzersparser nicht generieren. Kuenftig soll
                     GENER=0 entsprechen
INCLUDE=<FilePaare>- Definiert INCLUDE-Files und Initialisierer fuer
                     entsprechende Fetchmodule. <FilePaare> ist
                     ist entweder ein einzelnes <FilePaar> oder die
                     Liste von solchen in Hochkommas (Trenner=Comma).
                     <FilePaar> ist
                     <InclFile> <InitFunktion f. FetchModul -optionell>
                     Wenn InitFunktion ausgelassen ist, dann wird deren
                     Name aus InclFile generiert, wobei der 1. Symbol
                     auf 'M' gesetzt wird. Die gleichen Namen sind
                     erlaubt.
LIST=<token>       - Bezeichnung der zyklischen Verwendung einer
                     Elementenfolge (>=1).
                     Ist eine linke Klammer definiert, wird am Ende der
                     wiederholbaren Elementenfolge die entsprechende
                     rechte Klammer erwartet.
                     Default: "+".
LISTSEP=<token>    - Bezeichnung fuer Angabe von den Listentrennern.
                     Z.B.,disjunction=conjunction*['or'|'oder'|'o'|'|'].
                     Soll entweder eine linke Klammer oder Hochkomma
                     sein und sich von ALT,MULT,SEQ,RULE_BEGIN,RULE_END
		     unterscheiden.
		     Wenn eine von Bezeichnungen ALT,MULT,SEQ,RULE_END leer
		     ist, dann sind auch weder '(', noch Zeichen fuer NT,
		     TERM und ACTION zulaessig.
                     Default: "[".
MULT=<token>       - Zeichenfolge zur Trennung der Elemente innerhalb
                     einer Menge.
                     Leere Zeichenfolge ist erlaubt.
                     Default: ";".
NOLLK              - Setzt LLK-Analyse ab.
                     Falls NOLLK nicht angegeben, und die Grammatik
                     nicht LLk-korrekt ist, wird die Generierung
                     auch bei aktiver GENER-Option unterdrueckt
NT=<char>          - Anfangssymbol des Non-Terminals (NT).
                     Bei leerer Zeichenfolge wird ein Name erwartet.
                     NT bestimmt auch NT-Ende, wobei ([{< mit
                     jeweils )]}> ersetzt werden.
                     Default: '<'.
OPER=S|P|B|0       - S: OPT, LIST und OPTLIST sind Suffix-Operatoren,
                     P: OPT, LIST und OPTLIST sind Praefix-Operatoren,
                     B: OPT, LIST und OPTLIST sind Klammern
                     0: Schleifen und optionelle Elemente koennen,
                        unabhaengig von Parametern
                        OPT, LIST und OPTLIST, nur durch zusaetzliche
                        Regel implementiert werden.
                     Default: "S".
OPTIONAL=<token>   - Bezeichnung der optionellen Verwendung einer
                     Elementenfolge.
                     Ist eine linke Klammer definiert, wird am Ende der
                     optionellen Elementenfolge die entsprechende
                     rechte Klammer erwartet.
                     Default: "?".
OPTLIST="token"    - Bezeichnung der zyklischen Verwendung einer
                     Elementenfolge (>=0). Klammernbearbeitung - s. LIST
                     Default: "*".
PUBLIC={[TYPES,][+|=]name1,name2... | 0 | *}
                   - Liste der als extern zu generierten Funktionen.
                     Z.B. PUBLIC='PROG,QVPL'
                     ALLE NAMEN WERDEN ZUM KLEINTEXT KONVERTIERT!
                     Default: Alle unreferenzierte NTs.
RULE_BEGIN=<token> - Bezeichnung des Regelanfangs. Default: NULL.
RULE_END=<token>   - Bezeichnung des Regelendes. Default: ".".
                     0 setzt RULE_END zu NULL;
SEQ=<token>        - Zeichenfolge zur Trennung der Elemente innerhalb
                     /einer Alternative/ einer Regel.
                     Leere Zeichenfolge ist erlaubt.
                     Default: ",".
TERM=<char>        - Anfangssymbol des Terminals. 0 setzt TERM zu NULL,
                     d.h.: Terminale sind nicht erlaubt;
                           Analyse wird nicht augefuehrt;
                           ARGS=N ist nicht erlaubt.
                     Default: '\''.

OPTIONS (OPTS)     - Optionsliste drucken
NOOPTIONS(NOOPTS)  - Optionsliste nicht drucken (default)


MODULTYP
========
Fetchable.


INHALT
======

#1 HILFSFUNKTIONEN
gram_rulenamecmp
gram_rulecmp
gram_qtend
gram_plausid

#2 AUSKUNFT
gram_processed(public)
gram_status(public)
gram_getstdact

#3 gram-PARSEN
gram_parse(public)
gram_parrules
gram_parrule1
gram_parend
gram_parseq
gram_paritems
gram_parinfix
gram_paritem1
gram_parnt
gram_parname

#4 ERSTELLEN
gram_crerule
gram_creseq
gram_creitem1

#5 AUSDRUCK
gram_printf(public)
gram_ptrule
gram_ptseq
gram_ptitem1
gram_ptnt(public)
gram_ptargs - deaktiviert

#6 UMWANDLUNG ZUR STANDARTFORM
gram_artname
gram_outnames
gram_delmultiple
gram_delseq
gram_unreach
gram_replinseq
gram_del11
static gram_convert(public)

#7 LLk-Analyse
gram_ptelm (Hilfsfunktion)
gram_ptalt (Hilfsfunktion)
gram_anllk(public)
gram_creelm
gram_anle
gram_anlnte
gram_elmcmp1
gram_lnkcmp0
gram_lnkcmp2
gram_anl1
gram_testllk

#8 PARSERGENERATOR
gram_gener(public)
gram_findpublic
gram_settfns
gram_settfn1
gram_settpit
gram_settpl
gram_sctpit
gram_fopen
gram_fclose
gram_fpaste - MSDOS
gram_genprl
gram_genhead
gram_genforw
gram_genrules
gram_gendcl
gram_genargs
gram_convlit
gram_genseq
gram_genclr
gram_genepl
gram_putline
gram_putlit

#9 SPEICHERFREIGABE
gram_tobedel
gram_clrrule
gram_clritem1
gram_clrarg1
gram_clear(public)

#10 PLAUSI BLOCK.(DIE HAUPTFUNKTION IST gram_plausiopt)
pl_bend
pl_diffobj
pl_diffgr1
pl_diffgr20
pl_diffgr21
pl_nonpar
pl_nonqt
gram_plausiopt

#11 ALLGEMEINES SERVICE (INITIALIZATION, GETTING/SETTING PARAMETERS,...)
MAG1054_getenv(public)
MAG1054_setenv(public)
MAG1054_init(public)
MAG1054_setup(public)
MAG1054_gate
MAG1054(public)
========================================================================

* Historie:
* Wann      GQV0 AEND Was
* xx.11.2002 019 000 Ersterstellung
* xx.02.2004 019 000 Generation ueberarbeitet wg
*                    read-, write- and printf- & impl-Funktionen
* xx.02.2004 019 000 E-Element wird aus der Folge entfernt
* 12.05.2004 019 000 Umstellung auf MAG1032
* 29.06.2004 019 000 unsigned(union) & unsigned(scalar) untersch. bearb.
* 01.07.2004 019 000 Bug in genseq. BSt D
* 14.09.2004 019 000 Bug bei gen. parse_lit in Aps; setupgen ueberarb.
* 01.10.2004 019 000 include XAG2032
* 04.10.2004 019 000 Bug in genprl (NH2 fehlte)
* 08.10.2004 019 000 LLK: Aufruf v.extNT soll als TERM-Verbindung gelten
* 11.10.2004 019 000 Letzte Aenderung
======================================================================*/

#pragma langlvl(extended)

#define MAG1054_C
static const char *Modul= "MAG1054";

#include <limits.h>    /*PATH_MAX*/
#include "XAG2002"     /*msg;err*/
#include "XAG2004"     /*str_**/
#include "XAG1020"     /*Graf inkl. 1016 - List*/
#include "XAG2032"     /*dec_**/
#include "XAG2050"     /*tp_lexs;tks_*/
#include "XAG2052"     /*gram_**/
#include "XAG1054"     /*Eigenes Headerfile*/

#define MID  1301071054

#ifndef PATH_MAX
#define PATH_MAX      256
#endif

#define GRAM_MAXNAME  31
#define GRAM_MAXTP    GRAM_MAXNAME+12
#define VARMAXTP      env_.MaxName+12

#define GRAM_QINFIX    3

#ifndef QUOTMAX
#define QUOTMAX    8
#endif

#define SSTDCALL    "%s(%s,_Tks,%s)"   /*funcname(Output,_Tks,Oblig)*/
#define LSTDCALL    14

#define INDENT       3                /*Absatz nach '{'*/

#define GRAM_NOSUFFIX     ' '

#define DBGNF(t,x)     \
    if(dbg_isto(NULL,NULL)) \
      {printf("%s:%s=",(t)? (t): "",#x); puts((x)? (x): "NULL");}

/***************** MACROS *********************************************/

#define gram_itstr(Item1)                                             \
       ((Item1)->Type==GRAM_NONTERM?                                  \
            pvar_msg((Item1)->Term.NonTerminal->PVar,0):              \
        (Item1)->Type==GRAM_TERM? STR_NOT0((Item1)->Term.Terminal):   \
        (Item1)->Type==GRAM_STDACT?                                   \
           stdactions[(Item1)->Term.StdAction].Name:                  \
        (Item1)->Type==GRAM_USRACT? STR_NOT0((Item1)->Term.UsrAction):\
        (Item1)->Type==GRAM_CUT? "!":                                 \
        (Item1)->Type==GRAM_SEQ? "(...)":                             \
        (Item1)->Type==GRAM_EMPTY? "E": "???")

#define gram_isstdact(Name)   (gram_getstdact(Name,NULL,NULL,NULL)>=0)

#define gram_altterm(Item1)                                          \
        ((Item1) && (Item1)->Type==GRAM_NONTERM                      \
         && (Item1)->Term.NonTerminal->Seq                           \
         && (Item1)->Term.NonTerminal->Seq->InfSign=='|'             \
         && !(Item1)->Term.NonTerminal->Seq->QNT)

#define gram_warn(Expr,Gram,NegStat,Ec,Msg)                           \
         {if(!(Expr)) {(Gram)->Status&=~(NegStat); qv_printf(Msg);}}

#define pl_warn(Expr,Rt,Ec,Msg)                                       \
   {if(!(Expr)) {Rt++; ASSERT(0,WARNUNG,Ec,Msg);}}

/***************** TYPEDEFS & STATISCHE VARIABLEN *********************/

/* Generierte Objekte */
enum {G_PA=0, G_WR, G_PR, G_CL, G_RD, G_IM, G_OBJQ};
static char genobs[][6]=
                  {"parse", "write", "print", "clear", "read", "impl"};

 /*Generierte Filetypen*/
enum {G_EXT_C=0, G_EXT_H1, G_EXT_H2, G_EXT_Q};
enum {G_PART1=0, G_PART2};
static char extmod[][4]={"_c","_h1","_h2"};
#define G_EXT_H     G_EXT_H1

#ifndef _MSDOS
static char extpath[][3]={"_c","_h"};
#else
static char extpath[][3]={"$C","$H"};
#endif

#ifndef _MSDOS
#define MAXOUTLINE 72
#define ISFNAME(S)    stc_isname(S,0,"$",0,7)
#else
#define MAXOUTLINE 80
#define ISFNAME(S)    stc_isname(S,0,"_",0,2)
#endif


/* SETUP */
struct str_env
{int         id;
 char        Action;
 char       *Alt;
 int         Args;    /*Y=1|N=-1|O=0*/
 tp_strings *BlIn;
 char       *BNF;
 tp_lexs    *ClTks;
 char       *Cont;
 char        Cut;
 bool        Def2;
 char       *Empty;
 tp_strings *ExtNTs;

 char       *Dir[2];               /*0= fuer .c; 1= fuer .h*/
 int         GenNrs[G_OBJQ+1];
          /*NoGen: -1=keine Generation, sonst FlNr, wohin zu schreiben
           *Z.B., alle in 1 Datei: {0,0,0,0,0,0}
           *GenNrs[G_OBJQ]==1, wenn einer von [0 bis G_OBJQ-1] ist >=0*/
 char       *GenMods[G_OBJQ][3];   /*Objekt; 0=.h,1=.c; 2=init*/
 FILE       *GenFFs[G_OBJQ][2][2]; /*FILE * f. temporaere Datein*/
                                   /*Obj; 1=.h,0=.c; 0=Teil 1,1=Teil 2*/
 tp_strings *InclFiles;
 char       *List;
 char        LstSep;
 bool        LLk;
 tp_strings *InitFns;
 char        NT;
 unsigned    Oper;    /*2=S|1=P|3=B|0=0*/
 char       *Optional;
 char       *OptList;
 tp_strings *Pub;
 int         Pbt;
 char       *Quotes;
 char       *RuleBegin;
 char       *RuleEnd;
 char       *Mult;
 char       *Seq;
 char        Term;
 bool        Opts;
 bool        CaseIndep;
 size_t      MaxName;
};

/* ELEMENTTYPEN */
enum {GRAM_UNDEF=0, GRAM_EMPTY, GRAM_NONTERM, GRAM_TERM,
      GRAM_STDACT, GRAM_USRACT, GRAM_CUT, GRAM_SEQ
     ,GRAM_EXTNT                                          /*10.10.2004*/
     };

/* EINGEBAUTE FUNKTIONEN */
enum {GRAM_ACT_EMPTY=0, GRAM_ACT_LIT=1,
      GRAM_ACT_NAME,    GRAM_ACT_DATE,
      GRAM_ACT_TOKEN,   GRAM_ACT_UNTIL,  GRAM_ACT_UNTILSEP,
      GRAM_ACT_DEC,     GRAM_ACT_DOUBLE, GRAM_ACT_INT,
      GRAM_ACT_UNSIGNED,GRAM_ACT_VAR,
      GRAM_ACT_VAR_DCL, GRAM_ACT_VAR_USE,
      QSTDACT
     };

#define GRAM_ACT_NONSTD     QSTDACT

static struct
{char          *Name;
 char          *TypeD;
 char           TypeT[5]; /*0:Numeric|String|parsedVar|Tokens,
                            1:Argument|Return
                            2:SEP parameter*/
 unsigned short MinArgs; /*Min. number of user arguments*/
 unsigned short MaxArgs; /*Max. number of user arguments*/
 char          *Call[G_OBJQ-1];
} stdactions[QSTDACT]=
{
   {"",        "",          "  N",0,  0,
             {"","","","",""}
   },
         /*spec. handling f. Empty|terminal*/
   {"lit",     "char *",    "SRN",0,  2,
             {"%s%s=parse_lit(_Tks,", /*(_Tks,ApsAllowed,Oblig,SepReq)*/
                                      /* spec. handling of Aps    */
              "str_fwrite(_IOFile,%s);",
              "fprintf(_IOFile,\"\\\"%%s\\\"\",%s);",
              "free(%s);",
              "str_fread(_IOFile,&%s);"
             }
   },
   {"name",    "char *",    "SAS",0,  1,
             {"parse_name(_Tks,%s,NULL,NULL," "NULL,%s,",
              "str_fwrite(_IOFile,%s);",
              "fputs(%s,_IOFile);",
              "free(%s);",
              "str_fread(_IOFile,&%s);"
             }
   },
   {"date",    "char *",    "SAS",0,  1,
             {"parse_date(_Tks,%s,%s,",
              "str_fwrite(_IOFile,%s);",
              "fputs(%s,_IOFile);",
              "free(%s);",
              "str_fread(_IOFile,&%s);"
             }
   },
   {"token",   "char *",    "SAN",0,  0,
             {"parse_any(_Tks,%s,%s)",
              "str_fwrite(_IOFile,%s);",
              "fputs(%s,_IOFile);",
              "free(%s);",
              "str_fread(_IOFile,&%s);"
             }
   },
   {"until",   "tp_lexs *", "TAN",1,256,
             {"parse_until(_Tks, %s, %s",            /*_Tks2,Obl,*/
        /*+spec.handling: Brackets,Edge1,CaseDep,unsigned QUntil,...)*/
              "tks_fwrite(_IOFile,%s);",
              "tks_fput(_IOFile,%s);",
              "tks_clear(%s);",
              "tks_fread(_IOFile,%s);"
             }
   },
   {"untilsep","char *",    "SRN",1,  1,
             {"%s%s=parse_untilsep(_Tks,",       /*(_Tks,Oblig,SepReq)*/
              "str_fwrite(_IOFile,%s);",
              "fputs(%s,_IOFile);",
              "free(%s);",
              "str_fread(_IOFile,&%s);"
             }
   },
   {"decimal", "tp_declf","DASP",0,  1,
             {"parse_dec(_Tks,%s,%s,",
              "dec_fwrite(_IOFile,%s);",
              "dec_fput(_IOFile,%s);",
              "dec_clear(%s);\n",
              "dec_fread(_IOFile,&%s);"
             }
   },
   {"double",  "double",    "NAS",0,  1,
             {"parse_double(_Tks,%s,%s,",
              "fwrite(&%s,sizeof(double),1,_IOFile);",
              "fprintf(_IOFile,\"%%G\",%s);",
              "",
              "fread(&%s,sizeof(double),1,_IOFile);"
             }
   },
   {"int",     "int",       "NAS1",0,  1,
             {"parse_int(_Tks,%s,%s,",
              "fwrite(&%s,sizeof(int),1,_IOFile);",
              "fprintf(_IOFile,\"%%d\",%s);",
              "",
              "fread(&%s,sizeof(int),1,_IOFile);"
             }
   },
   {"unsigned","unsigned",  "NAS1",0,  1,
             {"parse_uns(_Tks,%s,%s,",
              "fwrite(&%s,sizeof(unsigned),1,_IOFile);",
              "fprintf(_IOFile,\"%%u\",%s);",
              "",
              "fread(&%s,sizeof(unsigned),1,_IOFile);"
             }
   },
   {"var",     "tp_pvar",   "VASP",0,  1,
             {"parse_var(_Tks,%s, PVAR_DCL|PVAR_USE,%s,",
              "pvar_fwrite(_IOFile,%s);",
              "pvar_fput(_IOFile,%s);",
              "pvar_free(%s);\n",
              "pvar_fread(_IOFile,%s);"
             }
   },
   {"var_dcl", "tp_pvar",   "VASP",0,  1,
             {"parse_var(_Tks,%s,PVAR_DCL,%s,",
              "pvar_fwrite(_IOFile,%s);",
              "fprintf(_IOFile,\"%s\",%s);",
              "pvar_free(%s);\n",
              "pvar_fread(_IOFile,%s);"
             }
   },
   {"var_use", "tp_pvar",   "VASP",0,  1,
             {"parse_var(_Tks,%s,PVAR_USE,%s,",
              "pvar_fwrite(_IOFile,%s);",
              "fprintf(_IOFile,\"%s\",%s);",
              "pvar_free(%s);\n",
              "pvar_fread(_IOFile,%s);"
             }
   }
};


/* Mark-WERTE (s. gram_rule1.Mark unten)*/
#define GRAM_PUBLIC       1
#define GRAM_TODIE        2  /*Muss sterben*/
#define GRAM_USED_LIST    4  /*Verwendet mit '*' oder mit '+'-Suffix*/
#define GRAM_USED_ANYOPT  8  /*Verwendet mit '*' oder mit '?'-Suffix*/
#define GRAM_USED_OPT    16  /*Verwendet mit '?' in ','-sequence*/
#define GRAM_OPTIONAL    32  /*Enthaellt E-Regel oder wird immer
                              mit '*' oder mit '?'-Suffix verwendet*/
#define GRAM_CANBE       64  /*fuer E-Analyse*/
#define GRAM_READY      128  /*Fertig*/
#define GRAM_INPROC     256  /*In Arbeit*/
#define GRAM_EXTERN     512  /*Kommt von aussen*/
#define GRAM_VARGS     1024  /*laesst vararg zu. In diesem Fall
                              Argq==min. Anzahl der Parameter - N/Impl*/
#define GRAM_STRUCT    2048
#define GRAM_UNION     4096


/* AUSGABESTRUKTUR */
typedef struct
{  int         Type;
   union gram_u_Term
   {   struct gram_s_seq   *Seq;          /*Unterfolge*/
       char                *Terminal;
       struct gram_s_rule1 *NonTerminal;
       int                  StdAction;    /*o. GRAM_ACT_NONSTD - keine*/
       char                *UsrAction;    /*Benutzersfunktion*/
   }           Term;
   unsigned    Argq;
   tp_args    *Args;          /*Fuer NT & Action, else NULL*/
   char        SuffSign;      /*'?' or '+' or '*' or ' '*/
   tp_strings *ListSeps;
   char        Tp0Ref[GRAM_MAXTP+1]; /*Externer Eingabetyp, ohne *.
                                      Ohne Ruecksicht auf Suffix*/
   char        TpPRef[GRAM_MAXTP+1]; /*Externer Eingabetyp, ohne *.
                                       Mit Ruecksicht auf evtl. Suffix*/
   char        Field[GRAM_MAXNAME+6];/*Namendupliz. auszuschliessen*/
} gram_item1;

DEFLIST(gram_items,gram_stru_items,gram_item1);

typedef struct gram_s_seq
{   char          *File;
    unsigned       Row;      /*F. Ersetzungen mit zusaetztl. NT*/
    size_t         Col;      /*Zeigt auf 1. Token nach Bracket*/
    char          *Bracket;  /* ( | env_.OptList | .Optional | .List*/
    char           InfSign;  /*','  o. '|' o. ';' o. ' '*/
    unsigned       QNT;      /*inkl. nicht leere Unterfolgen je als 1*/
    unsigned       QT;       /*Unterfolgen ignoriert*/
    gram_items    *Items;    /*Komponenten*/
} gram_seq;


typedef struct gram_s_rule1
{   tp_pvar              PVar;   /*Zgr auf nonTerm. Benutzersname*/
    char                *NameF;  /*Funktionsname*/
    char                *NameV;  /*Feld/Var.-Name. Capitalized NameF*/
    struct gram_s_rule1 *Parent; /*f. kuenstl. Regeln. Origin. parent*/
    unsigned             QArtif; /*f. Usersregeln:N v. kuenstl. Kinder*/
    unsigned             Argq;   /*Anzahl v. Elemente in Args*/
    tp_args             *Args;   /*kann sein NULL*/
    gram_seq            *Seq;    /*SEQUENCE OR ALTERNAT. OR MULTITUDES*/
    unsigned             Mark;   /*s. MARKS */
    unsigned             QNEmpty;
    char                 TpBasic[GRAM_MAXTP+1];/*Interner Typ, ohne * */
    char                 TpRef[GRAM_MAXTP+1];  /*Externer Typ, ohne * */
    char                 TpLRef[GRAM_MAXTP+1];  /*TpRef in Liste*/
    int                  TpStdBasic;  /*GRAM_ACT_NONSTD f.konstruierte
                                        Typen, 0 f. leere Term.-Folge*/
    int                  TpStdRef;    /* -"-*/
    bool                 CreFun[G_OBJQ+1]; /*Letzter = disj. v. allen*/
} gram_rule1;
DEFLIST(gram_rules,gram_s_rules,struct gram_s_rule1);


typedef struct st_gram
{   ulong       id;
    gram_rules *Rules;
    tp_strings *UsrActs;
      /* Container fuer Benutzersaktionssymbole (AS)
       * Geaendert wird: in gram_paritem1 - Anlegen neuer Eintraege;
       *                 in gram_clear    - Loeschen aller Eintraege.
       * Zweck: 1) falls ein AS undefiniert und mehrmals getroffen ist,
       *           dies nur einmal melden;
       *        2) Speicher sparen, denn mehrere UsrAction Felder
       *           in gram_item1 koennen dasselbe AS referenzieren
       */
    unsigned    Processed; /*Letzte Bearbeitungsart*/
    unsigned    Status;
    char        end;
} ts_gram;


/* ZUR LLk-ANALYSE */
typedef struct
{int         Type;
 char       *Name;
} gram_elm;


 /* RESERVIERTE WOERTER */
 static char reserved1[][9]=
   {
    "default","do","else","for",
    "if","while","return","switch",
    "const","var","char","void",
    "int","unsigned","short","long","float","double",
    "struct","union","enum","typedef",
    "main",
    "release","rename",
    "fclear","fclear1","fclear2","fcmp","fput","fdo", "usfn",
    "args","lexs","list","strings","tktype","pvar",
    "Types"
   };
 static char reserved2[][6]=
{"st_","stp_","tp_","tl_","ts_",
 "gram_","graf_","lst_","tree_",
 "_", "stl_"
};


/***************** STATISCHE VARIABLEN ********************************/

static struct str_env env_; /*Wie blich*/

static int      called_;    /*Zum setup*/
static int      ingate_;    /*Zum setup*/
static unsigned nmn;        /*Letzter generierter Name des 'elternlosen'
                              NTs*/

/* ZUR GENERIERUNG */
static size_t   ptpos=0;   /*stdout-Position (von 0)*/
static char     sectsep[73]="===================================="
                            "====================================";


/***************** FORWARD-DEKLARATIONEN ******************************/
static void        gram_parrules(ts_gram *Gram,gram_rule1 **Left,
                                 tp_lexs **Tks,bool Oblig);
static bool        gram_parrule1(ts_gram *Gram,gram_rule1 **Left,
                                 tp_lexs **Tks,bool Oblig);
static bool        gram_parend(tp_lexs **Tks,bool Oblig);
static void        gram_parseq(ts_gram *Gram, gram_seq **Seq,
                               gram_rule1 **Left, tp_lexs **Tks,
                               char *Brc);
static unsigned    gram_paritems(ts_gram *Gram, gram_items **Items,
                                 unsigned InfNr, char *InfSign,
                                 unsigned *QNT, unsigned *QT,
                                 gram_rule1 **Left, tp_lexs **Tks,
                                 char *Brc, bool Oblig);
static bool        gram_paritem1(ts_gram *Gram, gram_item1 **Item1,
                                 gram_rule1 **Left, int *NewRule,
                                 tp_lexs **Tks,bool Oblig);
static bool        gram_parinfix(tp_lexs **Tks,unsigned InfNr,
                                 char *InfSign);
static int         gram_parnt(tp_lexs **Tks,
                              gram_rules **Rules, gram_rule1 **Rule1,
                              char **Name,
                              char *File, unsigned Row, size_t Col,
                              unsigned Argq, tp_args *Args,
                              int *NewRule);
static int         gram_parname(tp_lexs **Tks,
                                int *Type, char **Name,
                                char **File, unsigned *Row, size_t *Col,
                                unsigned *ArgqOut, tp_args **ArgsOut,
                                bool Oblig);

static gram_rule1 *gram_crerule(tp_pvar PVar, gram_rule1 *Parent,
                                unsigned Argq, tp_args *Args,
                                gram_seq *Seq);
static gram_seq   *gram_creseq(char *File, unsigned Row,size_t Col,
                               char InfSign,
                               char *Brc,
                               unsigned QNT,unsigned QT,
                               gram_items *Items);
static gram_item1 *gram_creitem1(int Type, void *Term,
                                 unsigned Argq, tp_args *Args,
                                 char SuffSign);

static void        gram_ptrule(FILE *FF,gram_rule1 *Rule);
static void        gram_ptseq(FILE *FF, gram_seq *Seq);
static void        gram_ptitem1 (FILE *FF, gram_item1 *It);

static char       *gram_artname(gram_rule1 *Parent,char WhichName);
static void        gram_outnames(gram_rule1 *Rule1);
static void        gram_delmultiple(ts_gram *Gram);
static void        gram_delseq(ts_gram *Gram);
static void        gram_unreach(ts_gram *Gram);
static unsigned    gram_replinseq(gram_rule1 *Rule1, gram_seq *Seq);
static void        gram_del11(ts_gram *Gram);

static void        gram_anle(tp_gram Gram);
static int         gram_anlnte(tp_gram Gram, gram_rules **Rules,
                               bool Skip);
static gram_elm   *gram_creelm(int Type, char *Name);
int                gram_elmcmp1(gram_elm *Obj1, gram_elm *Obj2);
int                gram_lnkcmp0(gram_elm *UsObj1, gram_elm *UsObj2,
                                unsigned UsLevel, void *UsInfo,
                                ts_extlink *GrLink);
int                gram_lnkcmp2(gram_elm *UsObj1, gram_elm *UsObj2,
                                unsigned UsLevel, void *UsInfo,
                                ts_extlink *GrLink);
static void        gram_anl1(tp_gram Gram, tp_graf Graf);
static unsigned    gram_testllk(tp_graf Graf);

void               gram_fopen(char GenTFs[][2][2][PATH_MAX],
                              unsigned *QFls);
void               gram_fclose();
#ifdef _MSDOS
void               gram_fpaste(char GenTFs[G_OBJQ][2][2][PATH_MAX]);
#endif

static unsigned    gram_findpublic(gram_rules *Rules);
static void        gram_settfns(gram_rules *Rules);
static void        gram_settfn1(gram_rules *Rules, gram_rule1 *Rule1);

static void        gram_genprl();
static bool        gram_settpit(gram_rules *Rules,
                                char *RlName, char InfSign,
                                unsigned ItNr, gram_item1 *Item1);
static void        gram_settpl(char *FType0, char *FType1);
static void        gram_genhead(gram_rule1 *Rule1, int NOb, bool Impl);
static void        gram_genforw(gram_rules *Rules, unsigned QFls);
static void        gram_genrules(gram_rules *Rules, unsigned QFls);
static void        gram_gendcl(FILE *FFT, FILE *FFC12, int NOb,
                               char *Name, char InfSign,
                               bool StruOp, bool UniOp,
                               gram_items *Items, bool DclFds);
static void        gram_genargs(FILE *FFC12, char Start, tp_args *Args,
                                unsigned *Lev, unsigned *Move);
static char       *gram_convlit(char *ReqHere,size_t LReqH);
static int         gram_sctpit(bool IsRef, gram_item1 *Item1);
static unsigned    gram_genseq(FILE *FFC12, char *Nmu, char *Nmv,
                               bool OptAll, bool StruOp, bool UniOp,
                               gram_seq *Seq);
static unsigned    gram_genclr(FILE *FFC12, char *Nmv, int NOb,
                               bool StruOp,bool UniOp, gram_seq *Seq);
static void        gram_genepl();
static void        gram_putline(unsigned *Lev,unsigned *Move,
                                FILE *FFC12,char *Fmt,...);
static void        gram_putlit(char *Sd,size_t Indent, FILE *FFC12);

int                gram_tobedel(void *Unused,gram_rule1 *Rule);
static void        gram_clrrule(gram_rule1 *Rule);
static void        gram_clritem1 (gram_item1 *It);
static void        gram_clrarg1(tp_strings *Arg);

static void        gram_plausid(tp_gram Gram);
static void        gram_plausiopt(char *Mode);


/***************** IMPLEMENTIERUNG ************************************/

/******** #1 HILFSFUNKTIONEN ********/

/*==gram_rulenamecmp===(ii)=== Namenvergleich ========================*/
static int gram_rulenamecmp(char *Name1, gram_rule1 *Rule2)
{int   Rt;
 char *Name2;
 MSG_DCL("gram_rulenamecmp");
 ASSERT(Name1,ABBRUCH,EC_NullPointer,qv_msg("Parameter 1 == NULL"));
 ASSERT(Rule2,ABBRUCH,EC_NullPointer,qv_msg("Parameter 2 == NULL"));
 Name2= PVAR_GETNAME(Rule2->PVar);
 Rt= stricmp(Name1, Name2);
 MSG_ENDD();
 return Rt;
} /*gram_rulenamecmp*/


/*==gram_rulecmp===(ii)=== Regelnvergleich ===========================*/
static int gram_rulecmp(gram_rule1 *Rule1, gram_rule1 *Rule2)
{int Rt;
 MSG_DCL("gram_rulecmp");
 ASSERT(Rule1,ABBRUCH,EC_NullPointer,qv_msg("Parameter 1 == NULL"));
 Rt= gram_rulenamecmp(PVAR_GETNAME(Rule1->PVar),Rule2);
 MSG_ENDD();
 return Rt;
} /*gram_rulecmp*/


/*==gram_qtend===(i)====================================================
 * Liefert entsprechende schliessende Klammer oder Hochkomma zurueck
 * TBD => MAG1004 o. MAG1050 o. MAG1052
 *====================================================================*/
static char gram_qtend(char C1)
{char Rt;
 char Sd[5]="{(<[";
 char Sr[5]="})>]";
 char *Sw;
 if(Sw=strchr1(Sd,C1))
    Rt= Sr[4-strlen(Sw)];
 else Rt=C1;
 dbg("gram_qtend returns %c(%d)",Rt,Rt);
 return Rt;
} /*gram_qtend*/


/*===gram_plausid===(i)===============================================*/
static void gram_plausid(tp_gram Gram)
{ASSERT(Gram,ABBRUCH,EC_NullPointer,qv_msg("Parameter Gram == NULL"));
 ASSERT(Gram->id==MID-1,ABBRUCH,EC_CorruptStruct,
        qv_msg("Eingabestruktur ist korrupt. id=%lu",Gram->id));
 ASSERT(Gram->end=='E',ABBRUCH,EC_CorruptStruct,
        qv_msg("Eingabestruktur ist korrupt. end=%c(%d)",
                Gram->end,(int)Gram->end));
} /*gram_plausid*/


/***** #2 AUSKUNFT    ********/

/*===gram_processed===(i[o])============================================
 * Return:     TRUE - letzte Bearbeirungsart war erfolgreich
 *====================================================================*/
bool gram_processed(tp_gram Gram, gram_proc *LastProc)
{bool Rt;
 unsigned Success[GRAM_QPROC]=
   {GRAM_CONSISTENT, GRAM_NORMALIZED,
    GRAM_LLK, GRAM_LLKCONVD, GRAM_GENERATED
   };
 MSG_DCL("gram_processed");
 gram_plausid(Gram);
 if(LastProc) *LastProc= Gram->Processed;
 Rt= !!(Gram->Status & Success[Gram->Processed]);
 MSG_END();
 return Rt;
} /*gram_processed*/


/*===gram_status===(ii)=================================================
 * Return:     TRUE - angegebene Bearbeirungsart war erfolgreich
 *====================================================================*/
bool gram_status(tp_gram Gram, unsigned Status)
{bool Rt;
 MSG_DCL("gram_status");
 gram_plausid(Gram);
 Rt= !!(Gram->Status & Status);
 MSG_END();
 return Rt;
} /*gram_status*/

/*===gram_getstdact===(i[ooo])==========================================
 * Beschreibung: Sucht MAG1054-StdFunktion nach Namen.
 * Beim Erfolg fuellt Ausgabeparameter mit ihren Atributen und
 * liefert ihr Index zurueck. Beim Scheitern liefert -1 zurueck.
======================================================================*/
static int gram_getstdact(char *Name,
                          char **TypeD, char  **TypeT, char **Call)
{int Nr,Rt=-1;
 for(Nr=0; Rt<0 && Nr<QSTDACT; Nr++)
    if(!strcmp(Name,stdactions[Nr].Name))
      {Rt= Nr;
       if(TypeD) *TypeD= stdactions[Nr].TypeD;
       if(TypeT) *TypeT= stdactions[Nr].TypeT;
       if(Call) *Call= stdactions[Nr].Call[0];
      }
 return Rt;
} /*gram_getstdact*/

/***** #3 GRAM-PARSEN ********/

/*==gram_parse===(io)=== Parst einen BNF-Text ========================*/
int gram_parse(tp_lexs *Tks, tp_gram *Gram)
{int         Rt=0;
 char       *NameU;
 unsigned    Num;
 gram_rules *Rlsw;
 gram_rule1 *Rl1w=NULL;
 MSG_DCL("gram_parse");

 ASSERT(Tks,AUSSTEUERN,105404,"Die angegebene Lexemsliste ist leer");
 ASSERT(*Gram=ALLOC(ts_gram),ABBRUCH,EC_NotEnoughMemory,
        "Kann nicht eine neue Grammatik allokieren");
 memset(*Gram,0,sizeof(ts_gram));
 (*Gram)->id=  MID-1;
 (*Gram)->end= 'E';
 (*Gram)->Processed= GRAM_PARSE;
 (*Gram)->Status= GRAM_SYNT_OK | GRAM_SEM_OK | GRAM_CONSISTENT;

 TRY
    TRY
       gram_parrules(*Gram,&Rl1w,&Tks,TRUE);
       ASSERT(   (*Gram)->Status & GRAM_SYNT_OK
           /* && (*Gram)->Status & GRAM_SEM_OK*/
              && (*Gram)->Status & GRAM_CONSISTENT,
              AUSSTEUERN,105410,"");
       ASSERT(!Tks,AUSSTEUERN,105410,
              qv_msg("Unerkannte Symbole\n%s",parse_errtk(Tks)));
       ASSERT(!Rl1w,RC_SEVERR,105411,
              qv_msg("EOF waehrend Fortsetzung einer Regel erwartet"));
    FINALLY
       if(dbg("****** RESULTING NT LIST *****"))
         {
          LST_FPUT(stdout,(*Gram)->Rules,gram_ptnt,NULL);
          qv_printf80('-');
          dbg("***** RESTORED GRAMMAR *****");
          gram_printf(stdout,*Gram);
          qv_printf80('-');
         }
       ESCAPE;
    END
 RECOVER
    (*Gram)->Status=0;
    ESCAPE;
 END

 for(Rlsw=(*Gram)->Rules;Rlsw;Rlsw=Rlsw->Tail)
   {Rl1w= Rlsw->Head;
    if(!pvar_used(Rl1w->PVar,NULL,NULL,NULL))
      {ASSERT(0,Rt?WARNUNG:0,105425,pvar_msg(Rl1w->PVar,1));
       MAX1(Rt,WARNUNG);
      }
    if(!(   pvar_declared(Rl1w->PVar,NULL,NULL,NULL)
         || Rl1w->Mark & GRAM_EXTERN))
      {ASSERT(0,WARNUNG,105426,pvar_msg(Rl1w->PVar,1));
       Rt= AUSSTEUERN;
      }
    NameU=PVAR_GETNAME(Rl1w->PVar);
    if(tolower(*NameU)=='n' && sscanf(NameU+1,"%u",&Num)==4)
       MAX1(nmn,Num+1);
   } /*for*/

 dbg("nmn=%u,Rt=%d,Status=%u,",nmn,Rt,(*Gram)->Status);
 ASSERT(Rt<8,AUSSTEUERN,GRAM_INCONS,
        "Die angegebene Grammatik ist inkonsistent");
 /*GRAM_INCONS defined as 15400*/

 MSG_ENDD();
 return Rt;
} /*gram_parse*/


/*==gram_parrules===(mmmi)=== Parst [Rest von BNF-Regeln] ============*/
static void gram_parrules(ts_gram *Gram, gram_rule1 **Left,
                          tp_lexs **Tks, bool Oblig)
{MSG_DCL("gram_parrules");
 if(gram_parrule1(Gram,Left,Tks,Oblig))
    gram_parrules(Gram,Left,Tks,!!*Tks);
 MSG_ENDD();
} /*gram_parrules*/


/*==gram_parrule1===(mmmi)=== Parst 1 Regel===========================*/
static bool gram_parrule1(ts_gram *Gram,gram_rule1 **OutLeft,
                          tp_lexs **Tks, bool Oblig)
{bool        Rt= TRUE;
 unsigned    Argq;
 tp_args    *Args;
 bool        Cont= FALSE;
 gram_rule1 *CurrRule= NULL;
 char       *Name;
 int         NewRule= 1; /*   -1 - Verbot, neue Regel anzufangen
                               0 - neue Regel erlaubt
                               1 - neue Regel erforderlich*/
 char       *File;
 unsigned    Row;
 size_t      Col;
 int         Type=GRAM_NONTERM;
 MSG_DCL("gram_parrule1");

 dbg("*OutLeft=%ld,Gram->Status=%u",(long)*OutLeft,Gram->Status);
 TRY
    if(!*OutLeft)
      {if(env_.RuleBegin)
          if(Rt=parse_kw(Tks,env_.RuleBegin,Oblig,SEP_OPT))
             Oblig=TRUE;
       if(Rt=(gram_parname(Tks, &Type, &Name, &File, &Row, &Col,
                           &Argq, &Args, Oblig)>=0))
         {if(!gram_parnt(Tks, &Gram->Rules, &CurrRule, &Name,
                         File, Row, Col, Argq, Args, &NewRule))
             Gram->Status&= ~GRAM_SEM_OK;
          else
             ASSERT(!(CurrRule && CurrRule->Mark & GRAM_EXTERN),
                    RC_SEVERR, 105414,
                    qv_msg("(1) Neudefinition der externen NT '%s'",
                           Name));
         }
       else if(Oblig) Gram->Status= 0;
       DBG_D2(%d,NewRule,%u,Gram->Status);
      }
    else CurrRule= *OutLeft;

    *OutLeft= NULL;

    if(Rt)
      {
       dbg("After parnt for CurrRule:PVAR=%s",
            PVAR_GETNAME(CurrRule->PVar));
       if(NewRule!=2) /*2 = neue Regel ist leer (z.B. PROLOG's repeat)*/
         {
          gram_parseq(Gram, &CurrRule->Seq, OutLeft, Tks, NULL);
          dbg("After parseq for CurrRule:PVAR=%s,@Seq=%lu,@Items=%lu",
               PVAR_GETNAME(CurrRule->PVar),
               (ulong)CurrRule->Seq,
               (ulong)CurrRule->Seq->Items);
          if(dbg("FULL NT LIST:"))
            {LST_FPUT(stdout,Gram->Rules,gram_ptnt,NULL);
             qv_printf("\n");
            }
          gram_parend(Tks,TRUE);
         }
      }
 RECOVERS
    Gram->Status= 0;
    if(err_rc()<=AUSSTEUERN)
       if(env_.RuleEnd)
          while(!Cont && *Tks)
            {if(!(Cont=gram_parend(Tks,FALSE)))
                tks_del(Tks,TKS_DEL1);
            }
       else if(env_.RuleBegin)
          while(!Cont && *Tks)
             if(!(Cont=parse_forwkw(*Tks,env_.RuleBegin)))
                tks_del(Tks,TKS_DEL1);
    dbg("Gram->Status=%u",Gram->Status);
    if(Cont) qv_printf(err_msg());
    else err_escape(err_rc(),err_ec(),NULL);
 END
 dbg("Gram->Status=%u",Gram->Status);
 dbg("Rt=%d",(int)Rt);
 MSG_ENDD();
 return Rt;
} /*gram_parrule1*/


/*==gram_parend===(mi)=== Parst Ende der Regel =======================*/
static bool gram_parend(tp_lexs **Tks,bool Oblig)
{bool     Rt=FALSE;
 char    *File;
 unsigned Row;
 size_t   Col;
 char     SepIs,SepReq1,SepReq2,SepReq3=0,SepReq4=0;
 char    *Sw;
 unsigned Tkn=0,Tkq;
 tp_lexs *TkEnd,*Tkx;
 MSG_DCL("gram_parend");

 tks_dbg1(*Tks);
 dbg("Oblig=%d",(int)Oblig);

 if(env_.RuleEnd)
    if(tks_get(NULL,&SepIs,&File,&Row,&Col,*Tks)!=TKS_NO)
      {
       SepReq1=!!strchr(env_.RuleEnd,' ');
       SepReq2=!!strchr(env_.RuleEnd,'\n');

       if(tks_scans(&TkEnd,NULL,env_.RuleEnd,Row,Col)==TKS_NO)
          Rt= (!SepReq2 || SepIs&2) && (!SepReq1 || SepIs&1);
       else
         {
          Tkq= (unsigned)LST_COUNT(TkEnd);
          for(Tkx= *Tks; Tkn<Tkq && Tkx; Tkn++) Tkx= Tkx->Tail;

          if(tks_get(NULL,&SepIs,NULL,NULL,NULL,Tkx)!=TKS_NO)
            {
             for(Sw=env_.RuleEnd+strlen(env_.RuleEnd)-1;
                    Sw!=env_.RuleEnd
                 && isspace(*Sw)
                 && !(SepReq3 && SepReq4);
                 Sw--)
                if(isspace(*Sw))
                   if(*Sw=='\n') SepReq4= 1; else SepReq3= 1;
             Rt= (!SepReq4 || SepIs&2) && (!SepReq3 || SepIs&1);
            }
          else Rt= TRUE;

          if(Rt)
             Rt= parse_kw(Tks,env_.RuleEnd,Oblig,SEP_OPT);
         }
      }
    else Rt= FALSE;
 else Rt=TRUE;

 ASSERT(Rt || !Oblig,RC_SEVERR,105405,
        qv_msg("'%s' erwartet oder Trenner fehlt\n%s",
               env_.RuleEnd,parse_errtk(*Tks)));
 tks_dbg1(*Tks);
 dbg("Rt=%d",(int)Rt);
 MSG_ENDD();
 return Rt;
} /*gram_parend*/

/*==gram_parseq===(moomi)===============================================
 * Parst die rechte Seite der laufenden Regel und Kopf der naechsten.
 *====================================================================*/
static void gram_parseq(ts_gram *Gram, gram_seq **Seq,
                        gram_rule1 **Left, tp_lexs **Tks, char *Brc)
{char       *File;
 unsigned    Row;
 size_t      Col;
 char        InfSign;
 gram_items *Items;
 unsigned    QNT, QT;
 MSG_DCL("gram_parseq");

 if(tks_get(NULL,NULL,&File,&Row,&Col,*Tks)!=TKS_NO)
   {gram_paritems(Gram, &Items, GRAM_QINFIX, &InfSign,
                  &QNT, &QT, Left, Tks, Brc, TRUE);
    *Seq=gram_creseq(File,Row,Col,InfSign,Brc,QNT,QT,Items);
   }
 else *Seq= NULL;
 /*dbg("@*Seq=%lu,@Items=%lu,@Seq->Items=%lu",
      (ulong)*Seq,(ulong)Items,(*Seq)->Items);*/
 MSG_ENDD();
} /*gram_parseq*/


/*==gram_paritems===(moioooomii)========================================
 * Beschreibung: Parst /Rest der/ rechte/n/ Seite der laufenden Regel
 *               und Kopf der naechsten. Stoppt wenn das Kopf
 *               erkannt worden ist, oder Syntaxfehler aufgetreten.
 * Parameter (moioooomii):
 *               Gram     -m- geparste Regeln (kann ergaenzt werden),
 *               Items0   -o- Elemente der laufenden Regel,
 *               InfNr0   -i- Erwarteter Rang des Infix-Operators:
 *                            0=',' 1=';' 2='|' 3=Anfangswert
 *               InfSign0 -o- Tatsaechl. hoechster Infix-Operator
 *               QNT0     -o- Anzahl der non-Terminals
 *               QT0      -o- Anzahl der Terminalelemente
 *               Left     -o- Neue Regel (falls getroffen) o. NULL
 *               Tks      -m- Lexemsliste
 *               Brc      -i- Linke Klammer o. NULL
 *               Oblig    -i- Wenn Anfangselement nicht erkannt wurde
 *                            dann wird bei Oblig=0 0 zurueckgeliefert,
 *                                          sonst AUSSTEUERN-Exception.
 * Return: 1= 1 Element erkannt, 0=keines, 2=>mehrere
 *====================================================================*/
static unsigned gram_paritems(ts_gram *Gram,     gram_items **Items0,
                              unsigned InfNr0,   char *InfSign0,
                              unsigned *QNT0,    unsigned *QT0,
                              gram_rule1 **Left, tp_lexs **Tks,
                              char *Brc,         bool Oblig)
{unsigned    Rt0=0,Rt1;
 bool        BegRule=FALSE;
 gram_item1 *Item1;
 int         NewRule=0;      /*-1 - Verbot, neue Regel anzufangen
                                0 - neue Regel erlaubt
                                1 - neue Regel erforderlich*/
 unsigned    InfNr2;
 char        InfSign1=' ',InfSign2;
 gram_items *Items1,*Items2, /*A newly created subsequences*/
            *Itemz;
 unsigned    QNT1=0, QT1=0,  /*Counts of non- & terminals*/
             QNT2=0, QT2=0;  /*in the new subsequences  */
 char       *File;
 unsigned    Row;
 size_t      Col;
 int         Rti;            /* Return from parinfix*/
 gram_seq   *Seq1;
 MSG_DCL("gram_paritems");

 tks_dbg1(*Tks);
 dbg("InfNr0=%u,Oblig=%d,Brc=%s",InfNr0,(int)Oblig,STR_NOT0(Brc));
 *Items0= NULL;
 *QNT0= *QT0= 0;

 if(InfNr0)                                 /*Not yet comma=infix*/
   {if(InfNr0==GRAM_QINFIX) {InfNr0--; BegRule=TRUE;}    /*Anfang*/
    tks_get(NULL,NULL,&File,&Row,&Col,*Tks);
    Rt1=gram_paritems(Gram, &Items1, InfNr0-1, &InfSign1,
                      &QNT1, &QT1, Left, Tks, Brc, Oblig);
    dbg("After paritems(N-1):Rt1=%u,QNT1=%u,QT1=%u,InfSign1=%c",
        Rt1,QNT1,QT1,InfSign1);
   } /*if(InfNr0)*/
 else                                       /*comma=infix*/
   {NewRule= Oblig || Brc || BegRule? -1: 0;
    Rt1=(unsigned)gram_paritem1(Gram,&Item1,Left,&NewRule,Tks,Oblig);
    if(Rt1)
       dbg("Item1 recognized: Type=%d, Text=%s",
          (int)Item1->Type, gram_itstr(Item1));
   } /*if(InfNr0) / else*/

 DBG_D2(%u,Rt1,%d,NewRule);
 if(Rt1 && NewRule<1)
   {
    Rti=gram_parinfix(Tks, InfNr0, InfSign0);    /*Infix operator*/
    DBG_D1(%d,Rti);

    /* Now we can have detected the following:
     * a single item on ; or | level => as it's returned as items group,
     *                  we convert the group into a single item;
     * xor
     * a group of items separated by commas on ; or | level =>
     *                  we close the Item group and create a sequence
     * xor
     * a single item on comma-level => we allocate items, fill the 1st
     *                                 element and expect continuation*/
    if(InfNr0 && Rti>=0)
       if(Rt1==1)       /*Single item detected, but subseq. formed*/
         {Item1= Items1->Head;      /*Convert subseq. into an item*/
          free(Items1);
          gram_warn(Item1->Type!=GRAM_EMPTY, Gram,
                    GRAM_CONSISTENT | GRAM_SEM_OK, 105418,
                    qv_msg("(1) EMPTY darf nur am Ende einer "
                           "Alternative stehen.\n%s",
                            parse_errtk(*Tks)));
         }
       else             /* Conversion Items=>Sequence=>Item*/
         {Seq1= gram_creseq(File,Row,Col,InfSign1,NULL,QNT1,QT1,Items1);
          Item1= gram_creitem1(GRAM_SEQ,Seq1,0,NULL,GRAM_NOSUFFIX);
          QNT1=1; QT1=0;
         }

    if(!InfNr0 || Rti>=0)
      {ASSERT(*Items0= ALLOC(gram_items),ABBRUCH,EC_NotEnoughMemory,
              qv_msg("Kann nicht ein neues Element allokieren (1)"));
       (*Items0)->Head= Item1;
       (*Items0)->Tail= NULL;
       switch(Item1->Type)
         {case GRAM_SEQ:
          case GRAM_NONTERM:
          case GRAM_STDACT:  QNT1=1; break;
          case GRAM_TERM:    QT1=1;  break;
         }
       dbg("Determined regarding Item->Type=%d:QNT1=%u,QT1=%u",
           (int)Item1->Type,QNT1,QT1);
      }
    else {*Items0=Items1;*InfSign0=InfSign1;}

    *QNT0=QNT1; *QT0=QT1; Rt0=Rt1;
    dbg("Assigned after 1st step:QNT0=%u,QT0=%u",*QNT0,*QT0);

    if(Rti>=0)                                    /*Infix operator*/
      {tks_get(NULL,NULL,&File,&Row,&Col,*Tks);
                                       /*Parsing the tail of items*/
       if(gram_paritems(Gram, &Items2, InfNr0, &InfSign2,
                        &QNT2, &QT2, Left, Tks, Brc, !!Rti))
         {
          /*dbg("After tail-call: QNT2=%u, QT2=%u",QNT2,QT2);*/
          InfNr2= InfSign2==' '? 3:
                  InfSign2=='|'? 2:
                  InfSign2==';'? 1: 0;

       /* Newly parsed items have lower level separator
        *  like in N1 = N2 | N3, N4
        *  => we unite them into new Items2 which contains
        *  a single sequence of 'old' Items2.
        *  Later it will be pasted to all the priorly parsed
        *  items*/
          if(InfNr2<InfNr0 && LST_COUNT(Items2)>1)
            {
             DBG_D2(%u,InfNr0,%u,InfNr2);
             Seq1= gram_creseq(File,Row,Col,InfSign2,
                               NULL,QNT2,QT2,Items2);
             Item1= gram_creitem1(GRAM_SEQ,Seq1,0,NULL,GRAM_NOSUFFIX);
             ASSERT(Items2= ALLOC(gram_items),
                    ABBRUCH,EC_NotEnoughMemory,
                    qv_msg("Kann nicht ein neues"
                           "Element allokieren (2)"));
             Items2->Head= Item1; Items2->Tail= NULL;
             QNT2=1; QT2=0;
             dbg("QNT2=1; QT2=0;");
            } /*if(InfNr2<*InfNr0)*/

         /* In all cases of successful infix detection we paste the
          *  parsed parts into the output group */
          (*Items0)->Tail=Items2;
          *QNT0+=QNT2; *QT0+=QT2;
          /*dbg("QNT0 & QT0 increased"); */
          Rt0= 2;
         } /*if(gram_paritems(... &Items2...)*/
      }    /*if(Rti>=0)*/
   }       /*if(Rt1 && NewRule<1)*/

 if(   Rt0
    && dbg("Bef. end: \nInfSign=%c,QNT=%u,QT=%u,Left=%lu",
           *InfSign0, *QNT0, *QT0,(ulong) *Left))
   {puts("ITEM LIST");
    for(Itemz=*Items0;Itemz;Itemz=Itemz->Tail)
       printf(" %s",gram_itstr(Itemz->Head));
    puts("");
    tks_dbg1(*Tks);
   }
 DBG_D2(%u,Rt0,%u,Gram->Status);
 MSG_ENDD();
 return Rt0;
} /*gram_paritems*/

/*==gram_parinfix===(mio)===============================================
 * Parst einen Infix-Operator
 * Return: 1=explizit, 0=by default -1=kein Infix-Operator
 *====================================================================*/
static int gram_parinfix(tp_lexs **Tks,unsigned InfNr,char *InfSign)
{int       Rt= 0;
 int       Cmp1=1,Cmp2=1;
 char      Sep;
 char     *Text;
 tp_tktype Tp;
 MSG_DCL("gram_parinfix");

 DBG_D1(%u,InfNr);
 ASSERT(InfNr<GRAM_QINFIX,ABBRUCH,EC_InternalError,
        qv_msg("InfNr>=%u > %u !",InfNr,GRAM_QINFIX));
 tks_dbg1(*Tks);

 *InfSign=' ';

 if(   !(Tp=tks_get(&Text,&Sep,NULL,NULL,NULL,*Tks))
    ||    env_.RuleEnd
       && (      tks_is1(env_.RuleEnd,FALSE,0)
              && parse_forwkw(*Tks,env_.RuleEnd)
           || !strcmp(env_.RuleEnd,"\n") && Sep&2))
    Rt=-1;

 else if(   env_.Seq && !strcmp(Text,env_.Seq)
         ||    env_.Cont
            && Sep&2
            && !strcmp(Text,env_.Cont) && Sep&2)
    if(!InfNr) {Rt=1; *InfSign=',';tks_del(Tks,TKS_DEL1);}
    else Rt=-1;

 else if(   env_.Alt && !strcmp(Text,env_.Alt)
         || !(Cmp2=strcmp(env_.Alt,"\n")) && Sep&2)
    if(InfNr==2)
      {Rt=1; *InfSign='|';if(Cmp2) tks_del(Tks,TKS_DEL1);}
    else Rt=-1;

 else if(   env_.Mult
         && (   !strcmp(Text,env_.Mult)
             || !(Cmp1=strcmp(env_.Mult,"\n")) && Sep&2))
    if(InfNr==1)
      {Rt=1; *InfSign=';'; if(Cmp1) tks_del(Tks,TKS_DEL1);}
    else Rt=-1;

 else if(InfNr || env_.Seq) Rt=-1;
 else {*InfSign=',';Rt=0;}

 tks_dbg1(*Tks);
 DBG_D1(%d,Rt);
 MSG_ENDD();
 return Rt;
} /*gram_parinfix*/


/*==gram_paritem1===(moommi)============================================
 * Parst eine Komponente an der Rechten Seite der Regel
 *                   inkl. Suffixoperator. Wenn ein Nicht-Terminal
 *                   getroffen wird, sucht ihn in der Regelliste
 *                   oder fuegt hinzu.
 *                   Ist nur dann aufzurufen, wenn ein Element
 *                   pflichtig ist!
 * Parameter:
 *            Gram    = die zu bearbeitende Grammatik
 *            Item1   = Element (Ausgabe)
 *            Left    = s. gram_paritems
 *            NewRule:        -1 - Verbot, neue Regel anzufangen
 *                             0 - neue Regel erlaubt
 *                             1 - neue Regel erforderlich
 *            Tks     = Lexemsliste
 *            Oblig   = Vogehensweise beim Scheitern:
 *                            TRUE  = Fehlermeldung, Escape-Aussteuern
 *                            FALSE = Return FALSE
 * Return:
 *         FALSE = kein neues Element getroffen oder das Element beginnt
 *                 eine neue Regel
 *         TRUE  = Einzelelement getroffen
 *====================================================================*/
static bool gram_paritem1(ts_gram *Gram, gram_item1 **Item1,
                          gram_rule1 **Left, int *NewRule,
                          tp_lexs **Tks, bool Oblig)
{bool             Rt= TRUE;
 int              Actn;
 unsigned         Argq=0;
 tp_args         *Args=NULL;
 bool             CheckSuff= FALSE;
 size_t           Col;
 char            *File;
 char            *Name;
 int              Opn;
 char             OpRsl[4]="?+*";
 char            *OpSrc[4];
 char            *LBr=NULL,*RBr=NULL;    /*Brackets*/
 char             RBrLs=0x0;
 unsigned         Row;
 gram_rule1      *Rule1;
 gram_seq        *Seq;
 char             SuffSign=GRAM_NOSUFFIX;
 char            *Sw;
 union gram_term *Term=NULL;
 char            *Text;
 tp_tktype        TkTp;
 int              Type=GRAM_UNDEF;       /*Type of item*/
 bool             WasPref= FALSE;
 MSG_DCL("gram_paritem1");

 *Item1= NULL; *Left= NULL;

 if(!(TkTp=tks_get(&Text,NULL,&File,&Row,&Col,*Tks)))
   {ASSERT(!Oblig, RC_SEVERR, 105407,
           qv_msg("Unerwartetes EOF. Regel sollte fotgesetzt werden"));
    Rt=FALSE;
   }
 else
   {dbg("*NewRule=%d,Oblig=%d,UsrActs=%ld",
        *NewRule,(int)Oblig,(long)Gram->UsrActs);
    tks_dbg1(*Tks);
    if(env_.Oper)                          /*Prefix/suffix allowed*/
      {
       OpSrc[0]= env_.Optional;
       OpSrc[1]= env_.List;
       OpSrc[2]= env_.OptList;

       if(env_.Oper & 1 && *NewRule < 1 && strlen(Text)==1)
          for(Opn=0; !WasPref && Opn<3; Opn++)
                                            /*if Prefix detected*/
             if(OpSrc[Opn] && !strcmp(OpSrc[Opn],Text))
               {SuffSign= OpRsl[Opn];
                WasPref=TRUE;
                *NewRule=-1;
                if(env_.Oper==3 && (RBr=str_bracket(NULL,*Text)))
                   LBr=Text;
                else free(Text);
                tks_del(Tks,TKS_DEL0);
                ASSERT(TkTp=tks_get(&Text,NULL,&File,&Row,&Col,*Tks),
                       RC_SEVERR, 105408,
                       qv_msg("Unerwartetes Textende"));
                dbg("Prefix detected or set by default:'%c',"
                    "LBr='%s',RBr='%s'",
                    SuffSign,STR_NOT0(LBr),STR_NOT0(RBr));
                break;
               }
      }
    if(!LBr && parse_kw(Tks, "(", FALSE, SEP_OPT))
      {LBr=strdup("(");
       RBr=strdup(")");
       CheckSuff= TRUE;
      }
    if(LBr)
      {gram_parseq(Gram, &Seq, Left, Tks, LBr);
       parse_kw(Tks,RBr,TRUE,SEP_OPT);
       Type= GRAM_SEQ; Term= (union gram_term *)Seq;
       dbg("Subsequence detected. LBr=%s",LBr);
      }
    else if(   env_.Empty
            && SuffSign==GRAM_NOSUFFIX
            && parse_kw(Tks, env_.Empty, FALSE, SEP_OPT))
       Type= GRAM_EMPTY;
    else if(   env_.Cut
            && SuffSign==GRAM_NOSUFFIX
            && parse_char(Tks,env_.Cut,FALSE,SEP_OPT))
      {Type= GRAM_CUT;
       dbg("Cut detected");
      }
    else if(Rt=(gram_parname(Tks, &Type, &Name, &File, &Row, &Col,
                            &Argq, &Args, Oblig)>=0))
      {
       CheckSuff= TRUE;
       switch(Type)
         {case GRAM_TERM:
             Term= (union gram_term*)Name;
             dbg("Terminal detected: %s",(char *)Term);
             break;
          case GRAM_NONTERM:
             if(!gram_parnt(Tks, &Gram->Rules, &Rule1, &Name,
                            File, Row, Col, Argq, Args, NewRule))
                Gram->Status&= ~GRAM_SEM_OK;
             if(*NewRule>=1)
               {
                ASSERT(!(Rule1 && Rule1->Mark & GRAM_EXTERN),
                       RC_SEVERR, 105414,
                       qv_msg("(2) Neudefinition der externen NT '%s'",
                              Name));
                if(*NewRule==1) *Left= Rule1;
                Rt= CheckSuff= FALSE;
               }
             else
               {Term= (union gram_term*)Rule1;
                dbg("Nonterminal detected");
               }
             break;
          case GRAM_STDACT:
             Actn=gram_getstdact(Name,NULL,NULL,NULL);
             ASSERT(Actn>=0,ABBRUCH,EC_InternalError,
                    qv_msg("Der Name %s, den gram_parname als STDACT"
                           " definiert hat, ist in stdactions nicht"
                           " gefunden",Name));
             Term= (union gram_term*) Actn;
             free(Name);
             dbg("StdAction detected: %s",stdactions[Actn].Name);
             break;
          case GRAM_USRACT:
             if(Term=(union gram_term*)LST_FINDHEAD(Gram->UsrActs,
                                                    Name,strcmp))
                free(Name);
             else
                {Sw= Name; while(*Name=='!' || *Name==' ') Name++;
                 ASSERT(*Name,AUSSTEUERN,105413,
                        qv_msg("Inkorrekter Funktionsname: '%s'\n%s",
                               Sw,parse_errtk(*Tks)));
                 if(!(Term=(union gram_term*)LST_FINDHEAD(Gram->UsrActs,
                                                        Name,strcmp)))
                   {Name=strdup(Name); /*sonst Versuch in gram_clear,
                                         mehr freizugeben,
                                         als allokiert wurde*/
                    LST_PUSH(&Gram->UsrActs,Name);
                    Term= (union gram_term*) Name;
                    ASSERT(LST_FIND(env_.BlIn,Name,strcmp),
                           WARNUNG,105421,
                           qv_msg("Aktionssymbol %s ist "
                                  "nicht vordefiniert.\n%s",
                                  Name,parse_errtk(*Tks)));
                    if(dbg("User function list(%ld):",
                       (long)Gram->UsrActs))
                      {LST_FPUT(stdout,Gram->UsrActs,fprintf," %s ");
                       puts("");
                      }
                   } /*if(Term=LST_FINDHEAD()) / else */
                 free(Sw); /*Unabhaengig davon, ob gefunden ist*/
                }     /*if(Term=LST_FINDHEAD()) / else */
             dbg("UsrAction detected: %s", (char *)Term);
         } /*switch*/
      } /*if(Rt=gram_parname(...))*/
    else
      {ASSERT(!(Oblig || WasPref), RC_SEVERR, 105409,
              qv_msg("SYNTAXFEHLER. Fortsetzung der Regel erwartet\n%s",
                     parse_errtk(*Tks)));
       Rt= FALSE;
      }
   } /* if(!(TkTp=tks_get(&Text,NULL,&File,&Row,&Col,*Tks))) / else*/

 if(Rt)
   {if(env_.Oper == 2 && CheckSuff)
       for(Opn=0;Opn<3;Opn++)
          if(OpSrc[Opn])
             if(parse_kw(Tks, OpSrc[Opn], FALSE, SEP_OPT))
               {SuffSign= OpRsl[Opn];
                Opn= 3;
               }
    ASSERT(!strchr("+*",SuffSign) || Type!=GRAM_USRACT, WARNUNG, 105419,
           qv_msg("Benutzersfunktion wird zyklisch aufgerufen\n%s",
                     parse_errtk(*Tks)));

    if(Type!=GRAM_NONTERM || *NewRule<1)
       *Item1=gram_creitem1(Type,Term,Argq,Args,SuffSign);
    dbg("*Item1=%lu,NewRule=%d,CheckSuff=%d",
        (ulong)*Item1,*NewRule,(int)CheckSuff);

    if(SuffSign!=GRAM_NOSUFFIX)
      {dbg("Suffix detected or set by default:'%c'",
           (*Item1)->SuffSign);
       if(Type==GRAM_NONTERM)
          if(SuffSign=='?')
             Rule1->Mark|= GRAM_USED_ANYOPT;
          else if(strchr("+*",SuffSign))
             Rule1->Mark|=GRAM_USED_LIST;
       if(strchr("+*",SuffSign))
          if(parse_char(Tks, env_.LstSep, FALSE, SEP_NO))
            {dbg("ListSep detected");
             if(!str_bracket(&RBrLs, env_.LstSep))
                RBrLs= env_.LstSep;
             Sw= parse_lit(Tks,"\"",TRUE,SEP_OPT);
             do{LST_PUSH(&(*Item1)->ListSeps, Sw);
               } while(parse_char(Tks, ',', FALSE, SEP_OPT));
             parse_char(Tks, RBrLs, TRUE, SEP_OPT);
            } /*if(parse_char(Tks, env_.LstSep, ...))*/
       else dbg("No ListSep detected");
      } /*if(Suffix)*/

    ASSERT(   Type!=GRAM_SEQ
           || SuffSign!=GRAM_NOSUFFIX
           || LST_COUNT(Seq->Items)>1,WARNUNG,105412,
            qv_msg("Verdaechtger Ausdruck:"
                   " weniger als 2 Elemente in Klammern\n%s",
                    parse_errtxt(File,Row,Col,LBr,KEEP)));
    if(LBr)free(LBr);if(RBr)free(RBr);
   } /*if(Rt)*/

 DBG_D3(%d,Rt,%u,Gram->Status,%ld,(long)Gram->UsrActs);
 MSG_ENDD();
 return Rt;
} /*gram_paritem1*/


/*==gram_parname===(mmoooooi)===========================================
 * Parst Namen und (Parameterliste)
 * Wenn ein bestimmtes Element erwartet ist, muss dessen Typ angegeben
 * werden.
 * Return:    1=OK, 0=STDACT mit falscher Parameteranzahl, -1=Misserfolg
======================================================================*/
static int gram_parname(tp_lexs **Tks, int *Type, char **Name,
                        char **File, unsigned *Row,  size_t *Col,
                        unsigned *ArgqOut, tp_args **ArgsOut,
                        bool Oblig)
{int       Rt;
 bool      Rw= FALSE;
 tp_args  *Args=NULL;
 unsigned  Argq=0,Argm=0,Argx=1;
 char      C1;
 char      End[2];
 int       IQ=0;
 bool      IsUsrAct=FALSE;
 char      Quotes[4];
 char      Required[32]="";
 int       StdActNr;
 char     *Sw,*Text;
 tp_tktype Tp;
 MSG_DCL("gram_parname");

 ASSERT(Name,ABBRUCH,EC_NullPointer,qv_msg("Parameter 3 == NULL"));

 tks_dbg1(*Tks);

 /*Form part of possible error message*/
 switch(*Type)
   {case GRAM_NONTERM: strcpy(Required,"Non-Terminal");  break;
    case GRAM_TERM:    strcpy(Required,"Terminal");      break;
    case GRAM_STDACT:
    case GRAM_USRACT:  strcpy(Required,"Aktionssymbol"); break;
    default:           strcpy(Required,"Fortsetzung der Regel");
   }
 dbg("Oblig=%d,ReqType=%s",(int)Oblig,Required);

 if((Tp=tks_get(&Text, NULL, File, Row, Col, *Tks))!=TKS_NO)
   {
    *Name=NULL;
    if(ArgsOut) *ArgsOut= NULL;
    if(ArgqOut) *ArgqOut= 0;

 /*Form string of allowed quotes*/
    if((*Type==GRAM_UNDEF || *Type==GRAM_NONTERM) && env_.NT)
       Quotes[IQ++]=env_.NT;
    if((*Type==GRAM_UNDEF || *Type==GRAM_TERM) && env_.Term)
       Quotes[IQ++]=env_.Term;
    if(  (*Type==GRAM_UNDEF || *Type==GRAM_STDACT || *Type==GRAM_USRACT)
       && env_.Term)
       Quotes[IQ++]=env_.Action;
    Quotes[IQ]=0x0;
    dbg("Quotes='%s'",Quotes);

    C1=*Text;
    if(*Quotes && (Sw=strchr(Quotes,C1)))
      {
       *End= gram_qtend(C1); End[1]=0x0;
       if(C1 == *End)
         {if(Rw= !!(Sw= parse_lit(Tks,End,FALSE,SEP_OPT)))
            {*Name=str_strip(NULL,Text);
             free((char *)Sw);
            }
         }
       else
          if(Rw= tks_pasteto(Tks,NULL,End,TRUE,FALSE,"-1",FALSE,Name))
                                      /*Oblig,InklEnd,SpcStg,Keep*/
             memmove(*Name,*Name+1,strlen(*Name));  /*del. 1st char*/
       if(Rw)
          if(C1==env_.NT) *Type=GRAM_NONTERM;
          else if(C1==env_.Term) *Type=GRAM_TERM;
          else if((StdActNr=gram_getstdact(*Name,NULL,NULL,NULL))>=0)
             *Type=GRAM_STDACT;
          else  *Type=GRAM_USRACT;
      } /*strchr(Quuotes,*Text)*/

    else if(!env_.Term)
      {*Type=GRAM_TERM; *Name=Text; tks_del(Tks,TKS_DEL0); Rw= TRUE;}

    else if(parse_name(Tks, Name, NULL, NULL, NULL, FALSE, SEP_OPT))
      {Rw= TRUE;
       if((StdActNr=gram_getstdact(*Name,NULL,NULL,NULL))<0)
          IsUsrAct=!!LST_FIND(env_.BlIn,*Name,strcmp);

       if(!env_.NT)
         {
          *Type= GRAM_NONTERM;
          if(!env_.Action)
             if(StdActNr>=0) *Type= GRAM_STDACT;
             else if(IsUsrAct) *Type= GRAM_USRACT;
         }
       else if(!env_.Action)
          *Type= StdActNr>=0? GRAM_STDACT: GRAM_USRACT;
       else Rw=FALSE;
      }

    ASSERT(Rw || !Oblig, AUSSTEUERN, 105401,
           qv_msg("%s erwartet\n%s",
                  Required,parse_errtxt(*File,*Row,*Col,*Name,KEEP)));
   }
 else ASSERT(!Oblig, AUSSTEUERN, 105402,
             qv_msg("EOF waehrend %s erwartet", Required));

 Rt= Rw? 1:-1;

 if(   *Type!=GRAM_UNDEF
    || env_.Args>=0
    || *Type==GRAM_STDACT && stdactions[StdActNr].MinArgs>0)
   {
    parse_args(Tks,&Args,&Argq,"(",")",
               *Type==GRAM_STDACT && stdactions[StdActNr].MinArgs>0);

    if(*Type==GRAM_TERM || *Type==GRAM_STDACT) /*for NT - s. _parnt()*/
      {if(*Type==GRAM_STDACT)
         {Argm=stdactions[StdActNr].MinArgs;
          Argx=stdactions[StdActNr].MaxArgs;
         }
       if(!(Argq>=Argm && Argq<=Argx))
         {ASSERT(0, WARNUNG, 105416,
                 qv_msg("Falsche Anzahl der Parameter: %u. "
                        "Erwartet %u bis %u\n%s",
                        Argq,Argm,Argx,
                        parse_errtxt(*File,*Row,*Col,*Name,KEEP)));
          Rt= 0;
         }
      }
    if(ArgsOut) *ArgsOut= Args;
    if(ArgqOut) *ArgqOut= Argq;
   }

 dbg("Type=%d=%s,Name='%s',Rw=%d,Rt=%d",
     *Type,
     *Type==GRAM_NONTERM?"NT": *Type==GRAM_TERM?"TERM":
     *Type==GRAM_STDACT?"STDACT": *Type==GRAM_USRACT?"USRACT": "??",
      Rt? *Name: "-",
      (int)Rw,Rt);
 tks_dbg1(*Tks);
 MSG_ENDD();
 return Rt;
} /*gram_parname*/


/*==gram_parnt===(mmomiiiiim)===========================================
 * Parst NonTerminal
 * NewRule: als Eingabe:
 *                     -1 - Verbot, neue Regel anzufangen
 *                      0 - neue Regel erlaubt
 *                      1 - neue Regel erforderlich
 *          als Ausgabe:
 *                      1 - neue Regel angefangen
 *                      2 - neue Regel ist leer (z.B. repeat. )
 *                     sonst (==Eingabewert) - nicht.
 * Return 1 = OK, 0=Doppeldefinition oder falsche Anzahl der Parameter
======================================================================*/
static int gram_parnt(tp_lexs **Tks,
                      gram_rules **Rules, gram_rule1 **Rule1,
                      char **Name, char *File,
                      unsigned Row, size_t Col,
                      unsigned Argq, tp_args *Args,
                      int *NewRule)
{int      Rt= 1;
 bool     Added= FALSE;
 int      Declared=0;
 char    *NameU;
 int      NExt, NOb;
 tp_pvar  PVar=NULL;
 char    *FileDcl=NULL;
 unsigned RowDcl=0;
 size_t   ColDcl=0;
 MSG_DCL("gram_parnt");

 tks_dbg1(*Tks);
 dbg("NewRule=%d,env_.Def2=%d", *NewRule,(int)env_.Def2);
 ASSERT(Name, ABBRUCH, EC_NullPointer, "Parameter Name == NULL");
 ASSERT(*Name, ABBRUCH, EC_NullPointer, "Parameter *Name == NULL");

 if(*NewRule>=0)                /*Neue Regel erlaubt*/
   {
    if(   env_.RuleEnd             /*Endzeichen spezifiziert*/
       && !env_.Empty              /*Kein EMPTY-Symbol spezifiziert*/
       && env_.Def2                /*Doppeldefinition erlaubt*/
       && *NewRule==1              /*Kopf neuer Regel geparsed*/
       && gram_parend(Tks,FALSE))  /*Endzeichen getroffen*/
       *NewRule= 2;                   /*Neue Regel ist leer*/

    if(*NewRule!=2)      /*Neue Regel erlaubt -> Kopftrenner parsen*/
       if(parse_tks(Tks,env_.ClTks,*NewRule*99,'*'))
          *NewRule= 1;   /*Tatsaechlich neue Regel*/
   }
 dbg("Aft. end or clause token: NewRule=%d",*NewRule);


 /*Die Regel schon existiert => 'Name' Speicher freigeben*/
 if(*Rule1=LST_FINDHEAD(*Rules,*Name,gram_rulenamecmp))
   {
    PVar= (*Rule1)->PVar;
    NameU=PVAR_GETNAME(PVar);
    Declared=pvar_declared(PVar,&FileDcl,&RowDcl,&ColDcl);

    if(NameU != *Name)
      {free((char *)*Name);
       *Name=NameU;
       dbg("NT found: Name = %s",*Name);
      }
    if(Argq!=(*Rule1)->Argq)
      {ASSERT(0,WARNUNG,105417,
              qv_msg("FEHLER. Unterschiedliche Anzahl der Parameter "
                     " Bei Deklaration/Aufruf fuer \"%s\".\n"
                     "Erst:       %s Zeile %u Spalte %u Anzahl=%u\n"
                     "Vorlaeufig: %s Zeile %u Spalte %u Anzahl=%u",
                     *Name,FileDcl, RowDcl,ColDcl, (*Rule1)->Argq,
                           File, Row, Col,Argq));
       Rt=0;
      }
   } /*if(Rule1=LST_FINDHEAD(...))*/
 else
    for(NOb=0; NOb<G_OBJQ; NOb++)
       for(NExt=0; NExt<3; NExt++)
          ASSERT(   !env_.GenMods[NOb][NExt]
                 || strcmpi(*Name,env_.GenMods[NOb][NExt]),
                 AUSSTEUERN, 105420,
                 qv_msg("Modulname darf nicht als NT-Name verwendet"
                        " werden: '%s' (%s Zeile %u, Spalte %u)",
                        *Name, File, Row, Col));
 dbg("Name=%s,@PVar=%lu,Declared=%d",
     *Name,(ulong)PVar,PVar?(int)pvar_declared(PVar,NULL,NULL,NULL):0);

 if(!(   !PVar
      || !Declared                            /*Nicht deklariert*/
      || *NewRule<1                           /*Keine neue Regel*/
      || env_.Def2))                          /*Doppeldef. erlaubt*/
   {ASSERT(0,WARNUNG,105415,
           qv_msg("FEHLER. Doppeldefinition fuer \"%s\".\n"
                  "Erst: %s Zeile %u Spalte %u; "
                  "Vorlaeufig: %s Zeile %u Spalte %u",
                  *Name,FileDcl,RowDcl,ColDcl, File,Row,Col));
    Rt= 0;
   }

 if(!PVar || *NewRule>=1 && pvar_declared(PVar,NULL,NULL,NULL))
   {
    if(!PVar) PVar= pvar_create(*Name);

    *Rule1= gram_crerule(PVar,NULL,Argq,NULL,NULL);

    LST_INS(Rules,*Rule1,gram_rulecmp);
    dbg("New rule created: NT Name = %s",*Name);
    Added= TRUE;
   } /*if(*NewRule>=1 || !PVar)*/

 if(*NewRule>=1)
   {pvar_dcl((*Rule1)->PVar,File,Row,Col,0);
    (*Rule1)->Args= Args;
   }
 else pvar_use((*Rule1)->PVar,File,Row,Col,0);

 if(Added)
    if(dbg("FULL NT LIST:"))
      {LST_FPUT(stdout,*Rules,gram_ptnt,NULL);
       qv_printf("\n");
      }

 tks_dbg1(*Tks);
 dbg("NewRule=%d",*NewRule);
 DBG_D2(%s,PVAR_GETNAME((*Rule1)->PVar),%d,Rt);
 MSG_ENDD();
 return Rt;
} /*gram_parnt*/


/***** EOP ** End of parser part ****/

/***** #4 ERSTELLEN********/

/*===gram_crerule===(iiiii)===========================================*/
static gram_rule1 *gram_crerule(tp_pvar PVar,gram_rule1 *Parent,
                                unsigned Argq,tp_args *Args,
                                gram_seq *Seq)
{gram_rule1 *Rt;
 char       *NameU;
 MSG_DCL("gram_crerule");
 ASSERT(PVar,ABBRUCH,EC_NullPointer,
        qv_msg("Parameter PVar == NULL"));
 NameU= PVAR_GETNAME(PVar);
 ASSERT(Rt= ALLOC(gram_rule1),ABBRUCH,EC_NotEnoughMemory,
        qv_msg("Kann nicht eine neue Regel (Name='%s') allokieren",
               NameU));
 memset(Rt,0,sizeof(gram_rule1));
 Rt->PVar=   PVar;
 Rt->Argq=   Argq;
 Rt->Args=   Args;
 if(LST_FIND(env_.ExtNTs,NameU,strcmpi))
   {Rt->Mark|= GRAM_EXTERN;
    Rt->Seq= NULL;
    Rt->Parent= NULL;
   }
 else
   {Rt->Seq=    Seq;
    Rt->Parent= Parent;
   }
 dbg("New rule or NT created: @Rule=%lu,NameU=(%lu)'%s'",
     (ulong)Rt,(ulong)NameU,NameU);
 MSG_END();
 return Rt;
} /*gram_crerule*/


/*===gram_creseq===(iiiiiiii)=========================================*/
static gram_seq *gram_creseq(char *File, unsigned Row,size_t Col,
                             char InfSign, char *Brc,
                             unsigned QNT,unsigned QT,gram_items *Items)
{gram_seq   *Seq;
 MSG_DCL("gram_creseq");
 ASSERT(Seq= ALLOC(gram_seq),ABBRUCH,EC_NotEnoughMemory,
        qv_msg("Kann nicht eine neue gram_seq Struktur allokieren"));
 Seq->File=     File;
 Seq->Row=      Row;
 Seq->Col=      Col;
 Seq->InfSign=  InfSign;
 Seq->Bracket=  Brc? strdup(Brc): NULL;
 Seq->QNT=      QNT;
 Seq->QT=       QT;
 Seq->Items=    Items;
 dbg("Seq->InfSign=%c(%d),Bracket=%s,QNT=%u,QT=%u",
     InfSign,(int)InfSign,STR_NOT0(Seq->Bracket),QNT,QT);
 MSG_ENDD();
 return Seq;
} /*gram_creseq*/

/*===gram_creitem1===(iiiii)==========================================*/
static gram_item1 *gram_creitem1(int Type, void *Term,
                                 unsigned Argq, tp_args *Args,
                                 char SuffSign)
{gram_item1 *Rt;
 MSG_DCL("gram_creitem1");

 ASSERT(Rt= ALLOC(gram_item1),ABBRUCH,EC_NotEnoughMemory,
        qv_msg("Kann nicht eine neue item1-Struktur allokieren"));
 memset(Rt, 0, sizeof(gram_item1));
 switch(Rt->Type=Type)
   {
    case GRAM_SEQ:     Rt->Term.Seq=Term;         break;
    case GRAM_TERM:    Rt->Term.Terminal=Term;    break;
    case GRAM_NONTERM: Rt->Term.NonTerminal=Term; break;
    case GRAM_USRACT:  Rt->Term.UsrAction=Term;   break;
    case GRAM_STDACT:  Rt->Term.StdAction=(int)Term;
   }
 Rt->Argq=     Argq;
 Rt->Args=     Args;
 Rt->SuffSign= SuffSign;

 dbg("New item created: Type = %d,SuffSign=%c",(int)Type,SuffSign);
 MSG_END();
 return Rt;
} /*gram_creitem1*/


/***** #5 AUSDRUCK ********/

/*==gram_printf===(ii)=== Druckt alle gram-Regeln ====================*/
void gram_printf(FILE *FF, tp_gram Gram)
{gram_rules *Rules;
 MSG_DCL("gram_printf");

 ASSABBR(FF,EC_NullPointer,("Parameter #1 ist NULL"));
 gram_plausid(Gram);

 for(Rules=Gram->Rules; Rules; Rules=Rules->Tail)
    gram_ptrule(FF,Rules->Head);

 MSG_ENDD();
} /*gram_printf*/

/*==gram_ptrule=== Druckt eine Regel =================================*/
static void gram_ptrule(FILE *FF,gram_rule1 *Rule)
{int Rt=1;
 /*MSG_DCL("gram_ptrule");*/

 Rt= Rule->NameF? fprintf(FF,"%s ",Rule->NameF):
                  fprintf(FF,"%.80s",PVAR_GETNAME(Rule->PVar));
 ASSABBR(Rt>0,105430,("gram_ptrule: I/O FEHLER. RC von fprintf:%d\n%s",
                      Rt,strerror(ferror(FF))));
 if(Rule->Seq)
   {
    fprintf(FF,"(N=%u,T=%u)\n= ", Rule->Seq->QNT, Rule->Seq->QT);
    gram_ptseq(FF,Rule->Seq);
    fprintf(FF,".\n");
    dbg("In the above rule:QNT= %u,QT=%u,LIST=%d,OPT=%d,ANYOPT=%d",
        Rule->Seq->QNT,Rule->Seq->QT,
        !!(Rule->Mark & GRAM_USED_LIST),
        !!(Rule->Mark & GRAM_USED_OPT),
        !!(Rule->Mark & GRAM_USED_ANYOPT));
   }
 else fprintf(FF,".\n");
 /*MSG_ENDD();*/
} /*gram_ptrule*/

/*==gram_ptseq=== Druckt die Rechte Seite der Regel ==================*/
void gram_ptseq(FILE *FF, gram_seq *Seq)
{char       *RBr;
 gram_items *Items;
 if(!Seq) fputs("<NULL-Seq>",FF);
 else
   {/*fprintf(FF,"(N=%u,T=%u)",Seq->QNT,Seq->QT);*/
    if(Seq->Bracket) fputs(Seq->Bracket,FF);
    if(!(Items=Seq->Items)) fputs("<No items in seq>",FF);
    else
      {gram_ptitem1(FF,Seq->Items->Head);
       while(Items=Items->Tail)
         {fprintf(FF,"%c ",Seq->InfSign);
          gram_ptitem1(FF,Items->Head);
         }
      }
    if(Seq->Bracket)
      {RBr=str_bracket(NULL,*Seq->Bracket);
       fputs(RBr,FF);
       free(RBr);
      }
   }
} /*gram_ptseq*/


/*==gram_ptitem1========================================================
 * Druckt eine Komponente aus der Rechten Seite der Regel
 *====================================================================*/
void gram_ptitem1(FILE *FF,gram_item1 *It)
{
 gram_seq   *Seq= NULL;
 tp_strings *LSeps;
 ASSABBR(It,EC_NullPointer,("Parameter #2(It) ist NULL"));

 switch(It->Type)
   {
    case GRAM_SEQ:
       Seq= It->Term.Seq;
       if(!Seq->Bracket) fputc('(', FF);
       gram_ptseq(FF, Seq/*->Items, Seq->InfSign, Seq->Bracket*/);
       if(!Seq->Bracket) fputc(')', FF);
       break;
    case GRAM_TERM:   fprintf(FF,"'%s'",It->Term.Terminal); break;
    case GRAM_NONTERM:
       fputc('<',FF);
       if(It->Term.NonTerminal->NameF)
          fprintf(FF,It->Term.NonTerminal->NameF);
       else pvar_printf(FF,0,It->Term.NonTerminal->PVar);
       fputc('>',FF);
       break;
    case GRAM_STDACT:
       fprintf(FF,"\"%s\"",stdactions[It->Term.StdAction].Name);
       break;
    case GRAM_USRACT: fprintf(FF,"\"%s\"",It->Term.UsrAction);break;
    case GRAM_EMPTY:  fputc('E',FF);break;
    case GRAM_CUT:    fputc('!',FF);break;
    default:          fputs("<UNKNOWN>",FF);
   }
 fputc(It->SuffSign,FF);

 if(It->SuffSign && It->ListSeps)
   {fputc('[',FF);
    LSeps= It->ListSeps;
    for(;;)
      {fprintf(FF,"'%s'",LSeps->Head);
       if(LSeps=LSeps->Tail) fputc(',',FF);
       else {fputc(']',FF); break;}
      }
   }
} /*gram_ptitem1*/


/*==gram_ptnt=== Druckt Daten eines NTs ==============================*/
void gram_ptnt(FILE *FF, void *Unused, void *InRule1)
{
 gram_rule1 *Rule1;
 Rule1= InRule1;

 if(Rule1->NameF) fprintf(FF,"%s ",Rule1->NameF);
 else pvar_printf(FF,1,Rule1->PVar);

 if(Rule1->Seq)
    fprintf(FF,"SeqType='%c'\n",Rule1->Seq->InfSign);
 else fprintf(FF,"Seq=NULL\n");
} /*gram_ptnt*/

/*==gram_ptargs== Druckt Parameterliste ==============================*/
/*
*void gram_ptargs(FILE *FF, int Parent, tp_args *Args)
*{
* tp_args    *Argw;
* bool        Beg=TRUE;
* tp_strings *Ss;
*
* if(Parent>=1 || !Parent && Args) fputc('(',FF);
* for(Argw=Args;Argw;Argw=Argw->Tail)
*   {if(!Beg) fputc(',',FF);
*    else Beg= FALSE;
*    for(Ss=Argw->Head;Ss;Ss=Ss->Tail) fprintf(FF," %s",Ss->Head);
*   }
* if(Parent>=1 || !Parent && Args) fputc(')',FF);
*} / *gram_ptargs*/


/***** #6 UMWANDLUNG ZUR STANDARTFORM *****/


/*===gram_artname===(ii)================================================
 * Erzeugt "Familiennamen" eines kuenstlichen NT fuer Fehlermeldung
 *====================================================================*/
static char *gram_artname(gram_rule1 *Parent, char Which)
{char    *Rt=NULL;
 char    *NameP;
 size_t   Lr;

 MSG_BEG("gram_artname");
 ASSERT(Parent, ABBRUCH,EC_InternalError,"Parent=NULL!");
 ASSERT(strchr("FfUu",Which),ABBRUCH,EC_InternalError,
        qv_msg("Falscher Parameter Which=%c. Erlaubt: 'F' | 'U'",
               Which));

 if(Which=='U')
   {NameP= PVAR_GETNAME(Parent->PVar);
    Lr= strlen(NameP)+30;
    ASSERT(Rt= malloc(Lr),ABBRUCH,EC_NotEnoughMemory,
           qv_msg("Kann nicht ein Teil von zu generierender "
                  "Fehlermeldung allokieren (L=%u, Fall 1)",Lr));
    sprintf(Rt,"Element/Unterfolge #%04u von %s",
               ++(Parent->QArtif),NameP);
   }
 else
   {ASSERT(Parent->NameF,ABBRUCH,EC_InternalError,
           qv_msg("NameF=NULL fuer %s!",PVAR_GETNAME(Parent->PVar)));
    Lr= strlen(Parent->NameF)+6;
    ASSERT(Rt= malloc(Lr),ABBRUCH,EC_NotEnoughMemory,
           qv_msg("Kann nicht ein Teil von zu generierender "
                  "Fehlermeldung allokieren (L=%u; Fall 2)",Lr));
    sprintf(Rt,"%s_%04u",Parent->NameF,Parent->QArtif);
          /*No increment, because it's just called with 'U'!*/
   }
 DBG_D1(%u,Rt);
 MSG_END();
 return Rt;
} /*gram_artname*/


/*==gram_outnames===(i)=================================================
 * Generiert oder kopiert Datentyp- und Variablennamen
 *====================================================================*/
static void gram_outnames(gram_rule1 *Rule1)
{int       IR;
 unsigned  Dummy;
 bool      Modify=FALSE;
 size_t    LN;
 char     *NameU;
 int       ResQ1=sizeof(reserved1)/sizeof(reserved1[0]),
           ResQ2=sizeof(reserved2)/sizeof(reserved2[0]);
 MSG_DCL("gram_outnames");

 NameU= PVAR_GETNAME(Rule1->PVar);
 dbg("NameU='%s', stdname=%d",NameU,(int)STR_STDNAME(NameU));
 dbg("env_.MaxName=%u,GRAM_MAXTP=%u",env_.MaxName,GRAM_MAXTP);
 dbg("@Parent=%ld",(long)Rule1->Parent);

 if(!(Rule1->NameF && Rule1->NameV))
   {
    LN= strlen(NameU);
    Modify=    LN>env_.MaxName
           || !STR_STDNAME(NameU)
           ||    LN>5
              && NameU[LN-5]=='_'
              && sscanf(NameU+LN-4,"%u",&Dummy)==4;
    dbg("Modify(1)=%d",(int)Modify);

    for(IR=0;IR<ResQ1 && !Modify;IR++)
       Modify=!stricmp(NameU,reserved1[IR]);
    dbg("Modify(2)=%d, IR=%d",(int)Modify, IR);

    for(IR=0;IR<ResQ2 && !Modify;IR++)
       Modify=!strnicmp(NameU,reserved2[IR],strlen(reserved2[IR]));
    dbg("Modify(3)=%d, IR=%d",(int)Modify, IR);

    if(!Modify)
      {ASSERT(Rule1->NameF=strdup(NameU),ABBRUCH,EC_NotEnoughMemory,
              qv_msg("Kann nicht NT-Datatypnamen allokieren(1)."
                     "Benutzersname='%s' (L=%u)",
                     NameU,strlen(NameU)));
       strlwr(Rule1->NameF);
      }
    else if(Rule1->Parent)
       Rule1->NameF= gram_artname(Rule1->Parent,'F');
    else
      {LN=5;
       ASSERT(Rule1->NameF=(char *)malloc(LN+1),
              ABBRUCH,EC_NotEnoughMemory,
              qv_msg("Kann nicht NT-Datatypnamen allokieren(2)."
                     "Benutzersname='%s' (Size=%u)",
                     NameU,LN+1));
       memset(Rule1->NameF,0,LN+1);
       sprintf(Rule1->NameF,"n%04u",++nmn);
      }
    dbg("@Rule1=%lu,NameF=(%lu)'%s'",
        (ulong)Rule1,(ulong)Rule1->NameF,(ulong)Rule1->NameF);
    ASSERT(Rule1->NameV=strdup(Rule1->NameF),
           ABBRUCH,EC_NotEnoughMemory,
              qv_msg("Kann nicht NT-Strukturfeldnamen allokieren."
                     "Benutzersname='%s' (Size=%u)",
                     NameU,strlen(Rule1->NameF)+1));
    *Rule1->NameV= toupper(*Rule1->NameV);
   }
 MSG_ENDD();
} /*gram_outnames*/


/*==gram_delmultiple===(m)==============================================
 * Ersetzt mehrfache Definitionen mit Alternativen
 *====================================================================*/
static void gram_delmultiple(ts_gram *Gram)
{bool        Beg,Chg=FALSE,Done;
 gram_items *Itemz;
 gram_item1 *Item1;
 char       *NameU;
 gram_rules *Rlw;
 gram_rules *Rulez;
 gram_rule1 *Rule1,*Rule2;
 gram_seq   *Alt;
 MSG_DCL("gram_delmultiple");

 for(Rlw=Gram->Rules;Rlw;Rlw=Rlw->Tail)
   {Rule1= Rlw->Head;
    if(   (   !Rule1->Seq
           || !Rule1->Seq->Items
           ||    LST_COUNT(Rule1->Seq->Items)==1
              && Rule1->Seq->Items->Head->Type==GRAM_EMPTY)
       && Rlw->Tail
       && !gram_rulecmp(Rule1,Rlw->Tail->Head))
       ASSERT(0,AUSSTEUERN,105441,
              qv_msg("Die leere Regel fuer %s ist nicht die letzte."
                     " Umwandlung/Generation abgesetzt.",
                     PVAR_GETNAME(Rule1->PVar)));
   }

 for(Rlw=Gram->Rules;Rlw;)
   {Rule1= Rlw->Head;
    gram_outnames(Rule1);
    Done=FALSE;
    if(!(Rule1->Mark & GRAM_EXTERN))
      {if(!Rule1->Seq)
         {Alt=gram_creseq(NULL,0,0,' ',NULL,0,0,NULL);
          Item1=gram_creitem1(GRAM_EMPTY,NULL,0,NULL,GRAM_NOSUFFIX);
          LST_PUSH(&Alt->Items,Item1);
          Rule1->Seq= Alt;
         } /*if (!Rule1->Seq)*/
       if(Rlw->Tail && !gram_rulecmp(Rule1,Rlw->Tail->Head))
         {Beg=TRUE;
          for(Rulez=Rlw;
              Rulez && !gram_rulecmp(Rule1,Rulez->Head);
              Rulez=Rulez->Tail)
            {Rule2=Rulez->Head;
             NameU=PVAR_GETNAME(Rule1->PVar);
             dbg("Eliminating multiple definition of %s",NameU);
             if(Beg)
               {if(Rule1->Seq->InfSign!='|')
                  {Alt=gram_creseq(Rule1->Seq->File,
                                   Rule1->Seq->Row,Rule1->Seq->Col,
                                   '|',NULL,Rule1->Seq->QNT>0,0,NULL);
                   Item1=gram_creitem1(GRAM_SEQ,Rule1->Seq,
                                       0,NULL,GRAM_NOSUFFIX);
                   Itemz=(gram_items *)LST_PUSH(&Alt->Items,Item1);
                   Rule1->Seq= Alt;
                  } /*if (... ==',')*/
                else Itemz=(gram_items *)LST_GETLAST(Rule1->Seq->Items);
                Rule1->Seq->InfSign='|';
               }  /*if(Beg)*/
             else
               {if(Rule2->Seq->InfSign != '|')
                  {
                   Item1=gram_creitem1(GRAM_SEQ,Rule2->Seq,
                                       0,NULL,GRAM_NOSUFFIX);
                   Itemz=(gram_items *)LST_APPEND(Itemz,Item1);
                   Rule1->Seq->QNT += 1; /*Rule2->Seq->QNT > 0;*/
                  } /*if ==',')*/
                else /*if(InfSign == ',')/else -- d.h. | or singl*/
                  {
                   LST_CAT(&Itemz,Rule2->Seq->Items);
                   Itemz=(gram_items *)LST_GETLAST(Itemz);
                   Rule1->Seq->QNT += Rule2->Seq->QNT;
                   Rule1->Seq->QT  += Rule2->Seq->QT;
                   free(Rule2->Seq);
                  } /*single or |*/
                pvar_merge(Rule1->PVar, Rule2->PVar);
                Rule1->Mark |=
                    Rule2->Mark & (GRAM_USED_LIST | GRAM_USED_ANYOPT);
                Rule2->Mark |= GRAM_TODIE; /*Mark for the foll. del.*/
               } /*if(Beg)/ else*/
             Chg=Done= TRUE;
             Beg=FALSE;
            } /*for(Rulez)*/
         }    /*if(Rlw->Tail && !gram_rulecmp(Rule1,Rlw->Tail->Head))*/
      }    /*if(not EXTERN)*/
    if(Done)
      {if(dbg("Done:")) gram_ptnt(stdout,NULL,Rule1);
       Rlw= Rulez;
      }
    else Rlw= Rlw->Tail;
   } /*for(Rlw)*/

   /*DELETE MARKED RULES*/
 LST_DELFOR(&Gram->Rules,NULL,gram_tobedel,gram_clrrule);

 if(!Chg) dbg("No multiple declarations detected");
 else if(dbg("FULL LIST at the end:"))
   {gram_printf(stdout, Gram); qv_printf("\n");}

 MSG_ENDD();
} /*gram_delmultiple*/


/*==gram_delseq===(m)=== Ersetzt ()-Unterfolgen mit ZusatzNTn ========*/
static void gram_delseq(ts_gram *Gram)
{
 gram_items *Items;
 gram_item1 *Item1;
 char       *Name;
 int         NR=0;
 tp_pvar     PVar;
 gram_rules *Rlw;
 gram_rules *Rulez;
 gram_rule1 *Rule1,*Rule2,*Parent,*PW;
 MSG_DCL("gram_delseq");

 Rulez=(gram_rules *)LST_GETLAST(Gram->Rules);

 for(Rlw=Gram->Rules;Rlw;Rlw=Rlw->Tail)
    if(!(Rlw->Head->Mark & GRAM_EXTERN))
      {Rule1= Rlw->Head;
       dbg("Searching '%s' for subsequences",
            PVAR_GETNAME(Rule1->PVar));

       Parent=NULL; PW=Rule1 /*->Parent*/ ;
       while(PW) {Parent=PW;PW=PW->Parent;}

       for(Items=Rule1->Seq->Items;Items;Items=Items->Tail)
         {
          Item1=Items->Head;
          /*dbg("Item type = %d",(int)Item1->Type);*/
          if(Item1->Type==GRAM_SEQ)
            {dbg("Eliminating subsequence for '%s'",
                 PVAR_GETNAME(Rule1->PVar));
             Name= gram_artname(Parent,'U');
             PVar= pvar_create(Name);
             pvar_dcl(PVar,NULL,0,0,-1);
             pvar_use(PVar,Item1->Term.Seq->File,
                      Item1->Term.Seq->Row,Item1->Term.Seq->Col,1);
             Item1->Term.Seq->Bracket= NULL;
             Rule2=gram_crerule(PVar,Parent,0,NULL,Item1->Term.Seq);
             if(Item1->SuffSign=='?') Rule2->Mark |= GRAM_USED_ANYOPT;
             else if(strchr("+*",Item1->SuffSign))
                Rule2->Mark |= GRAM_USED_LIST;
             Rulez=(gram_rules *)LST_APPEND(Rulez,Rule2);
             Item1->Type= GRAM_NONTERM;
             Item1->Term.NonTerminal= Rule2;
             gram_outnames(Rule2);
             if(dbg("New Rule: "))
               {gram_ptrule(stdout,Rulez->Head);
                fputc('\n',stdout);
               }
             dbg("Tail = %lu",(unsigned)Rulez->Tail);
             if(dbg("Modified Rule: "))
               {gram_ptrule(stdout,Rule1);
                fputc('\n',stdout);
               }
        /*   if(dbg("Done"))
         *      gram_ptnt(stdout,NULL,Rule1);*/
            } /*if(gram_seq(...))*/
         } /*for(Items ... )*/
      } /*for(Rlw ... )*/
 if(dbg("FULL LIST at the end:"))
   {gram_printf(stdout, Gram);
    qv_printf("\n");
   }
 MSG_ENDD();
} /*gram_delseq*/

/*==gram_unreach===(m)==================================================
 * Entfernt unerreichbare Teile der Regeln
 * Beispiel: N=A?|B   wird zu  N=A? reduziert
 *====================================================================*/
static void gram_unreach(ts_gram *Gram)
{
 gram_items *Items, *ItemW;
 gram_item1 *Item1;
 bool        Optional;
 unsigned    QEl,QNT,QT;
 gram_rule1 *Rule1;
 gram_rules *Rlw;
 MSG_DCL("gram_unreach");

 for(Rlw=Gram->Rules;Rlw;Rlw=Rlw->Tail)
    if(!(Rlw->Head->Mark & GRAM_EXTERN))
      {Rule1= Rlw->Head;
       if(Rule1->Seq->InfSign=='|')
         {dbg("Analyzing '%s' for unreachable elements",
              PVAR_GETNAME(Rule1->PVar));
          Optional=FALSE; QT=QNT=QEl=0;
          for(Items=Rule1->Seq->Items;Items && !Optional;)
            {
             Item1=Items->Head;
             /*dbg("Item type = %d",(int)Item1->Type);*/
             switch(Item1->Type)
               {case GRAM_NONTERM:
                case GRAM_STDACT:  QNT++; break;
                case GRAM_TERM:    QT++;  break;
                case GRAM_EMPTY:   Optional=TRUE;
               }
             if(strchr("?*",Item1->SuffSign) && Items->Tail) /*???*/
                Optional=TRUE;                               /*???*/
             if(!Optional) Items=Items->Tail;
             QEl++;
            } /*for(Items ... )*/
          if(Optional)
            {LST_DESTROY(&Items->Tail);
             Rule1->Seq->QNT=QNT; Rule1->Seq->QT=QT;
             if(QEl<2) Rule1->Seq->InfSign=' ';
             if(dbg("'%s' modified to:",PVAR_GETNAME(Rule1->PVar)))
                gram_ptrule(stdout,Rule1);
             Rule1->Mark|=GRAM_OPTIONAL;
            } /*if(Optional)*/
         }    /*if(Rule1->Seq->InfSign=='|')*/
       else
         {
            /*OPTIONAL-Mark setzen*/
	  Optional=TRUE;
          for(Items=Rule1->Seq->Items;
              Items && Optional;
              Items=Items->Tail)
            {Item1=Items->Head;
             if(!strchr("?*",Item1->SuffSign)) Optional=FALSE;
            }
          if(Optional) Rule1->Mark|=GRAM_OPTIONAL;

            /*E-Elemente entfernen*/
          for(Items=Rule1->Seq->Items; Items; Items=Items->Tail)
             while(Items->Tail && Items->Tail->Head->Type==GRAM_EMPTY)
               {ItemW= Items->Tail;
                Items->Tail= ItemW->Tail;
                gram_clritem1(ItemW->Head);
		free(ItemW);
               }
         }    /*if(Rule1->Seq->InfSign=='|')/else*/
      }       /*for(Rlw ... ) if (not external)*/
 MSG_ENDD();
} /*gram_unreach*/


/*==gram_disjsuff===(ii)=== Suffix-Disjunktion =======================*/
static char gram_disjsuff(char Suff1, char Suff2)
{static char suffconv[4][5] = {" ?+*",
                               "??**",
                               "+*+*",
                               "****"
                              };
 static unsigned suffq=4;
 char      Rt;
 unsigned  I,J;
 char     *Sw;
 MSG_DCL("gram_disjsuff");

 ASSERT(Sw=strchr(suffconv[0],Suff1), ABBRUCH, EC_InternalError,
        qv_msg("Parameter Suff1 ist falsch: '%c', Erlaubt sind '%s'",
               Suff1,suffconv[0]));
 I=suffq-strlen(Sw);

 ASSERT(Sw=strchr(suffconv[0],Suff2), ABBRUCH, EC_InternalError,
        qv_msg("Parameter Suff2 ist falsch: '%c', Erlaubt sind '%s'",
               Suff2,suffconv[0]));
 J=suffq-strlen(Sw);

 Rt=suffconv[I][J];
 DBG_D3(%c,Suff1,%c,Suff2,%c,Rt);
 MSG_END();
 return Rt;
} /*gram_disjsuff*/


/*===gram_replinseq===(im)==============================================
 * Ersetzt primitiven NT innerhalb einer Elementenfolge
 *====================================================================*/
static unsigned gram_replinseq(gram_rule1 *Rule1, gram_seq *Seq)
{unsigned    Rt= 0;
 /*unsigned    Argq;
  *tp_args    *Args;*/
 gram_items *Items;
 gram_item1 *Item0,*Item1;
 unsigned    Nr;
 unsigned    QNT, QT;
 char        SuffSv;

 MSG_DCL("gram_replinseq");
 if(Seq)
   {
    Item1= Rule1->Seq->Items->Head;
    QNT= QT= 0;
    if(Item1->Type==GRAM_TERM) QT=1;
    else if(Item1->Type==GRAM_NONTERM || Item1->Type==GRAM_STDACT)
       QNT=1;

    for(Nr=1,Items=Seq->Items;Items;Nr++,Items=Items->Tail)
      {
       Item0= Items->Head;

       if(   Item0->Type==GRAM_NONTERM
          && !gram_rulecmp(Rule1, Item0->Term.NonTerminal))
         {Rt++;
          dbg("Element #%u (from 1) replaced",Nr);
          /*Argq= Item0->Argq; Args= Item0->Args;*/
          SuffSv= gram_disjsuff(Item0->SuffSign,Item1->SuffSign);
          memcpy(Item0,Item1,sizeof(gram_item1));
          Item0->SuffSign= SuffSv;
          /*Item0->Argq= Argq; Item0->Args= Args;*/
          if(Item1->Type==GRAM_TERM)
             ASSERT(Item1->Term.Terminal= strdup(Item1->Term.Terminal),
                    ABBRUCH, EC_NotEnoughMemory,
                    qv_msg("Speicherprobleme. Kann nicht Terminalsymbol"
                           " allokieren (L=%u)",
                           strlen(Item1->Term.Terminal)));
          Seq->QNT-= 1; Seq->QNT+= QNT; Seq->QT+= QT;
         }
      } /*for(Items=Seq->Items;Items;Items=Items->Tail)*/
   } /*if(Seq)*/
 else dbg("Seq=NULL");
 dbg("Rt=%u",Rt);
 MSG_ENDD();
 return Rt;
} /*gram_replinseq*/


/*==gram_del11===(m)====================================================
 * Loescht primitive Regeln und ersetzt entsprechende
 * Elemente in anderen Regeln
 * ===================================================================*/
static void gram_del11(ts_gram *Gram)
{tp_args    *Args1,*Args2;
 bool        Chg=FALSE;
 int         Diff;
 gram_item1 *Item1;
 unsigned    QRepl, ReplNow;
 gram_rules *Prev,*Rules1,*Rules2;
 gram_rule1 *Rule1;
 tp_strings *Sl1;
 MSG_DCL("gram_del11");

if(dbg("FULL LIST at the beginning:"))
   {gram_printf(stdout, Gram); qv_printf("\n");}

 Prev=NULL;

 for(Rules1=Gram->Rules;Rules1;)
   {
    QRepl= 0; Rule1= Rules1->Head; Diff= 1;

    if(   Rule1->Seq
       && Rule1->Seq->Items
       && (Item1=Rule1->Seq->Items->Head)->Type!=GRAM_SEQ
       && !Rule1->Seq->Items->Tail
       && !strchr("+*",Rule1->Seq->Items->Head->SuffSign)
       && (   !env_.Pub
           ||    strcmp(env_.Pub->Head,"*")
              && !LST_FIND(env_.Pub,PVAR_GETNAME(Rule1->PVar),stricmp)))
      {
       dbg("Rule %s is 1:1",pvar_msg(Rule1->PVar,0));
       Diff= 0;                              /*compare argument*/
       if(Rule1->Argq && Item1->Argq)
          if(Rule1->Argq != Item1->Argq) Diff=1;
          else
             for(Args1=Rule1->Args,Args2=Item1->Args;
                 !Diff && Args1 && Args2;
                 Args1=Args1->Tail,Args2=Args2->Tail)
                if(Args2->Head->Tail) Diff=1;/*right not a single arg*/
                else
                  {for(Sl1=Args1->Head;     /*skip left until [ or end*/
                       Sl1->Tail && strcmp(Sl1->Tail->Head,"[");)
                      Sl1=Sl1->Tail;
                   Diff=strcmp(Sl1->Head,Args2->Head->Head);
                  }
       dbg("Arguments are %scompatible",Diff? "in":"");
      } /*if 1:1*/

    if(!Diff)
      {QRepl= 0;                              /*replacements*/
       for(Rules2=Gram->Rules;Rules2;Rules2=Rules2->Tail)
         {
          ReplNow=gram_replinseq(Rule1,Rules2->Head->Seq);
          if(ReplNow)
             dbg("%u replacements in rule %s ...",
                 ReplNow, pvar_msg(Rules2->Head->PVar,0));
          QRepl+= ReplNow;
         }
       if(Item1->Type==GRAM_NONTERM)
         {Item1->Term.NonTerminal->Mark |= Rule1->Mark;
          Item1->Term.NonTerminal->Mark &= ~GRAM_TODIE;
         }
       dbg("Rule %s is deleted",pvar_msg(Rule1->PVar,0));
       pvar_clear(Rule1->PVar,TRUE);
       gram_clrrule(Rule1);
       Rules2= Rules1->Tail;
       if(Prev) Prev->Tail= Rules2; else Gram->Rules= Rules2;
       free(Rules1);
       Rules1= Rules2;
       Chg=TRUE;
      } /*if(!Diff)*/
    else {Prev= Rules1; Rules1= Rules1->Tail;}
   } /*for(Rules1=Gram->Rules;Rules1;)*/

 if(!Chg) dbg("No 1:1-rules deleted");
 else if(dbg("FULL LIST at the end:"))
   {gram_printf(stdout, Gram); qv_printf("\n");}

 MSG_ENDD();
} /*gram_del11*/



/*==gram_convert===(m)===Konvertiert die Grammatik zur Standartform===*/
static void gram_convert(ts_gram *Gram)
{MSG_DCL("gram_convert");
 gram_plausid(Gram);
 dbg("Gram->Processed=%d,CONSISTENT=%d,NORMALIZED=%d",
     Gram->Processed,
     !!(Gram->Status & GRAM_CONSISTENT),
     !!(Gram->Status & GRAM_NORMALIZED));

 if(   Gram->Status & GRAM_CONSISTENT
    && Gram->Processed<GRAM_NORMALIZE)
   {
    Gram->Processed= GRAM_NORMALIZE;

    gram_delmultiple(Gram);
    if(dbg("Aft.gram_delmultiple"))
      {gram_printf(stdout,Gram);
       qv_printf80('-');
      }
    gram_delseq(Gram);
    if(dbg("Aft.gram_delseq"))
      {gram_printf(stdout,Gram);
       qv_printf80('-');
      }
    gram_unreach(Gram);
    gram_del11(Gram);
    Gram->Status |= GRAM_NORMALIZED;
    if(dbg("NORMALIZED=%d",!!(Gram->Status & GRAM_NORMALIZED)))
      {gram_printf(stdout,Gram);
       qv_printf80('-');
      }
   } /*if(GRAM_CONSISTENT && Gram->Processed<GRAM_NORMALIZE)*/
 MSG_ENDD();
} /*gram_convert*/



/***** #7 LLk-ANALYSE *****/

/*===gram_ptelm== Hilfsfunktion. Aehnlich der gram_ptitem1 ===========*/
int gram_ptelm(FILE *FF,void *Fmt,gram_elm *It)
{char Sep=     ' ';
 ASSABBR(It,EC_NullPointer,("Parameter #3(It) ist NULL"));
 return fprintf(FF," %s(Type=%d) ",STR_NOT0(It->Name),(int)It->Type);
} /*gram_ptelm*/

/*===gram_ptalt== Hilfsfunktion. Druckt Nr der Alternative aus =======*/
int gram_ptalt(FILE *FF,void *Fmt,void *Alt)
{char Sep=     ' ';
 ASSABBR(Alt,EC_NullPointer,("Parameter #3(Alt) ist NULL"));
 return fprintf(FF," Alt=%u ",(unsigned)Alt);
} /*gram_ptalt*/


/*===gram_anllk===(i)===LLk-Analyse ==================================*/
bool gram_anllk(tp_gram Gram)
{bool        Rt=FALSE;
 tp_graf     Graf;
 MSG_DCL("gram_anllk");

 if(env_.LLk && Gram->Processed <GRAM_LLKTEST)
   {gram_convert(Gram);

    if(Gram->Status & GRAM_NORMALIZED)
      {Gram->Processed= GRAM_LLKTEST;
       gram_anle(Gram);
       Graf= graf_create("NT-Graf",FALSE,TRUE);
       gram_anl1(Gram,Graf);
       Rt= !gram_testllk(Graf);
       graf_clear(Graf,free,NULL);
       ASSERT(Rt,AUSSTEUERN,105454,
              "Die angegebene Grammatik ist nicht LLk-korrekt");
       Gram->Status|= GRAM_LLK;
      } /*if(Gram->Status & GRAM_NORMALIZED)*/
   }    /*if(env_.LLk && Gram->Processed <GRAM_LLKTEST)*/
 dbg("Rt=%d",(int)Rt);
 MSG_END();
 return Rt;
} /*gram_anllk*/


/*===gram_creelm===(ii)===============================================*/
static gram_elm *gram_creelm(int Type, char *Name)
{gram_elm *Rt;
 MSG_DCL("gram_creelm");
 ASSERT(Rt= ALLOC(gram_elm),ABBRUCH,EC_NotEnoughMemory,
        qv_msg("Kann nicht eine neue elm-Struktur allokieren"));
 Rt->Type= Type;
 Rt->Name= Name;

 dbg("New element created: Type = %d, Name=%s",
     (int)Type, STR_NOT0(Name));
 MSG_END();
 return Rt;
} /*gram_creelm*/


/*===gram_anle===(m)=== Epsilon-Analyse ==============================*/
static void gram_anle(tp_gram Gram)
{gram_rules *Rules,*Prev=NULL;
 MSG_DCL("gram_anle");
 gram_plausid(Gram);
 Rules= Gram->Rules;
 while(Rules)
   {Prev=Rules;
    gram_anlnte(Gram,&Rules,TRUE);
    if(Prev)
       dbg("Rule for NT '%s', Done=%d, E=%d",
           PVAR_GETNAME(Prev->Head->PVar),
           !!(Prev->Head->Mark & GRAM_READY),
           !!(Prev->Head->Mark & GRAM_CANBE));
   }
 MSG_END();
} /*gram_anle*/


/*===gram_anlnte===(mmi)================================================
 * Epsilon-Analyse fuer 1 NT
 * Return: TRUE = NT admits Epsilon
 *====================================================================*/
static int gram_anlnte(tp_gram Gram, gram_rules **Rules, bool Skip)
{int         Rt= 0;  /*-1=currently under processing,
                        1=can be E, 0=cannot be E*/
 int         Rw;     /*Return from recursive call to gram_anlnte*/
 bool        AssNT, ProcNT=TRUE, ContErr=TRUE, ContSeq;
 bool        ERl, EIt;
 gram_rules *CurrNT,*NextNT;
 gram_item1 *Item1;
 gram_items *Items;
 char       *Name;
 tp_pvar     NextPV,PVar;
 gram_rule1 *Rule1;
 MSG_DCL("gram_anlnte");

 ASSABBR(Rules,EC_NullPointer,("Parameter Rules == NULL"));
 ASSABBR(*Rules,EC_NullPointer,("Parameter *Rules == NULL"));

 PVar=(*Rules)->Head->PVar;
 Name= PVAR_GETNAME(PVar);
 DBG_D1(In_process:%s,Name);
 if(CurrNT=(gram_rules *)LST_FIND(*Rules,Name,gram_rulenamecmp))
   {
    if(CurrNT->Head->Mark & GRAM_INPROC) {Rt= -1;ProcNT= FALSE;}
    else if(CurrNT->Head->Mark & GRAM_READY)
      {Rt= !!(CurrNT->Head->Mark & GRAM_CANBE);
       ProcNT= FALSE;
      }
   }

 if(AssNT=ProcNT) CurrNT->Head->Mark |= GRAM_INPROC;

 while(*Rules && (*Rules)->Head->PVar==PVar && (ProcNT || Skip))
   {
    if(ProcNT)
      {
       Rule1=(*Rules)->Head;
       dbg("Next rule in process. Rule->Seq=%lu",(ulong)Rule1->Seq);

       if(!Rule1->Seq) ERl= TRUE;
       else
         {
          ERl= Rule1->Seq->InfSign!='|';
          ContSeq= TRUE;

          for(Items=Rule1->Seq->Items;
              Items && ContSeq;
              Items=Items->Tail)
            {Item1= Items->Head;
             Rw= 0;
             if(dbg("Next Item in process"))
                gram_ptitem1(stdout,Items->Head);
             if(strchr("?*",Item1->SuffSign)) EIt=TRUE;
             else switch(Items->Head->Type)
               {
                case GRAM_EMPTY:   EIt=TRUE; break;
                case GRAM_NONTERM:
                   if(!(  Items->Head->Term.NonTerminal->Mark
                        & GRAM_EXTERN))
                     {
                      NextPV= Items->Head->Term.NonTerminal->PVar;
                      Name= PVAR_GETNAME(NextPV);
                      NextNT=
                         (gram_rules *)LST_FIND(Gram->Rules,
                                                Name,gram_rulenamecmp);
                      if((Rw=gram_anlnte(Gram, &NextNT, FALSE))<0)
                         ContSeq= FALSE;
                      else EIt= Rw;
                     }
                   else EIt= Rw;
                   break;
                case GRAM_TERM:
                case GRAM_STDACT:   EIt= FALSE; break;
                default:            Rw= -1; /*Don't process the item*/
               } /*switch*/

             if(Rw>=0)
                if(Rule1->Seq->InfSign=='|' && EIt)
                  {ERl= TRUE; ContSeq= FALSE;}
                else if(Rule1->Seq->InfSign!='|' && !EIt)
                   ERl= ContSeq= FALSE;
             dbg("ERl=%d, ContSeq=%d",(int)ERl,(int)ContSeq);
            } /*for(Items...)*/
         }    /*if(!Rule1->Seq) ERl= TRUE; / else*/

       Rt|= ERl;
       if(Rt) ProcNT=FALSE;
       dbg("ProcNT=%d, Rt=%d",(int)ProcNT,(int)Rt);

      } /*if(ProcNT)*/
    *Rules= (*Rules)->Tail;
   } /*while(Rules && Rules...==CurrNT...)*/
 if(AssNT)
   {CurrNT->Head->Mark &= (unsigned) ~GRAM_INPROC;
    CurrNT->Head->Mark |= GRAM_READY | (GRAM_CANBE * Rt);
   }
 MSG_END();
 dbg("Rt=%d",(int)Rt);
 return Rt;
} /*gram_anlnte*/


/*===gram_elmcmp1===(ii)==============================================*/
int gram_elmcmp1(gram_elm *Obj1, gram_elm *Obj2)
{int Rt;
 char *Name1, *Name2;
 ASSERT(Obj1, ABBRUCH, EC_NullPointer,
        "gram_elmcmp1: Parameter Obj1=NULL");
 ASSERT(Obj2, ABBRUCH, EC_NullPointer,
        "gram_elmcmp1: Parameter Obj2=NULL");
 ASSERT(Name1=Obj1->Name, ABBRUCH, EC_IllegalArgument,
        "gram_elmcmp1: Parameter Obj1->Name=NULL");
 ASSERT(Name2=Obj2->Name, ABBRUCH, EC_IllegalArgument,
        "gram_elmcmp1: Parameter Obj2->Name=NULL");
 if(!(Rt=Obj1->Type-Obj2->Type))
    Rt=strcmp(Name1, Name2);
 return Rt;
} /*gram_elmcmp1*/

/*===gram_lnkcmp0===(iiii)============================================*/
int gram_lnkcmp0(gram_elm *UsObj1, gram_elm *UsObj2,
                 unsigned UsLevel, void *UsInfo,
                 ts_extlink *GrLink)
{int Rt;
 gram_elm *GrObj2;
 if(!(Rt=gram_elmcmp1(UsObj1,GrLink->Obj1)))
   {GrObj2=GrLink->Obj2;
    Rt=    GrObj2->Type!=GRAM_TERM
        && GrObj2->Type!=GRAM_STDACT
        && GrObj2->Type!=GRAM_USRACT
        && GrObj2->Type!=GRAM_EXTNT;                 /*10.10.2004:INS*/
   }
 DBG_D1(gram_lnkcmp0:%d,Rt);
 return Rt;
} /*gram_lnkcmp0*/

/*===gram_lnkcmp2===(iiiii)===========================================*/
int gram_lnkcmp2(gram_elm *UsObj1, gram_elm *UsObj2,
                 unsigned UsLevel, void *UsInfo,
                 ts_extlink *GrLink)
{int Rt;
 Rt=   gram_elmcmp1(UsObj1, GrLink->Obj1)
    || gram_elmcmp1(UsObj2, GrLink->Obj2);
 DBG_D1(gram_lnkcmp2:%d,Rt);
 return Rt;
} /*gram_lnkcmp2*/

/*===gram_anl1===(im)=== Berechnet FIRST()-Mengen ====================*/
static void gram_anl1(tp_gram Gram, tp_graf Graf)
{bool        ContSeq;
 unsigned    Alt;
 gram_rules *CurrNT;
 bool        EIt;
 gram_item1 *Item1;
 gram_items *Items;
 gram_elm   *Obj1, *Obj2;
 char       *Prev=NULL, *Left, *Right;
 tp_pvar     PVar;
 gram_rules *Rules;
 gram_rule1 *Rule1;
 MSG_DCL("gram_anl1");

 for(Rules= Gram->Rules;Rules; Rules= Rules->Tail)
   {
    ContSeq= TRUE;
    Rule1=Rules->Head;
    Left= PVAR_GETNAME(Rule1->PVar);
    if(Left!=Prev) Alt=1;

    if(Rule1->Seq && (Rule1->Seq->QNT || Rule1->Seq->QT))
      {
       Obj1=gram_creelm(GRAM_NONTERM,Left);

       for(Items=Rule1->Seq->Items;
           Items && ContSeq;
           Items=Items->Tail)
         {Item1= Items->Head;
          EIt= !!strchr("?*",Item1->SuffSign);
          Obj2=NULL;

          switch(Item1->Type)
            {
             case GRAM_EMPTY:   EIt=TRUE; break;
             case GRAM_NONTERM:
                PVar= Item1->Term.NonTerminal->PVar;
                Right= PVAR_GETNAME(PVar);

                if(   !EIt
                   && !(Item1->Term.NonTerminal->Mark & GRAM_EXTERN))
                  {CurrNT=(gram_rules *)LST_FIND(Gram->Rules,Right,
                                                 gram_rulenamecmp);
                   EIt= CurrNT->Head->Mark & GRAM_CANBE;
                  }
                Obj2=gram_creelm(  Item1->Term.NonTerminal->Mark
                                 & GRAM_EXTERN?       /*10.10.2004:UPD*/
                                 GRAM_EXTNT: GRAM_NONTERM,
                                 Right);
                break;
             case GRAM_TERM:
                Obj2=gram_creelm(GRAM_TERM,Item1->Term.Terminal);
                break;
             case GRAM_STDACT:
                Obj2=gram_creelm(GRAM_STDACT,
                                stdactions[Item1->Term.StdAction].Name);
            } /*switch*/
          if(Obj2)
            {graf_connect(Graf, Obj1, Obj2,
                          GRAF_DUPL,(void *)Alt,(tp_fcmp)gram_elmcmp1);
                         /*gram_elmcmp1 does not regard Alt*/
             dbg("Connected: %s(%u)->%s",Obj1->Name, Alt, Obj2->Name);
            }
          if(Rule1->Seq->InfSign=='|' || Rule1->Seq->InfSign==';')
             Alt++;
          else
             if(   Rule1->Seq->InfSign==','
                && !EIt
                && Item1->Type!=GRAM_USRACT)
                ContSeq= FALSE;
         } /*for(Items...)*/
       Alt++;
      }    /*if(Rule1->Seq->QNT && Rule1->Seq->QT)*/
   }       /*for(Rules= Gram->Rules;Rules;*Rules= (*Rules)->Tail)*/
 if(dbg("Just created graph:"))
    graf_fput(stdout, Graf, (tp_fput) gram_ptelm, gram_ptalt,
              NULL, NULL);
 graf_tlock(Graf);
 if(dbg("T-locked graph:"))
    graf_fput(stdout, Graf, (tp_fput) gram_ptelm, gram_ptalt,
              NULL, NULL);
 MSG_END();
} /*gram_anl1*/


/*===gram_testllk===(i)===============================================*/
static unsigned gram_testllk(tp_graf Graf)
{
 unsigned    Rt=0; /*Anzahl der Abweichungen*/
 unsigned    Alt;
 ts_extlink *Alt1R;
 tl_extlink *AltsR;
 char        Alt1S[6];
 char       *AltsS=NULL;
 void       *Info;
 unsigned    Level;
 unsigned    LQ;
 tp_list    *Objs, *Objw;
 gram_elm   *Obj1,*Obj2, *Rel1;
 tp_list    *Rels;
 MSG_DCL("gram_testllk");

/*Preparation*/
 Objs=graf_objs(Graf);

/*Test1: autorecursion*/
 for(Objw=Objs; Objw; Objw=Objw->Tail)
   {Obj1=Objw->Head;
    if(   Obj1->Type==GRAM_NONTERM
       && graf_connection(Graf, Obj1, Obj1, gram_elmcmp1,&Level,&Info))
      {Alt=(unsigned)Info;
       ASSERT(0,WARNUNG,105451,
              qv_msg("Linksrekursive Referenz. NT=%s, Level=%u, Alt=%u",
                     Obj1->Name, Level, Alt));
       Rt++;
      }
   } /*for Objw=Objs; Objw; Objw=Objw->Tail)*/

 if(!Rt)
   {
    /*Test2: terminal or AS*/
    for(Objw=Objs; Objw; Objw=Objw->Tail)
      {Obj1=Objw->Head;
       if(   Obj1->Type==GRAM_NONTERM
          && !LST_FIND(env_.ExtNTs,Obj1->Name,strcmpi)
          && !graf_connections(Graf, gram_lnkcmp0, Obj1, NULL, 0, Info,
                               NULL))
         {ASSERT(0,WARNUNG,105452,
                 qv_msg("Keine Terminalverbindung. NT=%s", Obj1->Name));
          Rt++;
         }
      } /*for Objw=Objs; Objw; Objw=Objw->Tail)*/

   /*Test3: ambiguities*/
    for(Objw=Objs; Objw; Objw=Objw->Tail)
      {Obj1=Objw->Head;
       Rels= graf_relatives(Graf, Obj1, 0, (tp_fcmp)gram_elmcmp1);

       while(Rel1=LST_POP(&Rels))
          if(LQ=graf_connections(Graf, (tp_grafcmp)gram_lnkcmp2,
                                 Obj1, Rel1, 0, NULL, &AltsR))
            {while(Alt1R=LST_POP(&AltsR))
               {sprintf(Alt1S, "%u", (unsigned)Alt1R->Info);
                STR_GROW(&AltsS, Alt1S);
                free(Alt1R);
               }
             ASSERT(0, WARNUNG, 105453,
                 qv_msg("Mehrdeutige Verbindung. %s->(Type %u) '%s'\n"
                        "Regeln%s",
                        Obj1->Name,Obj2->Type,Obj2->Name, AltsS));
             Rt++;
            }
      } /*for(Objw=Objs; Objw; Objw=Objw->Tail)*/
   } /*if(!Rt)*/

 LST_DESTROY(&Objs);
 DBG_D1(%u,Rt)
 MSG_END();
 return Rt;
} /*gram_testllk*/


/***** #8 PARSERGENERATOR *********/

/*==gram_gener===(i)=== Generiert Ausgabecode ========================*/
int gram_gener(tp_gram Gram)
{int      Rt= 0;
 char     GenTFs[G_OBJQ][2][2][PATH_MAX]; /*Temporaere Ausgabedateien*/
                           /*Objekt; 0=.h,1=.c; 0=Teil 1,1=Teil 2*/
 unsigned QFls= 0;

 MSG_DCL("gram_gener");

 gram_plausid(Gram);
 dbg("Gram->Processed=%d,CONSISTENT=%d,NORMALIZED=%d",
     Gram->Processed,
     !!(Gram->Status & GRAM_CONSISTENT),
     !!(Gram->Status & GRAM_NORMALIZED));

 if(Gram->Status & GRAM_SEM_OK && Gram->Status & GRAM_CONSISTENT)
   {
    dbg("gram_convert...");
    gram_convert(Gram);
    gram_anllk(Gram);
    if(dbg("Aft. evttl. gram_anllk")) gram_printf(stdout,Gram);
    Gram->Processed= GRAM_GENER;
    ASSERT(Gram->Rules, AUSSTEUERN, 105429,
           qv_msg("Die angegebene Grammatik ist leer. "
                  "Generation abgesetzt"));
    if(   Gram->Status & GRAM_NORMALIZED
       && (Gram->Status & GRAM_LLK || !env_.LLk))
      {
       dbg("gram_fopen...");
       gram_fopen(GenTFs, &QFls);
       if(QFls)
         {TRY
             dbg("gram_findpublic...");
             gram_findpublic(Gram->Rules);
             dbg("gram_settfns...");
             gram_settfns(Gram->Rules);
             dbg("gram_genprl...");
             gram_genprl();
             dbg("gram_genforw...");
             gram_genforw(Gram->Rules, QFls);
             dbg("gram_genrules...");
             gram_genrules(Gram->Rules, QFls);
             dbg("gram_genepl...");
             gram_genepl();
             Gram->Status |= GRAM_GENERATED;
          FINALLY
             dbg("gram_fclose...");
             gram_fclose();
             err_escape(err_rc(),err_ec(),NULL);
          END
#ifdef _MSDOS
          dbg("gram_fpaste...");
          gram_fpaste(GenTFs);
#endif
         } /*if(QFls)*/
      } /*if(NORMALIZED && LLK)*/
   } /*if(SEM_OK && CONSISTENT)*/
 Rt= err_getlev();
 MSG_ENDD();
 return Rt;
} /*gram_gener*/


/*===gram_findpublic===(i)=== Findet 'public'-NTs ====================*/
static unsigned gram_findpublic(gram_rules *Rules)
{unsigned    Rt=0, Qu=0;
 char       *Name;
 gram_rules *Rlws;
 gram_rule1 *Rule1;
 MSG_DCL("gram_findpublic");

 if(dbg("FULL NT LIST at the beginning:"))
   {LST_FPUT(stdout,Rules,gram_ptnt,NULL);
    qv_printf("\n");
    dbg("FULL PUBLIC LIST at the beginning:");
    LST_FPUT(stdout,env_.Pub,fprintf," '%s' ");
    qv_printf("\n");
   }
 for(Rlws=Rules;Rlws;Rlws=Rlws->Tail)
    if(Rlws->Head->Mark & GRAM_PUBLIC)
      {Rt++;
       Name = PVAR_GETNAME(Rlws->Head->PVar);
      }
 if(!Rt)
    for(Rlws=Rules;Rlws;Rlws=Rlws->Tail)
      {Rule1= Rlws->Head;
       if(!pvar_used(Rule1->PVar,NULL,NULL,NULL))
         {Rule1->Mark |=GRAM_PUBLIC;
          Name = PVAR_GETNAME(Rule1->PVar);
          dbg("Unreferenced NT %s marked PUBLIC",Name);
          Qu++;
         } /*if(!pvar_used(Rule1->PVar,NULL,NULL))*/
      } /*for(Rules)*/
 dbg("%u unused objects marked public",Qu);
 Rt += Qu;
 MSG_ENDD();
 return Rt;
} /*gram_findpublic*/

/*===gram_fopen===(oo)================================================*/
void gram_fopen(char GenTFs[][2][2][PATH_MAX], unsigned *QFls)
{char    Fmt[32]=
#ifdef _MSDOS
                 "_TMP%.2s%c%d";
#else
                 "DD:TEMP%.2s%c%d";
#endif
 int      Kont= -1;
 int      NOp, NOb, NExt, NPart;

 MSG_DCL("gram_fopen");

 for(NOb=0; NOb<G_OBJQ; NOb++)
    if(env_.GenNrs[NOb]==NOb)
      {dbg("Opening own file for NOb=%d", NOb);
       for(NExt=0; NExt<2; NExt++)
          for(NPart=0; NPart<2; NPart++)
            {sprintf(GenTFs[NOb][NExt][NPart],
	                    Fmt, genobs[NOb],extpath[NExt][1],NPart);
#ifndef _MSDOS
             strupr(GenTFs[NOb][NExt][NPart]);
#endif
             DBG_D4(%d, NOb, %d, NExt, %d, NPart, %s,
	            GenTFs[NOb][NExt][NPart]);
             ASSERT(env_.GenFFs[NOb][NExt][NPart]=
                    fopen(GenTFs[NOb][NExt][NPart],"w"),
                    ABBRUCH,EC_FileError,
                    qv_msg("Kann nicht '%s' oeffnen",
		           GenTFs[NOb][NExt][NPart]));
            }
       *QFls+=1;
      } /*for(NOb) if(GenNrs[NOb]==NOb)*/

 while(Kont)
   {Kont= 0;
    for(NOb=0; NOb<G_OBJQ; NOb++) if(!env_.GenFFs[NOb][0][0])
      {NOp= env_.GenNrs[NOb];
       if(NOp!=NOb && NOp>=0)
         {dbg("Assigning file pointer: NOb=%d <== NOp=%d", NOb, NOp);
          for(NExt=0; NExt<2; NExt++)
             for(NPart=0; NPart<2; NPart++)
               {if(env_.GenFFs[NOb][NExt][NPart]=
                   env_.GenFFs[NOp][NExt][NPart])
                   Kont= 1;
                DBG_D3(%d, NExt, %d, NPart,
                       %ld, env_.GenFFs[NOb][NExt][NPart]);
               } /*for(NPart=0; NPart<2; NPart++)*/
         } /*if(NOp!=NOb && NOp>=0)*/
      } /*for(NOb=0; NOb<G_OBJQ; NOb++)*/
   } /*while(Kont)*/
 MSG_ENDD();
} /*gram_fopen*/

/*===gram_fclose======================================================*/
void gram_fclose()
{
 int      NOb, NExt, NPart;
 MSG_DCL("gram_fclose");
 for(NOb=0; NOb<G_OBJQ; NOb++)
    if(env_.GenNrs[NOb]==NOb)
       for(NExt=0; NExt<2; NExt++)
          for(NPart=0; NPart<2; NPart++)
             fclose(env_.GenFFs[NOb][NExt][NPart]);
 MSG_ENDD();
} /*gram_close*/

#ifdef _MSDOS
/*===gram_fpaste===(i)================================================*/
void gram_fpaste(char GenTFs[G_OBJQ][2][2][PATH_MAX])
{
 char     Cmd[512];
 char     FlOut[512];
 int      NOb, NExt;
 MSG_DCL("gram_fpaste");
 for(NOb=0; NOb<G_OBJQ; NOb++)
   {DBG_D2(%d, NOb, %d, env_.GenNrs[NOb]);
    if(env_.GenNrs[NOb]==NOb)
       for(NExt=0; NExt<2; NExt++)
         {sprintf(FlOut, "%s%s%s%s",
                  env_.Dir[NExt],
                     env_.Dir[NExt] && *env_.Dir[NExt]
                  && LASTCHAR(env_.Dir[NExt])!='\\'?
                     "\\": "",
                  env_.GenMods[NOb][NExt],
                  NExt? "": ".c");
          sprintf(Cmd, "copy %s + %s %s",
                  GenTFs[NOb][NExt][G_PART1],
                  GenTFs[NOb][NExt][G_PART2],
                  FlOut);
          dbg("Cmd='%s'",Cmd);
          qv_printp("Generation v. %s", FlOut);
          ASSERT(!system(Cmd), RC_SEVERR, 105435,
                 qv_msg("Kann nicht '%s' ausfuehren\n%s",
                        Cmd,strerror(errno)));
         } /*for(NExt)*/
   } /*for(NOb)*/
 MSG_ENDD();
} /*gram_fpaste*/
#endif

/*==gram_genprl==== Schreibt Prolog des Headerfiles===================*/
static void gram_genprl()
{FILE       *FFH11, *FFH12, *FFC11;
 char        FlIncl[PATH_MAX]="";
 tp_strings *Fsw;
 char       *NC1, *NH1, *NH2;
 int         NOb, NOh;
 char       *Sw;
 MSG_DCL("gram_genprl");

 /*Name des Files, wo alle Typdefinitionen enthalten sind*/
 /*Es soll mit include in alle anderen Kopfdateien eingeschlossen sein*/
 for(NOh=0; NOh<G_OBJQ;)
   if(env_.GenNrs[NOh]==NOh)
     {sprintf(FlIncl, "%s%s%s",
              env_.Dir[G_EXT_H],
                 env_.Dir[G_EXT_H] && *env_.Dir[G_EXT_H]
              && LASTCHAR(env_.Dir[G_EXT_H])!='\\'?
                 "\\": "",
              env_.GenMods[NOh][G_EXT_H]);
      break;
     }
   else NOh++;

 ASSERT(NOh<G_OBJQ, ABBRUCH, EC_InternalError,
        "Kein Include-File zum Schreiben v. "
        "Forwarddeklarationen");

 /*Prolog schreiben*/
 for(NOb=0; NOb<G_OBJQ; NOb++) if(env_.GenNrs[NOb]==NOb)
   {FFH11= env_.GenFFs[NOb][G_EXT_H1][G_PART1];
    FFH12= env_.GenFFs[NOb][G_EXT_H1][G_PART2];
    FFC11= env_.GenFFs[NOb][G_EXT_C][G_PART1];
    NC1= env_.GenMods[NOb][G_EXT_C];
    NH1= env_.GenMods[NOb][G_EXT_H1];
    NH2= env_.GenMods[NOb][G_EXT_H2];

    fprintf(FFH11,"/*==%s",NH1);
    fprintf(FFH11,"%.*s*/\n",
            MAXOUTLINE-6-MIN(65,strlen(NH1)),sectsep);
    fprintf(FFH11,"/*%.68s*/\n\n",sectsep);
    fprintf(FFH11,"#ifndef %s_H\n",env_.GenMods[NOb][G_EXT_H1]);
    fprintf(FFH11,"#define %s_H\n\n",NH1);

    if(NOb!=NOh && !LST_FIND(env_.InclFiles,FlIncl,stricmp))
       fprintf(FFH11,"#include \"%s\"\n",FlIncl);

    for(Fsw=env_.InclFiles; Fsw; Fsw=Fsw->Tail)
       fprintf(FFH11,"#include \"%s\"\n",Fsw->Head);
    fprintf(FFH11,"\n");

    fprintf(FFH12,"#if !defined(MTP_FETCH)"
                  " && (!defined(%s_H) || defined(_MSC_RUN))\n",
                  env_.GenMods[NOb][G_EXT_H2]);
    fprintf(FFH12,"void *%s(void *Env,const char *Mode);\n",NC1);
    fprintf(FFH12,"#else\n\n");
    fprintf(FFH12,"#ifndef %s_C\n",NC1);
    fprintf(FFH12,"typedef void *(*%s_)(int);\n",NC1);
    fprintf(FFH12,"%s_ %s;\n",NC1,NC1);
    fprintf(FFH12,"#endif\n\n");
    fprintf(FFH12,"#endif\n\n");
    fprintf(FFH12,"#if   !defined(%s_H) && !defined(DCL_FN)",
                  NH2);
    fprintf(FFH12," && !defined(%s_NOF)\\\n",NC1);
    fprintf(FFH12,"   || defined(_MSC_RUN)\n");
    fprintf(FFH12,"#define DCL_FN(TpRet,FNm,Parm) TpRet FNm Parm;\n");
    fprintf(FFH12,"#endif\n\n");
    fprintf(FFH12,"#endif\n\n");
    fprintf(FFH12,"#if defined(DCL_FN)\n\n");
    fprintf(FFH12,
            "DCL_FN(void *, %s_open,   (void *Env,const char *Mode))\n",
            NC1);
    fprintf(FFC11,"/*===%s%.*s*/\n",NC1,
                  MAXOUTLINE-7-strlen(NC1),sectsep);
    fprintf(FFC11,"/*%.68s*/\n\n",sectsep);
    fprintf(FFC11,"#pragma langlvl(extended)\n");
    fprintf(FFC11,"#pragma linkage(%s, fetchable)\n\n",NC1);

    fprintf(FFC11,"#define %s_C\n",NC1);
    fprintf(FFC11,"static const char *Modul= \"%s\";\n\n",NC1);

    fprintf(FFH11,"#include \"XAG2002\"\n");
    fprintf(FFH11,"#include \"XAG2004\"\n");
    fprintf(FFH11,"#include \"XAG1016\"\n");
    fprintf(FFH11,"#include \"XAG2032\"\n");
    fprintf(FFH11,"#include \"XAG2050\"\n");
    fprintf(FFH11,"#include \"XAG2052\"\n\n");

    fprintf(FFC11,"#include \"%s\"\n\n",NH1);
    fprintf(FFC11,"#define MID          130107");
    for(Sw=NC1+3;*Sw && isdigit(*Sw);Sw++) fputc(*Sw,FFC11);
    fputs("\n\n",FFC11);
   } /*for(NOb)*/
 MSG_END();
} /*gram_genprl*/

/*==gram_settfns===(m)==================================================
 * Setzt Feldnamen, Datentypen und Schalter aller Regeln und Items
 * Das folgende wird befuellt bzw. geaendert:
 *  f. die Regeln: TpBasic,TpRef,TpStdBasic,TpStdRef,CreFun,
 *                 die Schalter GRAM_USED_OPT,GRAM_PUBLIC,
 *                              GRAM_STRUCT,GRAM_UNION
 *  f. Items:      Field, Tp0Ref, TpPRef
 =====================================================================*/
static void gram_settfns(gram_rules *Rules)
{
 gram_items *Items;
 gram_item1 *Item1;
 gram_rules *Rlws;
 gram_rule1 *Rule1;
 MSG_DCL("gram_settfns");

 for(Rlws=Rules; Rlws; Rlws=Rlws->Tail)
   {Rule1= Rlws->Head;

         /*---- GRAM_USED_OPT setzen ----*/
    if(   Rule1->Seq
       && Rule1->Seq->InfSign!='|'
       && Rule1->Seq->InfSign!=';')
       for(Items=Rule1->Seq->Items;Items;Items=Items->Tail)
         {
          Item1=Items->Head;
          if(Item1->Type==GRAM_NONTERM && Item1->SuffSign=='?')
            {dbg("Setting GRAM_USED_OPT to '%s'",
                 PVAR_GETNAME(Item1->Term.NonTerminal->PVar));
             Item1->Term.NonTerminal->Mark |= GRAM_USED_OPT;
            }
         } /*for(Items)*/

         /*---- GRAM_READY & GRAM_INPROC absetzen ----*/
    Rlws->Head->Mark &= ~(GRAM_READY | GRAM_INPROC);
   } /*for(Rlws)*/

         /*---- Andere Parameter vervollstaendigen ----*/
 for(Rlws=Rules; Rlws; Rlws=Rlws->Tail)
   {Rule1= Rlws->Head;
    ASSERT(!(Rule1->Mark & GRAM_INPROC), ABBRUCH, EC_InternalError,
           qv_msg("Versuch, halbfertige Regel neu zu bearbeiten: %s",
                  PVAR_GETNAME(Rule1->PVar)));
    if(!(Rule1->Mark & GRAM_READY))
       gram_settfn1(Rules, Rule1);
   } /*for(Rlws)*/
 MSG_ENDD();
} /*gram_settfns*/

/*==gram_settfn1===(mm)=== gram_settfnns f. einzelne Regel ===========*/
static void gram_settfn1(gram_rules *Rules, gram_rule1 *Rule1)
{int         ActN, ArtNr=0;
 bool        CrF;
 char       *Field1;
 tp_strings *Fields;
 char        InfSign;
 gram_item1 *Item1, *ItemNE;  /*ItemNE = 1. nicht leerer Typ*/
 gram_items *Items;
 unsigned    ItemN;
 size_t      LFd;
 char       *NmR, *NmF;
 int         NOb;
 bool        Process;
 char        SDbg[80];
 char       *Sw;
 int         ScTp, TNr;
 MSG_DCL("gram_settfn1");

 /*dbg("NT:NameU='%s',READY=%d,INPROC=%d",
  *   NmR, Rule1->Mark & GRAM_READY, Rule1->Mark & GRAM_INPROC);*/
 if(!(Rule1->Mark & GRAM_READY))
   {
    NmF= Rule1->NameF;
    if(Rule1->Mark & (GRAM_INPROC | GRAM_EXTERN))
      {sprintf(Rule1->TpBasic, "struct st_%s ", NmF);
       sprintf(Rule1->TpRef, "tp_%s ", NmF);
       Rule1->TpStdRef= GRAM_ACT_NONSTD;
      }
    else
      {  /*---- GRAM_PUBLIC setzen ----*/
       Rule1->Mark|= GRAM_INPROC;
       NmR = PVAR_GETNAME(Rule1->PVar);
       dbg("Processing NT:NameU='%s',NameF='%s',NameV='%s'",
           NmR, STR_NOT0(NmF),STR_NOT0(Rule1->NameV));
       dbg("EXTERN=%u,USED:LIST=%u,ANYOPT=%u,OPT=%u",
           !!(Rule1->Mark & GRAM_EXTERN),
           !!(Rule1->Mark & GRAM_USED_LIST),
           !!(Rule1->Mark & GRAM_USED_ANYOPT),
           !!(Rule1->Mark & GRAM_USED_OPT));
       if(   env_.Pub
          && (   !strcmp(env_.Pub->Head,"*")
              || LST_FIND(env_.Pub,NmR,stricmp)))
         {Rule1->Mark |= GRAM_PUBLIC;
          dbg("NT %s marked as PUBLIC",NmR);
         }

       if(Rule1->Seq)
         {
          dbg("InfSign=%c,QNT=%u,QT=%u",
              Rule1->Seq->InfSign, Rule1->Seq->QNT, Rule1->Seq->QT);
          InfSign= Rule1->Seq->InfSign;

         /*---- Interne Feldernamen setzen ----*/
          Fields= NULL;
          LST_PUSH(&Fields, PVAR_GETNAME(Rule1->PVar));
          for(Items=Rule1->Seq->Items, ItemN=1;
              Items;
              Items=Items->Tail, ItemN++)
            {Item1=Items->Head;
             Process= TRUE;

              /*-- Feldnamen --*/
             switch(Item1->Type)
               {case GRAM_NONTERM:
                   Field1= Item1->Term.NonTerminal->NameV;
                   break;
                case GRAM_TERM:
                   switch(Item1->SuffSign)
                     {case '?': Field1= "_Exists"; break;
                      case '+':
                      case '*': Field1= "_Count"; break;
                      default:  Process= FALSE;
                     }
                   break;
                case GRAM_STDACT:
                   Field1=
                      strdup(stdactions[Item1->Term.StdAction].Name);
                   if(Sw=strchr(Field1,'_')) *Sw=0x0;
                   *Field1= toupper(*Field1);
                   break;
                case GRAM_SEQ:
                   ASSERT(0,ABBRUCH,EC_InternalError,
                          qv_msg("Unterfolge nicht ersetzt in"
                                 " der Regel '%s'",
                                 NmR));
                default: Process= FALSE;
               } /*switch(Item1->Type)*/

            /* Namensduplizierung vermeiden*/
             if(Process)
               {
                if(LST_FIND(Fields,Field1,stricmp))
                  {LFd= strlen(Field1);
                   strcpy(Item1->Field, Field1);
                   do{sprintf(Item1->Field+LFd,"%02d",++ArtNr);
                     } while(   ArtNr<100
                             && LST_FIND(Fields,Item1->Field,stricmp));
                   ASSERT(ArtNr<100,AUSSTEUERN,105443,
                          qv_msg("Kann nicht mehrfache Deklaration"
                                 " eines Strukturfeldes vermeiden."
                                 " Das Element '%s' ist >=100mal"
                                 " in einer Regel referenziert",
                                 Field1));
                   dbg("Field name changed to '%s'", Item1->Field);
                  } /*if(LST_FIND(Fields,Field1,stricmp))*/
                else strcpy(Item1->Field, Field1);
                if(Item1->Type==GRAM_STDACT) free(Field1);
                LST_PUSH(&Fields, Item1->Field);
               } /*if(Process)*/
            } /*for(Items)*/
          LST_DESTROY(&Fields);

         /*---- Datentypen setzen ----*/
          Rule1->QNEmpty= 0;
          for(Items=Rule1->Seq->Items, ItemN=1;
              Items;
              Items=Items->Tail, ItemN++)
            {Item1=Items->Head;
             dbg("Setting type of Item='%s', Type=%d, SuffSign='%c'",
                 gram_itstr(Item1),Item1->Type,Item1->SuffSign);
             if(gram_settpit(Rules, NmR, InfSign, ItemN, Item1))
               {ItemNE= Item1;
                Rule1->QNEmpty+= 1;
               }
            } /*for(Items)*/
          DBG_D1(%u, Rule1->QNEmpty);

         /*---- Eigenen Scalartyp setzen ----*/
          switch(Rule1->QNEmpty)
            {case 0:
                if(InfSign=='|')
                  {strcpy(Rule1->TpBasic, "unsigned");
                   strcpy(Rule1->TpRef, Rule1->TpBasic);
                   Rule1->TpStdBasic= Rule1->TpStdRef=
                      GRAM_ACT_UNSIGNED;
                  }
                break;
             case 1:
                if(InfSign!='|')
                  {strcpy(Rule1->TpBasic, ItemNE->Tp0Ref);
                   strcpy(Rule1->TpRef, ItemNE->TpPRef);
                   ScTp= gram_sctpit(TRUE, ItemNE);
                   switch(ItemNE->Type)
                     {case GRAM_STDACT:
                         Rule1->TpStdBasic= ItemNE->Term.StdAction;
                         Rule1->TpStdRef=
                               ItemNE->SuffSign==' '
                            || ScTp && ItemNE->SuffSign=='?'
                            ? ItemNE->Term.StdAction : GRAM_ACT_NONSTD;
                         break;
                      case GRAM_TERM:
                         ASSERT(ItemNE->SuffSign!=' ',
                                ABBRUCH, EC_InternalError,
                                qv_msg("Regel %s. Nackter Terminal"
                                       "  als nicht leeres Element",
                                       NmF));
                         Rule1->TpStdBasic= Rule1->TpStdRef=
                            GRAM_ACT_UNSIGNED;
                         break;
                      case GRAM_NONTERM:
                         if(   strchr("+*", ItemNE->SuffSign)
                            ||    ItemNE->SuffSign=='?'
                               && (TNr=
                                    ItemNE->Term.NonTerminal->TpStdBasic
                                   )<GRAM_ACT_NONSTD)
                           {Rule1->TpStdBasic=
                               ItemNE->Term.NonTerminal->TpStdRef;
                            Rule1->TpStdRef= GRAM_ACT_NONSTD;
                           }
                         else
                           {Rule1->TpStdBasic=
                               ItemNE->Term.NonTerminal->TpStdBasic;
                            Rule1->TpStdRef=
                               ItemNE->Term.NonTerminal->TpStdRef;
                           }
                         break;
                      default:
                         ASSERT(0, ABBRUCH, EC_InternalError,
                                qv_msg("Regel %s: Item1->Type==%d bei"
                                       " nicht leerem Element",
                                       NmF, Item1->Type));
                     } /*switch*/
                   break;
                  } /*if(InfSign!='|')*/
             default:
                Rule1->TpStdBasic= Rule1->TpStdRef= GRAM_ACT_NONSTD;
                sprintf(Rule1->TpBasic, "struct st_%s", NmF);
                sprintf(Rule1->TpRef, "tp_%s", NmF);
            } /*switch*/
         } /*if(Seq)*/
      } /*if(Inproc | PUBLIC)/else*/

       /*---- Eigenen Listentyp setzen ----*/
    DBG_D3('%s', NmF, '%s', Rule1->TpBasic, '%s', Rule1->TpRef);
    DBG_D3('%s', NmF, %d, Rule1->TpStdBasic, %d, Rule1->TpStdRef);
    gram_settpl(Rule1->TpRef, Rule1->TpLRef);
    DBG_D3('%s', NmF, '%s', Rule1->TpRef, '%s', Rule1->TpLRef);

    if(Rule1->Seq)
      {
       DBG_D1(%u, Rule1->Seq->QNT);
         /*---- Struct- & Union- Flags setzen ----*/
       if(Rule1->QNEmpty>1 || Rule1->QNEmpty>0 && InfSign=='|')
          Rule1->Mark |= GRAM_STRUCT;
       if(Rule1->QNEmpty>1 && InfSign=='|')  Rule1->Mark |= GRAM_UNION;
       dbg("StruOp=%d, UniOp=%d",
           !!(Rule1->Mark & GRAM_STRUCT), !!(Rule1->Mark & GRAM_UNION));

         /*---- CreFun-Flags setzen ----*/
       for(NOb=0; NOb<G_OBJQ; NOb++)
          if(env_.GenNrs[NOb]>=0)
            {CrF= FALSE;
             switch(NOb)
               {case G_PA:     /*0.PARSE*/
                case G_PR:     /*2.PRINT*/
                   CrF= TRUE;
                   break;
                case G_WR:     /*1.WRITE*/
                case G_RD:     /*4.READ*/
                   CrF=    Rule1->TpRef[0]
                        && Rule1->TpStdRef>=GRAM_ACT_NONSTD
                        && Rule1->Seq->QNT;
                   break;
                case G_CL:     /*3.CLEAR*/
                   CrF=    Rule1->TpRef[0]
                        && (   !(ActN=Rule1->TpStdRef)
                            || Rule1->TpStdRef>=GRAM_ACT_NONSTD
                            || stdactions[ActN].TypeT[3]=='P'
                           )
                        && Rule1->Seq->QNT;
                   break;
                case G_IM:     /*5.IMPL*/
                   CrF= !!(Rule1->Mark & GRAM_STRUCT);
                   break;
                default:
                   ASSERT(0, ABBRUCH, EC_InternalError,
                          qv_msg("NOb=%d",NOb));
               } /*switch(NOb)*/
             Rule1->CreFun[G_OBJQ]|=(Rule1->CreFun[NOb]=CrF);
            } /*if(GenNrs[]>=0) for(NOb)*/
       if(dbg_isto(NULL, NULL))
         {strcpy(SDbg, "CreFun=");
          for(NOb=0; NOb<=G_OBJQ; NOb++)
             sprintf(SDbg+strlen(SDbg), " %d", Rule1->CreFun[NOb]);
          dbg(SDbg);
         }
      } /*if(Seq)*/
    Rule1->Mark &= ~GRAM_INPROC;
    Rule1->Mark |= GRAM_READY;
   } /*if(!!READY)*/
 MSG_ENDD();
} /*gram_settfn1*/

/*==gram_settpit===(iiiii)==============================================
 * Generiert Datentyp eines Elements
 * Beschreibung: Screibt in Item1->TpPRef und Tp0Ref
 * Return     1=non-empty
 =====================================================================*/
static bool gram_settpit(gram_rules *Rules, char *RlName,
                         char InfSign, unsigned ItNr, gram_item1 *Item1)
{char        *FType0, *FType1;
 char        *NmF= NULL;
 bool         Process=TRUE;
 int          StdTn= 0;
 MSG_DCL("gram_settpit");

 ASSERT(Item1,ABBRUCH,EC_InternalError,
        qv_msg("Paramater Item1 == NULL"));
 ASSERT(RlName,ABBRUCH,EC_InternalError,
        qv_msg("Paramater RlName == NULL"));
 ASSERT(RlName,ABBRUCH,EC_InternalError,
        qv_msg("Paramater FType0 == NULL"));

 dbg("Rule='%s' Item='%s', SuffSign='%c'",
     RlName,gram_itstr(Item1), Item1->SuffSign);

 StdTn= 0;
 FType0= Item1->Tp0Ref;
 FType1= Item1->TpPRef;

 switch(Item1->Type)
   {case GRAM_NONTERM:
       StdTn= GRAM_ACT_NONSTD;
       NmF= Item1->Term.NonTerminal->NameF;
       if(Item1->Term.NonTerminal->Mark & GRAM_EXTERN)
          str_concat(FType0, "tp_", NmF);
       else
         {gram_settfn1(Rules, Item1->Term.NonTerminal);
          strcpy(FType0, Item1->Term.NonTerminal->TpRef);
         }
       break;
    case GRAM_TERM:
       FType0[0]= 0x0;
       break;
    case GRAM_STDACT:
       StdTn= Item1->Term.StdAction;
       NmF= stdactions[StdTn].Name;
       strcpy(FType0, stdactions[StdTn].TypeD);
       break;
    case GRAM_SEQ:
       ASSERT(0,ABBRUCH,EC_InternalError,
              qv_msg("Unterfolge nicht ersetzt in der Regel '%s'",
                     RlName?RlName:"..."));
    default:
       Process=FALSE;
   } /*switch(Item1->Type)*/

 if(Process)
   {if(strchr("+*",Item1->SuffSign))
       gram_settpl(FType0, FType1);
    else if('?'==Item1->SuffSign && !*FType0)
       strcpy(FType1, "unsigned");
    else if(   '?'==Item1->SuffSign
            && *FType0
            && (strlen(FType0)<3 || strncmp(FType0,"tp_",3))
            && (      StdTn!=GRAM_ACT_NONSTD
                   && *stdactions[StdTn].TypeT=='N'
                ||    Item1->Type==GRAM_NONTERM
                   &&  Item1->Term.NonTerminal->TpStdBasic
                      <GRAM_ACT_NONSTD
                   && !gram_altterm(Item1)
               )
            && LASTCHAR(FType0)!='*'
           )
       str_concat(FType1, FType0, " *");
    else strcpy(FType1, FType0);
   } /*if(Rt)*/

 else *FType1=0x0;

 dbg("Rule='%s' Item='%s', FType0='%s',FType1='%s'",
     RlName,gram_itstr(Item1), FType0, FType1);

 MSG_END();
 return !!*FType1;
} /*gram_settpit*/


/*===gram_sctpit===(ii)=================================================
 * Beschreibung: Prueft, ob Datentyp des Elementes Einzeltyp
 *               (kein Zeiger) ist. Wenn ja,
 * Return:       seine Nr, sonst NULL
 *====================================================================*/
static int gram_sctpit(bool IsRef, gram_item1 *Item1)
{int Rt= 0;
 int TNr=0;
 MSG_DCL("gram_sctpit");
 ASSERT(Item1,ABBRUCH,EC_NullPointer,qv_msg("Parameter = NULL"));
 dbg("Item1=%s",gram_itstr(Item1));
 switch(Item1->Type)
   {
    case GRAM_NONTERM:
       TNr= IsRef? Item1->Term.NonTerminal->TpStdRef
                 : Item1->Term.NonTerminal->TpStdBasic;
       break;
    case GRAM_TERM:
       if(IsRef && Item1->SuffSign!=' ') TNr= GRAM_ACT_UNSIGNED;
       break;
    case GRAM_STDACT:
       if(!IsRef || Item1->SuffSign==' ') TNr= Item1->Term.StdAction;
       break;
    default:
       TNr= GRAM_ACT_NONSTD;
   }
 if(TNr!=GRAM_ACT_NONSTD && stdactions[TNr].TypeT[0]=='N')
    Rt= TNr;
 dbg("TNr=%d(NONSTD=%d),Rt=%d",TNr,GRAM_ACT_NONSTD,Rt);
 MSG_ENDD();
 return Rt;
} /*gram_sctpit*/

/*==gram_settpl===(iiio)================================================
 * Generiert Datentyp fuer einen NT mit Listensuffix
 =====================================================================*/
static void gram_settpl(char *FType0, char *FType1)
{int StpIn;

 MSG_DCL("gram_settpl");
 ASSERT(FType0, ABBRUCH, EC_InternalError, "Parameter FType0 == NULL");
 ASSERT(FType1, ABBRUCH, EC_InternalError, "Parameter FType1 == NULL");

 *FType1= 0x0;

 if(!*FType0)                        strcpy(FType1, "unsigned");
 else if(!strcmp(FType0,"char *"))   strcpy(FType1, "tp_strings *");
 else if(!strcmp(FType0,"tp_declf")) strcpy(FType1, "tp_decls *");
 else if(!strcmp(FType0,"tp_lexs *") || !strcmp(FType0,"tp_strings *"))
    strcpy(FType1, "tp_args *");
 else
   {for(StpIn=0; StpIn<QSTDACT; StpIn++)
       if(!strcmp(FType0, stdactions[StpIn].TypeD))
          sprintf(FType1, "%ss *", FType0);
    if(!*FType1)
      {sprintf(FType1, "tl_%s", FType0+(!strncmp(FType0,"tp_",3)?3:0));
       if(!strstr(FType1, " *")) strcat(FType1, " *");
      }
   }
 DBG_D2('%s', FType0, '%s', FType1);
 MSG_END();
} /*gram_settpl*/

/*==gram_genforw===(ii)=== Generiert Forward-Deklarationen============*/
static void gram_genforw(gram_rules *Rules, unsigned QFls)
{
 char        DefLst[9];
 FILE       *FFH11=NULL, *FFC11=NULL;
 FILE       *FFT, *FFU; /*Typenausgabe; Userdatentyp f. Ausgabeparam.*/
 int         NOb;
 char        TlRef[GRAM_MAXTP+1],TpRef[GRAM_MAXTP+1];
 gram_rules *Rlw;
 gram_rule1 *Rule1;
 char       *Sw;
 MSG_BEG("gram_genforw");

 for(NOb=0; NOb<G_OBJQ; NOb++)
    if(env_.GenNrs[NOb]==NOb)
      {FFH11= env_.GenFFs[NOb][G_EXT_H1][G_PART1];
       FFC11= env_.GenFFs[NOb][G_EXT_C][G_PART1];
       break;
      }
 ASSERT(FFH11 && FFC11, ABBRUCH, EC_InternalError,
        "Kein geoeffnetes File zum Wegschreiben v. "
        "Forwarddeklarationen");

 if(FFU=env_.GenFFs[G_IM][G_EXT_H1][G_PART1])
    fputs("typedef          void *_usrout_t;\n\n", FFU);

 for(Rlw=Rules;Rlw;Rlw=Rlw->Tail)
   {Rule1=Rlw->Head;
    DBG_D4('%s', Rule1->NameF, %u, Rule1->QNEmpty,
           %d, Rule1->TpStdBasic, %d, Rule1->TpStdRef);
    dbg("InfSign=%c, USED_LIST=%d",
        Rule1->Seq? Rule1->Seq->InfSign: 'N',
        Rule1->Mark & GRAM_USED_LIST);
    if(!(Rule1->Mark & GRAM_EXTERN))
      {if(   Rule1->QNEmpty
          && (   Rule1->QNEmpty>1
              || Rule1->Seq && Rule1->Seq->InfSign=='|'
              || Rule1->Mark & (GRAM_USED_LIST | GRAM_PUBLIC)
             )
          && Rule1->TpStdRef>=GRAM_ACT_NONSTD
         )
         {
          FFT= QFls>1 || env_.Pbt || Rule1->Mark & GRAM_PUBLIC?
               FFH11: FFC11;

          if(   (   Rule1->QNEmpty>1
                 || Rule1->Seq && Rule1->Seq->InfSign=='|')
        /*   && strcmp(Rule1->TpRef, "unsigned")
         *   && strcmp(Rule1->TpRef, "tp_strings *")
         *   && strcmp(Rule1->TpRef, "tp_decls *")
         *   && strcmp(Rule1->TpRef, "tp_args *")*/
            )
             fprintf(FFT,"typedef %s *%s;\n",
                         Rule1->TpBasic, Rule1->TpRef);
          dbg("********GEN:typedef %s *%s;",
              Rule1->TpBasic, Rule1->TpRef);
          if(Rule1->Mark & GRAM_USED_LIST)
            {strcpy(TpRef, Rule1->TpRef);
             if(Sw=strrchr(TpRef, '*')) {*Sw=0x0; STR_RTRIM1(TpRef);}
             strcpy(TlRef, Rule1->TpLRef);
             if(   strcmp(TlRef, "tp_strings *")
                && strcmp(TlRef, "tp_decls *")
                && strcmp(TlRef, "tp_args *"))
               {if(Sw=strrchr(TlRef, '*')) {*Sw=0x0; STR_RTRIM1(TlRef);}
                strcpy(DefLst,
                       Rule1->TpStdBasic>=GRAM_ACT_NONSTD
                          ? "DEFPLIST": "DEFLIST");
                fprintf(FFT,"%s(%s, _st_l_%s, %s);\n",
                             DefLst, TlRef, TlRef, TpRef);
                dbg("********%s(%s, %s_l_, %s *);",
                    DefLst, TlRef, TlRef, Rule1->TpBasic);
               }
            } /*if(Rule1->Mark & GRAM_USED_LIST)*/
         } /*if(QNEmpty+(Rule1->Seq && Rule1->Seq->InfSign=='|')>1)*/
       for(NOb=0; NOb<G_OBJQ; NOb++)
          gram_genhead(Rule1, NOb, FALSE);
      } /*if(!GRAM_EXTERN && TpStdBasic>=GRAM_ACT_NONSTD)*/
   } /*for(Rlw=Rules,...)*/
 fputs("\n",FFT);
 MSG_END();
} /*gram_genforw*/

/*==gram_genhead===(iii)=== Schreibt Kopf einer NT-Fuktion weg =======*/
static void gram_genhead(gram_rule1 *Rule1, int NOb, bool Impl)
{char     *Comma="", *End="";
 FILE     *FF;
 unsigned  Lev=0, Move=0, PBrc;
 char     *Nmf, *Nmv;
 char      NmOut[64];
 bool      Pub;
 char     *Stt;

 MSG_DCL("gram_genhead");
 ASSERT(Rule1, ABBRUCH, EC_NullPointer, "Rule1==NULL");
 dbg("Rule1->Name='%s',NOb=%d,Impl=%d,CreFun=%d",
      PVAR_GETNAME(Rule1->PVar), NOb,
      (int)Impl, (int)Rule1->CreFun[NOb]);
 if(Rule1->CreFun[NOb])
   {
    dbg("Stp0='%s',TpStdRef=%d,CreFun=%d",
        Rule1->TpBasic, Rule1->TpStdRef, (int)Rule1->CreFun[NOb]);
    ASSERT(Rule1->Seq, ABBRUCH, EC_NullPointer, "Rule1->Seq==NULL");

    Nmf=Rule1->NameF; Nmv=Rule1->NameV;
    Pub= !!(Rule1->Mark & GRAM_PUBLIC);
    Stt= !Pub? "static ": !Impl? "DCL_FN(": "";
    if(!Impl)
      {if(Pub)
         {Comma= ",";
          FF= env_.GenFFs[NOb][G_EXT_H1][G_PART2];             /*FFH12*/
         }
       else FF= env_.GenFFs[NOb][G_EXT_C][G_PART1];            /*FFC11*/
       End= Pub? ")": ";";
      }
    else FF= env_.GenFFs[NOb][G_EXT_C][G_PART2];               /*FFC12*/

    if(NOb==G_PA)    /*PARSE*/
      {if(Impl)
          fprintf(FF,"/*==%s%.*s*/\n",
                  Nmf,MAXOUTLINE-6-strlen(Nmf),sectsep);
       ptpos= fprintf(FF,"%sbool%s %s%s(",Stt,Comma,Nmf,Comma);
       dbg("%sbool%s %s%s(",Stt,Comma,Nmf,Comma);
       PBrc= ptpos-1;

       if(*Rule1->TpRef) /*for the case N='A','B'.*/
         {gram_putline(&Lev,&Move,FF,"%s *%s%s",
                       Rule1->TpRef,
                          Rule1->Mark & GRAM_USED_OPT
                       && Rule1->TpStdRef<GRAM_ACT_NONSTD
                       && stdactions[Rule1->TpStdRef].TypeD[0]=='N'
                          ? "*":"",
                       Nmv);
          dbg("%s * %s,\n",Rule1->TpRef,Nmv);
          if(   Rule1->Seq->QNT
             || Rule1->Seq->QT
             || Rule1->Seq->InfSign=='|'
             || Rule1->Args)
             gram_putline(&Lev,&Move,FF,",\n");
         } /*if(TpRef)*/

       Move= PBrc;
       if(Rule1->Seq->QNT || Rule1->Seq->QT)
         {
          dbg("tp_lexs **_Tks");
          gram_putline(&Lev,&Move,FF,"tp_lexs **_Tks, ");
          Move= 0;
         }
       if(   Rule1->Seq->QNT
          || Rule1->Seq->QT
          || Rule1->Seq->InfSign=='|')
         {
          gram_putline(&Lev,&Move,FF,"bool Oblig");
          if(Rule1->Args) gram_putline(&Lev,&Move,FF,",\n");
          dbg("tp_lexs ** _Tks, bool Oblig");
         }

       Move= PBrc;
       gram_genargs(FF, 0x0, Rule1->Args, &Lev, &Move);
       Lev=Move=0;
       gram_putline(&Lev,&Move,FF,")%s\n",End);
       dbg("%s)%s\n", Rule1->Args?"<Args>":"", End);
      } /*if(NOb==G_PA)*/
    else
      {
       sprintf(NmOut, "%s_%s", Nmf, genobs[NOb]);
       if(Impl)
          fprintf(FF,"/*==%s%.*s*/\n",
                  NmOut,MAXOUTLINE-6-strlen(NmOut),sectsep);
       Lev=Move=0;
       gram_putline(&Lev,&Move,FF,"%s%s%s %s%s(%s",
                    Stt,
                    NOb==G_CL || NOb==G_IM? "void": "size_t",
                    Comma, NmOut, Comma,
                    NOb==G_WR || NOb==G_RD || NOb==G_PR?
                       "FILE *_IOFile": "");
       if(*Rule1->TpRef)
         {if(NOb==G_WR || NOb==G_RD || NOb==G_PR)
             gram_putline(&Lev,&Move,FF,", ");
          gram_putline(&Lev,&Move,FF,"%s %s%s",
                       Rule1->TpRef, NOb==G_RD? "*": "", Nmv);
         }
       if(NOb==G_IM) gram_putline(&Lev,&Move,FF,", _usrout_t _Res");
       gram_putline(&Lev,&Move,FF, ")%s\n", End);
      } /*if(NOb==G_PA) / else*/
   } /*if(crefun)*/
 MSG_END();
} /*gram_genhead*/


/*==gram_genrules===(ii)================================================
 * Schreibt Datenstrukturen und Implementierung weg
 *====================================================================*/
static void gram_genrules(gram_rules *Rules, unsigned QFls)
{bool         DclFds;
 FILE        *FFT, *FFC12;
 char        *FType;
 bool         HeadCalled= FALSE;
 unsigned     Indent;
 unsigned     Lev,Move;
 char        *Nmf,*Nmv;
 char         NmOut[64];
 int          NOb;
 char         Opts[128];
 ulong        QIt;
 unsigned     QTN;
 gram_rules  *Rlw;
 gram_rule1  *Rule1;
 char        *STp;
 bool         StruOp,UniOp;
 MSG_DCL("gram_genrules");

 sprintf(Opts, "MAG1050:MAXNAME=%u,CASE=0,UBCHAR='_',UBPLACE=7;",
         GRAM_MAXNAME);
 MAG1050_setup(Opts);

 for(Rlw=Rules;Rlw;Rlw=Rlw->Tail)
   {Rule1=Rlw->Head;
    if(!(Rule1->Mark & GRAM_EXTERN) && Rule1->CreFun[G_OBJQ])
      {Nmf=Rule1->NameF; Nmv=Rule1->NameV;
       StruOp= !!(Rule1->Mark & GRAM_STRUCT);
       UniOp= !!(Rule1->Mark & GRAM_UNION);
       QTN= Rule1->Seq->QNT + Rule1->Seq->QT;
       FType= Rule1->TpRef;
       DclFds= TRUE;
       dbg("Rule='%s', NameF='%s',NameV='%s', InfSign=%c, QNT=%u,QT=%u",
            PVAR_GETNAME(Rule1->PVar), STR_NOT0(Nmf), STR_NOT0(Nmv),
            Rule1->Seq->InfSign, Rule1->Seq->QNT, Rule1->Seq->QT);
       dbg("StruOp=%d,UniOp=%d", !!StruOp,!!UniOp);


       for(NOb=0; NOb<G_OBJQ; NOb++)
          if(Rule1->CreFun[NOb])
            {gram_genhead(Rule1, NOb, TRUE);
	       FFC12= env_.GenFFs[NOb][G_EXT_C][G_PART2];
             if(NOb) sprintf(NmOut, "%s_%s", Nmf, genobs[NOb]);
             else strcpy(NmOut, Nmf);
             fputc('{', FFC12);

             if(!NOb)
               {
                /*FFT=FFH11:FFC11*/
                FFT= env_.GenFFs[NOb][!!env_.Pbt][G_PART1];

                fprintf(FFC12,"bool%*s _Rt=%s;\n",
                        VARMAXTP-4," ",
                           Rule1->Seq->InfSign=='|'
                        || Rule1->Seq->InfSign==';'
                        ? "FALSE": "TRUE");
               }
             else if(NOb==G_PR || NOb==G_WR || NOb==G_RD)
                fprintf(FFC12,"size_t%*s _Rt= 0;\n", VARMAXTP-6," ");
             else fputc('\n', FFC12);

             if(StruOp)
               {if(DclFds)
                  {
                   /*FFT=FFH11:FFC11*/
                   FFT= env_.GenFFs[NOb][QFls>1 || env_.Pbt][G_PART1];
                   fprintf(FFT, "struct st_%s\n  {\n",Nmf);
                   if(Rule1->Seq->InfSign=='|')
                      fprintf(FFT,"   unsigned _Type;\n");
                   if(UniOp)
                      fprintf(FFT,"   union un_%s\n     {\n",Nmf);
                  } /*if(!NOb)*/
               }
             gram_gendcl(FFT, FFC12, NOb, Nmv, Rule1->Seq->InfSign,
                         StruOp, UniOp, Rule1->Seq->Items, DclFds);
             if(StruOp)
               {if(DclFds)
                  {if(UniOp) fprintf(FFT, "     }      _Contents;\n");
                   fprintf(FFT,"  };\n");
                   DclFds= FALSE;
                  }

                if(NOb==G_PA && Rule1->Seq->InfSign==';')
                  {QIt= LST_COUNT(Rule1->Seq->Items);
                   fprintf(FFC12," char%*s _Was[%lu];\n",
                           VARMAXTP-4," ",QIt+1);
                   if(!(Rule1->Mark & GRAM_OPTIONAL))
                     {fprintf(FFC12," char%*s _EMsg[MAXMSGSIZE];\n",
                              VARMAXTP-4," ");
                      fprintf(FFC12," tp_lexs *%*s _Tkr;\n",
                              VARMAXTP-9," ");
                     }
                  } /*if(Rule1->Seq->InfSign==';')*/
               } /*if(StruOp)*/

          /* Damit sind alle Deklarationen ausgegeben*/

             Indent= 0;
             STp= StruOp? "->_Type": "";
             /*if(NOb!=G_PR)*/
             fprintf(FFC12," MSG_DCL(\"%s\");\n",NmOut);
             switch(NOb)
               {case G_PA:
                   if(QTN) fprintf(FFC12," tks_dbg1(*_Tks);\n");
                   if(StruOp)
                     {Lev= Move= 0;
                      gram_putline(&Lev,&Move,FFC12,
                                   "ASSERT(*%s=ALLOC(struct st_%s),"
                                   "ABBRUCH, EC_NotEnoughMemory,\n",
                                   Nmv, Nmf);
                      gram_putline(&Lev,&Move,FFC12,
                                    "       qv_msg(\"Speicherprobleme."
                                    " Kann nicht st_%s-Struktur"
                                    " allokieren\"));\n",
                                   Nmf);
                      fprintf(FFC12,
                              " memset(*%s,0,sizeof(struct st_%s));\n",
                              Nmv,Nmf);
                     } /*if(StruOp)*/
                   else if(*Rule1->TpRef)
                      fprintf(FFC12," *%s= (%s) 0;\n", Nmv, FType);

                   if(Rule1->Seq->InfSign==';')
                     {if(!(Rule1->Mark & GRAM_OPTIONAL))
                         fprintf(FFC12," _Tkr= tks_dup(*_Tks);\n");
                      fprintf(FFC12," memset(_Was,0,%lu);\n",QIt+1);
                      fprintf(FFC12," for(_NCurr=0;_NCurr<%lu;_NCurr++)"
                                    "\n",QIt);
                      fprintf(FFC12,"   {_Rt=FALSE;\n");
                     }
                   gram_genseq(FFC12, PVAR_GETNAME(Rule1->PVar), Nmv,
                               Rule1->Mark&GRAM_OPTIONAL,
                               StruOp, UniOp, Rule1->Seq);
                   if(QTN) fprintf(FFC12," if(_Rt) tks_dbg1(*_Tks);\n");
                   if(StruOp)
                     {fprintf(FFC12, QTN? " else {": " ");
                      fprintf(FFC12,"free(*%s); *%s=NULL;",Nmv,Nmv);
                      fprintf(FFC12, QTN? "}\n": "\n");
                     }
                   fprintf(FFC12," dbg(\"_Rt=%%d\",(int)_Rt);\n"
                                 " MSG_ENDD();\n");
                   fprintf(FFC12," return _Rt;\n} /*%s*/\n\n",Nmf);
                   break;

                case G_RD:
                case G_WR:
                   if(Rule1->Seq->InfSign=='|')
                     {if(StruOp) fputs(" if(", FFC12);
                      else fputc(' ', FFC12);
                      fprintf(FFC12,
                              "_Rt=f%s(&%s%s%s%s, "
                              " sizeof(unsigned), 1, _IOFile)",
                              genobs[NOb],
                              NOb==G_RD? "(*": "",
                              Nmv,
                              NOb==G_RD? ")": "",STp);
                      if(StruOp) fputs(")\n", FFC12);
                      else fputs(";\n", FFC12);
                     }
                   else Indent= 1;
                case G_CL:
                case G_PR:
                case G_IM:
                   if(Rule1->Seq->InfSign=='|' && (StruOp || NOb==G_PR))
                     {fprintf(FFC12,"%*sswitch(%s%s%s%s)\n",
                              Indent, " ",
                              NOb==G_RD? "(*": "",
                              Nmv,
                              NOb==G_RD? ")": "",
                              STp);
                      fprintf(FFC12,"%*s  {\n", Indent, " ");
                     }
                   gram_genclr(FFC12, Nmv, NOb, StruOp, UniOp,
                               Rule1->Seq);
                   if(Rule1->Seq->InfSign=='|' && (StruOp || NOb==G_PR))
                     {fprintf(FFC12,"%*s  }\n", Indent, " ");
                      if(StruOp && NOb==G_CL)
                         fprintf(FFC12, " free(%s);\n", Nmv);
                     }
                   /*if(NOb!=G_PR)*/
                   fprintf(FFC12," MSG_ENDD();\n");
                   if(NOb==G_WR || NOb==G_RD || NOb==G_PR)
                      fprintf(FFC12," return _Rt;\n", Nmf);
                   fprintf(FFC12,"} /*%s*/\n\n",NmOut);
               } /*switch*/
            } /*if(Nr>=0) for(NOb)*/
      } /*if(!(Rule1->Mark & GRAM_EXTERN))*/
   } /*for(Rlw=Rules;Rlw;Rlw=Rlw->Tail)*/
 if(FFT) fputs("\n\n",FFT);
 MSG_ENDD();
} /*gram_genrules*/


/*===gram_gendcl===(iiiiiiiii)==========================================
 * Beschreibung: Deklaration der Ausgabestrukturfelder u. Hilfsvariablen
 *               (z.B. _Last, _Current,...)
 *
 * Formiert Typnamen:
 *   bei optioneller oder wiederholbarer Verwendung eines Feldes
 *       wird der Typname standartmaessig modifiziert:
 *
 *                         wiederholt      | optionell
 *                     ----------------------------------------------
 * Nonterminal             tl_<NT>         | keine Deklaration
 * Eingebaute Prozedur     <stdTyp>s       | <stdTyp> *
 *
 *
 * Formiert Variablennamen:
 *    generiert die Namen fuer eingebaute AS/API (z.B. Int,
 *    mehrmals benutzte Namen werden mit 2 unterschiedliche Ziffern
 *    ergaenzt.
 *
 * Fuer Alternativen werden die Felder in union eingeschlossen.
 * (die Variable fuer AuswahlNr ist schon vorher deklariert worden)
 *
 * Fuer die Schleifen werden zusaetzlich locale Variablen
 *    <NT>_Last und <NT>_Current definiert.
 *
 *====================================================================*/
static void gram_gendcl(FILE *FFT, FILE *FFC12, int NOb,
                        char *Name, char InfSign,
                        bool StruOp, bool UniOp,
                        gram_items *Items, bool DclFds)
{int          ArtNr=0;
 bool         BegD= FALSE, CounterD= FALSE, NCurrD= FALSE, SizeD= FALSE;
 char         Field3[GRAM_MAXNAME];
 char        *FType0,*FType1; /*Typen des Items ohne und mit Suffix*/
 bool         InList;
 gram_items  *Itemw;
 gram_item1  *Item1;
 bool         NtAct;
 int          ScTp;
 MSG_BEG("gram_gendcl");

 dbg("Processing NT='%s', InfSign=%c",Name,InfSign);
 dbg("env_.MaxName=%u,GRAM_MAXTP=%u",env_.MaxName,GRAM_MAXTP);

 for(Itemw=Items; Itemw; Itemw=Itemw->Tail)
   {Item1=Itemw->Head;
    if(*(FType1= Item1->TpPRef))
      {InList= !!strchr("+*", Item1->SuffSign);
       NtAct= Item1->Type==GRAM_NONTERM || Item1->Type==GRAM_STDACT;
       FType0= Item1->Tp0Ref;
       ScTp= gram_sctpit(FALSE, Item1);

       if(NtAct || StruOp) strcpy(Field3, Item1->Field);
       else {strcpy(Field3, Name); strlwr(&Field3[1]);}

       dbg("Processing Item='%s', Type=%d, SuffSign='%c'",
           gram_itstr(Item1),Item1->Type,Item1->SuffSign);
       DBG_D4('%s',FType0,'%s',FType1,'%s',Item1->Field,'%s',Field3)
       dbg("ScTp=%d",ScTp);


       /*--- Structure field ---*/
       if(DclFds && StruOp)
          fprintf(FFT, "%*s%-*s %s;\n",
                       (1+UniOp)*3, " ",
                       VARMAXTP, FType1,
                       Field3);

       /*--- Field variables _Current, _Node, _Last ---*/
       if(      NOb==G_PA && NtAct
             && (   InList
                 ||    ScTp
                    && !gram_altterm(Item1)
                    && Item1->SuffSign=='?'
                )
          || NOb==G_RD && NtAct && InList
         )
          fprintf(FFC12," %-*s %s_Current;\n",
                     VARMAXTP, FType0, Field3);

       if(   InList && NtAct
          && (   NOb==G_WR
              || NOb==G_PR
              ||    NOb==G_IM && Item1->Type==GRAM_NONTERM
                 && *Item1->TpPRef
                 && Item1->Term.NonTerminal->CreFun[G_IM]))
          fprintf(FFC12," %-*s %s_Node;\n",
                  VARMAXTP,FType1,Field3);

       if((NOb==G_PA || NOb==G_RD) && *FType0 && InList)
          fprintf(FFC12," %-*s %s_Last=NULL;\n",
                  VARMAXTP,FType1,Field3);

       /*--- Function variables _NCurr, _Count, _Size ---*/
       if(!CounterD && (NOb==G_RD || NOb==G_WR) && NtAct && InList)
         {fprintf(FFC12," %-*s _Count;\n",VARMAXTP,"ulong");
          CounterD= TRUE;
         }
       if(   !NCurrD
          && (   NOb==G_PA && InfSign==';'
              || NOb==G_PR && InList && Item1->Type==GRAM_TERM
              || NOb==G_RD && InList && NtAct))
         {fprintf(FFC12," %-*s _NCurr;\n",VARMAXTP,"unsigned");
          NCurrD= TRUE;
         }
       if(   !SizeD
          && NOb==G_RD
          && (   NtAct && Item1->SuffSign=='?'
              || Item1->Term.StdAction==GRAM_ACT_LIT
              || Item1->Term.StdAction==GRAM_ACT_TOKEN
              || Item1->Term.StdAction==GRAM_ACT_UNTILSEP))
         {fprintf(FFC12," %-*s _Size;\n",VARMAXTP,"ushort");
          SizeD= TRUE;
         }
      } /*if(*FType1)*/
   } /*for(Items...)*/
  MSG_END();
} /*gram_gendcl*/


/*===gram_genargs===(iiimm)=== Gibt Parameterliste aus ===============*/
static void gram_genargs(FILE *FFC12, char Start, tp_args *Args,
                         unsigned *Lev, unsigned *Move)
{tp_strings *Arg1;
 char       *Next=NULL,*Curr;
 size_t      LArg;
 char        TNow,TWas;
 MSG_DCL("gram_genargs");
 while(Args)
   {
    if(Start) gram_putline(Lev,Move,FFC12,"%c ",Start);
    Start=',';

    for(Arg1=Args->Head;Arg1;Arg1=Arg1->Tail)
      {if(   (LArg=strlen(Arg1->Head))>1
          && *Arg1->Head=='\''
          && *(Arg1->Head+LArg-1)=='\'')
         {Curr= gram_convlit(Arg1->Head,LArg);
          *Curr=LASTCHAR(Curr)='"';
          TNow='S';
         }
       else
         {TNow= strlen(Arg1->Head)==1 && ispunct(*Arg1->Head)? 'C':'N';
          Curr= Arg1->Head;
         }
       if(   TNow=='C'
          && Arg1->Tail
          && (Next=Arg1->Tail->Head)
          && strlen(Next)==1
          && (*Curr==*Next || *Curr=='-' && *Next=='>'))
         {gram_putline(Lev,Move,FFC12," %s%s%s",Curr, Next);
          Arg1= Arg1->Tail;
         }
       else
          gram_putline(Lev,Move,FFC12,"%s%s",
                       TWas!='C' || TNow=='S'? " ":"", Curr);
       if(TNow=='S') free(Curr);
       TWas= TNow;
      }
    Args=Args->Tail;
   }
 MSG_END();
} /*gram_genargs*/


/*===gram_convlit===(ii)================================================
 * Fuegt Backslash vor jedes Doppelhochkomma ein
 *====================================================================*/
static char *gram_convlit(char *ReqHere,size_t LReqH)
{char  *Rt,*Swd,*Swr;
 size_t Sz;
 MSG_DCL("gram_convlit");

 Sz= (LReqH<<1)|1;
 ASSERT(Rt=(char *)malloc(Sz),ABBRUCH,EC_NotEnoughMemory,
        qv_msg("Speicherprobleme. Kann nicht %u bytes allokieren",Sz));

 Swd=ReqHere; Swr=Rt;

 while(*Swd)
   {if(*Swd=='"') *Swr++= '\\';
    *Swr++= *Swd++;
   }
 *Swr=0x0;
 MSG_END();
 return Rt;
} /*gram_convlit*/


/*===gram_genseq===(iiiiiii)============================================
 * Bearbeitung der Elementenfolge
 * Return: Anzahl der getroffenen Element inklusive evtl. EMPTY
 *====================================================================*/
static unsigned gram_genseq(FILE *FFC12,char *Nmu,char *Nmv,bool OptAll,
                            bool StruOp,bool UniOp, gram_seq *Seq)
{unsigned    Rt= 1;
 bool        AltInt;
 bool        AltTerm; /*Current item is NT,which is an option of terms*/
 char       *Aps;
 char       *FType;
 char        InfSign;
 bool        IsAlt,IsMult,IsSeq,IsSingle,IsTerm,IsEmpty;
 gram_items *Items;
 gram_item1 *Item1;
 char        Last[GRAM_MAXNAME+5];
 unsigned    Lev= 0;    /*{}-nesting level*/
 size_t      LReqH;
 bool        InList;
 unsigned    LSepsQ;
 tp_strings *LSepsS;
 unsigned    Move= 0;   /*Zusatzschub nach rechts (z.B. nach if())*/
 static int  nerr;
 char        NmTp[GRAM_MAXTP<<1];
 unsigned    Nr;
 bool        NtAct;
 unsigned    Oblq=0;    /*Laufende Anzahl der obligatorischen Elem.*/
 char       *Obls;
 bool        OptCurr, OptSoFar;
 unsigned    Order;
 char        OutArg[GRAM_MAXNAME<<1], OutField[GRAM_MAXNAME<<1];
 unsigned    QEl, QVArf, QVArg, QTN;
 char       *Required= NULL, *ReqHere, *ReqW;
 int         ScTp0,ScTp1;
 gram_seq   *SeqW;
 char        SuffSign;
 char       *Sw;
 tp_args    *VArgs;
 char       *WaOpt=NULL;

 char        BauIds[16];
 int         BauNr, BauQ;
/*Textbausteine fuer gram_genseq*/
struct st_baust
  {char     Id;
   unsigned PreOrd;
   char     PreTxt[32];
   unsigned PostOrd;
   char     PostTxt[256];
  } BauSt[]=
   {
    {'#', 1, "if(!_Was[%u])\n",  5, "_Was[%u]=_Rt;\n"},  /*{}*/
    {'A', 0, "",                 2, "%s=_Rt;\n"},
    {'C', 0, "",                 5, "_Was[%u]=_Rt;\n"},
    {'D', 2, "do\n",             3,
                         "while(parse_kwalt(_Tks, FALSE, SEP_OPT, ..."
    },
    {'W', 2, "while(",           1, ")\n"},
    {'E', 0, "",                 7, "...\n"},
    {'I', 3, "if(",              1, ")\n"},
    {'L', 0, "",                 2,
                    "   {%s_Last=(%s) LST_APPEND(%s_Last,%s_Current);\n"
                    "if(!%s) %s=%s_Last;\n   }\n"
    },
    {'M', 0, "",                 2,
                                 "ASSERT(%s=memdup(%s,sizeof(%s)),"
                                " ABBRUCH, EC_NotEnoughMemory,"
                                " \"Kein Speicher fuer Ergebnis\");\n"
    },
    {'P', 0, "",                 2, "%s+=1;\n"},
    {'Q', 0, "",                 5, "...\n"},
    {'R', 4, "_Rt=",             0, ""},
    {'T', 0, "",                 6, "%s=%u;\n"},
    {'V', 0, "",                 5, "if(_Rt=!!%s) "},
    {'X', 5, "%s=",              0, ""},
    {'Y', 0, "",                 4, "_Rt=TRUE;\n"},
    {'!', 0, "",                 4, "_Rt=!!%s;\n"},
    {';', 0, "",                 1, ";\n"},
    {'{', 0, "",                 2, "{\n"}
   };
 MSG_BEG("gram_genseq");

 ASSERT(Nmv,ABBRUCH,EC_InternalError,"Nmv == NULL");
 ASSERT(Seq,ABBRUCH,EC_InternalError,
        qv_msg("Nmv='%s',Seq == NULL",Nmv));
 dbg("Nmv=%s, Seq: UniOp=%d,InfSign=%c",Nmv,(int)UniOp,Seq->InfSign);

      /*---- INIT allgemein ----*/
 BauQ= sizeof(BauSt)/sizeof(BauSt[0]);
 InfSign= Seq->InfSign;
 IsAlt= InfSign=='|';
 IsMult= InfSign==';';
 IsSeq= InfSign==',';
 IsSingle= InfSign==' ';
 OptSoFar= !(IsAlt || IsMult);
 ptpos= 0;
 if(IsMult)
   {Lev=1;          /*because for(..) { is already written*/
    QEl=LST_COUNT(Seq->Items);
    WaOpt=(char *)malloc(QEl+1);
    memset(WaOpt,0,QEl+1);
   }
 for(Items=Seq->Items; Items; Items=Items->Tail,Rt++)
   {
      /*---- INIT item ----*/
    Item1=Items->Head;
    dbg("Item1 #%u(from 1): Field='%s',Type=%s,SuffSign=%c",
        Rt,Item1->Field,gram_itstr(Item1),Item1->SuffSign);
    SuffSign= Item1->SuffSign;
    InList= SuffSign=='*' || SuffSign=='+';
    NtAct= Item1->Type==GRAM_NONTERM || Item1->Type==GRAM_STDACT;
    IsTerm= Item1->Type==GRAM_TERM;
    IsEmpty= Item1->Type==GRAM_EMPTY;
    OptCurr= SuffSign=='?' || SuffSign=='*';
    LSepsQ= InList? LST_COUNT(Item1->ListSeps): 0;
    ScTp0= gram_sctpit(FALSE, Item1);
    ScTp1= gram_sctpit(TRUE, Item1);
    dbg("ScTp=(%d,%d)", ScTp0, ScTp1);
    if(!OptCurr) Oblq++;
    AltTerm=gram_altterm(Item1);
    dbg("AltTerm=%d",(int)AltTerm);

     /*---- Field-Parameter ----*/
    OutArg[0]= OutField[0]= 0x0;

    if(*Item1->TpPRef)
      {if(   NtAct
          && (InList || ScTp0 && !AltTerm && Item1->SuffSign=='?'))
          sprintf(OutArg,"&%s_Current",
                         StruOp || NtAct? Item1->Field: Nmv);
       if(StruOp)
         {if(UniOp)
             sprintf(OutField, "(*%s)->_Contents.%s",
                     Nmv, Item1->Field);
          else
             sprintf(OutField,"(*%s)->%s", Nmv, Item1->Field);
          if(!*OutArg) str_concat(OutArg, "&", OutField);
         }
       else
         {str_concat(OutField, "*", Nmv);
          if(!*OutArg) strcpy(OutArg, Nmv);
         }
       dbg("OutField='%s',OutArg='%s'", OutField, OutArg);
      } /*if(*Item1->Field)*/

    if(IsEmpty || OptCurr)
      {if(IsAlt)
         {OptSoFar=TRUE;
          if(Required) {free(Required); Required=NULL;}
         }
      }
    else
       if(!IsAlt) OptSoFar=FALSE;

     /*---- Oblig-Parameter ----*/
    if(LSepsQ)
       Obls= IsAlt || IsMult || OptCurr
           ? str_concat(NULL, "!!", OutField)
           : strdup("TRUE");
    else if(IsAlt || IsMult || OptCurr) Obls=strdup("FALSE");
    else if(InList)
      {Obls= str_concat(NULL, "!", OutField);
       if(Oblq==1) STR_GROW(&Obls," && Oblig");
      }
    else Obls=strdup(Oblq==1? "Oblig": "TRUE");

    ASSERT(Obls,ABBRUCH,EC_NotEnoughMemory,
           qv_msg("Speicherprobleme. Kann nicht 'Obls'-String "
                  "allokieren. Regel '%s' El# %u (ab 1)",
                  Nmv,Rt));
    dbg("Oblq=%u,Obls='%s'",Oblq,Obls);

     /*---- BAUSTEINSTEUERUNG ----*/
    BauIds[0]= 0x0;
    if(IsMult && !IsEmpty)                strcat(BauIds, "#");
    if(IsMult && SuffSign=='?' && IsTerm) strcat(BauIds, "A");
    if(IsMult && IsEmpty)                 strcat(BauIds, "C");
    if(LSepsQ && !IsEmpty)                strcat(BauIds, "D");
    if(IsAlt && !OptCurr && !IsEmpty)     strcat(BauIds, "E");

    if(   !IsEmpty
       && (      IsSingle
             && (SuffSign=='?' && ScTp0  && !AltTerm || LSepsQ)
           ||    IsSeq
              && (   SuffSign=='?' && ScTp0 && !AltTerm
                  || SuffSign==' ' && Items->Tail
                  || LSepsQ
                 )
           ||    IsAlt
              && (  SuffSign==' ' || SuffSign=='?' && ScTp0
                  || LSepsQ
                 )
           ||    IsMult
              && (SuffSign=='?' && ScTp0  && !AltTerm || LSepsQ)
          )
	)
       strcat(BauIds, "I");

    if(InList && !IsTerm)      strcat(BauIds, "L");

    if(ScTp0 && SuffSign=='?' && !AltTerm)
       strcat(BauIds, "M");

    if(InList && IsTerm)       strcat(BauIds, "P");
    if(   IsSeq && SuffSign=='+'
       && Items->Tail && Items->Tail->Head->Type!=GRAM_EMPTY
      )
       strcat(BauIds, "Q");

    if(!IsEmpty && !InList && (IsMult || SuffSign==' '))
       strcat(BauIds, "R");

    if(IsAlt)                  strcat(BauIds, "T");
    if(IsAlt && SuffSign=='+') strcat(BauIds, "V");
    if(InList && !LSepsQ)      strcat(BauIds, "W");

    if(IsAlt && (IsEmpty || OptCurr))
       strcat(BauIds, "Y");

    if(SuffSign=='+' || IsMult && SuffSign=='*')
       strcat(BauIds, "!");

    if(  !IsEmpty
       && (      (IsSingle || IsMult)
              && (SuffSign==' ' || SuffSign=='?' && (!ScTp0 || AltTerm))
           ||    IsSeq
              && (   SuffSign==' ' && !Items->Tail
                  || SuffSign=='?' && (!ScTp0 || AltTerm)
                 )
           || IsAlt && SuffSign=='?' && (!ScTp0 || AltTerm)
          )
      )
       strcat(BauIds, ";");

    if(IsSeq && SuffSign==' ' && Items->Tail)
       strcat(BauIds, "{");

    DBG_D1('%s', BauIds);

     /*---- PRE-CALL ----*/

    for(BauNr=0; BauNr<BauQ; BauNr++)
       if(BauSt[BauNr].PreOrd && strchr(BauIds, BauSt[BauNr].Id))
          switch(BauSt[BauNr].Id)
            {case '#':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PreTxt,Rt-1);
                gram_putline(&Lev,&Move,FFC12,"{\n");
                break;
             case 'D':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PreTxt);
                gram_putline(&Lev,&Move,FFC12,"{\n");
                break;
             case 'X':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PreTxt,
                             OutField);
                break;
             default:
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PreTxt);
            } /*switch*/

    if(LASTCHAR(BauSt[BauNr].PreTxt)==';') Move= 0;

     /*---- CALL & PREPARE (A PART OF) MSG ----*/

    ReqHere=ReqW= NULL;
    switch(Item1->Type)
      {
       case GRAM_NONTERM:
          if(SeqW=Item1->Term.NonTerminal->Seq)
            {QTN=  SeqW->QNT + SeqW->QT;
             AltInt= (SeqW->InfSign=='|');
            }
          else
            {AltInt= FALSE;
             QTN= !!(Item1->Term.NonTerminal->Mark & GRAM_EXTERN);
            }

          ReqHere= PVAR_GETNAME(Item1->Term.NonTerminal->PVar);
          gram_putline(&Lev,&Move,FFC12,"%s(",
                       Item1->Term.NonTerminal->NameF);
          if(*OutArg)
            {gram_putline(&Lev,&Move,FFC12,"%s",OutArg);
             if(QTN || AltInt || Item1->Args)
                gram_putline(&Lev,&Move,FFC12,",");
            }

          if(QTN) gram_putline(&Lev,&Move,FFC12,"_Tks, ");

          if(QTN || AltInt)
            {gram_putline(&Lev,&Move,FFC12,Obls);
             if(Item1->Args) gram_putline(&Lev,&Move,FFC12,",");
            }
          gram_genargs(FFC12,0x0,Item1->Args,&Lev,&Move);
          gram_putline(&Lev,&Move,FFC12,")");
          break;

       case GRAM_TERM:
          ReqHere= Item1->Term.Terminal;
          if((LReqH=strlen(ReqHere))==1 || LReqH==2 && *ReqHere=='\\')
             gram_putline(&Lev,&Move,FFC12,
                          "parse_char(_Tks,'%s',%s,SEP_OPT)",
                       ReqHere,Obls);
          else
            {ReqW=ReqHere;
             ReqHere=gram_convlit(ReqW,LReqH);
             gram_putline(&Lev,&Move,FFC12,
                          "parse_kw(_Tks,\"%s\",%s,",
                          ReqHere,Obls);
             if(Item1->Args)
                gram_genargs(FFC12,0x0,Item1->Args,&Lev,&Move);
             else gram_putline(&Lev,&Move,FFC12," SEP_OPT");
             gram_putline(&Lev,&Move,FFC12,")");
            }
          break;

       case GRAM_STDACT:
          dbg("Item1->Term.StdAction=%d,GRAM_ACT_LIT=%d,"
              "GRAM_ACT_UNTIL=%d",
              Item1->Term.StdAction,GRAM_ACT_LIT,GRAM_ACT_UNTIL);

          if(stdactions[Item1->Term.StdAction].TypeT[1] == 'R')
            {if(strchr(BauIds, 'R'))
                gram_putline(&Lev,&Move,FFC12,"!!(");
             gram_putline(&Lev,&Move,FFC12,
                          stdactions[Item1->Term.StdAction].Call[0],
                          StruOp || InList? "":"*",
                          OutArg+(*OutArg=='&'));

             if(Item1->Term.StdAction==GRAM_ACT_LIT)
               {if(Item1->Args) Aps=Item1->Args->Head->Head;
                else
                 /*Aps="\"\\\"'\\\\\\\"\\\"\""; druckt ueberf. "x"*/
                 /*Aps="\"'\\\\\"\"";  - tks_endlit meckert*/
                 /*Aps="\"'\\\"\"";    - misses backslash*/
                   Aps="\"'\\\\\\\"\"";
                gram_putline(&Lev,&Move,FFC12,"%s,%s",Aps,Obls);
                if(Item1->Argq>1)
                   gram_genargs(FFC12,',',Item1->Args->Tail,&Lev,&Move);
                else gram_putline(&Lev,&Move,FFC12,", SEP_OPT");
               }
             else
               {gram_putline(&Lev,&Move,FFC12,"%s",Obls);
                gram_genargs(FFC12,',', Item1->Args, &Lev,&Move);
               }
             gram_putline(&Lev,&Move,FFC12,")");
            } /*if(stdactions[...].TypeT[1] == 'R')*/

          else if(Item1->Term.StdAction==GRAM_ACT_UNTIL)
            {gram_putline(&Lev,&Move,FFC12,
                          stdactions[Item1->Term.StdAction].Call[0],
                          OutArg,Obls);
          /*spec.handling: Brackets,Edge1,CaseDep,unsigned QUntil,...)*/
             if(Item1->Argq==1 && LST_COUNT(Item1->Args->Head)==1)
                gram_putline(&Lev,&Move,FFC12,",\"{[(\",0,0,1");
             else
               {ASSERT(Item1->Argq>=5,AUSSTEUERN,105465,
                       qv_msg("Zu wenig Parameter beim Aufruf "
                              " von until(). Regel '%s' El# %u (ab 1)",
                              Nmv,Rt));
                for(QVArg=0,VArgs=Item1->Args;QVArg<4;QVArg++)
                   VArgs=VArgs->Tail;

                if(   LST_COUNT(VArgs->Head)==1
                   && isdigit(*VArgs->Head->Head))
                  {ASSERT(  sscanf(VArgs->Head->Head,"%u",&QVArg)
                          >=(int)strlen(VArgs->Head->Head),
                          AUSSTEUERN,105466,
                          qv_msg("Parameter #4 beim Aufruf von until()"
                                 " ist falsch. Erwartet unsigned int."
                                 " Getroffen '%s'."
                                 " Regel '%s' El# %u (ab 1)",
                                 VArgs->Head->Head,Nmv,Rt));

                   ASSERT((QVArf=LST_COUNT(VArgs->Tail))==QVArg,
                          AUSSTEUERN,105467,
                          qv_msg("Falsche Anzahl der variablen"
                                 "Parametern beim Aufruf von until(). "
                                 "Erwartet %u, bekommen %u. "
                                 "Regel '%s' El# %u (ab 1)",
                                 QVArg,QVArf,Nmv,Rt));
                  } /*if(   LST_COUNT(VArgs->Head)==1 && isdigit(...)*/

               } /*if(Item1->Argq==1)*/
             gram_genargs(FFC12,',',Item1->Args,&Lev,&Move);
             gram_putline(&Lev,&Move,FFC12,")");
             DBG_D1(%u,Lev);
            } /*else if(Item1->Term.StdAction==GRAM_ACT_UNTIL)*/
          else
            {gram_putline(&Lev,&Move,FFC12,
                          stdactions[Item1->Term.StdAction].Call[0],
                          OutArg,Obls);
             if(stdactions[Item1->Term.StdAction].TypeT[2] == 'S')
               {if(Item1->Args)
                   gram_genargs(FFC12,0x0,Item1->Args,&Lev,&Move);
                else gram_putline(&Lev,&Move,FFC12," SEP_OPT");
                gram_putline(&Lev,&Move,FFC12,")");
               }
            }
          if(   stdactions[Item1->Term.StdAction].TypeT[1] == 'R'
             && strchr(BauIds, 'R'))
             gram_putline(&Lev,&Move,FFC12,")");

          ReqHere= stdactions[Item1->Term.StdAction].Name;
          break;

       case GRAM_USRACT:
          gram_putline(&Lev,&Move,FFC12,"%s",Item1->Term.UsrAction);
          gram_putline(&Lev,&Move,FFC12,"(");
          gram_genargs(FFC12,0x0,Item1->Args,&Lev,&Move);
          gram_putline(&Lev,&Move,FFC12,")");
          ReqHere= Item1->Term.UsrAction;
          break;

       case GRAM_EMPTY:
          Move= 0;
          break;
       default: Rt--;
      } /*switch(Item1->Type)*/

      /*---- POSTCALL ----*/

    sprintf(NmTp, StruOp? "(*%s)->_Type": "*%s", Nmv);
    for(Order=1; Order<=7; Order++)
       for(BauNr=0; BauNr<BauQ; BauNr++)
       if(   BauSt[BauNr].PostOrd==Order
          && strchr(BauIds, BauSt[BauNr].Id))
         {switch(BauSt[BauNr].Id)
            {case '#':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt,
                             Rt-1);
                gram_putline(&Lev,&Move,FFC12,"}\n");
                break;
             case 'C':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt,
                             Rt-1);
                break;
             case 'A':
             case 'P':
             case 'V':
             case '!':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt,
                             OutField);
                break;
             case 'E':
                gram_putline(&Lev,&Move,FFC12,"else\n");
                if(!Items->Tail)
                  {if(!OptAll)
                     {
                      Move+= INDENT;
                      if(Seq->QT+Seq->QNT)
                        /*TBD
                         *gram_putline(&Lev,&Move,FFC12,
                         *            "ASSERT(!Oblig,AUSSTEUERN,%d,"
                         *            "qv_msg(\"Erwartet: "
                         *            "%s\\n%ss\","
                         *            "parse_errtk(*_Tks)));\n",
                         *             ++nerr, (*Required*) Nmu,"%");*/
                         gram_putline(&Lev,&Move,FFC12,
                                      "ASSERT(!Oblig,AUSSTEUERN,%d,"
                                      "\n       qv_msg(\"Erwartet: "
                                      "%s%ss\",\n"
                                      "                parse_errtk"
                                      "(*_Tks)));\n",
                                       ++nerr, /*Required*/ Nmu,"%");
                      else
                         gram_putline(&Lev,&Move,FFC12,
                                      "ASSERT(!Oblig,AUSSTEUERN,%d,"
                                      "qv_msg(\"%s"
                                      " gescheitert\"));\n",
                                      ++nerr, Nmu);
                      Move -=INDENT;
                     }
                  }
                else if(!IsEmpty) gram_putline(&Lev,&Move,FFC12,"{\n");
                break;
             case 'I':
             case 'W':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt);
                if(!strpbrk(BauIds, "L{")) Move+=INDENT;
                break;
             case 'L':
                sprintf(Last, "%s_Last",
                              StruOp || NtAct? Item1->Field: Nmv);
                gram_putline(&Lev,&Move,FFC12, "{%s=", Last);
                FType= Item1->TpPRef;
                if(*FType)
                   gram_putline(&Lev,&Move,FFC12,"(%s)",FType);
                if(ScTp0)
                   gram_putline(&Lev,&Move,FFC12,
                                "LST_APPEND(%s,"
                                "memdup(%s,sizeof(%s)));\n",
                                Last, OutArg, OutArg+1);
                else
                   gram_putline(&Lev,&Move,FFC12,
                                "LST_APPEND(%s,%s);\n",
                                Last, OutArg+1);
                gram_putline(&Lev,&Move,FFC12,
                             "if(!%s) %s=%s;\n",
                             OutField,OutField,Last);
                gram_putline(&Lev,&Move,FFC12,"}\n");
                break;
             case 'M':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt,
                             OutField, OutArg, stdactions[ScTp0].Name);
                break;
             case 'Q':
                if(Items->Tail)
                  {gram_putline(&Lev,&Move,FFC12,"if(_Rt)\n");
                   gram_putline(&Lev,&Move,FFC12,"{\n");
                  }
                break;
             case 'T':
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt,
                             NmTp, Rt);
                break;
             case 'D':
                Sw= strstr(BauSt[BauNr].PostTxt, "SEP_OPT, ")+9;
                sprintf(Sw, "%u", LSepsQ);
                for(LSepsS=Item1->ListSeps; LSepsS; LSepsS=LSepsS->Tail)
                   sprintf(Sw+strlen(Sw), ", %s", LSepsS->Head);
                strcat(Sw, "));\n");
                gram_putline(&Lev,&Move,FFC12,"}\n");
             default:
                gram_putline(&Lev,&Move,FFC12,BauSt[BauNr].PostTxt);
            } /*switch(BauSt[BauNr].Id) if() for(BauNr...)*/
          if(   !strchr("IWV", BauSt[BauNr].Id)
             && LASTCHAR(BauSt[BauNr].PostTxt)=='\n'
            )
             Move= 0;
         } /*for(BauNr) if(...)*/

      /*---- Ergaenzung der Meldung fuer Mult ----*/
    if(IsMult)
      {if(OptCurr) WaOpt[Rt-1]=0x1;
       else
         {
          if(ReqHere)
             STR_GROW(&Required,
                      (char *)
                      qv_msg("       if(!_Was[%u]) "
                             "sprintf(_EMsg+strlen(_EMsg),\"%c %s \");"
                            ,Rt-1,Rt==1?' ':'|',ReqHere));
          Move= 0;
         }
       if(strchr(BauIds,'{')) gram_putline(&Lev,&Move,FFC12,"}\n");
      } /*if(IsMult)*/

      /*---- Aufraeumen ----*/
    free(Obls);
    if(ReqHere && ReqW) free(ReqHere); /*D. h., ReqHere=strdup()*/
   } /*for(Items...)*/

    /*---- Klammern schliessen ----*/
 while(Lev) gram_putline(&Lev,&Move,FFC12,"}\n");

   /*---- Mult-Nachbearbeitung ----*/
 if(IsMult)
   {if(!OptAll && Required)
      {
       for(Nr=0;Nr<QEl;Nr++)
          if(WaOpt[Nr]) fprintf(FFC12," _Was[%u]=0x1;\n",Nr);
       fprintf(FFC12," if(strlen(_Was)<%u)\n",QEl);
       fprintf(FFC12,"   {_Rt=FALSE;\n");
       fprintf(FFC12,"    if(Oblig)\n");
       fprintf(FFC12,"      {\n");
       fprintf(FFC12,"%s", Required);
       fprintf(FFC12,"       *_EMsg=' ';\n");
       fprintf(FFC12,"       strcat(_EMsg,\"fehlt\");\n");
       fprintf(FFC12,"       ASSERT(0,AUSSTEUERN,%d,"
                     "qv_msg(\"%%s %%s\",_EMsg,parse_errtk(*_Tks)));\n",
               ++nerr);
       fprintf(FFC12,"      }\n");
       fprintf(FFC12,"    else {tks_clear(_Tks); *_Tks=_Tkr;}\n");
       fprintf(FFC12,"   }\n");
       fprintf(FFC12," else\n");
       fprintf(FFC12,"   {");
      }
    else fprintf(FFC12," ");

    if(!OptAll) fprintf(FFC12,"tks_clear(&_Tkr);");
    fprintf(FFC12,"_Rt=TRUE;");
    if(!OptAll && Required) fprintf(FFC12,"}");
    fprintf(FFC12,"\n");
   }
   /*---- Abschied ----*/
 if(Required) free(Required);
 Rt--;
 DBG_D1(%u,Rt);
 MSG_END();
 return Rt;
} /*gram_genseq*/


/*===gram_genclr===(iiiiii)=============================================
 * Generiert alle Funktionen ausser Parser
 * Return: Anzahl der getroffenen Elemente inklusive evtl. EMPTY
 *====================================================================*/
static unsigned gram_genclr(FILE *FFC12, char *Nmv, int NOb,
                            bool StruOp, bool UniOp, gram_seq *Seq)
{unsigned      Rt= 1;
 bool          AltTerm;
 bool          BlBc, BlMv;
 char          FdRdIn[GRAM_MAXNAME<<1],  FdPrIn[GRAM_MAXNAME<<1];
 char          FdRdOut[GRAM_MAXNAME<<1], FdPrOut[GRAM_MAXNAME<<1];
 char          FdRdPtr[GRAM_MAXNAME<<1], FdPrPtr[GRAM_MAXNAME<<1];
 char         *FdIn, *FdOut, *FdPtr;
 char          FdParm[GRAM_MAXNAME<<1];
 char          Fun[GRAM_MAXNAME];
 unsigned      Indented;
 gram_items   *Items;
 gram_item1   *Item1;
 unsigned      Lev0,Lev1,Lev2;
 bool          InList;
 unsigned      Move= 0;  /*Zusatzaufschub nach rechts (z.B. nach if())*/
 bool          NtAct;
 char          PrAst[2]=" ";
 int           ScTp0, ScTp1;      /*scalar type*/
 char          Size[GRAM_MAXNAME+10];
 char         *Sw;
 int           TNr;
 bool          VarSize;
 MSG_BEG("gram_genclr");
 ASSERT(Nmv,ABBRUCH,EC_InternalError,"Nmv == NULL");
 ASSERT(Seq,ABBRUCH,EC_InternalError,
        qv_msg("Nmv='%s',Seq == NULL", Nmv));
 dbg("Nmv=%s,NOb=%d, Seq: StruOp=%d,UniOp=%d,InfSign=%c",
     Nmv, NOb, (int)StruOp, (int)UniOp, Seq->InfSign);

 Lev1= Seq->InfSign=='|' && (StruOp || NOb==G_PR);
 Lev0= Lev2= Lev1<<1;

 for(Items=Seq->Items; Items; Items=Items->Tail,Rt++)
   {
    Item1=Items->Head;
    dbg("Item1 #%u(from 1):Field='%s',SuffSign=%c",
        Rt, Item1->Field, Item1->SuffSign);
    DBG_D3('%s', Item1->Tp0Ref, '%s', Item1->TpPRef, %u, Move);
    NtAct= Item1->Type==GRAM_NONTERM || Item1->Type==GRAM_STDACT;
    InList= Item1->SuffSign=='*' || Item1->SuffSign=='+';
    ScTp0= gram_sctpit(FALSE, Item1);
    ScTp1= gram_sctpit(TRUE, Item1);
    DBG_D3(%d, ScTp0, %d, ScTp1, %d, InList);
    AltTerm=gram_altterm(Item1);
    DBG_D4(%d, NOb, %d, NtAct, %u, Item1->Type, %d, AltTerm);

    if(   NOb==G_PR && (NtAct || Item1->Type==GRAM_TERM)
       ||     *Item1->TpPRef
          && (  (NOb==G_RD || NOb==G_WR) && (NtAct || InList)
              || NOb==G_CL && NtAct && (!ScTp0 || InList)
              ||    NOb==G_IM
                 && Item1->Type==GRAM_NONTERM
                 && Item1->Term.NonTerminal->CreFun[G_IM]
             )
      )       /*&& Item1->Term.NonTerminal->CreFun[NOb] - zu eng*/
      {
         /* Vorbereitung: INIT */
       *PrAst=    Item1->Type==GRAM_NONTERM && Item1->SuffSign=='?'
               && ScTp0 && !AltTerm
               ?'*': 0x0;
       Indented= 0;

         /* Vorbereitung: Field-Parameter */
       if(StruOp)
          if(UniOp)
            {sprintf(FdRdIn,"(*%s)->_Contents.%s", Nmv, Item1->Field);
             sprintf(FdRdOut,"&(*%s)->_Contents.%s", Nmv, Item1->Field);
             strcpy(FdRdPtr, ScTp1? FdRdOut: FdRdIn);

             sprintf(FdPrIn,"%s%s->_Contents.%s",
                     PrAst, Nmv, Item1->Field);
             sprintf(FdPrOut,"&%s->_Contents.%s", Nmv, Item1->Field);
             strcpy(FdPrPtr, ScTp1? FdPrOut: FdPrIn);
            }
          else
            {sprintf(FdRdIn,"(*%s)->%s", Nmv, Item1->Field);
             sprintf(FdRdOut,"&(*%s)->%s", Nmv, Item1->Field);
             strcpy(FdRdPtr, ScTp1? FdRdOut: FdRdIn);

             sprintf(FdPrIn,"%s%s->%s", PrAst, Nmv, Item1->Field);
             sprintf(FdPrOut,"&%s->%s", Nmv, Item1->Field);
             strcpy(FdPrPtr, ScTp1? FdPrOut: FdPrIn);
            }
       else
         {sprintf(FdRdIn,"*%s", Nmv);
          strcpy(FdRdOut, Nmv);
          strcpy(FdRdPtr, Nmv);
          sprintf(FdPrIn,"%s%s", PrAst, Nmv);
          sprintf(FdPrOut,"&%s", Nmv);
          strcpy(FdPrPtr, ScTp1? FdPrOut: FdPrIn);
         }
       if(NOb==G_RD) {FdIn= FdRdIn; FdOut= FdRdOut; FdPtr= FdRdPtr;}
       else          {FdIn= FdPrIn; FdOut= FdPrOut; FdPtr= FdPrPtr;}

       DBG_D3('%s', FdRdIn, '%s', FdRdOut, '%s', FdRdPtr)
       DBG_D3('%s', FdPrIn, '%s', FdPrOut, '%s', FdPrPtr)
       DBG_D3('%s', FdIn, '%s', FdOut, '%s', FdPtr)

         /* Vorbereitung: Size */
       VarSize= FALSE; *Size= 0x0;
       if(Item1->Type==GRAM_STDACT)
          if(VarSize=   Item1->Term.StdAction==GRAM_ACT_LIT
                     || Item1->Term.StdAction==GRAM_ACT_TOKEN
                     || Item1->Term.StdAction==GRAM_ACT_UNTILSEP)
             strcpy(Size, "_Size+1");
          else if(Item1->Term.StdAction==GRAM_ACT_DATE)
             strcpy(Size, "11");
          else
            {sprintf(Size, "sizeof(%s)",
                     stdactions[Item1->Term.StdAction].TypeD);
             if(Sw= strchr(Size, '*')) *Sw=' ';
            }
       else if(Item1->Type==GRAM_TERM) strcpy(Size, "sizeof(ulong)");

         /* Ausgabe: Union */
       if(Seq->InfSign=='|')
         {dbg("case %d",Rt);
          gram_putline(&Lev1,&Move,FFC12,"case %d:\n",Rt);
         }

         /* Ausgabe: Bausteine */
       /* Bausteinfolge:
        * (Q|R),(N|I|F),{,S,(A|J),C,(E|L),}*/

         /*Baustein Q*/
       if((NOb==G_RD || NOb==G_WR) && InList && NtAct)
         {dbg("BSt:Q, Lev2=%u, Move=%u", Lev2, Move);
          if(NOb==G_WR)
             gram_putline(&Lev2, &Move, FFC12,
                          "_Count= LST_COUNT(%s);\n", FdIn);
          gram_putline(&Lev2, &Move, FFC12,
                       "if(f%s(&_Count,sizeof(ulong),1,_IOFile)>=0"
                       " && _Count>0)\n",
                       genobs[NOb]);
          Lev2++; Indented++;
         } /*if(InList)*/

         /*Baustein R*/
       if(NOb==G_RD && Item1->SuffSign=='?')
         {dbg("BSt:R, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12,
                       "if(fread(&_Size,sizeof(short),1,_IOFile)"
                       ">=0 && _Size>0)\n");
          gram_putline(&Lev2, &Move, FFC12,"{");
         }

         /*Forward f. BSt:{*/
       BlBc=   NOb==G_RD && InList && NtAct
            ||     NOb==G_PR
               && (   InList && Item1->ListSeps
                   || Item1->SuffSign=='?' && NtAct
                  )
               && (Item1->Type==GRAM_TERM || Item1->Type==GRAM_STDACT);
       BlMv= FALSE;

       if(InList)
         {
         /*Baustein N*/
          if(   NOb==G_PR && Item1->Type==GRAM_TERM
             || NOb==G_RD && NtAct)
            {dbg("BSt:N, Lev2=%u, Move=%u", Lev2, Move);
             gram_putline(&Lev2, &Move, FFC12,
                          "for(_NCurr=0;_NCurr<%s;_NCurr++)\n",
                          Item1->Type==GRAM_TERM? FdIn: "_Count");
            /*if(NOb==G_PR && !Item1->ListSeps)*/
             if(!BlBc)
                BlMv=TRUE;
            }
         /*Baustein F*/
          else if(  (NOb==G_PR || NOb==G_WR) && NtAct
                  || NOb==G_IM && Item1->Type==GRAM_NONTERM)
            {dbg("BSt:F, Lev2=%u, Move=%u", Lev2, Move);
             gram_putline(&Lev2, &Move, FFC12,
                          "for(%s_Node=%s;%s_Node;"
                              "%s_Node=%s_Node->Tail)\n",
                          Item1->Field, FdIn, Item1->Field,
                          Item1->Field, Item1->Field);
             /*if(NOb!=G_PR || !Item1->ListSeps)*/
             if(!BlBc)
                BlMv=TRUE;
            }
         }
         /*Baustein I*/

       if(NOb==G_WR && NtAct && !AltTerm && Item1->SuffSign =='?')
         {dbg("BSt:I(WR), Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12, "if(%s)\n", FdPtr);
          BlMv=TRUE;
         }

       else if(   Item1->SuffSign=='?'
               && (      (NOb==G_PR /*|| NOb==G_WR*/ || NOb==G_CL)
                      && (   Item1->Type==GRAM_STDACT
                          ||    Item1->Type==GRAM_NONTERM
                           /*  && gram_sctpit(FALSE, Item1)*/
                         )
                   || NOb==G_IM && Item1->Type==GRAM_NONTERM
                  )
              )
         {dbg("BSt:I, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12, "if(%s)\n", FdIn);
          BlMv=TRUE;
         }

         /*Baustein {*/
       if(BlBc)
         {dbg("BSt:{, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12, "{");
         }
       else if(BlMv) {Lev2++; Indented++;}

         /*Baustein S*/
       if(   NOb==G_RD && Item1->Type==GRAM_STDACT && VarSize)
         {dbg("BSt:S, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12,
                       "fread(&_Size,sizeof(ushort),1,_IOFile);\n");
         }
         /*Baustein A*/
       if(   NOb==G_RD
          && !StruOp
          && (   Item1->Type==GRAM_STDACT
              || Item1->Type==GRAM_TERM && InList))
         {dbg("BSt:A, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12,
                       "ASSERT(%s=malloc(%s),"
                       " ABBRUCH, EC_NotEnoughMemory,"
                       "\" Kein Speicher f. %s (L=%s)\");\n",
                       FdIn, Size, FdIn, Size);
         }
         /*Baustein J*/
       if(NOb==G_PR)
          if(InList && Item1->ListSeps)
             if(Item1->Type==GRAM_TERM)
               {dbg("BSt:J1, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                             "if(_NCurr) fputs(%s,_IOFile);\n",
                             Item1->ListSeps->Head);
               }
             else
               {dbg("BSt:J2, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                             "if(%s_Node!=%s) fputs(%s,_IOFile);\n",
                             Item1->Field, FdIn, Item1->ListSeps->Head);
               }
          else if(  Item1->Type==GRAM_STDACT
                  || Item1->Type==GRAM_TERM)
             gram_putline(&Lev2, &Move, FFC12,"fputc(' ',_IOFile);\n");

         /*Baustein C*/
       if(NOb==G_RD || NOb==G_PR || NOb==G_WR)
          gram_putline(&Lev2, &Move, FFC12, "_Rt= ");

       if(InList && NtAct && NOb!=G_CL)
          if(NOb==G_RD)
             sprintf(FdParm, "%s%s_Current",
                        InList
                     && Item1->Type!=GRAM_STDACT
                     && (   Item1->Type!=GRAM_NONTERM
                         || Item1->Term.NonTerminal->TpStdRef
                            >=GRAM_ACT_NONSTD
                        )
                     ? "&": "",
                     Item1->Field);
          else sprintf(FdParm, "%s_Node->Head", Item1->Field);
       else if(   NOb==G_RD
               && Item1->Type==GRAM_NONTERM
               && (TNr=Item1->Term.NonTerminal->TpStdRef)
                  >=GRAM_ACT_NONSTD)
               /*&& !ScTp1)*/
          strcpy(FdParm, FdOut);
       else
          strcpy(FdParm, FdIn);
       DBG_D1('%s', FdParm)

       switch(Item1->Type)
         {case GRAM_TERM:
             if(NOb==G_PR)
               {dbg("BSt:C(T)1, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                             "fputs(\"%s\",_IOFile);\n",
                             Item1->Term.Terminal);
               }
             else if((NOb==G_WR || NOb==G_RD) && InList)
               {dbg("BSt:C(T)2, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                             "f%s(&%s,sizeof(unsigned),1,_IOFile);\n",
                             genobs[NOb], FdParm);
               }
             break;

          case GRAM_STDACT:
             if(Item1->Term.StdAction==GRAM_ACT_DATE && NOb==G_RD)
               {dbg("BSt:C(A)1, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                            stdactions[Item1->Term.StdAction].Call[NOb],
                            FdParm, FdParm);
                gram_putline(&Lev2, &Move, FFC12, "\n");
               }
             else if(NOb==G_CL && InList)
               {dbg("BSt:C(A)2, Lev2=%u, Move=%u", Lev2, Move);
                strcpy(Fun,stdactions[Item1->Term.StdAction].Call[NOb]);
                if(!*Fun) strcpy(Fun, "NULL");
                else if(Sw=strchr(Fun,'(')) *Sw= 0x0;
                gram_putline(&Lev2, &Move, FFC12,
                             "LST_CLEAR1(%s,%s);\n", FdParm, Fun);
               }
             else if(NOb!=G_IM)
               {dbg("BSt:C(A)3, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                            stdactions[Item1->Term.StdAction].Call[NOb],
                            FdParm);
                gram_putline(&Lev2, &Move, FFC12, "\n");
               }
             break;

          case GRAM_NONTERM:
             if(NOb==G_CL && InList)
               {dbg("BSt:C(N)1, Lev2=%u, Move=%u", Lev2, Move);
                if(ScTp1)
                   gram_putline(&Lev2, &Move, FFC12,
                                "LST_CLEAR1(%s,NULL);\n", FdParm);
                else
                   gram_putline(&Lev2, &Move, FFC12,
                                "LST_CLEAR1(%s,%s_clear);\n",
                                FdParm, Item1->Term.NonTerminal->NameF);
               }
             else if(NOb==G_PR && !*Item1->TpPRef)
               {dbg("BSt:C(N)0, TNr=%u, Lev2=%u, Move=%u",
                    TNr, Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                             "%s_%s(_IOFile);\n",
                             Item1->Term.NonTerminal->NameF,
                             genobs[NOb]);
               }
             else if(   NOb!=G_PR
                    && (TNr=Item1->Term.NonTerminal->TpStdRef)
                       <GRAM_ACT_NONSTD)
               {dbg("BSt:C(N)2, TNr=%u, Lev2=%u, Move=%u",
                    TNr, Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                            stdactions[TNr].Call[NOb], FdParm);
                gram_putline(&Lev2, &Move, FFC12, "\n");
               }
             else
               {dbg("BSt:C(N)3, Lev2=%u, Move=%u", Lev2, Move);
                gram_putline(&Lev2, &Move, FFC12,
                             "%s_%s(%s%s%s);\n",
                             Item1->Term.NonTerminal->NameF,
                             genobs[NOb],
                             NOb==G_PR || NOb==G_WR || NOb==G_RD?
                             "_IOFile,": "",
                             FdParm,
                             NOb==G_IM? ", _Res":"");
               }
         } /*switch*/


         /*Baustein E*/
       if(NOb==G_WR && NtAct && !AltTerm && Item1->SuffSign =='?')
         {
          if(BlMv) {Lev2--; Indented--;}
          dbg("BSt:E, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12,
                       "else fwrite(%s, 1, 1, _IOFile);\n", FdPtr);
         }
         /*Baustein L*/
       else if(NOb==G_RD && InList && NtAct)
         {dbg("BSt:L, Lev2=%u, Move=%u", Lev2, Move);
          if(ScTp0)
             gram_putline(&Lev2, &Move, FFC12,
                          "%s_Last=(%s) LST_APPEND(%s_Last,memdup"
                          "(&%s_Current,sizeof(%s_Current)));\n",
                          Item1->Field, Item1->TpPRef, Item1->Field,
                          Item1->Field, Item1->Field);
           else
             gram_putline(&Lev2, &Move, FFC12,
                          "%s_Last=(%s)"
                          " LST_APPEND(%s_Last,%s_Current);\n",
                          Item1->Field, Item1->TpPRef,
                          Item1->Field, Item1->Field);
          gram_putline(&Lev2, &Move, FFC12,
                       "if(_NCurr) %s=%s_Last;\n", FdIn, Item1->Field);
         }

         /*Baustein }*/
       if(BlBc)
         {dbg("BSt:}, Lev2=%u, Move=%u", Lev2, Move);
          gram_putline(&Lev2, &Move, FFC12, "}\n");
         }

       while(Indented) {Lev2--;Indented--;}

     /* Nachtrag union*/
       if(   Seq->InfSign=='|'
          && Items->Tail
          && Items->Tail->Head->Type!=GRAM_EMPTY)
         {dbg("break");
          gram_putline(&Lev2,&Move,FFC12,"break;\n");
         }

      } /*if(zu bearbeiten)*/
   } /*for(Items...)*/

    /*---- Klammern schliessen ----*/
 DBG_D1(%u, Lev2)
 while(Lev2>Lev0) gram_putline(&Lev2,&Move,FFC12,"}\n");

 Rt--;
 DBG_D1(%u,Rt);
 MSG_END();
 return Rt;
} /*gram_genclr*/



/*==gram_genepl==== Schreibt Epilog des Headerfiles===================*/
static void gram_genepl()
{size_t      Lng;
 tp_strings *Fsw;
 FILE *FFH12, *FFC12;
 char       *NC1;
 int         NOb;

 for(NOb=0; NOb<G_OBJQ; NOb++) if(env_.GenNrs[NOb]==NOb)
   {FFH12= env_.GenFFs[NOb][G_EXT_H1][G_PART2];
    FFC12= env_.GenFFs[NOb][G_EXT_C][G_PART2];
    NC1= env_.GenMods[NOb][G_EXT_C];
    Lng=strlen(NC1);
    fprintf(FFH12,"\n#undef DCL_FN\n\n");
    fprintf(FFH12,"#endif\n");

    fprintf(FFC12,"/*==%s_gate%.*s*/\n", NC1,MAXOUTLINE-11-Lng,sectsep);
    fprintf(FFC12,"static void *%s_gate"
                  "(void *EnvInp,const char *Mode)\n",
                  NC1);
    fprintf(FFC12,"{static const char *Routine=\"%s_gate\";\n", NC1);
    fprintf(FFC12," void *EnvOut;\n");
    fprintf(FFC12," QV_SETRUN(Modul,Routine,Mode);\n");
    fprintf(FFC12," EnvOut= MAG2002(EnvInp,Mode);\n");
    fprintf(FFC12," MAG2004(EnvOut, Mode);\n");
 /*fprintf(FFC12," MAG2008(EnvOut, Mode);\n");*/
    fprintf(FFC12," MAG1016(EnvOut, Mode);\n");
    fprintf(FFC12," MAG2032(EnvOut, Mode);\n");
    fprintf(FFC12," MAG2050(EnvOut, Mode);\n");
    fprintf(FFC12," MAG2052(EnvOut, Mode);\n");
    for(Fsw=env_.InitFns; Fsw; Fsw=Fsw->Tail)
       fprintf(FFC12," %s(EnvOut, Mode);\n",Fsw->Head);

    fprintf(FFC12," return EnvOut;\n");
    fprintf(FFC12,"}\n\n");
    fprintf(FFC12,"#ifndef MTP_FETCH\n\n");
    fprintf(FFC12,"/*===%s== statische openMAG %.*s*/\n",
                  NC1,MAXOUTLINE-28-Lng,sectsep);
    fprintf(FFC12,"void *%s(void *Env, const char *Mode)\n",NC1);
    fprintf(FFC12,"{static const char *Routine=\"%s\";\n",NC1);
    fprintf(FFC12," LINK_TEST(Modul,Routine,LINK_STAT)\n");
    fprintf(FFC12," return %s_gate(Env, Mode);\n",NC1);
    fprintf(FFC12,"}\n\n");
    fprintf(FFC12,"#else\n\n");
    fprintf(FFC12,"/*===%s_open%.*s*/\n",NC1,MAXOUTLINE-12-Lng,sectsep);
    fprintf(FFC12,"void *%s_open(void *Env, const char *Mode)\n",NC1);
    fprintf(FFC12,"{static const char *Routine=\"%s_open\";\n",NC1);
    fprintf(FFC12," LINK_TEST(Modul,Routine,LINK_FETCH)\n");
    fprintf(FFC12," return %s_gate(Env, Mode);\n",NC1);
    fprintf(FFC12,"} /*%s_open*/\n\n",NC1);
    fprintf(FFC12,"/*===%s%.*s*/\n",NC1,MAXOUTLINE-7-Lng,sectsep);
    fprintf(FFC12,"void *%s(int ix)\n",NC1);
    fprintf(FFC12,"{\n");
    fprintf(FFC12,"static void (*Fun[])()=\n");
    fprintf(FFC12,"{NULL,\n");
    fprintf(FFC12,"#define DCL_FN(tpret,fname,pformal)"
                  " VOIDFUN &fname,\n");
    fprintf(FFC12,"#include \"%s\"\n",env_.GenMods[NOb][G_EXT_H1]);
    fprintf(FFC12," NULL};\n");
    fprintf(FFC12," FT_ADDFUN(%s,Fun,ix);\n",NC1);
    fprintf(FFC12," }\n");
    fprintf(FFC12,"#endif /*MTP_FETCH*/\n");
   } /*for() if()*/
} /*gram_genepl*/


/*===gram_putline===(mmii)=== Ausdruck einer Codezeile==================
 * BESCHREIBUNG: C-Formatierte Textausgabe.
 *               Beruecksihtigt MAXLINE und newline-Zeichen,
 *               berechnet Level und Indent.
 * HINWEIS:      Keine Rcksicht auf interne Klammern!
 *               D.H., unbilanzierte Klammer muss 1. nicht leeres
 *               Zeichen sein
 * Parameter:   *Lev   Laufende {}-Ebene,
 *              *Move  Anzahl zusatzlich auszudruckender Leerzeichen
 *              *FFC12 Ausgabefile
 *              *Fmt   Formatstring (s. printf)
 *            ..  .    Zusatzliche Parameter (s. printf)
 *====================================================================*/
static void gram_putline(unsigned *Lev, unsigned *Move,
                         FILE *FFC12, char *Fmt,...)
{va_list     Ap;
 unsigned    ABr= 0;   /*Any bracket: 0|1*/
 bool        Arrow= FALSE;
 bool        BegL=TRUE, BegT;
 size_t      Col1;
 bool        Cont;
 size_t      End0=0;
 size_t      Indent,IndCurr;
 unsigned    LBr= 0;   /*Left bracket: 0|1*/
 size_t      LMs,LOut,LSp=0,Lw;
 unsigned    QS;       /*Count of pasted tokens*/
 unsigned    QUn=0;    /*Count of attempts to close unopen brackets*/
 char        Spc[MAXOUTLINE+2];
 char        Ss[MAXMSGSIZE];
 char       *Sc;
 char        SepFirst=0, SepCurr, SepNext;
 char       *Sn,*SOut,*Sw;
 tp_lexs    *Tks=NULL;
 tp_tktype   TkTp,Tps;
 MSG_DCL("gram_putline");

 ASSERT(Lev, ABBRUCH,EC_InternalError,"Lev == NULL!");
 ASSERT(Move,ABBRUCH,EC_InternalError,"Move== NULL!");
 ASSERT(Fmt, ABBRUCH,EC_InternalError,"Fmt == NULL!");
 ASSERT(FFC12,ABBRUCH,EC_InternalError,"FFC12== NULL!");
 if(dbg("*Lev=%u,*Move=%u,ptpos=%u",*Lev,*Move,ptpos))
   {printf("Fmt:"); puts(Fmt);}

 va_start(Ap,Fmt);
 vsprintf(Ss,Fmt,Ap);
 va_end(Ap);

 ASSERT((LMs=strlen(Ss))<MAXMSGSIZE,ABBRUCH,EC_InternalError,
       qv_msg("Zu lange Meldung. L=%u (MAX=%d), Text:\n'%s'",
              LMs,MAXMSGLEN,Ss));

 if(Ss[0])
   {
    memset(Spc,' ',MAXOUTLINE+1); Spc[MAXOUTLINE+1]=0x0;

    for(Sc=Ss; isspace(*Sc);) Sc++;
    if(*Sc=='}') ABr=1;
    for(Sc=Ss; *Sc && (isspace(*Sc) || *Sc=='{'); Sc++)
       if(*Sc=='{') {*Lev+=1;ABr=LBr=1;}

    Indent= 1+ *Lev*INDENT + *Move -ABr;
    MIN1(Indent,3*(MAXOUTLINE>>2));

    if(ABr || ptpos) *Move= 0;
    IndCurr= ptpos? 0: Indent;
    DBG_D3(%u,*Move,%u,ABr,%u,Indent)

    if(dbg("ptpos=%u, putline output (%u spaces, %u chars):=",
           IndCurr,ptpos,LMs))
       qv_printf("%.*s%s\n", IndCurr,Spc,Ss);

    if(ptpos+LMs+IndCurr<=MAXOUTLINE)
      {ptpos+=fprintf(FFC12,"%.*s%s", IndCurr,Spc,Ss);
       if(Sw=strrchr(Ss,'\n')) ptpos=strlen(Sw)-1;
      }
    else
      {
       TRY
          tks_scans(&Tks,NULL,Ss,0,0); tks_dbgs(Tks);
       RECOVER
          qv_printf(err_msg());
          ASSERT(0, err_rc(), err_ec(),
                 qv_msg("Fehlerhaftes String: '%s'", Ss));
       END

       do  /*Lines-loop*/
         {Cont=TRUE; QS=0;
          SOut=NULL; LOut=0; BegT=TRUE;

          /*Tks-loop*/
          while(   (TkTp=tks_get(&Sw,&SepCurr,NULL,NULL,&Col1,Tks))
                   !=TKS_NO
                && (!SOut || SepCurr<=1 && Cont))
            {
             if(   Arrow && BegT
                ||    !strcmp(Sw,"-")
                   && tks_get(&Sn,&SepNext,NULL,NULL,NULL,Tks->Tail)
                      !=TKS_NO
                   && !strcmp(Sn,">")
                   && !SepNext)
               {Sw="->";
                if(!Arrow)
                  {Arrow=TRUE;
                   tks_del(&Tks,TKS_DEL1);
                  }
               }
             else Arrow= FALSE;

             Lw=strlen(Sw);
             dbg("TkTp=%d,Sw='%s',LSw=%u",(int)TkTp,Sw,Lw);
             SepFirst=
                BegT && (ptpos && !BegL || SepCurr>2) && SepCurr>1?
                SepCurr: 0;
             if(SOut)
               {if(!SepCurr) LSp=0;
                else LSp=Col1>=End0? Col1-End0: 1;
                Cont=ptpos+IndCurr+LSp+LOut+Lw<=MAXOUTLINE;
               }
             if(Cont)
               {if(LSp) stc_grown(&SOut,NULL,Spc,LSp);
                STR_GROW(&SOut,Sw);
                LOut=strlen(SOut);
                Tps=TkTp;
                DBG_D2('%s',SOut,%u,LOut);
                End0=Col1+Lw;
                QS++;
                tks_del(&Tks,TKS_DEL1);
                Arrow= FALSE;
               }
             dbg("------------Cont=%d,Col1=%u,End0=%u",
                 (int)Cont,Col1,End0);
             BegT= FALSE;
            } /*while - Tks-loop*/
          dbg("============After tks-loop: ptpos=%u,IndCurr=%u",
              ptpos,IndCurr);
          if(SepFirst)
            {
             ptpos=0;
             do
               {SepFirst>>=1; fputc('\n',FFC12);}
             while(SepFirst&2);
            }
          if(SOut)
            {if(ptpos+IndCurr+LOut<MAXOUTLINE)
               {ptpos+=fprintf(FFC12, "%.*s%s", IndCurr,Spc,SOut);
                if(Tks) {fputc('\n',FFC12); ptpos=0;}
               }
             else if(ptpos+LOut+!!LSp<MAXOUTLINE)
                {
                 fprintf(FFC12,"%*.*s%s\n",
                         !!ptpos,MAXOUTLINE-ptpos-LOut,Spc,SOut);
                 ptpos=0;
                }
             else
               {if(ptpos) {fputc('\n',FFC12);ptpos=0;}
                if(LOut<MAXOUTLINE)
                   fprintf(FFC12,"%.*s%s\n",MAXOUTLINE-LOut,Spc,SOut);
                else
                  {DBG_D2(%u,QS,%d,(int)TkTp);
                   ASSERT(   QS==1
                          && (   Tps==TKS_LIT  || Tps==TKS_COMM
                              || Tps==TKS_ULIT || Tps==TKS_UCOMM),
                          ABBRUCH,EC_InternalError,
                          qv_msg("Programmfehler bei Formatierung der "
                                 "Ausgabefolge:\n'%s'\n"
                                 "Formatiertes Teil:\n'%s'\n"
                                 "Laufendes Teil:\n'%s'\nToken type=%d",
                                 Ss,SOut,Sw,(int)TkTp));
                   gram_putlit(SOut,IndCurr,FFC12);
                  }
               }
             IndCurr= Indent+3;
             DBG_D2(%u,IndCurr,%u,ptpos);
             free(SOut); LOut=0;
            }
          BegL=FALSE;
         } while(Tks); /*do - Lines-loop*/

       if(Sw=strrchr(Ss,'\n'))
          while(*Sw=='\n')
            {fputc('\n',FFC12);ptpos=0;
             if(Sw==Ss) break;
             Sw--;
            }
      } /*if(strlen(Ss)+IndCurr<=MAXOUTLINE) / else*/

    if(LBr)
       for(Sc=Ss+strlen(Ss)-1; *Sc && (*Sc=='}' || isspace(*Sc)); Sc--)
         {if(*Sc=='}')
             if(*Lev) *Lev-=1;
             else QUn++;
          if(Sc==Ss) break;
         }
    else
       for(Sc=Ss; *Sc && *Sc && (*Sc=='}' || isspace(*Sc)); Sc++)
          if(*Sc=='}')
             if(*Lev) *Lev-=1;
             else QUn++;

    ASSERT(!QUn,WARNUNG,EC_InternalError,
           qv_msg("Ungeoeffnete Klammer wird geschlossen\n."
                  "Anzahl der Faelle: %u\nText;\n'%s'",QUn,Ss));
    dbg("*Lev=%u,*Move=%u,ptpos=%u",*Lev,*Move,ptpos);
   } /*if(Ss[0])*/
 else dbg("*Ss=0x0");
 MSG_END();
} /*gram_putline*/


/*==gram_putlit===(iii)=================================================
 * Ausdruck eines [langen] Textliterals.
 * Der Literal kann geteilt werden.
 * Die Spezifik von '\' und '%' wird beruecksichtigt
 *====================================================================*/
static void gram_putlit(char *Sd, unsigned Indent, FILE *FFC12)
{bool     Beg=TRUE;
 int      Ls;
 int      LOut,MxOut;
 char    *Sw;
 MSG_BEG("gram_putlit");
 MxOut= MAXOUTLINE-2-Indent;
 Ls=(int)strlen(Sd);
 Sw=Sd;
 while(Ls>0)
   {if(!ptpos) ptpos=fprintf(FFC12,"%*s",Indent," ");
    if(!Beg) fprintf(FFC12,"\""); else Beg=FALSE;
    if(Ls>LOut)
       for(LOut=MxOut;LOut && strchr("\\%",*(Sw+LOut-1));)
          LOut--;
    fprintf(FFC12,"%.*s",LOut,Sw);
    dbg("putlit: '%.*s'",LOut,Sw);
    if(Ls>LOut) fprintf(FFC12,"\"");
    fputc('\n',FFC12); ptpos=0; dbg("NEWLINE");
    Ls-=LOut; Sw+=LOut;
   }
 MSG_END();
} /*gram_putlit*/


/***** #9 SPEICHERFREIGABE ********/

/*==gram_tobedel===(ii)=================================================
 * Liefert 1 zurueck, wenn die Regel geloescht sein soll
 *====================================================================*/
static int gram_tobedel(void *Unused,gram_rule1 *Rule)
{int Rt;
 MSG_BEG("gram_tobedel");
 Rt= !(Rule->Mark & GRAM_TODIE);
 dbg("Rule->Name=%s,Rt=%d",STR_NOT0(PVAR_GETNAME(Rule->PVar)),Rt);
 MSG_END();
 return Rt;
} /*gram_tobedel*/


/*==gram_clrrule=== Loescht eine Regel, gibt Speicher frei ===========*/
static void gram_clrrule(gram_rule1 *Rule)
{
 MSG_DCL("gram_clrrule");
 dbg("Clearing @Rule=%lu,NameF=(%lu)'%s'",
     (ulong)Rule,(ulong)Rule->NameF,(ulong)Rule->NameF);
 if(Rule->NameF)
   {free((char *)Rule->NameF);
    Rule->NameF= NULL;
   }
 if(Rule->NameV)
   {free((char *)Rule->NameV);
    Rule->NameV= NULL;
   }
 LST_CLEAR(&Rule->Args,gram_clrarg1);
 free(Rule);
 Rule= NULL;
 MSG_ENDD();
} /*gram_clrrule*/


/*==gram_clritem1=====================================================*/
static void gram_clritem1(gram_item1 *It)
{
 MSG_DCL("gram_clritem1");
 if(dbg("deleting")) {gram_ptitem1(stdout,It);puts("");}
 switch(It->Type)
   {
    case GRAM_SEQ:
       LST_CLEAR(&It->Term.Seq->Items,gram_clritem1);
       if(It->Term.Seq->Bracket) free(It->Term.Seq->Bracket);
       free((gram_seq *) It->Term.Seq);
       break;
    case GRAM_TERM:   free((char *)It->Term.Terminal); break;
   }
 MSG_ENDD();
} /*gram_clritem1*/


/*==gram_clrarg1======================================================*/
static void gram_clrarg1(tp_strings *Arg)
{
 MSG_DCL("gram_clrarg1");
 LST_CLEAR(&Arg,free);
 MSG_ENDD();
} /*gram_clrarg1*/


/*==gram_clear========================================================*/
void gram_clear(tp_gram Gram)
{gram_rules *NextRs;
 tp_pvar     PVar;
 gram_rules *Rlw;
 MSG_DCL("gram_clear");
 for(Rlw=Gram->Rules; Rlw; Rlw=Rlw->Tail)
   {if(Rlw->Head->Seq)
      {LST_CLEAR(&Rlw->Head->Seq->Items,gram_clritem1);
       free((gram_seq *) Rlw->Head->Seq);
      }
    if(   (NextRs=Rlw->Tail)
       && NextRs->Head->PVar!=(PVar=Rlw->Head->PVar))
       pvar_clear(PVar,TRUE);
   }
 LST_CLEAR(&Gram->Rules,gram_clrrule);
 LST_CLEAR(&Gram->UsrActs,free);
 Gram->id= 0; Gram->end=0x0;
 free(Gram);
 MSG_ENDD();
} /*gram_clear*/


/**#10 PLAUSI BLOCK. DIE HAUPTFUNKTION IST gram_plausiopt (s. unten) **/

/*===pl_bend===(ii)===================================================*/
static unsigned pl_bend(unsigned Q,char **Objs,char **Objn)
{unsigned Rt= 0;
 unsigned J;
 MSG_DCL("pl_bend");
 if(env_.RuleEnd)
   {for(J=0; J<Q; J++)
       pl_warn(!Objs[J] || stricmp(env_.RuleEnd,Objs[J]),
               Rt,105471,
              qv_msg("Bezeichnung Regelsende und %s sind identisch:'%s'"
                    ,Objn[J],Objs[J]));
   }
 else
    for(J=0; J<Q; J++)
       pl_warn(/*   Objs[J]!=env_.RuleBegin
              &&*/ !(   Objs[J]
                   && env_.RuleBegin
                   && !stricmp(env_.RuleEnd,Objs[J])),
               Rt,105472,
              qv_msg("Bezeichnung Regelsbeginn und %s sind identisch:"
                     "'%s'",
                     Objn[J],Objs[J]));
 MSG_END();
 return Rt;
} /*pl_bend*/

/*===pl_diffobj===(ii)================================================*/
static bool pl_diffobj(char *E1,char *E2)
{return (bool)(!E1 || !*E1 || !E2 || !*E2 || stricmp(E1,E2));}

/*===pl_diffgr1===(iii)=================================================
 * 2 gleiche Bezeichnungen innerh. der Gruppe - Fehler
 =====================================================================*/
static unsigned pl_diffgr1(unsigned Q,char **Objs,char **Objn)
{unsigned Rt= 0;
 unsigned I,J;
 MSG_DCL("pl_diffgr1");
 for(I=0; I<Q-1; I++)
    for(J=I+1; J<Q; J++)
       pl_warn(pl_diffobj(Objs[I],Objs[J]), Rt,105473,
              qv_msg("Gleiche Bezeichnungen fuer %s und %s",
                     Objn[I],Objn[J]));
 MSG_END();
 return Rt;
} /*pl_diffgr1*/

/*===pl_diffgr20===(iiiiii)=============================================
 * Vergleich v. 2 untersch. Gruppen. (0,0) ist OK
 *====================================================================*/
static unsigned pl_diffgr20(unsigned Q1,char **Objs1,char **Objn1,
                            unsigned Q2,char **Objs2,char **Objn2)
{unsigned Rt= 0;
 unsigned I,J;
 MSG_DCL("pl_diffgr20");
 for(I=0; I<Q1; I++)
    for(J=0; J<Q2; J++)
       pl_warn(pl_diffobj(Objs1[I],Objs2[J]), Rt,105474,
               qv_msg("Gleiche Bezeichnungen fuer %s und %s",
                      Objn1[I],Objn2[J]));
 MSG_END();
 return Rt;
} /*pl_diffgr20*/

/*===pl_diffgr21===(iiiiii)=============================================
 * Vergleich v. 2 untersch. Gruppen. (0,0) ist Fehler
 *====================================================================*/
static unsigned pl_diffgr21(unsigned Q1,char **Objs1,char **Objn1,
                            unsigned Q2,char **Objs2,char **Objn2)
{unsigned Rt= 0;
 unsigned I,J;
 MSG_DCL("pl_diffgr21");
 for(I=0; I<Q1; I++)
    for(J=0; J<Q2; J++)
       pl_warn(   Objs1[I]!=Objs2[J]
               && (   !Objs1[I] || !Objs2[J]
                   || stricmp(Objs1[I],Objs2[J])),
               Rt,105475,
               qv_msg("Gleiche Bezeichnungen fuer %s und %s",
                      Objn1[I],Objn2[J]));
 MSG_END();
 return Rt;
} /*pl_diffgr21*/

/*===pl_nonpar===(iii)=== Klammer als Bezeichnung ist ein Fehler =====*/
static unsigned pl_nonpar(unsigned Q,char **Objs,char **Objn)
{unsigned Rt= 0;
 unsigned J;
 MSG_DCL("pl_nonpar");
 for(J=0; J<Q; J++)
    pl_warn(!Objs[J] || !strpbrk(Objs[J],"()"),  Rt,105476,
            qv_msg("Klammer als [Teil von] Bezeichnung fuer %s ist "
                   "nicht erlaubt",
                   Objn[J]));
 MSG_END();
 return Rt;
} /*pl_nonpar*/

/*===pl_nonqt===(iii)=== Hochkomma als Bezeichnung - Fehler ==========*/
static unsigned pl_nonqt(unsigned Q,char **Objs,char **Objn)
{unsigned Rt= 0;
 unsigned J;
 MSG_DCL("pl_nonqt");
 for(J=0; J<Q; J++)
    pl_warn(!Objs[J] || !strpbrk(env_.Quotes,Objs[J]), Rt,105477,
            qv_msg("Hochkomma als Bezeichnung fuer %s ist nicht"
                   " erlaubt",
                   Objn[J]));
 MSG_END();
 return Rt;
} /*pl_nonqt*/

#define PLOBJQX   5
enum    {PL_ELM=0,PL_SEP,PL_CLS,PL_OPS,PL_BEND,PLGRPQ};

/*===gram_plausiopt===(i)=============================================*/
static void gram_plausiopt(char *Mode)
{
/* Fuer PLAUSIopts*/
 bool     BOE; /*Beginn oder Ende der Regel definiert*/
 bool     AAS; /*Bezeichnungen fuer Alternativen und Folgen beide def.*/
 unsigned G,J,K;
 char    *Objn[PLGRPQ][PLOBJQX]=
  {{"Aktion","Cut","Empty","NT","Term"},
   {"Alternativen","Mengen","Folgen","Folgenfortsetzung",
    "Listentrenner"
   },
   {"Clauses",NULL,NULL,NULL,NULL},
   {"Listen","Optionelle Elemente","Optionelle Listen",NULL,NULL},
   {"Regelbeginn","Regelende",NULL,NULL,NULL}
  };
 unsigned Objq[PLGRPQ]={5,5,1,3,2};
 char    *Objs[PLGRPQ][PLOBJQX];
 unsigned QErr= 0;
 char    *Sw;
 MSG_DCL("gram_plausiopt");

 /*** A. Initialisierung des Objs-Feldes ***/
 /*----------------------------------------*/

 for(J=0;J<Objq[PL_ELM];J++)
   {Objs[PL_ELM][J]=malloc(2); Objs[PL_ELM][J][1]=0x0;}
 Objs[PL_ELM][0][0]= env_.Action; Objs[PL_ELM][1][0]= env_.Cut;
 free(Objs[PL_ELM][2]);           Objs[PL_ELM][2]= env_.Empty;
 Objs[PL_ELM][3][0]= env_.NT;     Objs[PL_ELM][4][0]= env_.Term;

 Objs[PL_SEP][0]=env_.Alt; Objs[PL_SEP][1]=env_.Mult;
 Objs[PL_SEP][2]=env_.Seq; Objs[PL_SEP][3]=env_.Cont;
 Objs[PL_SEP][4]=malloc(2);
 Objs[PL_SEP][4][0]=env_.LstSep;
 Objs[PL_SEP][4][1]=0x0;

 if(Sw= MAG1000(Modul,"CLAUSES",Mode))
   {Objs[PL_CLS][0]= str_strip(NULL,Sw);
    free(Sw);
   }
 else Objs[PL_CLS][0]= NULL;

 Objs[PL_OPS][0]=env_.List;
 Objs[PL_OPS][1]=env_.Optional;
 Objs[PL_OPS][2]=env_.OptList;

 Objs[PL_BEND][0]= env_.RuleBegin; Objs[PL_BEND][1]= env_.RuleEnd;

 /*** Pruefungen innerhalb der Gruppen ***/

 /* 0. Elemente */

 pl_warn(env_.NT || env_.Term, QErr,105481,
        qv_msg("0-Bezeichnungen fuer beide NT und Terminaele"));
 pl_warn(!env_.Cut || !strchr(env_.Quotes,env_.Cut), QErr,105482,
        qv_msg("Hochkomma als Cut-Bezeichnung"));

 /* 1. Folgen/Alternativen/Mengen */
 for(J=0;J<Objq[PL_SEP]-2;J++)
    for(K=J+1;K<Objq[PL_SEP];K++)
       pl_warn(pl_diffobj(Objs[PL_SEP][J],Objs[PL_SEP][K]),
               QErr,105483,
               qv_msg("Bezeichnungen fuer %s und %s "
                      "sollen unterschiedlich sein",
                      Objn[PL_SEP][J],Objn[PL_SEP][K]));
 pl_warn(      (   !env_.Alt
               || (*env_.Alt!='\n' && stricmp(env_.Alt,"\\n")))
           && (   !env_.Mult
               || (*env_.Mult!='\n' && stricmp(env_.Mult,"\\n")))
        || !env_.Cont || !*env_.Cont,
         QErr,105484,
         qv_msg("CONT-Parameter spezifiziert waehrend 'newline' als "
                "Bezeichnung fuer Alternative oder Menge definiert"));
 QErr+= pl_nonqt(Objq[PL_SEP],Objs[PL_SEP],Objn[PL_SEP]);

 /* 2. Kopftrenner */
 QErr+= pl_nonqt(Objq[PL_CLS],Objs[PL_CLS],Objn[PL_CLS]);

 /* 3. List/optional */
 QErr+= pl_nonqt(Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS]);

 /* Gleichartig fuer alle Gruppen ausser Beg/End*/
 for(G=0;G<=PL_OPS;G++)
   {QErr+= pl_diffgr1(Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS]);
    QErr+= pl_nonpar(Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS]);
   }

 /*** B. Gruppen-uebergreifende Pruefungen ***/
 /*------------------------------------------*/

 /* Vorbereitung */
 AAS= env_.Alt && *env_.Alt && env_.Seq && *env_.Seq;
 BOE=    env_.RuleBegin && *env_.RuleBegin
      || env_.RuleEnd && *env_.RuleEnd;

/* ELM <=> Sep
 * -----------
 *    Seq!=0 && Alt!=0
 * || (different(Elm[j],Seq) and different(Elm[j],Alt) foreach j in ELM)
*/
 if(!AAS)
    QErr+= pl_diffgr20(Objq[PL_ELM],Objs[PL_ELM],Objn[PL_ELM],
                       Objq[PL_SEP]-1,Objs[PL_SEP],Objn[PL_SEP]);

/*LISTSEP Wenn eine von Bezeichnungen ALT,MULT,SEQ,RULE_END leer
	  ist, dann sind auch weder '(', noch Zeichen fuer NT,
	  TERM und ACTION zulaessig.*/
 if(!AAS || !(env_.RuleEnd && *env_.RuleEnd))
    QErr+= pl_diffgr21(Objq[PL_ELM],Objs[PL_ELM],Objn[PL_ELM],
                       1,Objs[PL_SEP]+4,Objn[PL_SEP]+4);

/* ELM <=> Cls <=> Bend
 * --------------------
 * RuleBegin!=0 || RuleEnd!=0 || (Elm[j]!=Cls foreach j in ELM)*/
 if(!BOE)
    QErr+= pl_diffgr21(Objq[PL_ELM],Objs[PL_ELM],Objn[PL_ELM],
                       Objq[PL_CLS],Objs[PL_CLS],Objn[PL_CLS]);

/* ELM <=> OpPref
 * --------------
 * different(c[i],c[j])    foreach i in ELM, j in OpPS
 * ELM <=> OpSuf
 * -------------
 * Seq!=0 && Alt!=0
 * || different(c[i],c[j])    foreach i in ELM, j in OpPS*/
 if(!AAS || env_.Oper&1)
    QErr+= pl_diffgr20(Objq[PL_ELM],Objs[PL_ELM],Objn[PL_ELM],
                       Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS]);

/* ELM <=> Bend
 * ------------
 * Seq!=0 && Alt!=0
 * || RuleEnd!=0 && different(Elm[j],RuleEnd) foreach j in ELM)
 * || RuleEnd==0 && different(Elm[j],RuleBegin) foreach j in ELM)*/
 if(!AAS) QErr+= pl_bend(Objq[PL_ELM],Objs[PL_ELM],Objn[PL_ELM]);

/* SepI <=> Cls
 * ------------
 * RuleBegin!=0 || RuleEnd!=0 || Cls!=Seq && Cls!=Alt */
 if(!BOE)
    QErr+= pl_diffgr21(Objq[PL_SEP]-1,Objs[PL_SEP],Objn[PL_SEP],
                       Objq[PL_CLS],Objs[PL_CLS],Objn[PL_CLS]);

/* SepI <=> OpPref
 * ---------------
 * Seq!=0 && Alt!=0 ||
 * (different(Seq,c[j]) && different(Alt,c[j]) foreach j in OpPS)
 *
 * SepI <=> OpSuf
 * --------------
 * different(Seq,c[j]) && different(Alt,c[j]) foreach j in OpPS */
 if(!AAS || env_.Oper&2)
    QErr+= pl_diffgr20(Objq[PL_SEP],Objs[PL_SEP],Objn[PL_SEP],
                       Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS]);

/* SepI <=> Bend
 * -------------
 * RuleEnd==0 && different(Seq,RuleBegin) && different(Alt,RuleBegin) ||
 * RuleEnd!=0 && different(Seq,RuleEnd) && different(Alt,RuleEnd) */
 QErr+= pl_bend(Objq[PL_SEP],Objs[PL_SEP],Objn[PL_SEP]);

/* Cls <=> OpPS
 * ------------
 * RuleBegin!=0 || RuleEnd!=0 || (c[j]!=Cls foreach j in OpPS)*/
 if(!BOE)
    QErr+= pl_diffgr21(Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS],
                       Objq[PL_CLS],Objs[PL_CLS],Objn[PL_CLS]);

/* Cls <=> Bend
 * ------------
 * (RuleBegin!=0 || RuleEnd!=0 || Cls!=0) &&
 * different(Cls,RuleBegin) && different(Cls,RuleEnd) */
 pl_warn(BOE || Objs[PL_CLS] && Objs[PL_CLS][0],
         QErr,105485,
        qv_msg("Keiner von CLAUSE, BEGIN und END Parameter definiert"));

 QErr+= pl_diffgr20(Objq[PL_CLS],Objs[PL_CLS],Objn[PL_CLS],
                    Objq[PL_BEND],Objs[PL_BEND],Objn[PL_BEND]);

/* OpPS <=> Bend
 * -------------
 * Seq!=0 && Alt!=0
 * || RuleEnd==0 && (c[j]!=RuleBegin foreach j in OPS)
 * || RuleEnd!=0 && (c[j]!=RuleEnd foreach j in OPS) */
 if(!AAS)
    QErr+= pl_diffgr20(Objq[PL_BEND],Objs[PL_BEND],Objn[PL_BEND],
                       Objq[PL_OPS],Objs[PL_OPS],Objn[PL_OPS]);

 ASSERT(!QErr, AUSSTEUERN, 105486, "Fehlrhafte Optionsparameter");
 MSG_END();
} /*gram_plausiopt*/


/*#11 ALLGEMEINES SERVICE(INITIALIZATION,GETTING/SETTING PARAMETERS..)*/

/*===MAG1054_getEnv===================================================*/
void *MAG1054_getEnv()
{void  *Rt;
 size_t Szm=sizeof(struct str_env);
 MSG_DCL("MAG1054_getEnv");
 ASSERT(Rt=(char *)malloc(Szm),ABBRUCH,EC_NotEnoughMemory,
           qv_msg("Kann nicht eine Kopie von env-Variable (L=%u)"
                  " allokieren",
                  Szm));
 memcpy(Rt,&env_,Szm);
 MSG_ENDD();
 return Rt;
} /*MAG1054_getEnv*/

/*===MAG1054_setEnv===================================================*/
void MAG1054_setEnv(void *Env)
{struct str_env *Enw;
 size_t Szm=sizeof(struct str_env);
 MSG_DCL("MAG1054_setEnv");
 if(!(Enw= Env)) MAG1054_init();
 else
   {ASSERT(Enw->id==MID,ABBRUCH,EC_IllegalID,
           qv_msg("Inkorrekter ID uebergeben"));
    memcpy(&env_,Env,Szm);
   }
 MSG_ENDD();
} /*MAG1054_setEnv*/

/*===MAG1054_init=====================================================*/
void MAG1054_init()
{const char *Routine="MAG1054_init";
 int         NOb;
 memset(&env_,0,sizeof(struct str_env));
 env_.id= MID;
 /*Voreinstellungen*/
 /*RuleBegin*/
 env_.Action=   '"';
 env_.Alt=      strdup("|");
 env_.Args=     0;
 env_.BlIn=     NULL;
 env_.CaseIndep=TKS_CASEINDEP;
 tks_scans(&env_.ClTks,NULL,"=",0,0);
 env_.Empty=    strdup("E");
 env_.ExtNTs=   NULL;
 /*env_.Gener=    TRUE;*/
 for(NOb=0; NOb<G_OBJQ; NOb++) env_.GenNrs[NOb]= -1;
 env_.InclFiles= NULL;
 env_.InitFns=  NULL;
 env_.List=     strdup("+");
 env_.LLk=      TRUE;
 env_.LstSep=   '[';
 env_.MaxName=  TKS_MAXNAME;
 env_.Mult=     strdup(";");
 env_.NT=       '<';
 env_.Oper=     2;
 env_.OptList=  strdup("*");
 env_.Optional= strdup("?");
 env_.Quotes=   (char *)MAG1050_getOpt("QUOTES");
 env_.RuleEnd=  strdup(".");
 env_.Seq=      strdup(",");
 env_.Term=     '\'';
} /*MAG1054_init*/


/*===parse_ffpairs===(moo)=== Hilfsfunktion fuer MAG1054_init ========*/
void parse_ffpairs(tp_lexs **Tks,
                   tp_strings **InclFiles, tp_strings **InitFns)
{bool OK=TRUE;
 bool WasBrc;
 size_t Ln;
 char *Fl0="",*Fl1,*Fl2="",*Fl3="",*FlRes,*Fn;
 MSG_DCL("parse_ffpairs");

 ASSERT(Tks, ABBRUCH, EC_NullPointer, "Parameter #1 (Tks) == NULL");

 Fl0= parse_kw(Tks,"DD:", FALSE, SEP_OPT)? "DD:": "";
 parse_name(Tks, &Fl1,NULL,NULL,NULL,TRUE, SEP_OPT);
 if(parse_kw(Tks,".", FALSE, SEP_NO))
   {Fl2=".";
    parse_name(Tks, &Fl3,NULL,NULL,NULL,FALSE, SEP_NO);
   }
 WasBrc= parse_kw(Tks,"(", FALSE, SEP_OPT);
 if(!parse_name(Tks, &Fn,NULL,NULL,NULL,WasBrc, SEP_OPT))
   {Fn= strdup(Fl1); *Fn='M';}
 parse_kw(Tks, ")", WasBrc, SEP_OPT);

 Ln= strlen(Fl0)+strlen(Fl1)+strlen(Fl2)+strlen(Fl3)+1;
 ASSERT(FlRes=(char *)malloc(Ln), ABBRUCH, EC_NotEnoughMemory,
        qv_msg("Speicherprobleme. Kann nicht Filenamen allokieren"
               " (%u bytes)",
               Ln));
 sprintf(FlRes, "%s%s%s%s", Fl0,Fl1,Fl2,Fl3);
 ASSERT(*InclFiles=(tp_strings *)malloc(sizeof(tp_strings)),
        ABBRUCH, EC_NotEnoughMemory,
        "Speicherprobleme. Kann nicht Includefile-Knoten allokieren");
 (*InclFiles)->Head= FlRes;
 ASSERT(*InitFns=(tp_strings *)malloc(sizeof(tp_strings)),
        ABBRUCH, EC_NotEnoughMemory,
        "Speicherprobleme. Kann nicht Initialisierer-Knoten"
        " allokieren");
 (*InitFns)->Head= Fn;
 if(*Tks)
   {parse_kw(Tks, ",", TRUE, SEP_OPT);
    parse_ffpairs(Tks, &(*InclFiles)->Tail, &(*InitFns)->Tail);
   }
 else (*InclFiles)->Tail= (*InitFns)->Tail= NULL;
 MSG_END();
} /*parse_ffpairs*/


/*===setupgen===(ii)====================================================
 * Scannen und Pruefung folgender Mode-Parameter:
 * GEN_PARSE, GEN_WRITE, GEN_PRINT, GEN_CLEAR, GEN_READ, GEN_IMPL,
 * GEN_ALL, GEN_NO, GEN_NOPARSE
 *
 * MOD_PARSE_H1,MOD_WRITE_H1,MOD_CLEAR_H1,MOD_READ_H1,MOD_IMPL_H1,
 * MOD_PARSE_H2,MOD_WRITE_H2,MOD_CLEAR_H2,MOD_READ_H2,MOD_IMPL_H2,
 * MOD_PARSE_C,MOD_WRITE_C,MOD_CLEAR_C,MOD_READ_C,MOD_IMPL_C,
======================================================================*/
void setupgen(const char *Mode, bool Pt)
{char   *Arg;
 int     Eq;
 bool    Fnd;
 size_t  Lp;
 int     NOb, NOp, NDf;
 int     NExt;
 char    Parm[16];
 size_t  SzB;
 int     DfltLike[G_OBJQ][G_OBJQ]=
     {{ 1,  3,  2,  4, 5},   /*0:PARSE*/
      { 0,  3,  2,  4, 5},   /*1:WRITE*/
      { 4,  3,  0,  1, 5},   /*2:PRINT*/
      { 4,  2,  5,  0, 1},   /*3:CLEAR*/
      { 3,  2,  5,  0, 1},   /*4:READ*/
      { 4,  3,  2,  0, 1}    /*5:IMPL*/
     };
 MSG_DCL("setupgen");

 env_.GenNrs[G_OBJQ]= 0;

   /*Gen*-Parameter holen*/
 if(MAG1000(Modul,"GEN_ALL", Mode))
    if(Pt) qv_print(Modul, NULL, "GEN_ALL");
    else
      {for(NOb=0; NOb<G_OBJQ; NOb++) env_.GenNrs[NOb]= NOb;
       env_.GenNrs[G_OBJQ]= 1;
      }
 else if(   MAG1000(Modul,"GEN_NO",Mode)
         || MAG1000(Modul,"NOGEN",Mode))
    if(Pt) qv_print(Modul, NULL, "GEN_NO");
    else for(NOb=0; NOb<G_OBJQ; NOb++) env_.GenNrs[NOb]= -1;

 strcpy(Parm,"GEN_");
 for(NOb=0; NOb<G_OBJQ; NOb++)
   {strcpy(Parm+4, genobs[NOb]);
    if(Pt) {if(env_.GenNrs[NOb]>=0) qv_print(Modul, NULL, "%s", Parm);}
    else
      {if(Fnd=!!MAG1000(Modul, Parm, Mode))
         {env_.GenNrs[NOb]= NOb;
          env_.GenNrs[G_OBJQ]= 1;
         }
       dbg("%s: %sfound", Parm, Fnd?"":"not ");
      }
   }
 if(!Pt && dbg("GenNrs (initially)="))
   {for(NOb=0; NOb<G_OBJQ; NOb++)
       qv_printf(" %d", env_.GenNrs[NOb]);
    qv_printf("\n");
   }

   /*GenMods-Parameter holen*/
 strcpy(Parm,"MOD_");
 for(NOb=0; NOb<G_OBJQ; NOb++)
   {strcpy(Parm+4, genobs[NOb]); Lp= strlen(Parm);
    for(NExt=0; NExt<G_EXT_Q; NExt++)
      {strcpy(Parm+Lp, extmod[NExt]);
       strupr(Parm);
       if(Pt)
         {if(env_.GenMods[NOb][NExt])
             qv_print(Modul, NULL, "%s=%s",
                      Parm, env_.GenMods[NOb][NExt]);
         }
       else if(Arg=MAG1000(Modul, Parm, Mode))
         {ASSERT(ISFNAME(Arg), AUSSTEUERN, 105487,
                 qv_msg("%s='%s' - kein gueltiger Name", Parm, Arg));
          env_.GenMods[NOb][NExt]= Arg;
          dbg("%s found", Parm);
         } /*else if(Arg=MAG1000(Modul, Parm, Mode))*/
       else
          dbg("%s not found", Parm);
      } /*for(NExt=0; NExt<G_EXT_Q; NExt++)*/
    if(!Pt)
      {ASSERT(     !!env_.GenMods[NOb][G_EXT_C]
                 ==!!env_.GenMods[NOb][G_EXT_H1]
              &&   !!env_.GenMods[NOb][G_EXT_C]
                 ==!!env_.GenMods[NOb][G_EXT_H2],
              AUSSTEUERN, 105488,
              qv_msg("Parameter mod_%s_* sollen entweder alle NULL"
                     " o. alle nicht NULL sein",
                     genobs[NOb]));
       ASSERT(   !env_.GenMods[NOb][G_EXT_C]
              ||    stricmp(env_.GenMods[NOb][G_EXT_C],
                            env_.GenMods[NOb][G_EXT_H1])
                 && stricmp(env_.GenMods[NOb][G_EXT_C],
                            env_.GenMods[NOb][G_EXT_H2])
                 && stricmp(env_.GenMods[NOb][G_EXT_H1],
                            env_.GenMods[NOb][G_EXT_H2]),
              AUSSTEUERN, 105489,
              qv_msg("Parameter sollen unterschiedlich sein:\n"
                     "mod_%s_c=%s\nmod_%s_h1=%s\nmod_%s_h2=%s",
                     genobs[NOb], env_.GenMods[NOb][G_EXT_C],
                     genobs[NOb], env_.GenMods[NOb][G_EXT_H1],
                     genobs[NOb], env_.GenMods[NOb][G_EXT_H2]));

         /*Falls zu generieren und Mod nicht angegeben ist,
          *ObjNummer bestimmen, mit dem das lfd Objekt ausgegeben wird*/
       if(env_.GenMods[NOb][G_EXT_C])
          for(NOp=0; NOp<NOb; NOp++)
             if(   env_.GenMods[NOp][G_EXT_C]
                && (Eq=!stricmp(env_.GenMods[NOb][G_EXT_C],
                                env_.GenMods[NOp][G_EXT_C])))
               {env_.GenNrs[NOb]= env_.GenNrs[NOp];
                ASSERT(   Eq==!stricmp(env_.GenMods[NOb][G_EXT_H1],
                                       env_.GenMods[NOp][G_EXT_H1])
                       && Eq==!stricmp(env_.GenMods[NOb][G_EXT_H2],
                                       env_.GenMods[NOp][G_EXT_H2]),
                       AUSSTEUERN, 105489,
                       qv_msg("MOD-Parameter f. %s u. %s sollen"
                              " entweder alle identisch oder alle"
                              " unterschiedlich sein:\n"
                              "c: %s<->%s\nh1: %s<->%s\nh2: %s<->%s",
                              genobs[NOb],genobs[NOp],
                              env_.GenMods[NOb][G_EXT_C],
                              env_.GenMods[NOp][G_EXT_C],
                              env_.GenMods[NOb][G_EXT_H1],
                              env_.GenMods[NOp][G_EXT_H1],
                              env_.GenMods[NOb][G_EXT_H2],
                              env_.GenMods[NOp][G_EXT_H2]));
                break;
               } /*if(Eq=!stricmp(env_.GenMods[NOb][G_EXT_C]...*/
      }  /*if(!Pt))*/
   } /*for(NOb)*/

   /*GenMods pruefen & ObjNummer bestimmen*/
 if(!Pt)
   {if(dbg("Nach GenMods-Pruefung:"))
       for(NOb=0; NOb<G_OBJQ; NOb++)
          qv_printf("NOb=%d(%s): GenNrs= %d,"
                    " GenMods=('%s','%s','%s')\n",
                    NOb, genobs[NOb], env_.GenNrs[NOb],
                    env_.GenMods[NOb][G_EXT_C],
                    env_.GenMods[NOb][G_EXT_H1],
                    env_.GenMods[NOb][G_EXT_H2]);

    for(NOb=0; NOb<G_OBJQ; NOb++)
       if(!env_.GenMods[NOb][G_EXT_C])
          for(NDf=0; NDf<G_OBJQ;NDf++)
            {NOp=DfltLike[NOb][NDf];
             if(env_.GenMods[NOp][G_EXT_C])
               {
                if(env_.GenNrs[NOp]>=0)
                  {
                   env_.GenNrs[NOb]= env_.GenNrs[NOp];
                   dbg("Aufgr.DfltLike:GenNrs[%d]:=GenNrs[%d]=%d",
                       NOb, NOp, env_.GenNrs[NOb]);
                  }
                else if(env_.GenNrs[NOp]>=0)
                  {for(NExt=0; NExt<G_EXT_Q; NExt++)
                      env_.GenMods[NOb][NExt]=
                         memdup(env_.GenMods[NOp][NExt],
                                sizeof(env_.GenMods[NOb][NExt]));
                   dbg("Aufgr.DfltLike:GenMods v. %d sind"
                       " in %d kopiert",
                       NOp, NOb);
                  }
                break;
               } /*if(env_.GenMods[NOp][G_EXT_C])*/
            } /*for(NDf=0; NDf<G_OBJQ;NDf++)*/

    if(dbg("Nach DfltLike-Ergaenzung:"))
       for(NOb=0; NOb<G_OBJQ; NOb++)
          qv_printf("NOb=%d(%s): GenNrs= %d,"
                    " GenMods=('%s','%s','%s')\n",
                    NOb, genobs[NOb], env_.GenNrs[NOb],
                    env_.GenMods[NOb][G_EXT_C],
                    env_.GenMods[NOb][G_EXT_H1],
                    env_.GenMods[NOb][G_EXT_H2]);

    if(env_.GenNrs[G_OBJQ])
       for(NOb=0,NOp=-1; NOb<G_OBJQ; NOb++)
          if(env_.GenNrs[NOb]==NOb && !env_.GenMods[NOb][G_EXT_C])
            {if(NOp==-1)
               {ASSERT(env_.BNF, AUSSTEUERN, EC_MissingEntry,
                       "Kein BNF-Parameter angegeben."
                       " Kann nicht Ausgabefilenamen bestimmen");
                SzB= strlen(env_.BNF)+4;
                NOp= NOb;
                for(NExt=0; NExt<G_EXT_Q; NExt++)
                  {ASSERT(env_.GenMods[NOb][NExt]=malloc(SzB),
                          ABBRUCH, EC_NotEnoughMemory,
                          qv_msg("Kein Speicher f. GenMods-Namen. L=%u",
                                 SzB));
                   sprintf(env_.GenMods[NOb][NExt], "%s%d",
                           env_.BNF, NExt);
                  } /*for(NExt=0; NExt<G_EXT_Q; NExt++)*/
               }
             env_.GenNrs[NOb]= NOp;
            } /*if(env_.GenNrs[NOb]>=0 && !env_.GenMods[NOb][G_EXT_C])*/

    if(dbg("Nach BNF-Ergaenzung, am Ende:"))
       for(NOb=0; NOb<G_OBJQ; NOb++)
          qv_printf("NOb=%d(%s): GenNrs= %d,"
                    " GenMods=('%s','%s','%s')\n",
                    NOb, genobs[NOb], env_.GenNrs[NOb],
                    env_.GenMods[NOb][G_EXT_C],
                    env_.GenMods[NOb][G_EXT_H1],
                    env_.GenMods[NOb][G_EXT_H2]);
   } /*if(!Pt)*/
 MSG_ENDD();
} /*setupgen*/


/*===MAG1054_setup===(i)================================================
 * Synopsis:  MAG1054_envInt MAG1054_setup(const char *Mode)
 * Return:    Referenz auf interne Optionsstruktur
======================================================================*/
void MAG1054_setup(const char *Mode)
{int          Actn;
 char        *Arg;
 tp_strings  *SLw;
 char         Cw;
 void        *Env1050;
 size_t       MaxNm;
 char         PSB[4]="PSB";
 char        *Sw;
 tp_lexs     *Tkw;
 tp_tktype    Tp;
 MSG_DCL("MAG1054_setup");
 dbg("Mode=",Mode);
 if(Mode)
   {
    if(Arg=MAG1000(Modul,"ACTION",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Action= 0x0;
       else
         {ASSERT(strlen(Arg)==1 && !isspace(*Arg),
                 AUSSTEUERN,EC_IllegalMode,
                 qv_msg("ACTION Mode-Parameter '%s' ist kein"
                        " Einzeltoken",
                        Arg));
          env_.Action= *Arg;
         }
      }
    if(Arg=MAG1000(Modul,"ALT",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Alt= NULL;
       else
         {if(!strcmp(Arg,"\\n")) strcpy(Arg,"\n");
          if(strcmp(Arg,"\n"))
             ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                    qv_msg("ALT Mode-Parameter '%s' ist weder "
                           "Einzeltoken noch \\n",
                           Arg));
          env_.Alt= Arg;
         }
      }
    if(Arg=MAG1000(Modul,"ARGS",Mode))
      {str_strip(Arg,Arg);
       Cw= toupper(*Arg);
       ASSERT(strlen(Arg)==1 && strchr("JYNO",Cw),
              AUSSTEUERN,EC_IllegalMode,
              qv_msg("ARGS Mode-Parameter '%s' inkorrekt."
                     "Erlaubt:  J|Y (erforderlich) "
                     "N (verboten) O (optionell)",
                     Arg));
       env_.Args= Cw=='N'? -1: Cw=='O'? 0: 1;
      }
    if(Arg=MAG1000(Modul,"BLIN",Mode))
      {str_strip(Arg,Arg);
       dbg("stripped Arg of BLIN='%s'",Arg);
       if((Cw=*Arg)=='=') Arg++;
       else if((Cw=*Arg)=='+') Arg++;
       else Cw= '=';
       Tkw=NULL;
       if(*Arg && strcmp(Arg,"0"))
         {Env1050= MAG1050_getEnv();
          MAG1050_setup("MAG1050:NOCARRY");
          tks_scans(&Tkw,NULL,Arg,0,0);
          MAG1050_setEnv(Env1050);
         }
       /*Clear blin-List from QSTDACT on.*/
       if(Cw=='=' || Cw=='0')
         {for(Actn=0,SLw=env_.BlIn; SLw && Actn<QSTDACT-1;)
            {Actn++; SLw=SLw->Tail;}
          if(SLw) LST_CLEAR(&SLw->Tail,NULL);
         }
       if(Tkw)
         {SLw=(tp_strings *)LST_GETLAST(env_.BlIn);
          TRY
             parse_names(&Tkw,SLw? &SLw->Tail: &env_.BlIn,',',TRUE);
          RECOVER
             qv_printf(err_msg());
             ASSERT(0, AUSSTEUERN, EC_IllegalArgument,
                    "Fehler in BLIN-Einstellungsparameter");
          END
         }
      } /*BLIN*/

    env_.BNF=MAG1000(Modul,"BNF",Mode);
    setupgen(Mode, FALSE);

    if(Sw=MAG1000("MAG1050","CASE",Mode))
      {while(isspace(*Sw)) Sw++;
       env_.CaseIndep= (*Sw>='1');
      }

    if(Arg=MAG1000(Modul,"CLAUSES",Mode))
      {str_strip(Arg,Arg);
       Tp= tks_scans(&env_.ClTks,NULL,Arg,0,0);
       ASSERT(Tp!=TKS_NO,AUSSTEUERN,EC_IllegalMode,
              qv_msg("Inkorrekter CLAUSES Mode-Parameter '%s'",Arg));
      }
    if(Arg=MAG1000(Modul,"CONT",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Cont= 0x0;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),
                 AUSSTEUERN,EC_IllegalMode,
                 qv_msg("CONT Mode-Parameter '%s' ist kein"
                        " Einzeltoken",
                        Arg));
          env_.Cont= Arg;
         }
      }
    if(Arg= MAG1000(Modul,"CUT",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Cut= 0x0;
       else
         {ASSERT(strlen(Arg)==1 && !isspace(*Arg),
                 AUSSTEUERN,EC_IllegalMode,
                 qv_msg("CUT Mode-Parameter '%s' ist kein"
                        " Einzeltoken",
                        Arg));
          env_.Cut= *Arg;
         }
      }

    env_.Def2|= !!MAG1000(Modul,"DEF2",Mode);
    env_.Def2&= !MAG1000(Modul,"NODEF2",Mode);

    if(Arg= MAG1000(Modul,"EMPTY",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Empty= NULL;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                 qv_msg("EMPTY Mode-Parameter '%s' ist kein"
                        " Einzeltoken",
                        Arg));
          env_.Empty= Arg;
         }
      }

#ifdef _MSDOS
    if(Arg= MAG1000(Modul,"DIRHEAD",Mode))
       env_.Dir[G_EXT_H1]= str_strip(NULL, Arg);
    else env_.Dir[G_EXT_H1]= "";

    if(Arg= MAG1000(Modul,"DIRMOD",Mode))
       env_.Dir[G_EXT_C]= str_strip(NULL, Arg);
    else env_.Dir[G_EXT_C]= "";
#endif

    if(Arg=MAG1000(Modul,"EXTERN",Mode))
      {str_strip(Arg,Arg);
       dbg("stripped Arg of EXTERN='%s'",Arg);
       strlwr(Arg);
       dbg("strlwr(Arg)='%s'",Arg);
       Tkw=NULL;
       if(*Arg)
         {Env1050= MAG1050_getEnv();
          MAG1050_setup("MAG1050:NOCARRY");
          tks_scans(&Tkw,NULL,Arg,0,0);
          MAG1050_setEnv(Env1050);
         }
       if(env_.ExtNTs) LST_CLEAR(&env_.ExtNTs, NULL);
       TRY
          if(Tkw) parse_names(&Tkw, &env_.ExtNTs, ',', TRUE);
       RECOVER
          qv_printf(err_msg());
          ASSERT(0, AUSSTEUERN, EC_IllegalArgument,
                 "Fehler in EXTERN-Einstellungsparameter");
       END
      } /*EXTERN*/

    if(Arg=MAG1000(Modul,"INCLUDE",Mode))
      {str_strip(Arg,Arg);
       dbg("stripped Arg of INCLUDE='%s'",Arg);
       Tkw=NULL;
       if(*Arg)
         {Env1050= MAG1050_getEnv();
          MAG1050_setup("MAG1050:NOCARRY");
          tks_scans(&Tkw,NULL,Arg,0,0);
          MAG1050_setEnv(Env1050);
         }
       if(env_.InclFiles) LST_CLEAR(&env_.InclFiles, NULL);
       if(env_.InitFns) LST_CLEAR(&env_.InitFns, NULL);
       TRY
          if(Tkw) parse_ffpairs(&Tkw, &env_.InclFiles, &env_.InitFns);
       RECOVER
          qv_printf(err_msg());
          ASSERT(0, AUSSTEUERN, EC_IllegalArgument,
                 "Fehler in INCLUDE-Einstellungsparameter");
       END
      } /*INCLUDE*/

    if(Arg=MAG1000(Modul,"LIST",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.List= NULL;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                 qv_msg("LIST Mode-Parameter '%s'"
                        " ist kein Einzeltoken",
                        Arg));
          env_.List= Arg;
         }
      } /*LIST*/
    if(Arg=MAG1000(Modul,"LISTSEP",Mode))
      {str_strip(Arg,Arg);
       ASSERT(strlen(Arg)==1 && strchr("{[(\"'`",*Arg),
              AUSSTEUERN,EC_IllegalMode,
              qv_msg("LISTSEP Mode-Parameter '%s' ist falsch."
                     " Richtig waere {[(\"'`",
                     Arg));
       env_.LstSep= *Arg;
      } /*LISTSEP*/

    env_.LLk= !MAG1000(Modul,"NOLLK",Mode);

    if(Sw=MAG1000("MAG1050","MAXNAME",Mode))
      {MaxNm=atoi(Sw);
       if(MaxNm) env_.MaxName= MaxNm;
       ASSERT(env_.MaxName+12<=GRAM_MAXTP, AUSSTEUERN, EC_IllegalMode,
              qv_msg("MAXXNAME ist zu gross. <=%u erlaubt\n",
                     GRAM_MAXTP-12));
      }
    if(Arg=MAG1000(Modul,"MULT",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Mult= NULL;
       else
         {if(!strcmp(Arg,"\\n")) strcpy(Arg,"\n");
          if(strcmp(Arg,"\n"))
             ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                    qv_msg("MULT Mode-Parameter '%s' ist weder "
                           "Einzeltoken noch \\n",
                           Arg));
          env_.Mult= Arg;
         }
      } /*MULT*/
    if(Arg=MAG1000(Modul,"NT",Mode))
      {str_strip(Arg,Arg);
       dbg("NT detected:Arg=<%s>",Arg);
       if(!strcmp(Arg,"0")) env_.NT= 0x0;
       else
         {ASSERT(strlen(Arg)==1 && !isspace(*Arg),
                 AUSSTEUERN,EC_IllegalMode,
                 qv_msg("NT Mode-Parameter '%s' ist kein Einzeltoken",
                        Arg));
          env_.NT= *Arg;
         }
      }
    if(Arg=MAG1000(Modul,"OPER",Mode))
      {str_strip(Arg,Arg);
       Cw= toupper(*Arg);
       ASSERT(strlen(Arg)==1 && strchr("BSPN0",Cw),
              AUSSTEUERN,EC_IllegalMode,
              qv_msg("OPER Mode-Parameter '%s' inkorrekt."
                     "Erlaubt sind:  B S P N 0",
                     Arg));
       env_.Oper= 0;
       if(strchr("BP",Cw)) env_.Oper=  1;
       if(strchr("BS",Cw)) env_.Oper|= 2;
      }
    if(Arg=MAG1000(Modul,"OPTIONAL",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Optional= NULL;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                 qv_msg("OPTIONAL Mode-Parameter '%s'"
                        " ist kein Einzeltoken",
                        Arg));
          env_.Optional= Arg;
         }
      }
    if(Arg=MAG1000(Modul,"OPTLIST",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.OptList= NULL;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                 qv_msg("OPTLIST Mode-Parameter '%s'"
                        " ist kein Einzeltoken",
                        Arg));
          env_.OptList= Arg;
         }
      }
    if(   (Arg=MAG1000(Modul,"PUBLIC",Mode))
       || (Arg=MAG1000(Modul,"PUB",Mode)))
      {dbg("unstripped Arg of PUB='%s'",Arg);
       str_strip(Arg,Arg);
       dbg("stripped Arg of PUB='%s'",Arg);
       if(!strncmp(Arg,"TYPES",5))
         {env_.Pbt=1; Arg+=5;
          while(*Arg==',' || *Arg && isspace(*Arg)) Arg++;
         }
       dbg("env_.Pbt=%d",(int)env_.Pbt);
       Tkw=NULL;
       if((Cw=*Arg)=='=') Arg++;
       else if(Cw=='+') Arg++;
       else if(Cw!='*') Cw= '=';
       if(Cw=='*') {LST_PUSH(&env_.Pub,strdup("*")); env_.Pbt=1;}
       else
         {if(*Arg && strcmp(Arg,"0"))
            {Env1050= MAG1050_getEnv();
             MAG1050_setup("MAG1050:CASE=1,NOCARRY");
             dbg("Args aft. TYPES & Prefix search: '%s'", Arg);
             tks_scans(&Tkw,NULL,Arg,0,0);
             tks_dbgs(Tkw);
             MAG1050_setEnv(Env1050);
            }
          if(*Arg=='0' || Cw=='=') LST_CLEAR(&env_.Pub,NULL);
          if(Tkw)
            {SLw=(tp_strings *)LST_GETLAST(env_.Pub);
             TRY
                parse_names(&Tkw,SLw? &SLw->Tail: &env_.Pub,',',TRUE);
             RECOVER
                qv_printf(err_msg());
                ASSERT(0, AUSSTEUERN, EC_IllegalArgument,
                       "Fehler in PUBLIC-Einstellungsparameter");
             END
            }
         } /* '*' / else*/
      } /*PUBLIC*/

    if(Arg=MAG1000(Modul,"RULE_BEGIN",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.RuleBegin= NULL;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                 qv_msg("RULE_BEGIN Mode-Parameter '%s' ist kein "
                        "Einzeltoken",
                        Arg));
          env_.RuleBegin= Arg;
         }
      }
    if(Arg=MAG1000(Modul,"RULE_END",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.RuleEnd= NULL;
       else
         {strupr(Arg);
          while(Sw=strstr(Arg,"\\N")) {*Sw='\n';strdel(Sw+1,1);}
          env_.RuleEnd= Arg;
         }
      }
    if(Arg=MAG1000(Modul,"SEQ",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Seq= NULL;
       else
         {ASSERT(tks_is1(Arg,FALSE,0),AUSSTEUERN,EC_IllegalMode,
                 qv_msg("SEQ Mode-Parameter '%s' ist kein Einzeltoken",
                        Arg));
          env_.Seq= Arg;
         }
      }
    if(Arg=MAG1000(Modul,"TERM",Mode))
      {str_strip(Arg,Arg);
       if(!strcmp(Arg,"0")) env_.Term= 0x0;
       else
         {ASSERT(strlen(Arg)==1 && !isspace(*Arg),
                 AUSSTEUERN,EC_IllegalMode,
                 qv_msg("TERM Mode-Parameter '%s' ist kein Einzeltoken",
                        Arg));
          env_.Term= *Arg;
         }
      }

    env_.Opts|= !!(   MAG1000(Modul,"OPTIONS",Mode)
                  || MAG1000(Modul,"OPTS",Mode));
    env_.Opts&= !(   MAG1000(Modul,"NOOPTIONS",Mode)
                  || MAG1000(Modul,"NOOPTS",Mode));

    if(env_.Opts && !(called_ && ingate_))
      {qv_print(Modul,NULL,"PARAMETER:");
       qv_print(Modul,NULL,"Uebergeben:\n<%s>",STR_NOT0(Mode));
       qv_print(Modul,NULL,"Interpretiert:");
       qv_print(Modul,NULL,"BNF='%s'",env_.BNF);
       setupgen(Mode, TRUE);
       qv_print(Modul,NULL,"DIRHEAD='%s'",env_.Dir[G_EXT_H1]);
       qv_print(Modul,NULL,"DIRMOD ='%s'",env_.Dir[G_EXT_C]);
       qv_print(Modul,NULL,"RULE_BEGIN='%s'",STR_NOT0(env_.RuleBegin));
       qv_print(Modul,NULL,"RULE_END='%s'",STR_NOT0(env_.RuleEnd));
       qv_print(Modul,NULL,"ARGS=%d",env_.Args);
       qv_print(Modul,NULL,"CLAUSES:");
       qv_printf("(");
       for(Tkw=env_.ClTks;
           tks_get(&Sw,NULL,NULL,NULL,NULL,Tkw)!=TKS_NO;
           Tkw=tks_tail(Tkw))
          qv_printf(" %s",Sw);
       qv_printf(" )\n");
       qv_print(Modul,NULL,"DEF2='%s'",STR_JN(env_.Def2));
       qv_print(Modul,NULL,"ALT='%s'", STR_NOT0(env_.Alt));
       qv_print(Modul,NULL,"MULT='%s'",STR_NOT0(env_.Mult));
       qv_print(Modul,NULL,"SEQ='%s'", STR_NOT0(env_.Seq));
       qv_print(Modul,NULL,"CONT='%s'",STR_NOT0(env_.Cont));
       qv_print(Modul,NULL,"NT=%c(%d)",env_.NT,(int)env_.NT);
       qv_print(Modul,NULL,"TERM=%c(%d)",env_.Term,(int)env_.Term);
       qv_print(Modul,NULL,"ACTION=%c(%d)",
                env_.Action,(int)env_.Action);
       qv_print(Modul,NULL,"BLIN:");
       qv_printf("(");
       for(SLw=env_.BlIn; SLw; SLw=(tp_strings *)LST_GETTAIL(SLw))
          qv_printf(" %s",STR_NOT0((char *)LST_GETHEAD(SLw)));
       qv_printf(" )\n");
       qv_print(Modul,NULL,"CUT=%c(%d)",
                env_.Cut?env_.Cut:' ',(int)env_.Cut);
       qv_print(Modul,NULL,"EMPTY='%s'",STR_NOT0(env_.Empty));
       qv_print(Modul,NULL,"EXTERN:");
       qv_printf("(");
       for(SLw=env_.ExtNTs; SLw; SLw=(tp_strings *)LST_GETTAIL(SLw))
          qv_printf(" %s",STR_NOT0((char *)LST_GETHEAD(SLw)));
       qv_printf(" )\n");
       qv_print(Modul,NULL,"OPTIONAL='%s'",STR_NOT0(env_.Optional));
       qv_print(Modul,NULL,"LIST=='%s'",STR_NOT0(env_.List));
       qv_print(Modul,NULL,"OPTLIST='%s'",STR_NOT0(env_.OptList));
       qv_print(Modul,NULL,"LISTSEP=='%c'(%0X)",
                env_.LstSep, (unsigned)env_.LstSep);
       qv_print(Modul,NULL,"OPER=%c(%d)",
                PSB[(int)env_.Oper],(int)env_.Oper);
       qv_print(Modul,NULL,"LLK='%s'",STR_JN(env_.LLk));
       qv_print(Modul,NULL,"PUBLIC:");
       qv_printf("(");
       for(SLw=env_.Pub; SLw; SLw=(tp_strings *)LST_GETTAIL(SLw))
          qv_printf(" %s",STR_NOT0((char *)LST_GETHEAD(SLw)));
       qv_printf(" )\n");
       qv_print(Modul,NULL,"\nENDE VON PARAMETERLISTE\n");
       qv_printf80('-');
      } /*if(env_.Opts)*/
    gram_plausiopt((char *)Mode);
   } /*if(Mode)*/
 else MAG1054_init();
 MSG_ENDD();
} /*MAG1054_setup*/
/**********************************************************************/

/*===MAG1054_gate===(ii)==============================================*/
/* Common initializer. Called from MAG1054 & MAG1054_open */
static void *MAG1054_gate(void *EnvInp, const char *Mode)
{static const char *Routine="MAG1054_gate";
 void * EnvOut;
 QV_SETRUN(Modul,Routine,Mode);

 ingate_= 1;
 EnvOut=  MAG2002(EnvInp, Mode);
 MAG2004(EnvOut, NULL);
 MAG1016(EnvOut, NULL);
 MAG1020(EnvOut, NULL);
 MAG2050(EnvOut, Mode);
 MAG2032(EnvOut, Mode);
 MAG2052(EnvOut, Mode);
 if(!called_) MAG1054_init();
 MAG1054_setup(Mode);
 ingate_= 0;
 called_ ++;
 return EnvOut;
} /*MAG1054_gate*/


#ifndef MTP_FETCH

/*===MAG1054===(ii)=== statische openMAG =============================*/
void *MAG1054(void *Env, const char *Mode)
{static const char *Routine="MAG1054";
 LINK_TEST(Modul,Routine,LINK_STAT)
 return MAG1054_gate(Env, Mode);
} /*MAG1054*/

#else

/*===MAG1054_open===(ii)==============================================*/
/* Dynamic initializer. Called from MAG2054 (ex initAG)*/
void *MAG1054_open(void *Env, const char *Mode)
{static const char *Routine="MAG1054_open";
 LINK_TEST(Modul,Routine,LINK_FETCH)
 return MAG1054_gate(Env, Mode);
} /*MAG1054_open*/

/*===MAG1054===(i)====================================================*/
void *MAG1054(int ix)
{
 static void (*Fun[])()=
 {NULL,
#define DCL_FN(tpret,fname,pformal) VOIDFUN &fname,

/*#undef qv_printf*/

#include "XAG1054"
  NULL
 };
 FT_ADDFUN(MAG1054,Fun,ix);
}
#endif   /*MTP_FETCH*/

/*Run
tso sub 'gqv0019.main.jcl(hag1054P)'
*/
